//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


#ifndef conf_3_h
#define conf_3_h

#include "conf_N.h"



//--------------------------------------------------------------------------------------------------
//-------------------------------------- CONF_3 ----------------------------------------------------
//--------------------------------------------------------------------------------------------------

/// Derived class for kinematics of three particles in the final state
class CONF_3:public CONF_N {
  
 public:

 /// The realization of a virtual function  
 void generate(double V[]);
  
 CONF_3();
 
 ~CONF_3() {   }

 private:
   
  /// Auxiliary variables
  double MM, M, phi, phi1, theta, costh, sinth, mm23, m23, E1s, E3s, mm13, E1, E2, E3;
  
  /// Euler rotation (re-coded the code of Wojtek Slominski)
  void rotate_Euler(TLorentzVector & v, double alpha, double beta, double gamma);
 
};



#endif