//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


#ifndef test_fc_dijets_h
#define test_fc_dijets_h


#include "userfun.h"


// The user-class for forward central dijets
// It inherits from the predefined user-class
// which sets ups some ROOT trees and saves events (see userfun.cpp)

class TEST_FCDIJETS:public USER_CLASS {
public:
  bool basic_cuts(const CONF_N & conf);
  TEST_FCDIJETS(string alias_, double CMenergy, PDF &hadron_A);
};


//------------------------ Initialization part ----------------------------------

// Here should be a definition of a class that will register user-classes
// via the static method RUNS::register_user. 
// The class object should be declared below after "#ifdef ..." statement

class TFC2j_INIT {
public:  
  TFC2j_INIT();
};

#ifdef main_function_ 

// ----> place here (!) a definition of an object of your initialization class <----
TFC2j_INIT init_tfc2j;

#endif




#endif
