//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


//********************* ME squared (g*)g->gg for helicities LLR *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_2.h"

double ME_2::me2_RgGGG_LLR() {
int Nsymb =32;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,n);
u[2] = Dot(k3,k4);
u[3] = Dot(k3,n);
u[4] = Dot(k4,n);
u[6] = S(L,k3,n);
u[7] = S(R,k2,k3);
u[8] = S(R,k2,n);
u[9] = S(R,k4,n);
u[10] = Den(u[4]);
u[11] = Den(u[3]);
u[12] = Den(u[2]);
u[13] = Den(u[1]);
u[14] = Dot(e1,k3);
u[15] = Dot(k2,k3);
u[16] = S(R,k3,k4);
u[17] = Den(u[15]);
u[18] = Dot(e1,k4);
u[19] = S(L,k4,n);
u[20] = S(R,k2,k4);
u[21] = S(R,k4,n,e1);
u[22] = S(R,k2,n,e1);
u[25] = Dot(k2,k4);
u[26] = S(L,k2,k3);
u[27] = S(L,k2,n);
u[28] = Den(u[25]);
u[29] = S(L,k3,k4);
u[30] = S(R,n,k3,e1);
u[31] = Dot(e1,k2);
COMPLEX subW1 = pow2(u[6]);
COMPLEX subW2 = -u[9]*u[22];
COMPLEX subW3 = u[14] -u[18] + u[31];
u[5] = sqrt(2.);
u[23] = subW1*u[5]*u[8]*u[9]*u[10]*u[13]*(u[11]*(subW2 + u[6]*u[12]*(u[7]*u[9] + u[8]*u[16])*(kTv + 2.*(u[14] + u[18])) + u[8]*u[21]) + 2.*u[9]*u[12]*u[22]);
u[24] = subW1*u[5]*u[8]*u[9]*u[10]*u[11]*u[13]*(subW2 -u[8]*u[21] + u[17]*(2.*(u[18]*(u[6]*u[8]*u[16] -u[9]*u[19]*u[20]) + u[2]*u[8]*u[21]) + pow2(kTv)*u[9]*u[22] + kTv*(u[8]*(u[6]*u[16] - 2.*u[14]*u[21]) + u[9]*(-u[19]*u[20] + 2.*u[18]*u[22]))));
u[32] = -u[5]*u[6]*u[8]*u[9]*u[10]*u[11]*u[13]*(u[20]*(u[19]*u[21] -u[22]*u[27])*u[28]*(u[8]*u[26] + u[9]*u[29]) + u[6]*(u[9]*(-u[22] + subW3*u[19]*u[20]*u[28]) + u[8]*(u[21] -subW3*u[20]*u[27]*u[28]) + u[20]*(u[16]*u[19] + u[7]*u[27])*u[28]*u[30]));
COMPLEX subA1 = u[23] -u[24];
COMPLEX subA2 = u[24] -u[32];
COMPLEX subA3 = -u[23] + u[32];


COMPLEX amp1234 = 0.125*subA1;

COMPLEX amp1243 = 0.125*subA3;

COMPLEX amp1324 = 0.125*subA2;

COMPLEX amp1342 = 0.125*subA3;

COMPLEX amp1423 = 0.125*subA2;

COMPLEX amp1432 = 0.125*subA1;

delete [] u;

// color factors are included below, without averaging

return 9.*8./16.*(norm (amp1234) +norm (amp1243) +norm (amp1324) +norm (amp1342) +norm (amp1423) +norm (amp1432) );


}
