//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


//********************* ME squared (g*)g->gg for helicities LRL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_2.h"

double ME_2::me2_RgGGG_LRL() {
int Nsymb =32;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k3);
u[2] = Dot(k2,n);
u[3] = Dot(k3,n);
u[4] = Dot(k4,n);
u[6] = S(L,k2,k4);
u[7] = S(L,k2,n);
u[8] = S(L,k4,n);
u[9] = S(R,k2,k3);
u[10] = S(R,k2,n);
u[11] = S(R,k2,n,e1);
u[12] = S(R,k3,n);
u[13] = Den(u[4]);
u[14] = Den(u[3]);
u[15] = Den(u[2]);
u[16] = Den(u[1]);
u[17] = S(L,k3,n);
u[18] = S(R,k3,n,e1);
u[19] = S(L,k3,k4);
u[20] = S(R,k2,k4);
u[21] = S(R,n,k4,e1);
u[22] = Dot(e1,k2);
u[23] = Dot(e1,k3);
u[24] = Dot(e1,k4);
u[25] = S(R,k3,k4);
u[27] = Dot(k3,k4);
u[28] = Den(u[27]);
u[30] = Dot(k2,k4);
u[31] = Den(u[30]);
COMPLEX subW1 = u[22] -u[23] + u[24];
COMPLEX subW2 = pow2(u[8]);
COMPLEX subW3 = kTv - 2.*u[22];
COMPLEX subW4 = u[12]*u[19];
COMPLEX subW6 = subW4 + kTv*u[21];
u[5] = sqrt(2.);
u[26] = u[5]*u[8]*u[10]*u[12]*u[13]*u[14]*u[15]*(u[9]*(-subW4 + u[6]*u[10])*u[16]*(u[7]*u[11] -u[17]*u[18]) + u[8]*(u[11]*u[12] + u[10]*(subW1*u[7]*u[9]*u[16] -u[18]) -u[9]*u[16]*(subW1*u[12]*u[17] + u[21]*(u[7]*u[20] -u[17]*u[25]))));
u[29] = subW2*u[5]*u[10]*u[12]*u[14]*u[15]*(u[11]*u[12]*(u[13] - 2.*u[28]) -u[13]*(-subW3*u[8]*u[12]*u[20]*u[28] + u[10]*(u[18] + subW3*u[8]*u[25]*u[28])));
u[32] = u[5]*u[8]*u[10]*u[12]*u[13]*u[14]*u[15]*((-subW6*(kTv*u[11] -u[9]*u[17])*u[18] + subW2*(kTv + 2.*u[23])*(u[12]*u[20] -u[10]*u[25]))*u[31] + u[8]*(-u[11]*u[12] + u[18]*(subW6*u[20]*u[31] + u[10]*(-1. + (-2.*kTv*u[24] + 2.*u[27])*u[31]))));
COMPLEX subA1 = u[26] + u[29];
COMPLEX subA2 = -u[29] -u[32];
COMPLEX subA3 = -u[26] + u[32];


COMPLEX amp1234 = 0.125*subA1;

COMPLEX amp1243 = 0.125*subA2;

COMPLEX amp1324 = 0.125*subA3;

COMPLEX amp1342 = 0.125*subA2;

COMPLEX amp1423 = 0.125*subA3;

COMPLEX amp1432 = 0.125*subA1;

delete [] u;

// color factors are included below, without averaging

return 9.*8./16.*(norm (amp1234) +norm (amp1243) +norm (amp1324) +norm (amp1342) +norm (amp1423) +norm (amp1432) );


}
