//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->ggg for helicities LLLL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGGGG_LLLL() {
int Nsymb =98;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k1,k1);
u[2] = Dot(k1,k2);
u[3] = Dot(k2,n);
u[4] = Dot(k3,k4);
u[5] = Dot(k3,n);
u[6] = Dot(k4,n);
u[7] = Dot(k5,n);
u[8] = S(L,k2,k3);
u[9] = S(L,k3,k4);
u[10] = S(L,k3,k5);
u[11] = S(L,k3,n);
u[12] = S(L,k4,n);
u[13] = S(L,k5,n);
u[14] = S(R,k2,n);
u[15] = S(R,k2,n,e1);
u[16] = S(R,k3,n);
u[17] = Den(u[7]);
u[18] = Den(u[6]);
u[19] = Den(u[5]);
u[20] = Den(u[4]);
u[21] = Den(u[3]);
u[22] = S(L,k4,k5);
u[23] = S(R,k4,n);
u[24] = S(L,k2,k4);
u[25] = S(L,k2,k5);
u[26] = S(R,k5,n);
u[27] = S(R,k2,k3);
u[28] = S(R,n,k3,e1);
u[29] = S(R,n,k4,e1);
u[30] = S(R,n,k5,e1);
u[31] = Dot(e1,k2);
u[32] = Dot(e1,k3);
u[33] = Dot(e1,k4);
u[34] = Dot(e1,k5);
u[35] = S(R,k2,k4);
u[36] = Dot(k1,k5);
u[37] = Dot(k2,k3);
u[38] = Den(u[37]);
u[39] = S(R,k2,k5);
u[40] = Dot(k4,k5);
u[41] = Den(u[40]);
u[42] = Den(u[3] -u[5]);
u[43] = Den(u[1] -2.*u[36]);
u[45] = Den(u[1] + 2.*u[2]);
u[47] = Dot(k2,k5);
u[57] = Dot(k2,k4);
u[58] = Dot(k3,k5);
u[60] = Den(u[58]);
u[61] = Dot(k1,k4);
u[62] = Den(u[1] -2.*u[61]);
u[71] = Den(u[57]);
u[72] = Den(u[3] -u[6]);
u[79] = Dot(k1,k3);
u[80] = Den(u[1] -2.*u[79]);
u[87] = Den(u[47]);
u[88] = Den(u[3] -u[7]);
COMPLEX subW1 = pow2(u[11]);
COMPLEX subW2 = pow2(u[14]);
COMPLEX subW3 = u[19] + u[21];
COMPLEX subW4 = u[22]*u[26];
COMPLEX subW5 = -kTv*u[29];
COMPLEX subW7 = pow2(kTv);
COMPLEX subW8 = 2.*kTv*u[34];
COMPLEX subW12 = u[10]*u[16];
COMPLEX subW13 = u[22]*u[23];
COMPLEX subW15 = u[8]*u[16];
COMPLEX subW16 = u[23]*u[24];
COMPLEX subW17 = u[25]*u[26];
COMPLEX subW20 = u[11]*u[16];
COMPLEX subW21 = u[12]*u[23];
COMPLEX subW22 = u[13]*u[26];
COMPLEX subW24 = u[31] + u[32] + u[33] + u[34];
COMPLEX subW27 = u[16]*u[28];
COMPLEX subW28 = u[23]*u[29];
COMPLEX subW29 = u[26]*u[30];
COMPLEX subW31 = u[11]*u[27];
COMPLEX subW32 = u[12]*u[35];
COMPLEX subW33 = u[13]*u[39];
COMPLEX subW38 = pow2(u[23]);
COMPLEX subW40 = u[32] + u[33];
COMPLEX subW44 = u[9]*u[23];
COMPLEX subW45 = u[10]*u[26];
COMPLEX subW46 = -kTv*u[28];
COMPLEX subW48 = kTv + 2.*u[34];
COMPLEX subW50 = -kTv*u[33];
COMPLEX subW56 = u[4] + u[47];
COMPLEX subW57 = u[14]*u[25];
COMPLEX subW58 = pow2(u[13]);
COMPLEX subW63 = u[31] -u[32] + u[33] + u[34];
COMPLEX subW64 = u[32] + u[34];
COMPLEX subW65 = 2.*kTv*u[33];
COMPLEX subW69 = kTv + 2.*u[33];
COMPLEX subW70 = kTv*u[34] -u[40];
COMPLEX subW73 = -4.*u[31] + u[34];
COMPLEX subW75 = u[47] + u[57];
COMPLEX subW79 = u[9]*u[16];
COMPLEX subW85 = pow2(u[26]);
COMPLEX subW87 = u[14]*u[24];
COMPLEX subW88 = pow2(u[12]);
COMPLEX subW89 = u[18] + u[21];
COMPLEX subW91 = 2.*u[19] -u[21];
COMPLEX subW92 = -u[19]*u[21];
COMPLEX subW95 = -u[12]*u[28];
COMPLEX subW96 = -2.*u[11]*u[29];
COMPLEX subW97 = 2.*u[11]*u[22];
COMPLEX subW98 = pow3(kTv);
COMPLEX subW108 = u[30]*u[71];
COMPLEX subW110 = -kTv*u[32];
COMPLEX subW118 = 2.*u[15]*u[24];
COMPLEX subW119 = -u[27]*u[28];
COMPLEX subW122 = 2.*kTv*u[32];
COMPLEX subW127 = 2.*kTv*u[29];
COMPLEX subW131 = kTv + 2.*u[32];
COMPLEX subW132 = u[17] + u[21];
COMPLEX subW138 = u[29]*u[87];
COMPLEX subW148 = 2.*u[15]*u[25];
COMPLEX subW149 = u[31] -u[32] -u[33] + 3.*u[34];
COMPLEX subW152 = u[37] + u[40] + u[57] + u[58];
COMPLEX subW155 = subW4 + subW5;
COMPLEX subW156 = subW7 + subW8;
COMPLEX subW159 = subW12 + subW13;
COMPLEX subW160 = subW27 + subW28 + subW29;
COMPLEX subW161 = subW31 + subW32 + subW33;
COMPLEX subW162 = subW20 + subW21 + subW22;
COMPLEX subW164 = subW15 + subW16 + subW17;
COMPLEX subW169 = subW27 + subW28;
COMPLEX subW170 = subW20 + subW21;
COMPLEX subW171 = subW38*u[12]*u[22];
COMPLEX subW172 = -2.*subW40 + 2.*u[31] -u[34];
COMPLEX subW173 = subW28 + subW29;
COMPLEX subW174 = subW13 + kTv*u[30];
COMPLEX subW175 = subW44 + subW45 + subW46;
COMPLEX subW176 = subW13*subW48*u[38];
COMPLEX subW177 = subW50 + u[40];
COMPLEX subW182 = subW21 + subW22;
COMPLEX subW183 = subW44 + subW45;
COMPLEX subW184 = subW40 + 3.*u[31] + u[34];
COMPLEX subW185 = subW16 + subW17;
COMPLEX subW186 = subW65 + subW7;
COMPLEX subW189 = -1. + subW70*u[38];
COMPLEX subW190 = kTv*subW73;
COMPLEX subW194 = -subW4 + subW79;
COMPLEX subW195 = subW27 + subW29;
COMPLEX subW196 = subW20 + subW22;
COMPLEX subW197 = subW85*u[13] + subW21*u[26];
COMPLEX subW198 = subW45 + subW46;
COMPLEX subW199 = subW12 + kTv*u[30];
COMPLEX subW200 = -2.*subW87*u[13];
COMPLEX subW201 = 2.*subW98*u[28];
COMPLEX subW202 = subW57*u[12] + subW4*u[13];
COMPLEX subW203 = 4.*subW7*u[28];
COMPLEX subW204 = subW17*u[12]*u[14];
COMPLEX subW205 = subW85*u[13]*u[22];
COMPLEX subW207 = -2.*subW7*u[29];
COMPLEX subW208 = subW12*subW48*u[71];
COMPLEX subW209 = subW110 + u[58];
COMPLEX subW216 = subW64 + u[31] -u[33];
COMPLEX subW218 = subW122 + subW7;
COMPLEX subW221 = subW127 - 2.*subW4;
COMPLEX subW223 = -4.*subW7*u[31];
COMPLEX subW224 = subW44 + subW46;
COMPLEX subW225 = 2.*subW13*u[12];
COMPLEX subW226 = kTv*subW13;
COMPLEX subW228 = subW69*subW79*u[87];
COMPLEX subW229 = subW110 + u[4];
COMPLEX subW236 = subW79 + kTv*u[29];
COMPLEX subW237 = subW148 + subW149*u[13];
COMPLEX subW238 = subW40 + u[31] -u[34];
COMPLEX subW240 = 2. + subW156*u[17];
COMPLEX subW241 = subW162*subW24;
COMPLEX subW245 = 1. + subW177*u[38];
COMPLEX subW248 = 2. + subW186*u[18];
COMPLEX subW249 = subW190 + 4.*subW75 -u[40];
COMPLEX subW252 = subW204 + subW205;
COMPLEX subW253 = 1. + subW209*u[71];
COMPLEX subW258 = 2. + subW218*u[19];
COMPLEX subW259 = subW226 + subW7*u[30];
COMPLEX subW260 = 1. + subW229*u[87];
COMPLEX subW265 = subW241 + subW164*u[15];
COMPLEX subW268 = subW176 + subW245*u[30];
COMPLEX subW269 = 3. + subW249*u[38];
COMPLEX subW270 = subW208 + subW253*u[30];
COMPLEX subW273 = subW228 + subW260*u[29];
COMPLEX subW276 = -subW160*subW161 + subW265*u[14];
COMPLEX subW277 = subW108 + subW270*u[19];
COMPLEX subW278 = subW138 + subW273*u[19];
COMPLEX subWW1 = u[22]*u[23];
COMPLEX subWW3 = u[33] + u[34];
COMPLEX subWW4 = u[4]*u[19];
COMPLEX subWW5 = -subW16*u[13]*u[14];
COMPLEX subWW6 = subWW1 + kTv*u[30];
u[44] = subW1*subW155*subW2*subW240*subW3*u[12]*u[13]*u[18]*u[30]*u[38];
u[46] = subW159*subW276*u[9]*u[11]*u[12]*u[13]*u[14]*u[17]*u[18]*u[19]*u[20]*u[21];
u[48] = subW2*u[9]*u[11]*u[12]*u[13]*u[18]*u[19]*u[20]*(subW21*(-2.*u[21]*u[30] + 4.*u[17]*(u[30] + subW12*u[21]*u[34])) + 2.*subW20*(-u[21]*u[30] + 2.*u[17]*(u[30] + subW159*u[21]*u[34])) + u[17]*u[21]*(-subW7*(2.*subW169*u[13] + 3.*subW170*u[30]) + 4.*(subW171 + subW159*subW22)*u[34] + 2.*kTv*(u[22]*(subW38*u[12] + subW22*u[23]) + u[16]*(subW162*u[10] + u[11]*(subW13 + subW172*u[30]) - 2.*u[13]*u[28]*u[34]) + u[23]*(subW172*u[12]*u[30] - 2.*u[13]*u[29]*u[34]))));
u[49] = -subW1*subW173*subW2*u[12]*u[13]*u[19]*(u[17]*(2.*u[18] -u[21]) -u[18]*u[21])*u[22]*u[38];
u[50] = subW1*subW174*subW2*subW3*u[12]*u[13]*u[17]*u[18]*u[29]*u[38];
u[51] = subW2*u[11]*u[12]*u[13]*u[17]*u[19]*u[21]*(2.*subW175*(subW268*u[12]*u[18] + (subW155*subW48*u[13]*u[18] + u[12]*u[30])*u[38]) + u[11]*(2.*u[14]*(subW268*u[18]*u[24] + (subW155*subW48*u[18]*u[25] + u[24]*u[30])*u[38]) -subW155*u[30]*(3.*u[38] -u[18]*(3. + u[38]*(4.*subW56 + kTv*(-4.*u[31] - 3.*u[33]) + 3.*u[40])))));
u[52] = subW2*subW92*u[11]*u[12]*u[13]*((subW12 + subW57)*u[11] - 2.*u[8]*u[13]*u[14])*u[17]*u[18]*u[29]*u[38];
u[53] = subW2*u[9]*u[11]*u[12]*u[13]*u[17]*u[18]*u[19]*u[20]*u[21]*(-subW169*u[13] + subW170*u[30]);
u[54] = subW169*subW2*subW58*u[9]*u[11]*u[12]*u[17]*u[18]*u[19]*u[20]*u[21];
u[55] = subW2*u[11]*u[12]*u[13]*u[17]*u[18]*u[19]*u[21]*u[22]*(subW173*u[11] -subW182*u[28])*u[41];
u[56] = subW183*subW276*u[11]*u[12]*u[13]*u[14]*u[17]*u[18]*u[19]*u[21]*u[22]*u[41];
u[59] = u[11]*u[12]*u[13]*u[14]*u[17]*u[18]*u[19]*u[21]*(u[38]*(u[11]*(subW2*(u[25]*u[29] -u[24]*u[30]) + subW79*(-u[14]*u[30] + 2.*subW13*u[27]*u[28]*u[41]) + u[10]*(2.*subW160*subW4*u[27]*u[41] + u[14]*u[16]*(u[29] -subW184*subW4*u[41])) - 2.*subW4*u[14]*u[30]*u[41]*u[57]) - 2.*u[14]*(u[8]*(u[15]*(-subW185*u[14] + subW183*u[16])*u[22]*u[41] -u[12]*(-subW173*u[22]*u[35]*u[41] + u[14]*(u[30] + subW13*subW63*u[41])) + u[13]*(subW173*u[22]*u[39]*u[41] + u[14]*(u[29] -subW4*subW63*u[41]))) + subW4*u[11]*u[30]*u[41]*(u[47] + u[58]))) + u[22]*u[41]*(-2.*u[14]*(u[28]*(subW22 + u[23]*(u[12] + subW31*u[24]*u[38])) + subW28*u[11]*u[38]*u[57]) + u[11]*u[38]*(u[9]*(-subW64*u[14]*u[16]*u[23] + 2.*u[27]*(subW29*u[23] + subW38*u[29])) + subW185*subW2*(u[31] + 3.*u[32] -u[33] -u[34]) + u[14]*(-2.*(subW28*subW56 + u[26]*(u[25]*u[27]*u[28] + u[4]*u[30])) -u[23]*(subW79*(3.*u[31] + u[33]) + 2.*u[29]*u[58])))));
u[63] = subW1*subW174*subW2*subW248*subW3*u[12]*u[13]*u[17]*u[29]*u[38];
u[64] = subW2*u[11]*u[12]*u[13]*u[18]*u[19]*u[21]*(2.*subW175*(subW189*u[13]*u[17]*u[29] + (subW174*subW69*u[12]*u[17] + u[13]*(subW4*subW69*u[17] -u[29]))*u[38]) + u[11]*((subW174 - 2.*subW57)*u[29]*u[38] + u[17]*(subW269*subWW6*u[29] + 2.*(subW189*u[14]*u[25]*u[29] + subW69*(u[22]*(subW17*u[14] + subW87*u[23]) + kTv*u[14]*u[24]*u[30])*u[38]))));
u[65] = subW194*subW276*u[10]*u[11]*u[12]*u[13]*u[14]*u[17]*u[18]*u[19]*u[21]*u[60];
u[66] = subW1*subW155*subW2*subW3*u[12]*u[13]*u[17]*u[18]*u[30]*u[38];
u[67] = -subW2*u[10]*u[11]*u[12]*u[13]*u[17]*u[19]*(2.*subW20*(u[21]*u[29] - 2.*u[18]*(u[29] + subW194*u[21]*u[33])) + subW22*(2.*u[21]*u[29] - 4.*u[18]*(u[29] + subW79*u[21]*u[33])) + u[18]*u[21]*(subW7*(2.*subW195*u[12] + 3.*subW196*u[29]) + (-4.*subW21*subW79 + 4.*subW197*u[22])*u[33] + 2.*kTv*(subW197*u[22] + u[16]*(-subW162*u[9] + 2.*u[12]*u[28]*u[33] + u[11]*(subW4 + u[29]*(2.*subW64 - 2.*u[31] + u[33]))) + u[26]*(2.*u[12]*u[30]*u[33] + u[13]*u[29]*(-2.*u[31] + u[33] + 2.*(u[32] + u[34]))))))*u[60];
u[68] = subW2*u[10]*u[11]*u[12]*u[13]*u[17]*u[18]*u[19]*u[21]*(-subW195*u[12] + subW196*u[29])*u[60];
u[69] = subW2*subW92*u[11]*u[12]*u[13]*((subW79 + subW87)*u[11] - 2.*u[8]*u[12]*u[14])*u[17]*u[18]*u[30]*u[38];
u[70] = subW195*subW2*subW88*u[10]*u[11]*u[13]*u[17]*u[18]*u[19]*u[21]*u[60];
u[73] = subW108*subW198*subW2*subW240*subW88*subW89*u[11]*u[13]*u[19];
u[74] = -subW195*subW2*subW88*u[10]*u[11]*u[13]*(subW92 + subW91*u[17])*u[18]*u[71];
u[75] = subW199*subW2*subW88*subW89*u[11]*u[13]*u[17]*u[19]*u[28]*u[71];
u[76] = subW2*subW92*u[11]*u[12]*(subW200 + (subW13 + subW57)*u[12])*u[13]*u[17]*u[18]*u[28]*u[71];
u[77] = subW2*u[11]*u[12]*u[13]*u[17]*u[18]*u[21]*(2.*subW277*u[8]*u[12]*u[14] + (u[30]*(kTv*(subW95 + subW96) + u[26]*(subW97 + u[10]*u[12]*(1. + u[19]*(kTv*u[32] + 4.*u[47]))) + u[12]*u[19]*(4.*(subW7*u[28]*u[31] + subW45*u[37]) -subW45*u[58])) + u[19]*((subW201 - 2.*subW45*subW7)*u[13]*u[29] + (-4.*kTv*subW202*u[28] + (subW203 - 4.*kTv*subW45)*u[13]*u[29] + 4.*u[10]*(subW252 -kTv*subW20*u[29]))*u[34] + u[10]*(2.*kTv*(subW252 - 2.*subW29*u[12]*u[31]) + subW20*(subW207 + 4.*subW4*u[34])) - 2.*u[28]*(subW202*subW7 + 2.*kTv*u[12]*u[30]*u[37]) + u[30]*((subW7*subW95 + u[11]*(-2.*kTv*subW4 + 2.*subW7*u[29]))*u[32] - 4.*kTv*u[12]*u[28]*u[47] + (kTv*u[12]*u[28] + 2.*u[11]*(subW4 -kTv*u[29]))*u[58])))*u[71] + u[19]*(((subW97 + 3.*u[10]*u[12])*u[26] + kTv*(subW96 - 3.*u[12]*u[28]))*u[30] + 2.*kTv*subW12*subW4*u[11]*u[71]) - 2.*subW79*(subW277*u[11] + subW198*subW48*u[13]*u[19]*u[71]));
u[78] = u[11]*u[12]*u[13]*u[14]*u[17]*u[18]*u[19]*u[21]*(u[14]*(2.*subW87*(-u[13]*u[28] + u[11]*u[30]) + u[12]*(u[14]*(u[25]*u[28] -u[8]*u[30]) + u[23]*(u[22]*u[28] + u[9]*u[30])))*u[71] + u[10]*u[60]*((u[26]*(u[15]*u[24]*(-2.*subW13*u[14] + 2.*subW2*u[25]) + u[12]*(subW2*u[25]*u[31] + 2.*subW27*u[22]*u[35] + u[14]*(-subW13*(subW40 + u[34]) - 2.*u[30]*(subW56 + u[37])))) + u[12]*((-2.*subW17*u[14]*u[29] + 2.*subW85*u[22]*u[30])*u[35] + u[14]*(-3.*subW4*u[23]*u[31] - 2.*subW27*(u[4] + u[37])) + u[26]*(-subW2*u[25]*(u[32] - 3.*u[33] + u[34]) + 2.*subW13*u[29]*u[35] - 2.*u[14]*u[30]*u[40])) + u[16]*(u[9]*(-2.*subW160*subW32 + (subW118 + subW184*u[12])*u[14]*u[23]) + u[14]*(u[8]*(-2.*subW32*u[29] + u[14]*(subW118 + u[12]*(u[31] -u[32] + 3.*u[33] -u[34]))) - 2.*u[12]*u[28]*(u[40] + u[47]))))*u[71] + 2.*u[14]*(u[11]*(-subW29*u[24]*u[27]*u[71] + u[16]*(-u[29] + (subW119 + subW216*u[14])*u[24]*u[71])) -u[13]*(subW27*u[24]*u[39]*u[71] + u[26]*(u[29] + u[24]*(-subW216*u[14] + u[30]*u[39])*u[71])))));
u[81] = subW199*subW2*subW258*subW88*subW89*u[11]*u[13]*u[17]*u[28]*u[71];
u[82] = subW2*u[11]*u[12]*u[13]*u[18]*u[19]*u[21]*((u[30]*(u[17]*(2.*subW7*(subW4*u[11] + u[8]*u[12]*u[14]) + u[11]*(-2.*subW98*u[29] + 4.*(kTv*subW4 -subW7*u[29])*u[32])) + kTv*u[12]*(u[28] + 4.*u[17]*(u[8]*u[14]*u[32] + u[28]*u[37]))) + u[28]*(subW221*u[13] + u[17]*(((subW207 + 2.*kTv*subW4)*u[13] + subW7*u[12]*u[30])*u[34] + u[12]*(u[30]*(subW223 + 4.*kTv*u[47]) + subW57*(subW8 - 2.*u[58])) + (subW221*u[13] -kTv*u[12]*u[30])*u[58])))*u[71] + u[28]*(u[17]*(-2.*subW202 + kTv*(2.*u[13]*u[29] + 3.*u[12]*u[30])) - 2.*subW57*u[12]*u[71]) - 2.*subW79*(kTv*subW108*subW131*u[11]*u[17] + u[13]*u[28]*(-u[71] + u[17]*(-1. + (kTv*u[34] -u[58])*u[71]))) + u[10]*(-2.*subW131*subW196*u[17]*(subW194 + kTv*u[29])*u[71] + u[12]*(2.*subW131*subW17*u[14]*u[17]*u[71] + u[16]*(u[28]*u[71] + u[17]*(2.*subW131*u[8]*u[14]*u[71] + u[28]*(3. + (subW190 + 4.*(u[37] + u[47]) -u[58])*u[71]))))));
u[83] = subW108*subW198*subW2*subW88*subW89*u[11]*u[13]*u[17]*u[19];
u[84] = subW108*subW2*u[11]*u[12]*u[13]*(-2.*subW87*u[11] + u[12]*(-subW44 + u[8]*u[14]))*u[17]*u[18]*u[19]*u[21];
u[85] = subW2*u[11]*u[12]*u[13]*u[17]*u[18]*u[22]*(2.*(2.*subW183*subW20*u[19]*u[21]*u[32] + subW182*(u[21]*u[28] - 2.*u[19]*(u[28] -subW183*u[21]*u[32]))) + u[19]*u[21]*(subW7*(2.*subW173*u[11] + 3.*subW182*u[28]) + 2.*kTv*(subW162*subW183 + (2.*subW28*u[11] + u[26]*(u[13]*u[28] + 2.*u[11]*u[30]))*u[32] + u[28]*(2.*subW22*subWW3 - 2.*subW182*u[31] + subW21*(2.*subWW3 + u[32])))))*u[41];
u[86] = subW1*subW173*subW2*u[12]*u[13]*u[17]*u[18]*u[19]*u[21]*u[22]*u[41];
u[89] = subW132*subW138*subW2*subW224*subW248*subW58*u[11]*u[12]*u[19];
u[90] = subW2*u[11]*u[12]*u[13]*u[17]*u[18]*u[21]*(2.*subW278*u[8]*u[13]*u[14] + ((kTv*subW96 + (kTv*subW96*u[4] + (subW201 - 2.*subW44*subW7)*u[12])*u[19])*u[30] + u[29]*(u[23]*(-2.*(1. + subWW4)*u[11]*u[22] + u[13]*(u[9] -u[9]*u[19]*(u[4] + 4.*kTv*u[31] - 4.*u[37]))) + u[13]*(kTv*((-1. + subWW4)*u[28] + subW44*u[19]*u[32]) + 4.*subW44*u[19]*u[57])) + u[19]*((4.*kTv*(subW13*u[12] -subW87*u[13])*u[28] + (subW203 - 4.*kTv*subW44)*u[12]*u[30] - 4.*u[9]*(subW171 + subWW5 + kTv*subW20*u[30]))*u[33] - 2.*u[9]*(kTv*(subW171 + subWW5) + subW20*(subW7*u[30] + 2.*subW13*u[33])) + u[28]*(subW225*subW7 - 2.*u[13]*(subW7*(subW87 - 2.*u[29]*u[31]) + 2.*kTv*u[29]*u[37])) + u[29]*(2.*subW259*u[11]*u[32] -u[13]*u[28]*(subW7*u[32] + 4.*kTv*u[57]))))*u[87] + u[19]*((-2.*subWW6*u[11] + u[13]*(3.*u[9]*u[23] - 3.*kTv*u[28]))*u[29] - 2.*subW20*subW226*u[9]*u[87]) - 2.*subW12*(subW278*u[11] + subW224*subW69*u[12]*u[19]*u[87]));
u[91] = subW132*subW2*subW236*subW58*u[11]*u[12]*u[18]*u[19]*u[28]*u[87];
u[92] = -subW169*subW2*subW58*u[9]*u[11]*u[12]*u[17]*(subW92 + subW91*u[18])*u[87];
u[93] = subW2*u[11]*u[12]*u[13]*(-2.*subW57*u[12] + (-subW4 + subW87)*u[13])*u[17]*u[18]*u[19]*u[21]*u[28]*u[87];
u[94] = u[11]*u[12]*u[13]*u[14]*u[17]*u[18]*u[19]*u[21]*(u[14]*(2.*subW57*(subW95 + u[11]*u[29]) + u[13]*(u[14]*(u[24]*u[28] -u[8]*u[29]) + u[26]*(-u[22]*u[28] + u[10]*u[29])))*u[87] + u[9]*u[20]*((subW16*subW2*subW237 - 2.*subW159*subW160*subW33 + u[14]*((subW13*subW148 + subW12*(subW148 + subW184*u[13]))*u[26] + subW15*(subW237*u[14] - 2.*subW33*u[30]) + u[13]*(-2.*subW152*(subW27 + u[23]*u[29]) + u[23]*(subW184*subW4 - 2.*u[24]*u[30]*u[39]))))*u[87] + 2.*u[14]*(u[11]*(-subW28*u[25]*u[27]*u[87] + u[16]*(-u[30] + (subW119 + subW238*u[14])*u[25]*u[87])) -u[12]*(subW27*u[25]*u[35]*u[87] + u[23]*(u[30] + u[25]*(-subW238*u[14] + u[29]*u[35])*u[87])))));
u[95] = subW132*subW2*subW236*subW258*subW58*u[11]*u[12]*u[18]*u[28]*u[87];
u[96] = subW2*u[11]*u[12]*u[13]*u[17]*u[19]*u[21]*((u[18]*((subW96*subW98 + 2.*kTv*u[4]*u[12]*u[28])*u[30] + 4.*kTv*u[8]*u[13]*u[14]*u[29]*u[32] + u[28]*(u[13]*(2.*kTv*subW87 + subW7*u[29]) - 2.*subW7*u[12]*u[30])*u[33]) + u[29]*(u[18]*(subW46*u[4]*u[13] + subW7*(-2.*subW13*u[11] + 2.*u[8]*u[13]*u[14]) - 4.*subW259*u[11]*u[32]) + u[13]*u[28]*(kTv + u[18]*(subW223 + 4.*kTv*u[37]))) + u[28]*(2.*kTv*u[12]*u[30] - 2.*(subW87*u[13] + subW226*u[12]*u[18]*u[33]) + u[18]*((subW200 + subW225)*u[4] + 4.*kTv*u[13]*u[29]*u[57])))*u[87] + u[28]*(u[18]*(2.*subW174*u[12] + u[13]*(-2.*subW87 + 3.*kTv*u[29])) + subW225*u[87]) - 2.*subW12*(subW131*subW236*u[11]*u[18]*u[87] + u[12]*(-u[28]*u[87] + u[18]*(subW131*subW44*u[87] + u[28]*(-1. + (-u[4] + kTv*u[33])*u[87])))) + u[9]*(-2.*subW131*subW170*subW174*u[18]*u[87] + u[13]*(2.*subW131*subW16*u[14]*u[18]*u[87] + u[16]*(u[28]*u[87] + u[18]*(2.*subW131*u[8]*u[14]*u[87] + u[28]*(3. + (-u[4] + kTv*(-4.*u[31] + u[33]) + 4.*(u[37] + u[57]))*u[87]))))));
u[97] = subW132*subW138*subW2*subW224*subW58*u[11]*u[12]*u[18]*u[19];
u[98] = subW138*subW2*u[11]*u[12]*u[13]*u[17]*u[18]*u[19]*u[21]*(-subW22*u[10] + u[14]*(u[8]*u[13] - 2.*u[11]*u[25]));
COMPLEX subA1 = -u[43]*u[44];
COMPLEX subA2 = u[46] + u[56];
COMPLEX subA4 = -u[62]*u[63];
COMPLEX subA7 = u[46] + u[65];
COMPLEX subA9 = -u[72]*u[73];
COMPLEX subA10 = u[43]*u[44];
COMPLEX subA11 = -u[72]*u[75];
COMPLEX subA12 = u[72]*u[73];
COMPLEX subA15 = u[80]*u[82];
COMPLEX subA16 = u[80]*u[81];
COMPLEX subA19 = u[80]*u[85];
COMPLEX subA20 = u[62]*u[64];
COMPLEX subA21 = u[62]*u[90];
COMPLEX subA22 = -u[62]*u[89];
COMPLEX subA25 = u[88]*u[91];
COMPLEX subA26 = u[80]*u[88]*u[95];
COMPLEX subA27 = -u[88]*u[97];
COMPLEX subA28 = u[80]*u[96];
COMPLEX subA29 = -4.*subA2*u[45];
COMPLEX subA30 = subA4 + u[49] + u[66];
COMPLEX subA32 = 4.*subA7*u[45];
COMPLEX subA33 = subA12 - 2.*u[51] - 2.*u[77];
COMPLEX subA35 = subA16 -u[74] -u[83];
COMPLEX subA37 = subA22 + u[91] + u[92];
COMPLEX subA39 = -subA30*u[42];


COMPLEX amp12345 = 0.03125*(subA29 + u[42]*(subA1 + u[49] + u[50]) + u[43]*(-2.*u[48] + 2.*u[51]) + u[52] + 2.*u[54] - 2.*(u[53] + u[55]) -u[59]);

COMPLEX amp12435 = 0.03125*(subA32 - 2.*u[54] + 2.*(u[53] + u[68]) + u[72]*(u[74] + u[75]) + u[76] + u[43]*(subA9 + 2.*(u[48] + u[77])) -u[78]);

COMPLEX amp12534 = 0.03125*(subA32 + 2.*(subA21 + u[53] + u[62]*u[67] + u[68]) - 2.*u[70] + subA37*u[88] -u[93] -u[94]);

COMPLEX amp13245 = 0.03125*(subA11 + 2.*subA15 - 2.*subA19 + subA33*u[43] + u[42]*(subA10 -u[49] -u[50]) -u[52] + u[59] -subA16*u[72] -u[76] + u[72]*u[83] + u[84] - 2.*u[86]);

COMPLEX amp13425 = 0.03125*(subA26 + subA27 - 2.*(subA15 + subA28 + u[54]) + u[76] + u[43]*(subA9 + 2.*u[48] + 2.*u[77]) + u[72]*(subA16 + u[75] -u[83]) -u[84] -u[88]*u[92] + u[94] -u[98]);

COMPLEX amp13524 = 0.03125*(subA25 + subA26 + subA27 - 2.*(subA15 + subA28 + u[70]) + subA35*u[72] + u[78] -u[84] + u[62]*(2.*u[67] -u[88]*u[89] + 2.*u[90]) -u[93] -u[98]);

COMPLEX amp14235 = 0.03125*(subA11 + 2.*subA20 + subA33*u[43] -u[52] + u[42]*(subA10 + subA4 -u[50] + u[66]) + 2.*u[62]*u[67] -u[69] - 2.*u[70] -u[72]*u[74] -u[76] + u[78]);

COMPLEX amp14325 = 0.03125*(-2.*(subA20 + u[43]*(u[48] -u[51])) + u[52] + 2.*(subA21 + u[54]) + u[42]*(subA1 + u[50] + u[62]*u[63] -u[66]) + u[69] + subA37*u[88] -u[93] -u[94]);

COMPLEX amp14523 = 0.03125*(-2.*(subA19 + subA20) + 2.*subA21 + subA25 + subA26 + subA27 - 2.*subA28 + subA39 + u[59] + u[69] - 2.*u[86] + subA22*u[88] -u[93] -u[98]);

COMPLEX amp12354 = 0.03125*(subA39 + u[59] + u[45]*(4.*u[56] - 4.*u[65]) - 2.*(u[62]*(u[64] + u[67]) + u[68]) + u[69] + 2.*(u[55] + u[70]));

COMPLEX amp12453 = 0.03125*(4.*u[45]*(u[56] -u[65]) - 2.*(subA15 + u[68]) + subA35*u[72] + u[78] -u[84] + 2.*(subA19 + u[55] + u[86]));

COMPLEX amp12543 = 0.03125*(subA29 + u[94] - 2.*(u[53] + u[55] + u[86] + u[80]*(u[85] + u[96])) + u[88]*(-u[92] + u[80]*u[95] -u[97]) -u[98]);

delete [] u;

// color factors are included below, without averaging

return 2.*27.*8./32.*(norm(amp12345) +norm(amp12435) +norm(amp12534) +norm(amp13245) +norm(amp13425) +norm(amp13524)
+norm(amp14235) +norm(amp14325) +norm(amp14523) +norm(amp12354) +norm(amp12453) +norm(amp12543) );


}
