//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->ggg for helicities LLLR *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGGGG_LLLR() {
int Nsymb =106;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k1,k1);
u[2] = Dot(k1,k2);
u[3] = Dot(k2,n);
u[4] = Dot(k3,n);
u[5] = Dot(k4,k5);
u[6] = Dot(k4,n);
u[7] = S(L,k3,k4);
u[8] = S(L,k3,n);
u[9] = S(L,k4,n);
u[10] = S(R,k2,n);
u[11] = S(R,k2,n,e1);
u[12] = S(R,k4,n);
u[13] = S(R,k5,n);
u[14] = Den(u[6]);
u[15] = Den(u[5]);
u[16] = Den(u[4]);
u[17] = Den(u[3]);
u[18] = Dot(e1,k2);
u[19] = Dot(k5,n);
u[20] = Dot(k3,k4);
u[21] = Den(u[19]);
u[22] = S(R,k2,k3);
u[23] = S(R,k3,n);
u[24] = Den(u[20]);
u[25] = S(R,k3,k5);
u[26] = S(L,k3,k5);
u[27] = S(R,k2,k4);
u[28] = S(R,k4,k5);
u[29] = Dot(e1,k3);
u[30] = S(L,k4,k5);
u[31] = S(R,k5,n,e1);
u[32] = Dot(e1,k4);
u[33] = Den(u[3] -u[4]);
u[34] = Den(u[1] + 2.*u[2]);
u[36] = S(R,n,k3,e1);
u[37] = Dot(e1,k5);
u[38] = S(R,n,k4,e1);
u[39] = Dot(k1,k5);
u[40] = Dot(k2,k3);
u[41] = Den(u[40]);
u[43] = Den(u[1] -2.*u[39]);
u[45] = S(L,k5,n);
u[46] = S(R,k2,k5);
u[47] = Dot(k3,k5);
u[50] = S(L,k2,n);
u[54] = S(L,k2,k3);
u[55] = S(L,k2,k4);
u[61] = Dot(k2,k4);
u[62] = Dot(k2,k5);
u[65] = Den(u[47]);
u[66] = Den(u[4] + u[19]);
u[68] = Dot(k1,k4);
u[69] = Den(u[1] -2.*u[68]);
u[81] = Den(u[61]);
u[82] = Den(u[3] -u[6]);
u[91] = Dot(k1,k3);
u[92] = Den(u[1] -2.*u[91]);
u[101] = Den(u[62]);
COMPLEX subW1 = pow2(u[9]);
COMPLEX subW2 = pow2(u[13]);
COMPLEX subW3 = pow2(kTv);
COMPLEX subW4 = -2.*kTv*u[18];
COMPLEX subW8 = u[14] -u[21];
COMPLEX subW9 = 2.*kTv - 4.*u[18];
COMPLEX subW10 = u[7]*u[12];
COMPLEX subW11 = u[13]*u[26];
COMPLEX subW14 = u[9]*u[12];
COMPLEX subW15 = u[8]*u[23];
COMPLEX subW17 = u[13]*u[22];
COMPLEX subW18 = u[10]*u[25];
COMPLEX subW21 = u[13]*u[27];
COMPLEX subW22 = u[10]*u[28];
COMPLEX subW25 = u[29] + u[32] + u[37];
COMPLEX subW26 = pow2(u[8]);
COMPLEX subW27 = pow2(u[10]);
COMPLEX subW28 = u[16] + u[17];
COMPLEX subW29 = 2.*kTv*u[37];
COMPLEX subW33 = 4.*u[9]*u[37];
COMPLEX subW34 = 2.*u[21]*u[31];
COMPLEX subW35 = u[8]*u[22];
COMPLEX subW36 = u[9]*u[27];
COMPLEX subW37 = -u[45]*u[46];
COMPLEX subW38 = u[11]*u[13];
COMPLEX subW45 = u[29] + u[32];
COMPLEX subW46 = pow3(kTv);
COMPLEX subW49 = u[10]*u[32];
COMPLEX subW50 = u[27]*u[38];
COMPLEX subW51 = u[13]*u[30];
COMPLEX subW52 = -2.*u[37]*u[38];
COMPLEX subW54 = 4.*u[29] + u[32];
COMPLEX subW55 = u[26]*u[31];
COMPLEX subW56 = u[5]*u[41];
COMPLEX subW58 = u[20] + u[47];
COMPLEX subW62 = -2.*u[36]*u[37];
COMPLEX subW64 = 2.*u[36]*u[37];
COMPLEX subW66 = -2.*u[11]*u[37];
COMPLEX subW67 = u[45]*u[46];
COMPLEX subW69 = 2.*u[7]*u[23]*u[32];
COMPLEX subW70 = u[18] -u[29];
COMPLEX subW72 = u[46]*u[50];
COMPLEX subW73 = u[17]*u[19];
COMPLEX subW75 = u[32] + u[37];
COMPLEX subW78 = u[17] - 2.*u[21];
COMPLEX subW79 = u[17]*u[21];
COMPLEX subW80 = u[21]*u[41];
COMPLEX subW81 = -u[14] + u[21];
COMPLEX subW82 = u[18] + u[29];
COMPLEX subW84 = -u[22]*u[36];
COMPLEX subW87 = u[32] -u[37];
COMPLEX subW90 = u[17] + 3.*u[21];
COMPLEX subW96 = u[17] -u[21];
COMPLEX subW102 = u[15]*u[25]*u[30]*u[36];
COMPLEX subW104 = 2.*u[27]*u[30];
COMPLEX subW105 = u[22]*u[26];
COMPLEX subW107 = -u[20] + u[47];
COMPLEX subW108 = u[17] + u[21];
COMPLEX subW113 = -2.*u[13]*u[37];
COMPLEX subW114 = u[28]*u[38];
COMPLEX subW117 = -u[25]*u[36];
COMPLEX subW120 = u[29] + u[37];
COMPLEX subW122 = u[20] -u[47];
COMPLEX subW126 = u[27]*u[30]*u[31];
COMPLEX subW128 = 3.*u[17] + u[21];
COMPLEX subW129 = u[23]*u[28]*u[36];
COMPLEX subW142 = -2.*u[22]*u[36];
COMPLEX subW151 = u[16] -u[21];
COMPLEX subW152 = -u[7]*u[23];
COMPLEX subW154 = 2.*kTv*u[32];
COMPLEX subW158 = u[9]*u[10];
COMPLEX subW159 = u[11]*u[38];
COMPLEX subW167 = -2.*u[32]*u[36];
COMPLEX subW170 = u[37]*u[38];
COMPLEX subW172 = -4.*u[18] + u[37];
COMPLEX subW173 = u[38]*u[41];
COMPLEX subW179 = u[13]*u[45];
COMPLEX subW180 = -u[10]*u[50];
COMPLEX subW187 = 2.*u[17] + u[21];
COMPLEX subW190 = u[27]*u[30];
COMPLEX subW192 = -u[16] + u[21];
COMPLEX subW194 = u[21]*u[65];
COMPLEX subW195 = u[5] -u[20];
COMPLEX subW199 = u[25]*u[36];
COMPLEX subW200 = u[29] -u[37];
COMPLEX subW205 = u[7]*u[13]*u[23];
COMPLEX subW210 = u[10]*u[55];
COMPLEX subW211 = u[7]*u[23];
COMPLEX subW216 = -u[10]*u[31];
COMPLEX subW226 = u[12]*u[25]*u[38];
COMPLEX subW231 = u[23]*u[36];
COMPLEX subW232 = u[12]*u[38];
COMPLEX subW234 = 2.*u[13]*u[29];
COMPLEX subW236 = 2.*u[13]*u[32];
COMPLEX subW238 = u[14] + u[17];
COMPLEX subW239 = u[18] -u[32];
COMPLEX subW243 = 2.*u[8]*u[30];
COMPLEX subW244 = u[29]*u[37];
COMPLEX subW245 = u[47]*u[81];
COMPLEX subW247 = u[31]*u[36]*u[81];
COMPLEX subW248 = u[40] + u[62];
COMPLEX subW252 = -2.*u[65]*u[81];
COMPLEX subW253 = u[65] + u[81];
COMPLEX subW256 = u[18] + u[32];
COMPLEX subW260 = 2.*kTv*u[29];
COMPLEX subW264 = u[8]*u[10];
COMPLEX subW265 = u[11]*u[36];
COMPLEX subW267 = 2.*u[29]*u[38];
COMPLEX subW269 = u[36]*u[37];
COMPLEX subW271 = -u[36]*u[81];
COMPLEX subW273 = u[10]*u[54];
COMPLEX subW280 = u[15]*u[21];
COMPLEX subW290 = u[20]*u[38];
COMPLEX subW294 = u[22]*u[36];
COMPLEX subW295 = u[25]*u[27];
COMPLEX subW296 = u[22]*u[28];
COMPLEX subW299 = u[10]*u[50];
COMPLEX subW301 = u[28]*u[45];
COMPLEX subW302 = u[27]*u[50];
COMPLEX subW310 = -2.*u[10]*u[29];
COMPLEX subW313 = u[20]*u[36];
COMPLEX subW317 = subW10 + subW11;
COMPLEX subW319 = subW3 + subW4;
COMPLEX subW322 = subW14 + subW15;
COMPLEX subW323 = subW17 + subW18;
COMPLEX subW325 = subW21 + subW22;
COMPLEX subW327 = subW29 + subW3;
COMPLEX subW330 = subW17 + 2.*subW18;
COMPLEX subW332 = subW21 + 2.*subW22;
COMPLEX subW334 = -2.*subW18*subW26*u[38];
COMPLEX subW335 = subW51 + subW52;
COMPLEX subW336 = 4.*subW58 + u[5];
COMPLEX subW339 = 1. + subW56;
COMPLEX subW340 = -subW11 + subW64;
COMPLEX subW341 = subW66 + subW67;
COMPLEX subW342 = 2.*subW70*u[9]*u[13];
COMPLEX subW343 = -2. + subW73;
COMPLEX subW344 = subW36 + subW67;
COMPLEX subW346 = subW84 + subW82*u[10];
COMPLEX subW348 = -subW79*u[16];
COMPLEX subW349 = 4.*subW22*u[14]*u[16]*u[21];
COMPLEX subW350 = subW113 + subW114;
COMPLEX subW353 = subW114*subW67;
COMPLEX subW354 = -3.*subW96*u[16];
COMPLEX subW358 = -subW128*u[16];
COMPLEX subW362 = -subW79 + subW96*u[16];
COMPLEX subW365 = -3.*subW79*u[16];
COMPLEX subW366 = subW79 + subW90*u[16];
COMPLEX subW369 = subW79 + subW96*u[16];
COMPLEX subW371 = subW104 + subW105;
COMPLEX subW372 = subW102 + u[38];
COMPLEX subW373 = -subW114*u[26];
COMPLEX subW374 = 2.*subW75*u[13];
COMPLEX subW376 = 2.*subW67*u[29];
COMPLEX subW378 = subW25 + 3.*u[18];
COMPLEX subW381 = subW70 -u[32] + 3.*u[37];
COMPLEX subW382 = subW122 -u[61] + u[62];
COMPLEX subW383 = subW75 -u[18] - 3.*u[29];
COMPLEX subW384 = subW120 -u[18] - 3.*u[32];
COMPLEX subW385 = subW152 + subW51;
COMPLEX subW386 = subW154 + subW3;
COMPLEX subW389 = subW158 + subW159;
COMPLEX subW390 = subW35 + subW67;
COMPLEX subW392 = subW10*subW37*u[13];
COMPLEX subW393 = subW22*u[13] + subW2*u[27];
COMPLEX subW395 = subW67*u[13]*u[36];
COMPLEX subW396 = subW10 + subW167;
COMPLEX subW397 = subW170 + subW51;
COMPLEX subW398 = subW179 + subW180;
COMPLEX subW400 = -2.*subW51*u[32]*u[41];
COMPLEX subW404 = subW79 + subW108*u[16];
COMPLEX subW405 = subW17 + 4.*subW18;
COMPLEX subW407 = -3.*subW2*u[22]*u[30];
COMPLEX subW408 = 2.*subW105 + subW190;
COMPLEX subW409 = 1. + subW195*u[65];
COMPLEX subW410 = subW199 + subW200*u[13];
COMPLEX subW413 = subW205 + subW2*u[30];
COMPLEX subW414 = subW120 -u[18];
COMPLEX subW415 = subW211 -subW51;
COMPLEX subW417 = subW216 + subW38;
COMPLEX subW420 = -3.*subW79 + subW96*u[16];
COMPLEX subW423 = subW113 + subW199;
COMPLEX subW426 = subW199*u[30] + subW195*u[38];
COMPLEX subW427 = subW231 + subW232;
COMPLEX subW428 = subW199 + subW234;
COMPLEX subW429 = subW114 + subW236;
COMPLEX subW430 = 2.*subW239*u[8]*u[13];
COMPLEX subW431 = 2.*subW27*u[9]*u[31]*u[54];
COMPLEX subW432 = subW11 + subW62;
COMPLEX subW433 = 1. + subW245;
COMPLEX subW434 = 4.*subW248 -u[47];
COMPLEX subW437 = subW252 + subW253*u[21];
COMPLEX subW438 = -subW50 + subW256*u[10];
COMPLEX subW439 = 2.*subW27*u[25];
COMPLEX subW440 = subW260 + subW3;
COMPLEX subW443 = subW264 + subW265;
COMPLEX subW444 = subW11 + subW269;
COMPLEX subW445 = subW211 + subW267;
COMPLEX subW446 = -2.*subW11*u[29]*u[81];
COMPLEX subW449 = subW21 + 4.*subW22;
COMPLEX subW451 = subW114 + subW87*u[13];
COMPLEX subW452 = subW2*u[11]*u[26];
COMPLEX subW453 = subW75 -u[18];
COMPLEX subW455 = -2.*subW49 + subW50;
COMPLEX subW458 = subW290 + subW69;
COMPLEX subW461 = subW295 + subW296;
COMPLEX subW462 = -subW179 + subW299;
COMPLEX subW463 = subW301 + subW302;
COMPLEX subW464 = subW45 + u[18] -u[37];
COMPLEX subW469 = subW294 + subW310;
COMPLEX subW470 = -2.*subW10*u[29];
COMPLEX subW474 = -2. + subW319*u[17];
COMPLEX subW475 = 2. + subW327*u[21];
COMPLEX subW476 = -3. + subW336*u[41];
COMPLEX subW477 = -subW344*u[36];
COMPLEX subW478 = 2.*subW346*u[9]*u[13];
COMPLEX subW479 = subW129 + subW350*u[12];
COMPLEX subW480 = subW354 + subW79;
COMPLEX subW483 = subW358 + subW79;
COMPLEX subW486 = subW362*u[14] + subW79*u[16];
COMPLEX subW487 = subW365 + subW366*u[14];
COMPLEX subW488 = subW117 + subW374;
COMPLEX subW489 = subW376 + subW55*u[22];
COMPLEX subW490 = subW142 + subW378*u[10];
COMPLEX subW491 = 2. + subW386*u[14];
COMPLEX subW492 = subW400 + subW339*u[38];
COMPLEX subW495 = subW211*subW405;
COMPLEX subW496 = subW410*u[8] + subW11*u[31];
COMPLEX subW497 = subW348 + subW404*u[14];
COMPLEX subW498 = subW420*u[14] + subW79*u[16];
COMPLEX subW499 = subW226 + subW423*u[23];
COMPLEX subW500 = 3. + subW434*u[81];
COMPLEX subW501 = 2. + subW440*u[16];
COMPLEX subW502 = -subW371*u[13];
COMPLEX subW504 = subW429*subW67;
COMPLEX subW505 = subW455*u[9]*u[28];
COMPLEX subW507 = u[38] + subW458*u[101];
COMPLEX subW508 = -subW464*subW72*u[101];
COMPLEX subW512 = subW313 + subW470;
COMPLEX subW515 = subW480*u[14] + subW79*u[16];
COMPLEX subW516 = subW483*u[14] + subW79*u[16];
COMPLEX subW517 = subW173 + subW492*u[21];
COMPLEX subW518 = subW502 + subW10*u[22];
COMPLEX subW519 = subW504 + subW505;
COMPLEX subW520 = subW508 + u[31];
COMPLEX subW523 = u[36] + subW512*u[101];
COMPLEX subW524 = -subW38 + subW520*u[10];
COMPLEX subWW1 = -u[14] + u[17];
COMPLEX subWW2 = u[17] - 2.*u[21];
COMPLEX subWW4 = u[17]*u[21];
COMPLEX subWW6 = 2.*subW17 + subW18;
COMPLEX subWW7 = -subW2*u[11]*u[26];
COMPLEX subWW8 = u[13]*u[26];
COMPLEX subWW9 = -2.*u[10]*u[31];
COMPLEX subWW11 = kTv*u[31]*u[36];
COMPLEX subWW12 = -4.*u[18] + u[29];
COMPLEX subWW13 = 2.*u[8]*u[25]*u[37];
COMPLEX subWW14 = u[31]*u[47];
COMPLEX subWW16 = 2.*u[11]*u[29];
COMPLEX subWW17 = subWW4 + subWW2*u[14];
COMPLEX subWW18 = subW38 + subWW9;
COMPLEX subWW19 = subWW13 + subWW14;
u[35] = subW1*subW2*subW264*subW474*subW8*(subW264*subW9 + subW317*u[11])*u[15]*u[16];
u[42] = subW158*subW322*u[7]*u[8]*u[13]*u[14]*u[16]*(2.*subW79*(subW323*u[8] + subW325*u[9])*(kTv - 2.*u[18]) + subW38*(-2.*u[21] + u[17]*(4. + (3.*subW3 + kTv*(4.*subW25 - 2.*u[18]))*u[21])))*u[24];
u[44] = -subW26*subW27*subW28*subW475*u[9]*u[13]*u[14]*(u[13]*(subW33 -u[30]*u[31]) + kTv*(2.*u[9]*u[13] + u[31]*u[38]))*u[41];
u[48] = subW158*subW322*u[7]*u[8]*u[13]*u[14]*u[16]*u[24]*(subW79*(subW3*(subW38 - 3.*u[10]*u[31]) + kTv*(subW330*u[8] + subW332*u[9] + subWW9*(2.*subW45 - 2.*u[18] + u[37]) + u[13]*(subW37 + 2.*u[11]*u[37]))) + 2.*((subW35 + subW36 + subW37)*subW79*u[13]*u[37] + u[10]*(subW34 + u[17]*(-u[31] + 2.*u[21]*(u[8]*u[25] + u[9]*u[28])*u[37]))));
u[49] = subW158*u[8]*u[13]*u[16]*u[17]*(2.*u[7]*(subW14*(subW113*subW67*u[14]*u[21] + u[10]*(subW34 + u[14]*(u[31] + 2.*u[9]*u[21]*u[28]*u[37])))*u[41] + subW15*u[10]*u[21]*(u[31]*u[41] + u[14]*(u[31] + (u[5]*u[31] + 2.*u[9]*u[28]*u[37])*u[41]))) + u[21]*(u[14]*(-2.*subW38*subW46*u[8]*u[38] + subW3*(subW334 + u[9]*(subW10*(2.*subW38 + u[10]*u[31]) + 2.*(-subW325*u[9] + subW49*u[31])*u[36]) + u[8]*(2.*((subW49 + subW50)*u[9] + subW335*u[11])*u[13] + (2.*subW67*u[13] + subW54*u[10]*u[31])*u[38])))*u[41] + u[13]*(4.*subW1*subW325*u[14]*u[26]*u[37]*u[41] + u[8]*u[30]*(subW476*u[10]*u[14]*u[31] -(4.*subW67*u[13]*u[14]*u[37] + u[10]*(u[31] - 4.*u[8]*u[14]*u[25]*u[37]))*u[41]) + 2.*u[9]*(-2.*subW21*u[8]*u[14]*u[30]*u[37]*u[41] + u[10]*((subW55 + 2.*u[8]*u[37])*u[41] + u[14]*(subW339*subW55 - 2.*u[8]*u[37]*(1. + (u[5] + 2.*u[20])*u[41]))))) + kTv*(2.*subW18*subW26*subW335*u[14]*u[41] - 2.*u[9]*((subW10*subW341 + subW340*subW36)*u[13]*u[14]*u[41] + u[10]*(u[31]*u[36]*u[41] + u[14]*(-(subW317 + subW62)*u[9]*u[28]*u[41] + u[31]*(subW339*u[36] + (subW11*u[32] -subW10*u[37])*u[41])))) -u[8]*(u[10]*u[31]*(-subW173 + u[14]*(subW476*u[38] + (subW51*subW54 + subW69)*u[41])) + 2.*(u[13]*u[14]*(subW335*subW67 - 2.*subW38*u[30]*u[37])*u[41] + u[9]*(subW21*subW335*u[14]*u[41] + u[10]*(subW152*u[14]*u[28]*u[41] + u[13]*(-u[41] + u[14]*(1. + (u[5] + 2.*u[20] - 2.*u[32]*u[37])*u[41])))))))));
u[51] = subW26*subW27*subW28*subW80*u[9]*u[13]*u[14]*(subW342 + (subW72 -u[8]*u[25])*u[38]);
u[52] = kTv*subW1*subW2*subW26*subW27*u[16]*(subW343*u[14] + (2. -u[6]*u[17])*u[21])*(-2.*u[41] + u[15]*(-2. + (subW3 + 2.*kTv*subW75)*u[41]));
u[53] = subW1*subW2*subW264*(subW477 + 2.*subW264*subW75)*subW8*u[15]*u[16]*u[17];
u[56] = subW158*u[8]*u[13]*u[16]*(u[15]*(u[17]*(u[13]*(subW1*subW81*u[27]*u[36] - 2.*subW158*u[8]*u[21]*u[37]) + u[9]*(subW452*subW8 + u[13]*(subW10*subW8*u[11] + subW37*u[14]*u[36] + 2.*subW264*(u[21]*(2.*u[18] -u[32]) + u[14]*(-2.*u[18] + u[32] + u[37]))))) + u[9]*u[13]*u[21]*(subW67*u[17]*u[36] + subW264*subW46*subWW1*u[41])) + subW264*((subW114*subWW17*u[9] + u[13]*((subW79 + subW78*u[14])*u[30]*u[31] + 2.*u[9]*(subW3*subW75*subWW1*u[15]*u[21] + subWW17*(u[32] -u[37]))))*u[41] + 2.*kTv*u[9]*u[13]*(-subW79*u[41] + u[15]*(subW80 + u[17]*(-2.*u[21] + u[41])) + u[14]*(subW80 + u[15]*(subW108 + (-3. + subW73)*u[41])))));
u[57] = subW158*subW79*u[8]*u[13]*u[14]*u[16]*u[41]*(subW26*subWW6*u[38] + u[8]*(subW478 + subW72*u[10]*u[38]) + 2.*subW158*subW38*u[54]);
u[58] = subW27*subW322*subW79*u[7]*u[8]*u[9]*u[13]*u[14]*u[16]*u[24]*u[31];
u[59] = subW158*subW2*subW322*subW79*u[7]*u[8]*u[11]*u[14]*u[16]*u[24];
u[60] = subW158*subW79*u[8]*u[13]*u[14]*u[15]*u[16]*(2.*subW264*(subW114*u[9] + u[13]*(subW87*u[9] + u[30]*u[31])) + u[9]*(-subW332*u[9] + subW67*u[13])*u[36]);
u[63] = -subW158*u[8]*u[13]*u[17]*(u[7]*(u[15]*(subW1*(kTv*u[12]*(subW349 + subW21*(subW348 + u[14]*(-subW79 + subW128*u[16]))) + 4.*u[14]*u[16]*u[21]*(2.*subW22*subW25*u[12] -subW479*u[27])) + 4.*subW51*(-subW35 + subW37 + kTv*u[11])*u[12]*u[14]*u[16]*u[21]*u[31]) -u[9]*(u[15]*(kTv*(u[12]*(subW17*subW516*u[8] + subW515*subW67*u[13]) - 4.*subW22*u[8]*u[14]*u[16]*u[21]*u[23]) + 4.*u[14]*u[16]*u[21]*(subW129*subW67 + u[12]*(subW353 + (subW126 + 2.*subW45*subW67)*u[13]) + u[8]*(subW479*u[22] - 2.*subW22*subW25*u[23]))) + u[11]*(-4.*kTv*subW129*subW280*u[14]*u[16] + u[12]*(-4.*kTv*subW114*subW280*u[14]*u[16] + u[13]*(subW3*subW348*u[15] + u[14]*(-2.*u[16]*u[21] + u[15]*(-subW3*subW79 + u[16]*(8. + subW128*subW3 + u[21]*(-2.*subW58 + 8.*kTv*u[37]))))))))) + u[13]*(-subW3*subW38*u[15]*(subW243*subW486 + subW487*u[9]*u[26]) + kTv*(u[8]*(2.*subW486*subW51*subW67*u[15] + 4.*subW372*u[11]*u[14]*u[16]*u[21] + u[9]*(u[13]*u[15]*((subW104 - 3.*subW105)*subW79*u[16] + u[14]*((subW105 - 2.*subW190)*subW79 + subW371*subW96*u[16])) + 4.*u[10]*u[14]*(1. + subW107*u[15])*u[16]*u[21])) + u[15]*(2.*subW26*(subW17*(subW79*u[16] + u[14]*(-subW79 + subW108*u[16])) + 2.*subW18*u[14]*u[16]*u[21])*u[30] + u[26]*(subW1*(subW349 + subW21*subW487) + 4.*subW38*u[14]*u[16]*u[21]*u[30]*u[31]) + u[9]*(subW11*subW67*(subW365 + subW369*u[14]) + 4.*u[11]*u[14]*u[16]*u[21]*(subW350*u[26] + subW107*u[36])))) + 2.*u[14]*u[16]*(-u[9]*(2.*u[21]*(u[15]*(subW11*(subW126 + 2.*subW67*u[32]) + subW67*(subW114*u[26] + subW107*u[36])) + u[8]*(subW50 + 2.*subW25*u[10]*(-1. + subW122*u[15]) + u[15]*(subW105*subW114 + 2.*u[13]*(subW190*u[29] + subW105*u[32]) + (subW107*u[22] + subW190*u[25])*u[36]))) + subW11*u[11]*(-3.*u[21] + u[15]*(4. + u[21]*(subW58 - 4.*u[40])))) + 2.*u[21]*(u[15]*(subW11*subW37*u[30]*u[31] + subW1*(2.*(subW120*subW21 + subW22*subW25)*u[26] + u[27]*(subW373 + subW122*u[36]))) + subW26*(2.*subW18*subW25*u[15]*u[30] + u[22]*(subW488*u[15]*u[30] -u[38])) + u[8]*(subW37*subW372 -subW489*subW51*u[15] + subW38*u[30]*(-1. + u[15]*(subW58 - 2.*u[40])))))));
u[64] = subW158*subW348*u[8]*u[13]*u[14]*(u[7]*(u[8]*(u[10]*u[23] - 2.*subW17*u[12]*u[15]*u[30])*u[31]*u[41] + u[9]*u[15]*(u[8]*(u[12]*(-2.*subW114 + subW381*u[13])*u[22] + subW490*u[23]*u[28])*u[41] + u[11]*(-u[12]*u[13] + 2.*subW22*u[23]*u[41]*u[54]))) + u[15]*(subW1*(subW21*(u[36] + subW273*(subW45 -u[18] - 3.*u[37])*u[41]) + 2.*subW22*(u[36] + (subW50 -(subW70 + subW75)*u[10])*u[41]*u[54])) + u[30]*(subW2*(-2.*u[8]*u[11] + 2.*subW26*u[18]*u[22]*u[41]) + u[10]*u[13]*u[41]*(u[46]*(-u[8]*u[18]*u[50] + 2.*u[31]*u[45]*u[54]) + 2.*u[8]*u[31]*u[61]))) + u[41]*(-subW26*subWW6*u[38] + u[8]*(subW72*(subW51*(2.*subW294 + subW75*u[10])*u[15] -u[10]*u[38]) + 2.*subW18*subW38*u[15]*u[30]*u[54] + subW27*u[31]*u[55]) + u[15]*u[30]*(-2.*subW273*subW38*subW72 + 2.*subW2*(subW26*u[22]*(subW75 -u[29]) -subW105*u[8]*u[31]) + u[13]*(subW26*subW490*u[25] + u[8]*u[10]*(-3.*subW72*u[29] + 2.*u[31]*(subW58 + u[62]))))) + u[9]*(u[15]*(u[13]*(subW37*u[36] + subW104*subW273*u[31]*u[41]) + u[11]*(subW2*u[26] - 2.*u[41]*u[54]*(subW382*u[10]*u[13] + subW27*u[28]*u[55]))) + u[41]*((-2.*subW27*u[31] + subW67*u[10]*u[15]*(2.*subW114 + u[13]*(subW70 + 3.*u[32] -u[37])))*u[54] + u[8]*u[15]*(subW17*(subW11*subW384 + 2.*(subW373 + subW382*u[36])) + subW27*subW383*u[28]*u[55] + u[10]*(u[13]*(u[20]*(-u[29] + u[32] - 3.*u[37]) + (subW200 + 3.*u[32])*u[47] + (3.*u[29] + u[32] - 3.*u[37])*u[61] + u[18]*(-3.*u[20] + 3.*u[47] + u[61] -u[62]) -(3.*u[29] - 3.*u[32] + u[37])*u[62]) + 2.*u[28]*(subW294*u[55] + u[38]*(subW58 + u[61] + u[62])))))));
u[67] = -subW151*subW158*subW2*subW26*subW474*(subW158*subW9 + subW385*u[11])*u[14]*u[65];
u[70] = subW26*subW27*subW28*subW491*subW80*u[9]*u[13]*(u[9]*(subW114 + 2.*u[13]*(kTv + 2.*u[32])) + kTv*u[31]*u[38]);
u[71] = subW151*subW158*subW2*subW26*subW491*u[17]*(-2.*kTv*subW389 + (-4.*subW49 + 2.*subW50)*u[9] + subW390*u[38])*u[65];
u[72] = subW158*u[8]*u[13]*u[14]*u[16]*u[17]*(subW80*(u[9]*(4.*(subW392 + u[9]*(subW10*subW22 + subW393*u[26]))*u[32] + subW46*subWW9*u[36]) + subW3*(-2.*subW1*subW22*u[36] + 2.*u[9]*(subW395 + subWW7 + u[10]*(subW396*u[31] + u[13]*(u[26]*u[31] + u[8]*u[37]))) + u[8]*(2.*subW38*subW397 + u[10]*u[31]*(2.*subW210 + subW172*u[38])))) + u[8]*(2.*subW398*subW517*u[46] + u[9]*(2.*subW21*subW517 + 4.*subW27*subW80*u[28]*u[32]*u[55] + u[10]*(-4.*u[13]*u[32]*(-u[41] + u[21]*(1. + u[41]*(u[5] - 2.*u[62]))) + subW114*(u[41] + u[21]*(3. + u[41]*(-u[5] + 4.*(u[61] + u[62]))))))) + kTv*(2.*subW80*u[9]*(subW392 + u[9]*(subW22*subW396 + subW393*u[26]) + 2.*(subW395 + subWW7 + (subW10 + subWW8)*u[10]*u[31])*u[32]) + u[8]*(-2.*(subW2*subW67*subW80*u[30] + subW38*(subW173 + u[21]*(u[38] + (-2.*subW51*u[32] + u[5]*u[38])*u[41]))) + u[38]*(subW113*subW67*subW80 + u[10]*(2.*subW72*subW80*u[37] + u[31]*(-(-3. + subW56)*u[21] + u[41] + 4.*subW80*u[61]))) + subW80*(2.*subW51*subW72*u[10] + 4.*u[31]*(subW27*u[32]*u[55] + u[10]*u[38]*u[62])) + u[9]*(subW80*(-2.*subW21*subW397 + 2.*subW27*u[28]*u[55]) + u[10]*(subW114*subW172*subW80 - 2.*u[13]*(-u[41] + u[21]*(1. + u[41]*(u[5] - 2.*(u[32]*u[37] + u[62])))))))));
u[73] = subW158*u[8]*u[13]*u[14]*(2.*((-2.*subW11*subW79*u[9]*(subW332*u[9] + subW37*u[13])*u[16]*u[32] + subW26*(2.*subW18*subW404*u[38] + u[16]*((subW407 + subW495)*subW79*u[32] + u[13]*(-4.*subW18*subW79*u[30]*u[32] + subW187*u[22]*u[38]))))*u[65] + u[8]*(subW194*subW67*u[13]*((-3.*subW211 + subW51)*u[16]*u[17]*u[32] -(u[16] + 2.*u[17])*u[38]) + u[9]*u[17]*(-4.*subW49*(-subW10*subW194*u[16]*u[25] + u[13]*(subW194 + u[16]*(subW409*u[21] -u[65]))) + u[13]*(subW408*u[13]*u[16]*u[21]*u[32] + u[27]*(subW211*u[16]*u[21]*u[32] + subW192*u[38]))*u[65]))) + u[17]*(-subW194*subW3*u[16]*(u[9]*(-2.*subW452 + 4.*subW496*u[10]) + u[8]*(subW413*u[11] + (subW330*u[8] + subW37*u[13])*u[38])) + kTv*(subW194*u[16]*(-2.*subW11*u[9]*(subW332*u[9] + subW37*u[13] - 2.*subWW18*u[32]) + subW26*(subW407 + subW495 + 4.*subW18*(subW70 -u[37])*u[38] - 2.*u[13]*(2.*subW18*u[30] + subW414*u[22]*u[38]))) + u[8]*(u[13]*(-2.*u[11]*(subW51*u[16]*u[21]*u[32] + subW192*u[38]) + u[16]*u[21]*(2.*subW152*u[11]*u[32] + subW67*(3.*subW152 + subW51 + 2.*subW414*u[38])))*u[65] + u[9]*(subW194*u[13]*u[16]*(subW408*u[13] + subW211*u[27]) - 4.*u[10]*(-subW194*u[16]*u[25]*(subW10 - 2.*u[32]*u[36]) + u[13]*(subW194 + u[16]*(-u[65] + u[21]*(1. + (subW195 + 2.*u[32]*(u[29] -u[37]))*u[65])))))))));
u[74] = subW26*subW27*subW28*subW80*u[9]*u[13]*u[14]*(subW342 + (subW152 + subW210)*u[31]);
u[75] = subW151*subW158*subW2*subW26*(2.*subW120*subW158 + subW415*u[11])*u[14]*u[17]*u[65];
u[76] = -subW151*subW158*subW2*subW26*u[14]*u[17]*(2.*subW120*subW158 -subW390*u[38])*u[65];
u[77] = subW158*subW348*u[8]*u[13]*u[14]*u[41]*(u[8]*(subW478 + (subW210 + subW211)*u[10]*u[31]) + 2.*subW158*subW417*u[54]);
u[78] = subW158*subW79*u[8]*(u[9]*(-2.*subW452 + 2.*subW496*u[10]) + subW413*u[8]*u[11])*u[13]*u[14]*u[16]*u[65];
u[79] = subW158*subW79*u[8]*u[13]*u[14]*u[16]*(2.*subW158*(subW410*u[8] + subW11*u[31]) + (-subW26*subW330 + subW67*u[8]*u[13])*u[38])*u[65];
u[80] = subW158*u[8]*u[13]*u[17]*(-subW3*subW38*(subW15*subW516*u[7] + u[13]*(2.*subW497*u[9]*u[26] + subW498*u[8]*u[30]))*u[65] + kTv*(subW26*(subW17*(subW211*subW516 + subW51*(subW90*u[14]*u[16] + subW79*(-3.*u[14] + u[16]))) + 4.*subW18*(-subW211 + subW51)*u[14]*u[16]*u[21])*u[65] + u[8]*((-4.*subW499*u[7]*u[11]*u[14]*u[16]*u[21] + u[13]*(4.*subW426*u[11]*u[14]*u[16]*u[21] + subW67*(subW498*subW51 + subW515*u[7]*u[23])))*u[65] + u[9]*(u[13]*(u[13]*((-2.*subW105 + subW190)*subW79*u[16] + u[14]*((2.*subW105 - 3.*subW190)*subW79 + subW408*subW96*u[16])) + subW211*subW516*u[27])*u[65] + 4.*u[10]*u[14]*u[16]*u[21]*(subW409*u[13] -subW10*u[25]*u[65]))) + 2.*u[13]*((subW34*subW385*u[11]*u[14]*u[16] + subW1*(subW21*subW497 + 2.*subW22*u[14]*u[16]*u[21]))*u[26]*u[65] + u[9]*(subW11*subW67*(subW348 + subW369*u[14])*u[65] + 2.*u[11]*u[14]*u[16]*u[21]*(u[36] + subW350*u[26]*u[65])))) - 2.*u[14]*u[16]*(u[7]*(-2.*subW194*(subW26*(subW499*u[22] - 2.*subW18*subW25*u[23]) + subW11*subW344*u[23]*u[31]) + u[8]*(2.*subW194*(-u[13]*(2.*subW45*subW67 + subW55*u[22])*u[23] + subW37*subW427*u[25] + u[9]*(2.*subW18*subW25*u[12] -subW499*u[27])) + subW38*u[23]*(-4.*u[65] + u[21]*(1. + (u[5] + u[20])*u[65])))) + u[13]*(u[21]*((2.*subW11*subW67*u[30]*u[31] - 2.*subW26*(2.*subW18*subW25*u[30] + u[22]*(subW488*u[30] + (-u[5] + u[20])*u[38])))*u[65] + 2.*subW1*(-2.*subW22*subW25*u[26]*u[65] + u[27]*(u[36] + (subW114 - 2.*subW120*u[13])*u[26]*u[65])) + u[8]*(2.*(subW489*subW51 + subW426*subW67)*u[65] + subW38*u[30]*(-3. + (u[5] - 3.*u[20] + 4.*u[40])*u[65]))) + 2.*u[9]*(subW11*u[11]*(2.*u[65] + u[21]*(1. + (-u[5] + u[20] - 2.*u[40])*u[65])) + u[21]*(u[26]*(subW353 + subW21*u[30]*u[31])*u[65] + subW67*(u[36] + 2.*subW11*u[32]*u[65]) + u[8]*(-2.*subW25*subW409*u[10] + u[27]*(subW428*u[30] + subW195*u[38])*u[65] + u[22]*(u[36] + subW429*u[26]*u[65])))))));
u[83] = -subW1*subW238*subW27*subW475*u[8]*u[13]*u[16]*(subWW11 + u[13]*(-subW55 + u[8]*(2.*kTv + 4.*u[37])))*u[81];
u[84] = kTv*subW1*subW2*subW26*subW27*u[14]*(subW343*u[16] + (2. -u[4]*u[17])*u[21])*(-2.*u[81] + u[65]*(-2. + (2.*kTv*subW120 + subW3)*u[81]));
u[85] = subW1*subW238*subW27*u[8]*u[13]*u[16]*u[21]*(subW430 + (subW72 -u[9]*u[28])*u[36])*u[81];
u[86] = subW158*subW79*u[8]*u[13]*u[14]*((subW431 + u[16]*(4.*(subW18*subW26*subW51 -subW2*(subW67*u[9]*u[26] + u[22]*(u[8]*u[9]*u[26] -subW26*u[30])))*u[37] -subW3*(u[9]*(u[13]*(-2.*subW432*u[11] + 2.*u[8]*(subW84 + u[10]*u[29])) + (-2.*subW67*u[13] + u[10]*(2.*subW72 + subWW12*u[31]))*u[36]) + 2.*u[8]*(subW211*subW38 + (subW323*u[8] + subW216*u[29])*u[38])) + u[10]*u[13]*(4.*subW55*u[9]*u[40] + u[8]*(subW33 + 2.*u[30]*u[31])*u[47]) + 2.*subW27*subWW19*u[9]*u[54]) + u[10]*u[13]*(u[9]*u[37]*(4.*subW72*u[16]*u[26] - 4.*u[8]*(1. + 2.*u[16]*u[40])) + u[31]*(subW243 + u[9]*u[26]*(1. -u[16]*(u[47] - 4.*u[62])))))*u[81] + u[16]*(subW431 + u[13]*(u[10]*((subW243 + 3.*u[9]*u[26])*u[31] - 4.*u[8]*u[9]*u[37]) - 2.*subW265*subW46*u[9]*u[81])) - 2.*subW15*u[7]*(subW113*subW67*u[16]*u[81] + u[10]*(u[31]*u[81] + u[16]*(u[31] + subWW19*u[81]))) + kTv*(-2.*subW26*(subW18*subW211 -subW323*subW335)*u[16]*u[81] -u[9]*(2.*u[16]*((subW11*subW66 + subW432*subW67)*u[13] + subW27*u[29]*u[31]*u[54])*u[81] + u[10]*(subW247 + u[16]*(subW500*u[31]*u[36] -(2.*subW432*subW72 + subW11*subWW12*u[31])*u[81]))) + 2.*u[8]*(subW205*subW341*u[16]*u[81] + subW216*(subW433*u[16]*u[38] + (subW385*u[16]*u[29] + u[38])*u[81]) + u[9]*(u[16]*(subW17*subW340 + subW27*u[25]*u[54])*u[81] -u[10]*u[13]*(u[81] + u[16]*(1. + (2.*(subW244 + u[40]) -u[47])*u[81]))))));
u[87] = subW1*subW27*u[8]*u[13]*u[14]*((subW79 + subW78*u[16])*(2.*subW199*u[8] + u[13]*(2.*subW55 + u[8]*(4.*subW200 + (2.*subW120*subW3 + subW46)*u[65])))*u[81] + 2.*kTv*u[8]*u[13]*(-subW437*u[17] + u[16]*(2.*subW437 + u[17]*(-u[81] + u[65]*(-1. + 2.*u[19]*u[81])))));
u[88] = subW151*subW158*subW2*subW26*u[17]*(2.*kTv*subW158*(2.*u[65]*u[81] + u[14]*(-u[65] + u[81])) + u[14]*u[65]*(3.*subW158*subW46*u[81] + 2.*(subW415*u[11] + subW390*u[38] + subW158*(4.*u[18] - 2.*(u[29] + u[37]) + subW3*(subW120 - 2.*u[18] + 2.*u[32])*u[81]))));
u[89] = subW158*subW79*u[8]*u[13]*u[14]*u[16]*(2.*u[8]*(subW438*u[9] + subW210*u[11])*u[13] + u[9]*((2.*subW21 + subW22)*u[9] + subW72*u[10])*u[36])*u[81];
u[90] = subW158*subW79*u[8]*u[13]*u[14]*u[16]*((u[55]*((subW26*(u[10]*(subW17*(u[18] -u[29]) -u[22]*(2.*subW199 + u[13]*(u[32] - 3.*u[37]))) + subW439*(u[18] + u[29] + u[37])) - 2.*(subW26*subW27*u[25]*u[32] + subW264*u[13]*(subW55*u[22] + u[11]*u[40])) + subW439*u[8]*u[11]*u[54] + u[10]*(u[46]*((-2.*subW199*u[8] + (-2.*subW55 + subW383*u[8])*u[13])*u[45] + 2.*subW11*u[11]*u[50]) + 2.*subW38*u[8]*u[62]))*u[65] + 2.*u[8]*(subW27*u[31] + subW38*u[10]*u[20]*u[65])) -subW1*(-subW22*u[36] + 2.*subW2*u[26]*u[27]*(subW82 -u[32] + u[37])*u[65] + u[13]*(subW22*subW378*u[26]*u[65] - 2.*u[27]*(u[36] + subW114*u[26]*u[65]))))*u[81] + u[65]*(subW334 -subW2*u[8]*u[11]*u[30] -subW17*subW26*u[38] + subW67*u[8]*u[13]*u[38] - 2.*subW210*subW38*u[5]*u[8]*u[81]) + u[9]*(-(subW21*(2.*u[26]*(-subW51*u[31] + subW72*u[38]) + u[8]*(subW383*subW51 - 2.*(subW199*u[30] + u[38]*(subW195 + u[40] -u[62]))))*u[65] + subW27*u[54]*(u[31] + subW384*u[8]*u[25]*u[65]) + u[10]*((u[13]*(u[5]*(2.*subW55 + (3.*subW82 + subW87)*u[8]) + u[26]*(subW384*subW72 + 2.*(subW248 + u[20])*u[31])) + u[8]*(2.*subW50*u[25]*u[54] -u[13]*(u[20]*(-u[29] + u[32] + 3.*u[37]) -(u[29] + 3.*u[32] - 3.*u[37])*u[40] + (-3.*u[29] + 3.*u[32] + u[37])*u[62] + u[18]*(3.*u[20] -u[40] + u[62]))))*u[65] + u[36]*(-subW72 + 2.*u[8]*(subW248 + u[5] + u[20])*u[25]*u[65])))*u[81] + 2.*subW11*u[11]*u[65]*(u[13] -subW22*u[55]*u[81])) + u[7]*(u[9]*u[31]*(u[10]*u[12] - 2.*subW11*u[23]*u[27]*u[65])*u[81] + u[8]*u[65]*(u[9]*(subW18*subW378*u[12] + (subW381*u[13]*u[23] - 2.*subW427*u[25])*u[27])*u[81] + u[11]*(-u[13]*u[23] + 2.*subW18*u[12]*u[55]*u[81]))));
u[93] = -subW1*subW2*subW264*subW501*subW8*u[15]*u[17]*(2.*kTv*subW443 + subW477 + u[8]*(subW142 + 4.*u[10]*u[29]));
u[94] = subW1*subW238*subW27*subW501*u[8]*u[13]*u[21]*(subWW11 + u[8]*(subW199 + 2.*u[13]*(kTv + 2.*u[29])))*u[81];
u[95] = subW1*subW2*subW264*subW8*(-2.*subW264*subW75 + subW317*u[11])*u[15]*u[16]*u[17];
u[96] = subW158*u[8]*u[13]*u[14]*u[16]*u[17]*(-2.*subW398*u[9]*(subW271 -u[21]*(subW446 + subW433*u[36]))*u[46] + u[21]*(4.*subW26*(subW152*subW18 + subW323*subW51)*u[29] - 2.*subW264*subW46*u[31]*u[38] + subW3*(u[9]*(2.*subW38*subW444 + u[10]*(u[31]*(2.*subW273 + subW172*u[36]) + 2.*u[8]*u[13]*u[37])) - 2.*u[8]*((subW2*u[11] + subW216*u[13])*u[30] + subW37*u[13]*u[38] + u[10]*(subW445*u[31] + u[8]*u[25]*u[38]))))*u[81] + u[8]*(4.*subW205*subW67*u[21]*u[29]*u[81] + u[9]*(4.*subW27*u[21]*u[25]*u[29]*u[54]*u[81] + 2.*subW17*(u[36]*u[81] + u[21]*(u[36] + (-2.*subW11*u[29] + u[36]*u[47])*u[81])) + u[10]*(subW199*(subW500*u[21] + u[81]) - 4.*u[13]*u[29]*(-u[81] + u[21]*(1. + (u[47] - 2.*u[62])*u[81]))))) + kTv*(2.*subW26*u[21]*(subW2*u[22]*u[30] + subW18*(subW385 - 2.*u[29]*u[38]))*u[81] + u[9]*(2.*subW271*subW38 + subW247*u[10] + u[21]*(subW500*u[10]*u[31]*u[36] - 2.*subW38*(subW446 + (1. + subW245)*u[36]) + 2.*(subW444*(subW72*u[10] -subW67*u[13]) + 2.*subW27*u[29]*u[31]*u[54])*u[81])) + u[8]*(2.*u[21]*(subW211*(subW67*u[13] + subW310*u[31]) + 2.*u[29]*(-subW2*u[11]*u[30] + u[13]*(u[10]*u[30]*u[31] + subW67*u[38])))*u[81] + u[9]*(u[21]*(-2.*subW17*subW444 + subW439*u[54])*u[81] + u[10]*(subW172*subW199*u[21]*u[81] + 2.*u[13]*(u[81] + u[21]*(-1. + (-u[47] + 2.*(subW244 + u[62]))*u[81])))))));
u[97] = subW1*subW238*subW27*u[8]*u[13]*u[16]*u[21]*(subW430 + (subW10 + subW273)*u[31])*u[81];
u[98] = subW158*u[8]*u[13]*u[16]*(2.*(u[8]*u[17]*(u[9]*(4.*u[10]*(u[13]*(subW280 + u[14]*(u[21] + u[15]*(-1. + subW107*u[21]))) + subW211*subW280*u[14]*u[28])*u[29] + u[13]*u[15]*(subW294*subW8 + subW518*u[14]*u[21]*u[29])) - 2.*subW2*subW280*subW67*u[14]*u[29]*u[30]) + u[15]*(2.*subW26*subW330*subW51*subW79*u[14]*u[29] + u[9]*(u[21]*(subW10*(subW449*u[9] - 3.*subW67*u[13])*u[14]*u[17]*u[29] + subW67*u[13]*(-subW11*u[14]*u[17]*u[29] + (u[14] + 2.*u[17])*u[36])) + u[9]*(-2.*subW22*(subW79 + subW108*u[14])*u[36] + u[14]*(4.*subW22*subW79*subWW8*u[29] + u[27]*(3.*subW2*subW79*u[26]*u[29] -subW187*u[13]*u[36])))))) + u[17]*(subW280*subW3*u[14]*(u[13]*(-subW10*u[9]*u[11] - 2.*subWW18*u[8]*u[30]) + subW1*subW332*u[36] + u[9]*(4.*subW264*subW451 + subW452 + subW37*u[13]*u[36])) + kTv*(u[8]*(-2.*subW280*subW51*u[14]*(subW67*u[13] + 2.*subWW18*u[29]) + u[9]*(subW280*subW518*u[13]*u[14] + 4.*u[10]*(subW280*subW445*u[14]*u[28] + u[13]*(subW280 + u[14]*(u[21] + u[15]*(-1. + u[21]*(subW107 + 2.*subW87*u[29]))))))) + u[15]*(2.*subW26*subW330*subW51*u[14]*u[21] + u[9]*(u[13]*(subW11*(subW37 + subWW16)*u[14]*u[21] + 2.*(subW81*u[11] + subW37*subW453*u[14]*u[21])*u[36]) + u[14]*u[21]*(subW10*(subW449*u[9] -(3.*subW67 + subWW16)*u[13]) + u[9]*(4.*subW22*(subWW8 + subW453*u[36]) + u[27]*(3.*subW2*u[26] + 2.*subW453*u[13]*u[36]))))))));
u[99] = subW158*subW79*u[8]*u[13]*u[14]*u[16]*(2.*u[8]*(subW210*subW417 + subW438*u[9]*u[13]) + subW158*(-subW10 + subW273)*u[31])*u[81];
u[100] = subW158*subW79*u[8]*u[13]*(-(2.*subW264*subW451 + subW452)*u[9] + (subW243*subW417 + subW10*u[9]*u[11])*u[13])*u[14]*u[15]*u[16];
u[102] = subW158*subW79*u[8]*u[13]*u[14]*(u[16]*(subW10*subW519*u[9] + subW389*subW46*u[31]*u[36] -subW3*(u[7]*(subW322*u[10] + subW159*u[12])*u[31] + u[36]*(-subW1*subW22 + u[9]*(-subW114*u[11] + subW67*u[13] + subW455*u[31]) + subW67*u[31]*u[38]) -u[8]*(subW18*u[9]*u[36] + (u[10]*u[29]*u[31] + (u[11]*u[25] -u[22]*u[31])*u[36])*u[38])))*u[101] -subW26*(subW507*u[10]*u[16]*u[25] + u[38]*(subW17*u[16] + (u[10] -subW10*u[16]*u[22])*u[25]*u[101])) + u[8]*(subW67*(u[7]*u[16]*(subW226 + subW236*u[23]) + u[13]*(1. + u[16]*u[20])*u[38])*u[101] -u[9]*(u[16]*u[38]*(subW21 -subW10*subW461*u[101]) + u[10]*(subW507*u[16]*u[28] + (subW114 + 2.*subW10*u[16]*u[25]*u[32])*u[101]))) + kTv*(-u[16]*(subW519*u[9]*u[36] + subW26*u[25]*(subW211*u[10] + (subW294 -u[10]*u[29])*u[38]) + subW10*(subW1*subW22 + u[9]*(subW114*u[11] + subW37*u[13] + (2.*subW49 -subW50)*u[31]) + subW37*u[31]*u[38]))*u[101] -u[8]*(u[16]*(-u[7]*(subW67*u[13]*u[23] + subW232*u[22]*u[31]) + (subW199*subW67 + subW67*u[13]*u[29] + subW461*u[9]*u[36])*u[38])*u[101] + subW159*u[16]*(-u[13] + subW10*u[25]*u[101]) + u[10]*(u[31]*u[38]*u[101] + u[16]*(u[9]*(subW10*u[25] + subW167*u[25] + subW211*u[28] -subW114*u[29])*u[101] + u[31]*(u[38] + (subW290 + subW69)*u[101]))))));
u[103] = subW1*subW264*subW462*subW79*u[13]*u[14]*u[16]*u[36]*u[46]*u[101];
u[104] = subW158*subW348*u[8]*u[13]*u[14]*(-subW398*(u[9]*u[36] -u[8]*u[38])*u[46]*u[101] + u[7]*u[24]*(u[46]*(u[31]*u[45] -u[11]*u[50])*(u[13]*(u[23]*u[26] + u[12]*u[30]) + u[10]*(u[23]*u[54] + u[12]*u[55]))*u[101] + u[9]*(subW524*u[12] + (subW231*subW463 + u[12]*(subW179*subW464 + subW463*u[38]))*u[46]*u[101]) + u[8]*(subW524*u[23] + u[46]*(subW179*subW464*u[23] + subW427*(u[25]*u[45] + u[22]*u[50]))*u[101])));
u[105] = subW158*subW79*u[8]*u[13]*u[16]*(u[14]*(subW211*subW26*subW469*u[25] -subW443*subW46*u[31]*u[38] -subW3*(u[7]*(subW14*u[10] + subW443*u[23])*u[31] + (subW18*subW26 + u[8]*(subW199*u[11] + subW37*u[13] + (subW84 + 2.*u[10]*u[29])*u[31]) + subW37*u[31]*u[36])*u[38] + u[9]*(subW114*u[8]*u[10] + u[36]*(u[10]*u[31]*u[32] + (u[11]*u[28] -u[27]*u[31])*u[38]))))*u[101] + u[9]*(subW67*(u[7]*(subW129 + subW234*u[12])*u[14] -u[13]*(1. + u[14]*u[20])*u[36])*u[101] + u[9]*(subW523*u[10]*u[14]*u[28] + u[36]*(subW21*u[14] + (u[10] + subW211*u[14]*u[27])*u[28]*u[101]))) + u[8]*(subW211*subW428*subW67*u[14]*u[101] + u[9]*(u[14]*u[36]*(subW17 + subW211*subW461*u[101]) + u[10]*(subW523*u[14]*u[25] + (subW199 - 2.*subW211*u[14]*u[28]*u[29])*u[101]))) + kTv*(u[14]*(-subW1*u[28]*(subW10*u[10] + (subW49 -subW50)*u[36]) + subW211*(-subW18*subW26 + u[8]*(subW117*u[11] + subW67*u[13] + subW469*u[31]) + subW67*u[31]*u[36]) + u[8]*(subW428*subW67 + subW469*u[8]*u[25])*u[38])*u[101] + u[9]*(u[14]*((u[7]*(subW67*u[12]*u[13] + subW231*u[27]*u[31]) + u[36]*(subW67*(subW114 + u[13]*u[32]) + subW461*u[8]*u[38]))*u[101] -subW265*(u[13] + subW211*u[28]*u[101])) + u[10]*(u[31]*u[36]*u[101] + u[14]*(subW523*u[31] -u[8]*(u[7]*(u[12]*u[25] + u[23]*u[28]) + 2.*subW114*u[29] + subW199*u[32])*u[101])))));
u[106] = subW158*subW26*subW462*subW79*u[13]*u[14]*u[16]*u[38]*u[46]*u[101];
COMPLEX subA1 = pow2(u[33]);
COMPLEX subA2 = u[34]*u[35];
COMPLEX subA3 = -u[43]*u[44];
COMPLEX subA4 = u[48] -u[49];
COMPLEX subA6 = 2.*u[42] + u[63];
COMPLEX subA8 = -u[69]*u[70];
COMPLEX subA9 = u[66]*u[71];
COMPLEX subA10 = u[75] -u[76];
COMPLEX subA12 = u[66]*u[67];
COMPLEX subA13 = u[49] + u[86];
COMPLEX subA14 = u[66]*u[84];
COMPLEX subA15 = -u[66]*u[88];
COMPLEX subA16 = u[48] + u[86];
COMPLEX subA19 = -2.*u[92]*u[94];
COMPLEX subA20 = u[82]*u[97];
COMPLEX subA21 = -u[92]*u[93];
COMPLEX subA22 = u[82]*u[83];
COMPLEX subA23 = u[43]*u[44];
COMPLEX subA24 = u[92]*u[94];
COMPLEX subA27 = u[92]*u[93];
COMPLEX subA28 = u[103] + u[106];
COMPLEX subA29 = -subA6*u[34];
COMPLEX subA30 = subA12 + 2.*u[42] + u[80];
COMPLEX subA32 = subA24 + u[85] + u[97];
COMPLEX subA34 = -subA32*u[82];


COMPLEX amp12345 = 0.015625*(-subA1*u[52] - 2.*u[33]*(subA2 + subA3 + u[51] -u[53] + u[56]) + 2.*(subA29 + u[57] + 2.*(subA4*u[43] + u[58] + u[59]) + u[60] + u[64]));

COMPLEX amp12435 = 0.015625*((-4.*subA16 + 2.*subA22)*u[43] - 4.*(u[58] + u[59]) + u[82]*(-2.*u[85] -u[87]) + u[66]*(-2.*u[76] -u[82]*u[84] + u[88]) + 2.*(subA30*u[34] + u[79] + u[89] + u[90]));

COMPLEX amp12534 = 0.03125*(subA30*u[34] + subA10*u[66] + u[78] + u[79] + u[69]*(subA9 -u[73] - 4.*u[102]) - 2.*(u[58] + u[103]) + 2.*u[104]);

COMPLEX amp13245 = 0.015625*(subA1*u[52] - 2.*(subA34 + (-2.*subA13 + subA22)*u[43] + u[57] + u[64] + u[89] + u[33]*(subA21 + subA23 -u[51] -u[56] + u[95]) + u[92]*(2.*u[96] -u[98]) + u[99] + u[100]));

COMPLEX amp13425 = 0.03125*(subA34 + (-2.*subA16 + subA22)*u[43] + u[89] + u[99] + u[92]*(2.*u[96] + 4.*u[105]) - 2.*(u[59] + u[104] + u[106]));

COMPLEX amp13524 = 0.015625*(-4.*subA28 + u[82]*(subA19 + u[87]) + u[66]*(2.*(u[69]*u[71] + u[75]) + u[82]*u[84] -u[88]) + 2.*(u[78] + u[99]) - 2.*(subA20 + u[90] + u[69]*(u[73] + 4.*u[102])) + u[92]*(4.*u[96] + 8.*u[105]));

COMPLEX amp14235 = 0.015625*(subA15 + (4.*subA13 - 2.*subA22)*u[43] + u[69]*(2.*subA9 - 4.*u[72]) + 2.*(u[33]*(subA3 + u[51] + u[69]*u[70] + u[74]) + u[66]*u[75] + u[77] + u[78] + u[82]*u[85]) + u[82]*(subA14 + u[87]) - 2.*(u[57] + u[69]*u[73] + u[89] + u[90]));

COMPLEX amp14325 = 0.03125*(u[57] + u[33]*(subA23 + subA8 -u[51] -u[74]) -u[77] - 4.*u[69]*u[102] - 2.*u[103] + 2.*(subA4*u[43] + u[59] + u[69]*u[72] + u[104]));

COMPLEX amp14523 = 0.015625*(subA1*u[52] + 2.*u[33]*(subA27 + subA8 + u[56] -u[74] -u[95]) - 2.*(2.*subA28 + u[64] + u[77] + u[100] - 2.*u[69]*(u[72] - 2.*u[102]) + u[92]*(-u[98] - 4.*u[105])));

COMPLEX amp12354 = 0.015625*(subA1*u[52] + 2.*u[33]*(subA2 + subA8 -u[53] + u[56] -u[74]) - 2.*(u[60] + u[64] + subA10*u[66] + u[69]*(subA9 - 2.*u[72] -u[73]) + u[77] + u[78] + u[79] + u[34]*(subA12 -u[63] + u[80])));

COMPLEX amp12453 = 0.015625*(subA15 + u[82]*(subA14 + subA19 + u[87]) - 2.*(subA20 + u[60] + u[79] + u[34]*(subA12 + u[80]) + u[90]) + u[92]*(4.*u[96] - 2.*u[98]) + 2.*(u[34]*u[63] + u[66]*u[76] + u[33]*(subA2 + subA21 -u[53] + u[95]) + u[99] + u[100]));

COMPLEX amp12543 = 0.03125*(subA29 + 2.*u[58] + u[60] + u[33]*(-subA2 + subA27 + u[53] -u[95]) + u[92]*u[98] -u[100] - 2.*u[104] + 4.*u[92]*u[105] - 2.*u[106]);

delete [] u;

// color factors are included below, without averaging

return 2.*27.*8./32.*(norm(amp12345) +norm(amp12435) +norm(amp12534) +norm(amp13245) +norm(amp13425) +norm(amp13524)
+norm(amp14235) +norm(amp14325) +norm(amp14523) +norm(amp12354) +norm(amp12453) +norm(amp12543) );


}
