//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->ggg for helicities LLRL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGGGG_LLRL() {
int Nsymb =104;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k1,k1);
u[2] = Dot(k1,k2);
u[3] = Dot(k2,n);
u[4] = Dot(k3,n);
u[5] = Dot(k4,k5);
u[6] = Dot(k4,n);
u[7] = S(L,k3,k4);
u[8] = S(L,k3,n);
u[9] = S(L,k5,n);
u[10] = S(R,k2,n);
u[11] = S(R,k2,n,e1);
u[12] = S(R,k4,n);
u[13] = Den(u[6]);
u[14] = Den(u[5]);
u[15] = Den(u[4]);
u[16] = Den(u[3]);
u[17] = Dot(k5,n);
u[18] = Dot(k3,k4);
u[19] = Dot(e1,k2);
u[20] = S(L,k3,k5);
u[21] = S(R,k3,n);
u[22] = Den(u[18]);
u[23] = Den(u[17]);
u[24] = S(L,k4,k5);
u[25] = S(R,k5,n);
u[26] = S(R,k2,k3);
u[27] = S(R,k4,n,e1);
u[28] = S(L,k4,n);
u[29] = S(R,k2,k4);
u[30] = S(R,k2,k5);
u[31] = Den(u[3] -u[4]);
u[32] = Den(u[1] + 2.*u[2]);
u[34] = Den(u[3] -u[17]);
u[36] = S(R,k4,k5);
u[37] = S(R,n,k5,e1);
u[38] = Dot(e1,k5);
u[39] = Dot(k1,k5);
u[40] = Dot(k2,k3);
u[41] = Den(u[40]);
u[42] = Dot(e1,k3);
u[43] = Dot(e1,k4);
u[44] = Den(u[1] -2.*u[39]);
u[46] = Dot(k3,k5);
u[47] = S(R,k3,k4);
u[48] = S(R,n,k3,e1);
u[50] = S(L,k2,k5);
u[51] = S(L,k2,n);
u[52] = Dot(k2,k4);
u[53] = Dot(k2,k5);
u[63] = S(L,k2,k3);
u[70] = Den(u[46]);
u[71] = Dot(k1,k4);
u[72] = Den(u[1] -2.*u[71]);
u[81] = Den(u[52]);
u[85] = Dot(k1,k3);
u[86] = Den(u[1] -2.*u[85]);
u[93] = Den(u[53]);
COMPLEX subW1 = pow2(u[9]);
COMPLEX subW2 = pow2(u[12]);
COMPLEX subW3 = pow2(kTv);
COMPLEX subW4 = u[13] -u[23];
COMPLEX subW5 = u[7]*u[12];
COMPLEX subW6 = u[20]*u[25];
COMPLEX subW7 = pow2(u[8]);
COMPLEX subW8 = u[13] -u[15];
COMPLEX subW9 = u[20]*u[21];
COMPLEX subW10 = u[12]*u[24];
COMPLEX subW12 = pow2(u[10]);
COMPLEX subW13 = u[15] + u[16];
COMPLEX subW14 = u[8]*u[26];
COMPLEX subW15 = u[28]*u[29];
COMPLEX subW16 = u[15]*u[16]*u[23];
COMPLEX subW17 = u[16] -u[23];
COMPLEX subW19 = -u[16]*u[23];
COMPLEX subW22 = u[16]*u[23];
COMPLEX subW23 = u[16] + 3.*u[23];
COMPLEX subW24 = u[38] + u[42] + u[43];
COMPLEX subW26 = u[36]*u[37];
COMPLEX subW27 = u[42] + u[43];
COMPLEX subW30 = u[24]*u[27]*u[30];
COMPLEX subW31 = u[9]*u[30];
COMPLEX subW35 = u[16] + u[23];
COMPLEX subW36 = u[25]*u[37];
COMPLEX subW37 = u[21]*u[48];
COMPLEX subW39 = u[24]*u[27];
COMPLEX subW40 = -u[18] + u[46];
COMPLEX subW43 = u[18] -u[46];
COMPLEX subW44 = u[38] + u[42];
COMPLEX subW45 = u[38] + u[43];
COMPLEX subW47 = -u[26]*u[48];
COMPLEX subW48 = u[37]*u[46];
COMPLEX subW49 = u[24]*u[47]*u[48];
COMPLEX subW54 = -u[30]*u[37];
COMPLEX subW55 = pow3(kTv);
COMPLEX subW56 = u[11]*u[12];
COMPLEX subW57 = -u[10]*u[27];
COMPLEX subW60 = u[9]*u[36];
COMPLEX subW61 = -2.*u[27]*u[38];
COMPLEX subW63 = 2.*u[11]*u[38];
COMPLEX subW64 = -2.*u[38]*u[48];
COMPLEX subW66 = 2.*u[5] + u[18] -u[52];
COMPLEX subW69 = 2.*u[37]*u[43];
COMPLEX subW70 = u[30]*u[37];
COMPLEX subW72 = u[12]*u[26];
COMPLEX subW73 = 2.*u[10]*u[47];
COMPLEX subW75 = u[42] -u[43];
COMPLEX subW77 = u[19] + u[42];
COMPLEX subW78 = u[47]*u[48];
COMPLEX subW80 = -u[38] + u[43];
COMPLEX subW89 = u[8]*u[21];
COMPLEX subW90 = u[9]*u[25];
COMPLEX subW92 = u[10]*u[47];
COMPLEX subW94 = -2.*u[11]*u[43];
COMPLEX subW96 = u[29]*u[51];
COMPLEX subW97 = u[26]*u[27];
COMPLEX subW98 = -u[11]*u[47];
COMPLEX subW101 = u[38]*u[48];
COMPLEX subW103 = 2.*u[37]*u[42];
COMPLEX subW105 = u[40] + u[52];
COMPLEX subW109 = u[18]*u[93];
COMPLEX subW114 = u[10]*u[63];
COMPLEX subW115 = u[43]*u[48];
COMPLEX subW117 = subW10 + subW9;
COMPLEX subW118 = subW19 + subW17*u[15];
COMPLEX subW120 = -2.*subW24*u[10]*u[36];
COMPLEX subW121 = subW14 + subW15;
COMPLEX subW122 = 2.*subW10*u[30];
COMPLEX subW123 = subW15 + subW31;
COMPLEX subW124 = subW36 + subW37;
COMPLEX subW125 = subW10 + 3.*subW9;
COMPLEX subW126 = -subW10 + subW9;
COMPLEX subW127 = subW56 + subW57;
COMPLEX subW128 = subW60 + subW61;
COMPLEX subW129 = subW6 + subW64;
COMPLEX subW130 = 1. + subW66*u[41];
COMPLEX subW131 = subW15 -subW31;
COMPLEX subW132 = subW72 + subW73;
COMPLEX subW133 = subW39 + subW80*u[9];
COMPLEX subW136 = subW27 -u[19] - 3.*u[38];
COMPLEX subW137 = subW24 + 3.*u[19];
COMPLEX subW138 = subW45 -u[19] - 3.*u[42];
COMPLEX subW139 = subW89 + subW90;
COMPLEX subW140 = subW10 + subW69;
COMPLEX subW141 = subW15 + subW94;
COMPLEX subW142 = subW97 + subW98;
COMPLEX subW143 = subW44 + u[19] -u[43];
COMPLEX subW144 = subW101 + subW6;
COMPLEX subW145 = subW103 + subW9;
COMPLEX subW146 = 1. + subW109;
COMPLEX subW147 = 4.*subW105 -u[18];
COMPLEX subW150 = subW92*u[12] + subW2*u[26];
COMPLEX subW152 = subW115 + subW5;
COMPLEX subW153 = subW26*u[9] + subW133*u[12];
COMPLEX subW154 = 3. + subW147*u[93];
COMPLEX subWW1 = -kTv*u[11];
COMPLEX subWW2 = u[15]*u[16];
COMPLEX subWW3 = 4.*subW60*u[10];
COMPLEX subWW4 = u[16] - 2.*u[23];
COMPLEX subWW6 = u[19] + u[38];
COMPLEX subWW7 = -u[26]*u[36];
COMPLEX subWW8 = u[30]*u[47];
COMPLEX subWW10 = u[8]*u[10];
COMPLEX subWW11 = u[11]*u[48];
COMPLEX subWW13 = subWW7 + subWW8;
COMPLEX subWW14 = subWW10 + subWW11;
u[33] = subW1*subW2*subW4*subWW10*u[14]*u[15]*((subW5 + subW6)*u[11] + 2.*subWW10*(kTv - 2.*u[19]))*(-2. + u[16]*(subW3 - 2.*kTv*u[19]));
u[35] = subW2*subW7*subW8*u[9]*u[10]*(-subW117*u[11] + 2.*u[9]*u[10]*(kTv - 2.*u[19]))*(-2. + u[16]*(subW3 - 2.*kTv*u[19]))*u[22]*u[23];
u[45] = -subW12*subW13*subW7*u[9]*u[12]*u[13]*(2. + u[23]*(subW3 + 2.*kTv*u[38]))*(kTv*u[27]*u[37] + u[9]*(-subW26 + u[12]*(2.*kTv + 4.*u[38])))*u[41];
u[49] = -subW2*subW7*subW8*u[9]*u[10]*u[16]*u[22]*((subW121 + 2.*subW31)*u[37] - 2.*kTv*(u[9]*u[10] + u[11]*u[37]) - 4.*u[9]*u[10]*u[38])*(2. + u[23]*(subW3 + 2.*kTv*u[38]));
u[54] = subWW10*u[9]*u[12]*u[16]*(u[12]*(subW3*u[11]*u[14]*(2.*subW10*u[8]*(subW16 + subW118*u[13]) + subW6*u[9]*(-3.*subW16 + u[13]*(subW22 + subW23*u[15]))) + u[7]*(u[14]*(4.*subW10*(subW121 + subWW1)*u[13]*u[15]*u[23]*u[27] + subW1*(4.*u[13]*u[15]*u[23]*(subW120 + (subW26 + 2.*subW27*u[12])*u[30]) + kTv*(u[12]*(subW16 + u[13]*(subW22 - 3.*subW17*u[15]))*u[30] - 4.*u[10]*u[13]*u[15]*u[23]*u[36]))) + u[9]*(u[14]*(kTv*subW121*u[12]*(subW16 -u[13]*(subW19 + u[15]*(3.*u[16] + u[23]))) + 4.*u[13]*u[15]*u[23]*(subW30*u[12] + subW121*(subW26 - 2.*u[12]*u[38]))) + u[11]*(-4.*kTv*subW26*u[13]*u[14]*u[15]*u[23] + u[12]*(-subW16*subW3*u[14] + u[13]*(-2.*u[15]*u[23] + u[14]*(subW19*subW3 + u[15]*(subW3*(3.*u[16] + u[23]) + 8.*kTv*u[23]*u[38] - 2.*(-4. + u[23]*(u[18] + u[46])))))))))) -kTv*(u[8]*(u[9]*(u[12]*u[14]*(subW16*(subW122 - 3.*subW6*u[26]) + u[13]*(subW17*u[15]*(subW122 + subW6*u[26]) + subW22*(subW6*u[26] - 2.*subW10*u[30]))) - 4.*u[10]*u[13]*u[15]*u[23]*(u[12]*(1. + subW43*u[14]) -subW9*u[14]*u[36])) + 2.*u[12]*(subW10*subW15*(subW16 + subW118*u[13])*u[14] + 2.*u[11]*u[13]*u[15]*u[23]*(subW49*u[14] -u[37]))) + u[14]*(subW6*u[9]*(subW123*u[12]*(-3.*subW16 + (subW22 + subWW2)*u[13]) + (subWW3 + (3.*subW15 -subW31)*u[12])*u[13]*u[15]*u[23]) + 2.*subW10*subW7*(subW16*subW72 + u[13]*(subW19*subW72 + u[15]*(subW35*subW72 + subW73*u[23]))) + 4.*u[11]*u[13]*u[15]*u[23]*(subW124*subW60*u[20] + u[12]*(subW39*subW6 + u[9]*(-2.*subW6*u[38] + subW40*u[48]))))) + 2.*u[13]*u[15]*(u[9]*(subW56*subW6*(-3.*u[23] + u[14]*(4. + u[23]*(u[18] - 4.*u[40] + u[46]))) + 2.*u[14]*u[23]*(subW124*subW15*u[20]*u[36] + u[12]*((subW30 - 2.*subW15*subW44)*subW6 + subW15*subW40*u[48]))) + 2.*u[23]*(-subW7*u[12]*(subW24*subW73*u[14]*u[24] + u[26]*(-(subW78 - 2.*subW45*u[12])*u[14]*u[24] + u[37])) + u[14]*(subW10*subW15*subW6*u[27] + subW1*(u[20]*(subW37*u[30]*u[36] + u[25]*(subW120 + u[30]*(subW26 + 2.*u[12]*u[43]))) + subW40*u[12]*u[30]*u[48])) + u[8]*(subW2*u[24]*(2.*subW123*u[14]*u[42] -u[11]*(-1. + u[14]*(u[18] - 2.*u[40] + u[46]))) + subW60*u[14]*u[20]*(-2.*subW24*u[10]*u[21] + u[26]*(subW36 + u[21]*u[48])) + u[12]*(2.*subW24*u[9]*u[10] -subW123*u[37] + u[14]*(subW15*subW49 + subW6*u[26]*(subW39 + 2.*u[9]*u[43]) + u[9]*(2.*subW24*subW43*u[10] + (subWW8*u[24] + subW40*u[26])*u[48])))))));
u[55] = -subWW10*u[9]*u[12]*u[16]*(subW7*u[22]*(kTv*(4.*subW9*subW92*u[13]*u[15]*u[23] + subW2*(subW16 + u[13]*(-3.*subW22 + subW23*u[15]))*u[24]*u[26] + u[12]*(4.*subW92*u[13]*u[15]*u[23]*u[24] + subW9*(3.*subW16 + u[13]*(subW19 + u[15]*(-u[16] + u[23])))*u[26])) + 4.*u[13]*u[15]*u[23]*(u[26]*(2.*subW2*subW45*u[24] + u[5]*u[12]*u[37]) + u[12]*(2.*subW24*subW92*u[24] -u[26]*(subW48 + subW49 - 2.*subW9*u[43])) + u[20]*((subW47 + 2.*subW24*u[10])*u[21] -subW36*u[26])*u[47])) -u[8]*(u[11]*(subW2*u[24]*(subW3*(subW16 + u[13]*(-3.*subW22 + subW17*u[15]))*u[22] + 2.*u[13]*u[15]*u[23]*(-3. + u[22]*(u[5] + 4.*u[40] - 3.*u[46]))) -u[12]*(-3.*subW16*subW3*subW9*u[22] + u[13]*(subW22*subW3*subW9*u[22] + u[15]*(4.*kTv*u[22]*u[23]*(subW49 + u[37]*(-u[5] + u[46])) + subW9*(2.*u[23] + u[22]*(8. + subW23*subW3 + 2.*u[23]*(-3.*u[5] + 4.*kTv*u[38] - 4.*u[40] + u[46])))))) - 4.*kTv*subW124*u[13]*u[15]*u[20]*u[22]*u[23]*u[47]) + kTv*(subW15*u[12]*u[22]*(-subW125*subW16 + u[13]*(subW22*(3.*subW10 + subW9) + u[15]*(subW126*u[16] + subW125*u[23]))) + u[9]*(u[12]*(-subW125*subW16 + u[13]*(subW22*(3.*subW10 + subW9) + subW126*subW17*u[15]))*u[22]*u[30] + 4.*u[10]*u[13]*u[15]*u[23]*(u[12]*(1. + u[22]*(u[5] -u[46])) -subW6*u[22]*u[47]))) + 4.*u[13]*u[15]*u[23]*(u[22]*(u[5]*u[12]*(u[9]*(subW54 + 2.*subW24*u[10]) -subW15*u[37]) + subW15*((subW48 + subW49 + 2.*subW44*subW9)*u[12] + 2.*subW2*u[24]*u[42] + subW124*u[20]*u[47])) + u[9]*(u[12]*(subW47 + u[22]*u[30]*(subW48 + subW49 - 2.*subW9*u[43])) + u[22]*u[30]*(2.*subW2*u[24]*u[42] + subW124*u[20]*u[47]) - 2.*subW24*u[10]*(u[12]*(-1. + u[22]*u[46]) + subW6*u[22]*u[47])))) + u[12]*(2.*u[7]*(u[22]*(-2.*subW117*(subW14 + subW15 + subWW1)*u[13]*u[15]*u[23]*u[27] + subW1*(-2.*u[13]*u[15]*u[23]*(subW120 + (subW26 + 2.*subW27*u[12])*u[30]) + kTv*(u[12]*(-subW16 + subW118*u[13])*u[30] + 2.*u[10]*u[13]*u[15]*u[23]*u[36]))) + u[9]*(u[22]*(kTv*subW121*u[12]*(-subW16 + u[13]*(subW19 + subW35*u[15])) - 2.*u[13]*u[15]*u[23]*(subW121*subW26 + subW9*u[27]*u[30] + u[12]*(subW30 - 2.*subW121*u[38]))) + u[11]*(2.*kTv*subW26*u[13]*u[15]*u[22]*u[23] + u[12]*(subW16*subW3*u[22] + u[13]*(subW22*subW3*u[22] -u[15]*(-2.*u[23] + u[22]*(subW3*subW35 + 4.*kTv*u[23]*u[38] - 2.*(-2. + u[23]*(u[5] + u[46]))))))))) + 4.*(subW123 + subWW1)*u[9]*u[13]*u[15]*u[23]*u[48]));
u[56] = subW16*subWW10*u[9]*u[12]*u[13]*(u[41]*(u[9]*(4.*((subW15*subW6 + subW60*u[7]*u[10])*u[12] + u[9]*(-subW2*u[7]*u[30] + subW6*u[10]*u[36]))*u[38] + 2.*subW55*u[10]*u[27]*u[48]) + 2.*subW3*(u[9]*(-u[10]*(subW6*u[27] + subW128*u[48]) + u[12]*(subW127*u[7] -subW15*u[48])) + u[8]*(subW56*(subW10 - 2.*u[37]*u[43]) + u[10]*u[27]*(2.*u[19]*u[37] -u[10]*u[50])))) + kTv*(2.*u[9]*(subW2*(-subW31 + subW63)*u[7] + (subW129*subW60 + subW6*subW61)*u[10] + (subW129*subW15 + subW128*u[7]*u[10])*u[12])*u[41] + u[8]*(u[27]*(-4.*subW12*u[38]*u[41]*u[50] -u[10]*u[37]*(3. + u[41]*(u[18] + 3.*u[52]))) + 2.*(subW56*(subW130*u[37] + 2.*subW10*u[38]*u[41]) + u[9]*(u[41]*((-subW10 + subW69)*u[12]*u[30] + subW12*u[36]*u[50]) -u[10]*(2.*subW26*u[19]*u[41] + u[12]*(-1. + u[41]*(u[18] + u[52]))))) + u[41]*(u[29]*(u[28]*(-2.*subW2*u[24] + 4.*u[12]*u[37]*u[43]) + 2.*u[10]*(subW10 - 2.*u[37]*u[43])*u[51]) - 4.*u[10]*u[27]*u[37]*u[53]))) + u[8]*(-4.*subW123*subW2*u[24]*u[38]*u[41] - 2.*u[12]*(u[29]*(subW130*u[28]*u[37] - 2.*u[10]*u[24]*u[38]*u[41]*u[51]) + u[9]*(subW130*subW70 + 2.*u[10]*u[38]*(-1. + u[41]*(u[18] + u[52])))) + u[10]*(2.*subW130*subW96*u[37] + subW60*(4.*u[10]*u[38]*u[41]*u[50] + u[37]*(3. + u[41]*(u[18] + 3.*u[52] + 4.*u[53]))))));
u[57] = subW12*subW13*subW7*u[9]*u[12]*u[13]*u[23]*u[41]*(2.*u[9]*u[12]*(u[19] -u[42]) + u[27]*(-subW9 + u[10]*u[50]));
u[58] = kTv*subW1*subW12*subW2*subW7*u[15]*(u[13]*(-2. + u[16]*u[17]) + (2. -u[6]*u[16])*u[23])*(-2.*u[41] + u[14]*(-2. + (subW3 + 2.*kTv*subW45)*u[41]));
u[59] = subW1*subW2*subW4*subWW10*subWW2*u[14]*(2.*subW45*subWW10 -subW123*u[48]);
u[60] = subW19*subW2*subW7*subW8*u[9]*u[10]*(2.*subW27*u[9]*u[10] + subW117*u[11])*u[22];
u[61] = subW19*subW2*subW7*subW8*u[9]*u[10]*u[22]*(-2.*subW27*u[9]*u[10] + subW121*u[37]);
u[62] = subWW10*u[9]*u[12]*u[15]*(subWW10*((subW26*u[9]*(subWW4*u[13] + u[16]*u[23]) + u[12]*(subW39*(subW22 + subWW4*u[13]) - 2.*u[9]*(subWW4*u[13] + u[16]*u[23])*u[38]))*u[41] + u[9]*u[12]*(2.*kTv*(subW19*u[41] + u[13]*(subW35*u[14] + (u[14]*(-3. + u[16]*u[17]) + u[23])*u[41]) + u[14]*(u[23]*u[41] + u[16]*(-2.*u[23] + u[41]))) - 2.*subW22*u[14]*u[43])) + u[12]*u[14]*u[16]*(subW15*u[9]*u[23] + subW1*(-u[13] + u[23])*u[30])*u[48] + u[9]*(2.*subWW10*u[12]*u[41]*(subW3*subW45*u[14]*(-u[13] + u[16])*u[23] + (subW22 + subWW4*u[13])*u[43]) + u[14]*(u[16]*(u[11]*(subW2*subW4*u[7] + subW6*u[12]*u[13]) + u[12]*(subWW10*(2.*subW45*u[13] + 4.*u[19]*(-u[13] + u[23])) -u[23]*(subW6*u[11] + 2.*subWW10*u[38]))) + u[12]*(subW55*subWW10*(-u[13] + u[16])*u[23]*u[41] -subW15*u[13]*u[16]*u[48]))));
u[64] = subWW10*u[9]*u[12]*u[23]*(2.*(u[22]*(2.*subW5*subWW2*u[9]*(2.*subW60*u[10] + subW131*u[12])*u[13]*u[38] + subW7*(subW73*(subWW2*u[37] + u[13]*(u[16]*u[37] + u[15]*(u[37] + 2.*subW9*u[16]*u[38]))) + u[15]*(3.*subW2*u[13]*u[16]*u[24]*u[26]*u[38] + u[12]*(2.*u[16]*u[26]*u[37] + u[13]*(4.*subW92*u[16]*u[24]*u[38] + u[26]*(u[37] + subW9*u[16]*u[38])))))) -u[8]*(subWW2*u[13]*u[22]*(subW123*subW2*u[24] + u[9]*(-4.*subW6*subW92 - 2.*subW2*u[7]*u[26]))*u[38] + u[12]*(subWW2*u[9]*u[22]*(subW70 - 4.*u[10]*u[38]) + u[13]*(u[16]*u[22]*(2.*subW15*u[37] + u[9]*(subW54 + 4.*u[10]*u[38])) + u[15]*(subW15*u[22]*(u[37] + 3.*subW9*u[16]*u[38]) + u[9]*u[16]*u[38]*(-subW9*u[22]*u[30] + 4.*u[10]*(1. + u[22]*(u[5] -u[46])))))))) + u[16]*(subW3*u[13]*u[15]*u[22]*(2.*subW5*u[9]*(subW56 - 2.*u[10]*u[27]) -u[8]*(4.*subW78*u[9]*u[10] + subW132*u[8]*u[37] + u[12]*(subW126*u[11] -subW15*u[37] + 4.*u[9]*u[10]*(u[42] -u[43])))) + kTv*(u[13]*u[15]*u[22]*(2.*subW5*u[9]*(2.*subW128*u[10] + (subW131 + subW63)*u[12]) + subW7*(3.*subW2*u[24]*u[26] + u[12]*(4.*subW92*u[24] + u[26]*(subW9 + 2.*(-subW27 + u[19])*u[37])) + 4.*subW92*(subW9 + u[37]*(u[19] -u[42] -u[43])))) -u[8]*(u[12]*u[22]*(-2.*u[11]*u[15]*u[37] + u[13]*(2.*u[11]*u[37] + u[15]*((3.*subW15 + subW63)*subW9 + subW10*(subW15 - 2.*u[11]*u[38]) + 2.*subW15*u[37]*(u[19] -u[42] -u[43])))) + u[9]*(u[12]*u[13]*u[15]*u[22]*(-2.*subW5*u[26] + (subW10 -subW9)*u[30]) + 4.*u[10]*(u[12]*(-u[15]*u[22] + u[13]*(u[22] + u[15]*(1. + u[22]*(u[5] + 2.*subW75*u[38] -u[46])))) + (2.*subW101 -subW6)*u[13]*u[15]*u[22]*u[47]))))));
u[65] = -subW16*subWW10*u[9]*u[12]*u[13]*u[41]*(2.*subW114*subW127*u[9] + u[8]*(2.*u[9]*(subW47 + subW77*u[10])*u[12] + u[10]*u[27]*(subW9 + u[10]*u[50])));
u[66] = subW16*subWW10*u[9]*u[12]*u[13]*u[22]*(subW126*subW56*u[8] + 2.*u[9]*(subWW10*(subW78 + subW75*u[12]) + subW5*(-subW56 + u[10]*u[27])));
u[67] = subW16*subWW10*u[9]*u[12]*u[13]*u[14]*(2.*subW153*subWW10 + u[9]*(-2.*subW60*u[10] + (-subW15 + subW31)*u[12])*u[48]);
u[68] = subW16*subWW10*u[9]*u[12]*u[13]*u[22]*(2.*subW5*u[9]*u[10]*u[27] + u[8]*(-subW132*u[8]*u[37] + u[12]*(2.*subW75*u[9]*u[10] + subW15*u[37]) + subW73*u[9]*u[48]));
u[69] = -subW16*subWW10*u[9]*u[12]*u[13]*(u[14]*(subW1*(-u[12]*u[30] + 2.*u[10]*u[36])*u[48] + u[12]*(-u[7]*(subW56*u[9] + subW14*(u[9]*(2.*subW26 + subW136*u[12]) + 2.*subW10*u[27])*u[41]) + u[9]*(u[11]*(subW6 - 2.*subW114*u[18]*u[41]) + subW15*u[48]))) + u[41]*(subW7*(subW92*u[37] + u[12]*(subW137*subW92*u[14]*u[24] + 2.*u[26]*(-subW49*u[14] + u[37])) + 2.*subW2*u[14]*u[24]*u[26]*(subW45 + u[19] -u[42])) + (2.*subW12*u[9]*u[27] + u[14]*(subW1*(-u[10]*u[12]*u[30]*(u[38] + u[42] - 3.*u[43]) - 2.*subW12*u[36]*(u[38] -u[42] + u[43])) + u[36]*(2.*subW15*u[9]*u[10]*u[37] - 2.*subW12*(subW1*u[19] + u[9]*u[11]*u[50])) + u[10]*(2.*((subW1*subW70 + subW9*u[9]*u[11])*u[36] + subW56*u[9]*(u[46] + u[52])) + u[12]*((2.*subW39*u[9] + subW1*u[19])*u[30] + u[29]*((2.*subW39 + subW136*u[9])*u[28] - 2.*u[11]*u[24]*u[51]) - 2.*u[9]*u[11]*u[53]))))*u[63]) + u[8]*(u[41]*(-subW12*u[27]*u[50] + u[10]*(-subW9*u[27] + subW96*u[37] + subW10*u[14]*(subW138*subW96 + 2.*u[27]*(u[18] + u[46] + u[52] + u[53]))) + u[14]*(2.*subW10*u[26]*(-subW6*u[27] + subW96*u[48]) + u[9]*(subW12*subW138*u[36]*u[50] + u[26]*(-2.*subW124*u[20]*u[36] + u[12]*(subW6*(subW44 -u[19] - 3.*u[43]) + 2.*u[48]*(subW43 -u[52] + u[53]))) + u[10]*(u[12]*(-(subW75 + 3.*subWW6)*u[18] -u[38]*u[46] + u[42]*u[46] + 3.*u[43]*u[46] - 3.*u[38]*u[52] + 3.*u[42]*u[52] + u[43]*u[52] + u[19]*(3.*u[46] + u[52] -u[53]) -u[38]*u[53] - 3.*u[42]*u[53] + 3.*u[43]*u[53]) + u[36]*(subW137*subW9 + 2.*(u[26]*u[48]*u[50] + u[37]*(u[18] + u[46] + u[52] + u[53]))))))) - 2.*subW10*u[11]*u[14]*(u[12] -subW92*u[41]*u[63])));
u[73] = subW12*subW13*subW7*u[9]*u[12]*u[23]*u[41]*(2. + u[13]*(subW3 + 2.*kTv*u[43]))*(kTv*(2.*u[9]*u[12] + u[27]*u[37]) + u[12]*(subW39 + 4.*u[9]*u[43]));
u[74] = -subW139*subWW10*u[9]*u[12]*u[20]*(-u[16]*(-2.*kTv*u[13]*u[15]*u[23]*((subW72 + subW92)*u[8] + u[9]*(u[12]*u[30] -u[10]*u[36])) + u[8]*(-4.*(subW44*subW72 + subW24*subW92)*u[13]*u[15]*u[23] + subW72*(subW16 + u[13]*(subW22 + u[15]*(u[16] - 5.*u[23])))*u[43]) + u[9]*(4.*subW24*u[10]*u[13]*u[15]*u[23]*u[36] + u[12]*u[30]*(-4.*subW44*u[13]*u[15]*u[23] + (subW16 + u[13]*(subW22 + u[15]*(u[16] - 5.*u[23])))*u[43]))) + subW56*(subW16*(-4. + kTv*u[16]*u[43]) + u[13]*(kTv*pow2(u[16])*u[23]*u[43] + u[15]*(kTv*pow2(u[16])*u[43] -u[23]*(-2. + u[16]*(3.*subW3 + kTv*(4.*subW44 - 2.*u[19] + 5.*u[43])))))))*u[70];
u[75] = subW139*subWW10*u[9]*u[12]*u[15]*u[20]*u[23]*(u[13]*u[16]*(subW3*(subW56 - 3.*u[10]*u[27]) + kTv*(subW132*u[8] + u[12]*(-subW15 + subW31 + 2.*u[11]*u[43]) - 2.*u[10]*(subW60 + u[27]*(2.*subW44 - 2.*u[19] + u[43])))) + 2.*((subW14 -subW15 + subW31)*u[12]*u[13]*u[16]*u[43] + u[10]*(-u[16]*u[27] + 2.*u[13]*(u[27] + u[16]*u[43]*(-subW60 + u[8]*u[47])))))*u[70];
u[76] = -subWW10*subWW2*u[9]*u[12]*(u[41]*(u[10]*u[27]*(-4.*subW6*u[9]*u[13] + u[23]*(-2.*u[20]*(subW90 -subW89*u[13]*u[46]) + subW10*u[8]*u[13]*(4.*u[18] + u[53]))) + u[13]*u[23]*(subW3*(2.*(subW140*subW56*u[8] + u[37]*(subW7*subW92 -u[8]*(subW123*u[12] + 2.*u[10]*u[27]*u[42]))) + u[9]*(u[12]*(-2.*subW6*u[11] + 2.*subW31*u[48]) -u[10]*(subW6*u[27] + 2.*subW60*u[48]))) + u[8]*(2.*subW55*u[11]*u[12]*u[37] + 4.*u[43]*(-subW15*subW2*u[24] + u[9]*u[10]*u[12]*(u[46] + u[53]))))) + u[13]*(u[10]*(u[8]*(-u[27]*(3.*subW10*u[23] + 2.*subW9*(u[23] + 2.*u[41])) + 4.*u[9]*u[12]*u[23]*u[43]) + 4.*subW10*subW7*u[23]*u[41]*u[43]*u[47]) + u[23]*u[41]*((4.*subW1*subW6*u[10]*u[36] + u[9]*(-4.*subW2*u[8]*u[24]*u[30] + 4.*u[20]*(subW15*u[12]*u[25] + subW89*u[10]*u[36])))*u[43] + subWW10*u[27]*(3.*subW10*u[46] - 2.*subW9*u[53])) - 2.*subW5*u[9]*(2.*subW31*u[12]*u[23]*u[41]*u[43] + u[10]*(2.*u[27]*u[41] + u[23]*(-2.*subW60*u[41]*u[43] + u[27]*(1. + u[41]*(-u[46] + u[53]))))) + kTv*(2.*u[9]*(u[23]*(-subW2*subW31*u[7] + u[12]*(subW141*subW6 + u[9]*(2.*subW115*u[30] + u[7]*u[10]*u[36])))*u[41] + u[10]*((-2.*subW115 + subW6)*subW60*u[23]*u[41] + u[27]*(-subW6*u[23]*u[41]*u[43] + u[48]*(2.*u[41] + u[23]*(1. + u[41]*(-u[46] + u[53])))))) + u[23]*(subW140*subW7*subW73*u[41] + u[8]*(-2.*(subW10*subW141 + subW15*subW69)*u[12]*u[41] + u[10]*u[27]*(-4.*subW10*u[41]*u[42] + u[37]*(-3. + u[41]*(4.*u[18] + 3.*u[46] + u[53]))) + 2.*u[9]*(-subW140*u[12]*u[30]*u[41] + u[10]*(subW9*u[36]*u[41] + u[12]*(1. + u[41]*(u[46] + u[53])))))))));
u[77] = subW12*subW13*subW7*u[9]*u[12]*u[13]*u[23]*u[41]*(2.*u[9]*u[12]*(u[19] -u[42]) + u[37]*(subW96 -u[8]*u[47]));
u[78] = subW16*subWW10*u[9]*u[12]*u[13]*(2.*subW114*subW56*u[9] + subW7*(2.*subW72 + subW92)*u[37] + u[8]*(2.*u[9]*(subW47 + subW77*u[10])*u[12] + subW96*u[10]*u[37]))*u[41];
u[79] = subW12*subW139*subW16*u[8]*u[9]*u[12]*u[13]*u[20]*u[27]*u[70];
u[80] = subW139*subW16*subW2*subWW10*u[9]*u[11]*u[13]*u[20]*u[70];
u[82] = subW22*subWW10*u[9]*u[12]*u[13]*(u[15]*(-subW6*u[9]*(subW60*(subW70 - 2.*u[10]*u[38]) + subW15*(subW26 - 2.*u[12]*u[38])) + subW55*u[27]*(u[9]*u[10] + u[11]*u[37])*u[48] -subW3*(subW1*u[10]*u[36]*u[48] + u[27]*u[37]*(subW6*u[11] + subW15*u[48]) + u[8]*(-u[10]*(subW78*u[9] + u[27]*(-subW9 + u[37]*u[42])) + subW142*u[37]*u[48]) + u[9]*(subW129*u[10]*u[27] + (subW15*u[12] + (u[27]*u[30] + u[11]*u[36])*u[37])*u[48])))*u[81] -subW7*(subW72*u[15]*u[37] + u[47]*(-subW6*u[15]*u[26]*u[37]*u[81] + u[10]*(u[37]*u[81] + u[15]*(u[37] + (subW48 + 2.*subW9*u[38])*u[81])))) + u[8]*(subW15*(u[12]*(2.*subW9*u[15]*u[38] + u[37]*(1. + u[15]*u[46])) + subW6*u[15]*u[37]*u[47])*u[81] + u[9]*(u[15]*u[37]*(-u[12]*u[30] + subW6*subWW13*u[81]) + u[10]*(subW26*u[81] + u[15]*(-2.*subW6*u[38]*u[47]*u[81] + u[36]*(u[37] + (subW48 + 2.*subW9*u[38])*u[81]))))) + kTv*(u[15]*(subW15*subW6*u[27]*u[37] + subW1*u[36]*(subW129*u[10] + subW70*u[48]) -subW7*u[47]*(u[10]*(subW9 -u[37]*u[42]) + u[26]*u[37]*u[48]) + u[9]*(subW129*subW15*u[12] + subW6*u[27]*(subW70 - 2.*u[10]*u[38]) + subW26*(subW6*u[11] + subW15*u[48])))*u[81] + u[8]*(u[15]*((subW15*u[12]*(subW9 -u[37]*u[42]) + u[37]*(subW6*subW97 -(subWW13*u[9] + subW15*u[47])*u[48]))*u[81] + u[11]*u[37]*(u[12] -subW6*u[47]*u[81])) -u[10]*(u[27]*u[37]*u[81] + u[15]*(u[9]*(subW26*u[42] + subW64*u[47] + u[20]*(-u[21]*u[36] + u[25]*u[47]))*u[81] + u[27]*(2.*subW9*u[38]*u[81] + u[37]*(1. + u[46]*u[81])))))));
u[83] = subW1*subW16*subWW10*u[12]*u[13]*u[29]*u[48]*(-u[12]*u[28] + u[10]*u[51])*u[81];
u[84] = -subW16*subWW10*u[9]*u[12]*u[13]*(u[20]*u[29]*(u[27]*u[28] -u[11]*u[51])*(u[12]*(u[7]*u[21] -u[24]*u[25]) + u[10]*(u[25]*u[50] + u[21]*u[63]))*u[70]*u[81] + u[9]*(-subW56*subW6*u[70] + u[29]*(subW124*u[20]*(-u[28]*u[36] + u[30]*u[51])*u[70] + u[12]*u[28]*(-u[48] + subW143*subW6*u[70]))*u[81] + u[10]*(subW96*u[48]*u[81] + subW6*u[70]*(u[27] -subW143*subW96*u[81]))) + u[8]*(-subW56*subW9*u[70] + u[29]*(subW124*u[20]*(u[28]*u[47] + u[26]*u[51])*u[70] + u[12]*u[28]*(u[37] + subW143*subW9*u[70]))*u[81] + u[10]*(-subW96*u[37]*u[81] + subW9*u[70]*(u[27] -subW143*subW96*u[81]))));
u[87] = -subW1*subW2*subW4*subWW10*u[14]*u[16]*(2. + u[15]*(subW3 + 2.*kTv*u[42]))*(2.*kTv*subWW14 -subW123*u[48] + u[8]*(4.*u[10]*u[42] - 2.*u[26]*u[48]));
u[88] = subWW10*subWW2*u[9]*u[12]*u[13]*(u[23]*(-subW55*subWW14*u[27]*u[37] + subW7*subW9*u[47]*(-2.*u[10]*u[42] + u[26]*u[48]) + subW3*(subW144*subW57*u[9] -subW9*subWW14*u[27] + u[37]*(-subW7*subW92 + (u[27]*(subW15 + u[9]*u[30]) + u[9]*u[11]*u[36])*u[48] + u[8]*(subW15*u[12] + u[10]*(subW60 - 2.*u[27]*u[42]) + subW142*u[48]))))*u[81] + u[9]*(subW15*(2.*subW6*u[12]*u[23]*u[42] -(subW9*u[23]*u[36] + u[12]*(1. + u[23]*u[46]))*u[48])*u[81] + u[9]*(u[12]*u[23]*u[30]*u[48] -u[36]*(subW9*u[23]*u[30]*u[48]*u[81] + u[10]*(u[48]*u[81] + u[23]*(u[48] + (-2.*subW6*u[42] + u[46]*u[48])*u[81]))))) + u[8]*(subW15*subW9*u[23]*(subW78 + 2.*u[12]*u[42])*u[81] + u[9]*(u[23]*u[48]*(subW72 + subW9*subWW13*u[81]) + u[10]*(subW78*u[81] + u[23]*(2.*subW9*u[36]*u[42]*u[81] + u[47]*(u[48] + (-2.*subW6*u[42] + u[46]*u[48])*u[81]))))) + kTv*(u[23]*(subW15*subW9*u[27]*u[48] + subW1*u[36]*(subW144*u[10] + subW54*u[48]) + subW7*u[47]*(-subW145*u[10] + u[26]*u[37]*u[48]) + u[8]*(subW145*subW15*u[12] - 2.*subW9*u[10]*u[27]*u[42] + (subW142*subW9 + subW15*u[37]*u[47])*u[48]))*u[81] + u[9]*(u[23]*((subW144*subW15*u[12] + (subW9*u[27]*u[30] + (subWW8*u[8] -subW121*u[36])*u[37])*u[48])*u[81] + subWW11*(-u[12] + subW9*u[36]*u[81])) + u[10]*(u[27]*u[48]*u[81] + u[23]*(u[8]*(-subW78*u[38] + 2.*subW26*u[42] + u[20]*(u[21]*u[36] -u[25]*u[47]))*u[81] + u[27]*(-2.*subW6*u[42]*u[81] + u[48]*(1. + u[46]*u[81])))))));
u[89] = subWW10*u[9]*u[12]*u[15]*(2.*(u[9]*u[14]*(2.*subW60*u[10]*(2.*subW6*u[13]*u[16]*u[23]*u[42] + (subW19 -u[13]*(u[16] + u[23]))*u[48]) + u[12]*(subW22*(u[7]*(subWW3 + (subW15 - 3.*subW31)*u[12])*u[13]*u[42] + 2.*subW31*u[48]) + u[13]*((-subW15 + subW31)*u[23]*u[48] + u[16]*((3.*subW15 -subW31)*subW6*u[23]*u[42] - 2.*subW15*u[48])))) + u[16]*(2.*subW10*subW132*subW7*u[13]*u[14]*u[23]*u[42] -u[8]*(2.*subW15*subW2*u[13]*u[14]*u[23]*u[24]*u[42] + u[9]*(4.*u[10]*(u[12]*(-u[14]*u[23] + u[13]*(u[14] + u[23] + subW43*u[14]*u[23])) -subW9*u[13]*u[14]*u[23]*u[36])*u[42] + u[12]*u[14]*(u[13]*(subW47 + u[23]*(subW122 + subW6*u[26])*u[42]) + u[23]*u[26]*(-subW5*u[13]*u[42] + u[48])))))) + u[16]*(subW3*u[13]*u[14]*u[23]*(4.*subW153*subWW10 -subW2*u[11]*(u[7]*u[9] + 2.*u[8]*u[24]) + u[9]*(subW6*u[11]*u[12] + (2.*subW60*u[10] + subW131*u[12])*u[48])) + kTv*(u[8]*(-2.*subW10*u[13]*u[14]*u[23]*(-4.*u[10]*u[27]*u[42] + u[12]*(subW15 + 2.*u[11]*u[42])) + u[9]*(u[12]*u[13]*u[14]*u[23]*((subW5 -subW6)*u[26] - 2.*subW10*u[30]) - 4.*u[10]*(-subW145*u[13]*u[14]*u[23]*u[36] + u[12]*(-u[14]*u[23] + u[13]*(u[23] + u[14]*(1. + u[23]*(subW43 + 2.*u[42]*(u[38] -u[43])))))))) + u[14]*(2.*subW10*subW132*subW7*u[13]*u[23] + u[9]*(u[13]*u[23]*(subW5*(subWW3 + u[12]*(subW15 - 3.*subW31 - 2.*u[11]*u[42])) + subWW3*(subW6 + (subW45 -u[19])*u[48])) + u[12]*(2.*subWW11*u[23] + u[13]*(subW6*u[23]*(3.*subW15 -subW31 + 2.*u[11]*u[42]) - 2.*(u[11] + subW131*u[23]*(u[19] -u[38] -u[43]))*u[48])))))));
u[90] = subW1*subW2*subW4*subWW10*subWW2*(-2.*subW45*subWW10 + (subW5 + subW6)*u[11])*u[14];
u[91] = subW16*subW7*u[9]*u[10]*u[12]*u[13]*u[29]*u[37]*(-u[12]*u[28] + u[10]*u[51])*u[81];
u[92] = subW16*subWW10*u[9]*u[12]*u[13]*u[14]*(-2.*subW153*subWW10 + u[11]*(u[9]*(subW2*u[7] -subW6*u[12]) + 2.*subW2*u[8]*u[24]));
u[94] = -subW1*subW12*subW35*u[8]*u[12]*u[15]*(2. + u[13]*(subW3 + 2.*kTv*u[43]))*(u[12]*(-u[7]*u[27] + 4.*u[8]*u[43]) + kTv*(2.*u[8]*u[12] + u[27]*u[48]))*u[93];
u[95] = subW19*subWW10*u[9]*u[12]*u[13]*(u[15]*(2.*subW55*subW56*u[9]*u[48] + subW3*(2.*(subW7*(subW72 + subW92)*u[37] + u[8]*(subW57*u[37]*u[42] + u[12]*(subW9*u[11] + u[9]*(subW47 + u[10]*u[42])))) + u[9]*(-2.*subW2*u[7]*u[11] + (-2.*subW141*u[12] + u[10]*(2.*subW96 + u[27]*(-4.*u[19] + u[42])))*u[48])))*u[93] + subW5*u[9]*(4.*subW121*u[12]*u[15]*u[43]*u[93] + u[10]*(-u[27]*u[93] + u[15]*(-4.*subW96*u[43]*u[93] + u[27]*(-3. + (-4.*subW105 + u[18])*u[93])))) + kTv*(2.*subW7*u[15]*((subW69 + subW9)*subW92 + subW2*u[24]*u[26] + u[12]*(subW92*u[24] + subW69*u[26]))*u[93] + u[9]*(2.*u[15]*((-2.*subW115*subW15 + subW141*subW5)*u[12] + subW12*u[27]*u[42]*u[63])*u[93] + u[10]*(u[27]*u[48]*u[93] + u[15]*(-2.*(-2.*subW115 + subW5)*subW96*u[93] + u[27]*(subW154*u[48] + subW5*(4.*u[19] -u[42])*u[93])))) - 2.*u[8]*(subW141*subW9*u[12]*u[15]*u[93] + subW57*(subW146*u[15]*u[37] + (u[37] -subW117*u[15]*u[42])*u[93]) + u[9]*(u[15]*((2.*subW115 -subW5)*subW72 + subW12*u[47]*u[63])*u[93] + u[10]*u[12]*(-u[93] + u[15]*(-1. + (u[18] - 2.*(u[40] + u[42]*u[43]))*u[93]))))) + 2.*(2.*subW7*u[15]*(subW9*subW92 + subW150*u[24])*u[43]*u[93] -subW12*u[9]*u[27]*u[63]*(subW146*u[15] + u[93]) + u[8]*(-2.*u[15]*u[43]*(subW15*subW9*u[12] + subW12*u[9]*u[47]*u[63])*u[93] + u[10]*((subW9*u[27] + u[12]*(subW39 + 2.*u[9]*u[43]))*u[93] + u[15]*(subW146*subW9*u[27] + u[12]*(subW146*subW39 + 2.*u[9]*u[43]*(1. -(u[18] - 2.*u[40])*u[93])))))));
u[96] = -kTv*subW1*subW12*subW2*subW7*(u[13]*(-2. + u[4]*u[16]) + u[15]*(2. -u[6]*u[16]))*u[23]*(-2.*u[93] + u[22]*(-2. + (2.*kTv*subW27 + subW3)*u[93]));
u[97] = subW1*subW12*subW35*u[8]*u[12]*u[13]*u[15]*(2.*u[8]*u[12]*(u[19] -u[38]) + (subW60 + subW96)*u[48])*u[93];
u[98] = subWW10*u[9]*u[12]*u[23]*(u[8]*(subW8*u[12]*u[16]*u[22]*(subW117*u[11] + subW15*u[37]) + u[9]*u[10]*(subW78*(subWW2 + u[13]*(-2.*u[15] + u[16]))*u[93] + 2.*u[12]*(subWW2*((subW27 - 2.*u[19])*u[22] + subW75*u[93]) + u[13]*(2.*u[15]*(-u[42] + u[43])*u[93] + u[16]*(u[22]*(2.*u[19] -u[42] -u[43]) + subW75*u[93]))))) + u[12]*(u[22]*(subW7*subW8*u[16]*u[26]*u[37] + subW55*subWW10*u[9]*u[13]*(-u[15] + u[16])*u[93]) + u[9]*u[10]*((2.*subW27*subW3*u[8]*u[13]*(-u[15] + u[16])*u[22] + u[7]*(subWW2 + u[13]*(-2.*u[15] + u[16]))*u[27])*u[93] + 2.*kTv*u[8]*(u[13]*(u[22]*u[93] + u[15]*(u[22] + u[93]) -u[16]*(2.*u[22] + u[93])) + u[22]*(u[16]*u[93] + u[15]*(-3.*u[93] + u[16]*(1. + u[6]*u[93])))))));
u[99] = subW16*subWW10*u[9]*u[12]*u[13]*(u[9]*(2.*subW31*u[12]*u[48] + u[10]*(subW6*u[27] + (-subW60 + subW96)*u[48]) -subW12*u[27]*u[63])*u[93] -u[22]*(subW7*(subW73*(u[37] -(subW47 + u[10]*(subW27 + u[19] -u[38]))*u[50]*u[93]) + subW72*(u[37] + u[10]*(subW44 -u[19] - 3.*u[43])*u[50]*u[93])) + subW5*((subW1*((2.*subW70 -subW137*u[10])*u[36] + 2.*u[12]*u[30]*(subW27 + u[19] -u[38])) + 2.*u[10]*u[50]*(subW14*u[27] + u[29]*(u[27]*u[28] -u[11]*u[51])))*u[93] + u[9]*((2.*(subW70*subW96 + u[27]*(subW117*u[30] + u[10]*(u[5] + u[40] + u[46]))) + u[10]*(subW136*subW96 + 2.*u[27]*u[52]))*u[93] - 2.*u[11]*(u[12] + u[10]*u[36]*u[50]*u[93])))) + u[8]*((2.*u[10]*(-subW15*subW78*u[22] + u[10]*u[27])*u[50] + u[9]*u[22]*(subW138*subW2*u[24]*u[30] + u[47]*(-2.*subW124*u[20]*u[30] + subW12*(u[19] + 3.*u[38] -u[42] -u[43])*u[63] + u[10]*(subW137*subW6 - 2.*((subW105 + u[5] + u[46])*u[48] + subW70*u[63])))))*u[93] + u[22]*(u[12]*(-u[9]*(u[5]*(-2.*subW70 + u[10]*(3.*subW77 + u[38] -u[43])) + u[10]*(u[40]*(3.*u[38] + u[42] - 3.*u[43]) + (-u[38] + u[42] - 3.*u[43])*u[46] -(3.*u[38] - 3.*u[42] + u[43])*u[52]) -u[19]*(subW9*u[30] + u[10]*(-u[40] + 3.*u[46] + u[52])) + u[30]*(subW9*(subW44 - 3.*u[43]) + 2.*(subW49 + u[37]*(-u[40] + u[46] + u[52]))))*u[93] + subW15*(u[37] + subW138*u[10]*u[50]*u[93])) + u[11]*(subW2*u[24] + (subW114 + subW6)*subW73*u[50]*u[93] -u[12]*(subW9 + 2.*u[10]*u[50]*(u[5] + u[40] -u[46] -u[52])*u[93])))));
u[100] = subW16*subWW10*u[9]*u[12]*u[13]*(u[9]*(subW96*u[10] + u[9]*(2.*u[12]*u[30] -u[10]*u[36]))*u[48] + 2.*u[8]*u[12]*(subW54*u[9] + u[10]*(subWW6*u[9] + u[11]*u[50])))*u[93];
u[101] = subW1*subW12*subW35*u[8]*u[12]*u[13]*(2. + u[15]*(subW3 + 2.*kTv*u[42]))*(u[8]*(subW78 + 2.*u[12]*(kTv + 2.*u[42])) + kTv*u[27]*u[48])*u[93];
u[102] = subW16*subWW10*u[9]*u[12]*(u[13]*(-2.*subW55*subWW10*u[27]*u[37] - 4.*subW7*(subW9*subW92 + subW150*u[24])*u[42] + subW3*(-2.*subW7*subW92*u[37] + 2.*(subW2*u[7]*u[9]*u[11] + u[8]*(subW2*u[11]*u[24] + subW15*u[12]*u[37] -u[10]*(subW145*u[27] + u[12]*(subW39 -u[9]*u[43])))) + u[9]*((2.*subW56*u[43] + u[10]*u[27]*(-4.*u[19] + u[43]))*u[48] + 2.*subW12*u[27]*u[63])))*u[93] + 2.*u[9]*u[29]*(u[12]*u[28] -u[10]*u[51])*(subW146*u[13]*u[48] + (-2.*subW5*u[13]*u[42] + u[48])*u[93]) + u[8]*(4.*subW15*subW9*u[12]*u[13]*u[42]*u[93] + u[9]*(4.*subW12*u[13]*u[42]*u[47]*u[63]*u[93] + 2.*subW72*(u[48]*u[93] + u[13]*(u[48] + (-2.*subW5*u[42] + u[18]*u[48])*u[93])) + u[10]*(subW78*(subW154*u[13] + u[93]) - 4.*u[12]*u[42]*(-u[93] + u[13]*(1. + (u[18] - 2.*u[52])*u[93]))))) + kTv*(-2.*subW7*u[13]*(subW145*subW92 + subW150*u[24])*u[93] + u[9]*(subW154*u[10]*u[13]*u[27]*u[48] + (2.*subW152*(subW96*u[10] -subW15*u[12])*u[13] + u[27]*(u[10]*u[48] + 4.*subW12*u[13]*u[42]*u[63]))*u[93] - 2.*subW56*(u[48]*u[93] + u[13]*((1. + subW109)*u[48] - 2.*subW5*u[42]*u[93]))) + u[8]*(2.*u[13]*(-2.*(-subW2*u[11]*u[24] + u[10]*(subW39*u[12] + subW9*u[27]))*u[42] + subW15*u[12]*(subW9 + 2.*u[37]*u[42]))*u[93] + u[9]*(u[13]*(-2.*subW152*subW72 + 2.*subW12*u[47]*u[63])*u[93] + u[10]*(subW78*u[13]*(-4.*u[19] + u[43])*u[93] - 2.*u[12]*(-u[93] + u[13]*(1. + (u[18] - 2.*(u[42]*u[43] + u[52]))*u[93])))))));
u[103] = subW1*subW12*subW35*u[8]*u[12]*u[13]*u[15]*((subW114 + subW6)*u[27] + 2.*u[8]*u[12]*(u[19] -u[38]))*u[93];
u[104] = subW16*subWW10*u[9]*u[12]*u[13]*((subW114 -subW6)*u[9]*u[10]*u[27] + 2.*u[8]*(u[9]*(subW54 + subWW6*u[10])*u[12] + subW127*u[10]*u[50]))*u[93];
COMPLEX subA1 = pow2(u[31]);
COMPLEX subA2 = u[34]*u[35];
COMPLEX subA5 = u[44]*u[49];
COMPLEX subA8 = u[32]*u[33];
COMPLEX subA9 = -u[44]*u[45];
COMPLEX subA10 = 2.*u[56] -u[64];
COMPLEX subA12 = u[54] - 2.*u[74];
COMPLEX subA14 = -u[72]*u[73];
COMPLEX subA17 = u[56] + 2.*u[82];
COMPLEX subA18 = u[44]*u[45];
COMPLEX subA19 = -u[86]*u[87];
COMPLEX subA20 = -4.*u[86]*u[88];
COMPLEX subA21 = u[86]*u[89];
COMPLEX subA24 = pow2(u[34]);
COMPLEX subA26 = -u[72]*u[94];
COMPLEX subA27 = u[75] + u[95];
COMPLEX subA28 = u[34]*u[94];
COMPLEX subA29 = subA2 + u[54] + u[55];
COMPLEX subA31 = subA5 + u[60] -u[61];
COMPLEX subA33 = subA2 + u[55] + 2.*u[74];
COMPLEX subA35 = subA19 + subA8 -u[59] + u[90];
COMPLEX subA37 = -subA24*u[96];


COMPLEX amp12345 = 0.015625*(-subA1*u[58] - 2.*(subA29*u[32] + subA31*u[34] + subA10*u[44] + u[31]*(subA8 + subA9 + u[57] -u[59] + u[62]) + u[65] + u[66] -u[67] + u[68] -u[69]));

COMPLEX amp12435 = 0.03125*(subA33*u[32] + subA31*u[34] + u[66] + u[68] + u[44]*(-u[64] - 4.*u[82]) - 2.*(u[79] + u[83]) + 2.*u[84]);

COMPLEX amp12534 = 0.015625*(subA37 - 2.*u[34]*(subA26 + u[61] + u[97] + u[98]) + 2.*(subA33*u[32] + u[68] - 2.*(subA27*u[72] + u[79] + u[80]) + u[99] + u[100]));

COMPLEX amp13245 = 0.015625*(subA1*u[58] - 2.*u[31]*(subA18 + subA19 -u[57] -u[62] + u[90]) + 2.*(subA20 + subA21 + 2.*subA17*u[44] + u[65] -u[69] + 2.*u[83] + 2.*u[91] -u[92]));

COMPLEX amp13425 = 0.015625*(subA24*u[96] + 2.*u[34]*(subA5 + u[60] + u[98] -u[86]*u[101] -u[103]) - 2.*(subA20 -u[66] + u[44]*(u[64] + 4.*u[82]) + 2.*u[83] + 2.*u[91] + u[99] - 2.*u[86]*u[102] -u[104]));

COMPLEX amp13524 = 0.03125*((-2.*subA27 + subA28)*u[72] - 2.*(u[80] + u[84] + u[91]) + u[100] + u[86]*(4.*u[88] -u[34]*u[101] + 2.*u[102]) -u[34]*(u[97] + u[103]) + u[104]);

COMPLEX amp14235 = 0.03125*(u[65] + u[72]*(-2.*u[75] + 2.*u[76]) + u[31]*(subA9 + u[57] + u[72]*u[73] + u[77]) -u[78] + 2.*(subA17*u[44] + u[83]) - 2.*(u[80] + u[84]));

COMPLEX amp14325 = 0.015625*(subA37 + 2.*u[31]*(subA14 + subA18 -u[57] -u[77]) - 2.*(subA10*u[44] + u[65] + u[66] -u[78] + 2.*u[72]*(u[76] + u[95]) + u[34]*(subA26 + subA5 + u[60] + u[97] + u[98]) -u[99] -u[100]));

COMPLEX amp14523 = 0.015625*(subA1*u[58] + 2.*(subA21 -u[69] + u[78] + u[31]*(subA14 + u[62] -u[77] + u[86]*u[87] -u[90]) -u[92] + u[72]*(subA28 - 2.*u[76] - 2.*u[95]) -u[34]*u[97] + u[100] -u[34]*u[86]*u[101] + 2.*u[86]*u[102] -u[34]*u[103] + u[104]));

COMPLEX amp12354 = 0.015625*(subA1*u[58] + 2.*(subA12*u[32] -u[67] -u[69] + 2.*u[72]*u[75] - 2.*u[72]*u[76] + u[31]*(subA14 + subA8 -u[59] + u[62] -u[77]) + u[78] + 2.*u[79] + 2.*u[80]));

COMPLEX amp12453 = 0.03125*(-subA21 + subA35*u[31] + subA12*u[32] -u[67] + 2.*u[79] - 2.*u[84] + 4.*u[86]*u[88] - 2.*u[91] + u[92]);

COMPLEX amp12543 = 0.015625*(subA24*u[96] + 4.*u[86]*u[102] - 2.*(subA35*u[31] + subA29*u[32] + u[68] + u[92] + u[99] + u[34]*(u[86]*u[101] + u[103])) + 2.*(subA21 + u[67] + u[34]*(u[61] + u[98]) + u[104]));

delete [] u;

// color factors are included below, without averaging

return 2.*27.*8./32.*(norm(amp12345) +norm(amp12435) +norm(amp12534) +norm(amp13245) +norm(amp13425) +norm(amp13524)
+norm(amp14235) +norm(amp14325) +norm(amp14523) +norm(amp12354) +norm(amp12453) +norm(amp12543) );


}
