//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->ggg for helicities LRLL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGGGG_LRLL() {
int Nsymb =106;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k1,k1);
u[2] = Dot(k1,k2);
u[3] = Dot(k2,n);
u[4] = Dot(k5,n);
u[5] = Dot(k3,k4);
u[6] = Dot(k3,n);
u[7] = S(L,k3,k5);
u[8] = S(L,k4,n);
u[9] = S(L,k5,n);
u[10] = S(R,k2,n);
u[11] = S(R,k2,n,e1);
u[12] = S(R,k3,n);
u[13] = Den(u[6]);
u[14] = Den(u[5]);
u[15] = Den(u[4]);
u[16] = Den(u[3]);
u[17] = Dot(e1,k2);
u[18] = Dot(k4,n);
u[19] = Den(u[18]);
u[20] = S(L,k4,k5);
u[21] = S(R,k4,n);
u[22] = Den(u[3] -u[4]);
u[23] = Den(u[1] + 2.*u[2]);
u[25] = Dot(k4,k5);
u[26] = S(R,k2,k4);
u[27] = Den(u[25]);
u[28] = Dot(e1,k3);
u[29] = Dot(e1,k4);
u[30] = Dot(e1,k5);
u[31] = S(R,k3,k4);
u[32] = S(R,k5,n);
u[33] = S(R,k2,k5);
u[34] = S(L,k3,k4);
u[35] = S(L,k3,n);
u[36] = S(R,k2,k3);
u[37] = S(R,k3,n,e1);
u[38] = S(R,k3,k5);
u[39] = S(R,n,k5,e1);
u[40] = Dot(k1,k5);
u[41] = Dot(k3,k5);
u[43] = Den(u[1] -2.*u[40]);
u[45] = S(R,n,k4,e1);
u[46] = Dot(k2,k3);
u[47] = Den(u[46]);
u[51] = S(L,k2,k4);
u[52] = S(L,k2,n);
u[53] = S(L,k2,k5);
u[61] = Den(u[41]);
u[62] = Den(u[4] + u[6]);
u[64] = Dot(k1,k4);
u[65] = Den(u[1] -2.*u[64]);
u[75] = Dot(k2,k4);
u[76] = Den(u[75]);
u[77] = Den(u[3] -u[18]);
u[79] = Dot(k2,k5);
u[87] = Dot(k1,k3);
u[88] = Den(u[1] -2.*u[87]);
u[95] = Den(u[79]);
COMPLEX subW1 = pow2(u[8]);
COMPLEX subW2 = pow2(u[12]);
COMPLEX subW3 = pow2(kTv);
COMPLEX subW4 = -2.*kTv*u[17];
COMPLEX subW8 = u[13] -u[19];
COMPLEX subW9 = 2.*kTv - 4.*u[17];
COMPLEX subW10 = u[7]*u[12];
COMPLEX subW11 = u[20]*u[21];
COMPLEX subW13 = u[8]*u[21];
COMPLEX subW14 = u[9]*u[32];
COMPLEX subW16 = pow2(u[16]);
COMPLEX subW17 = u[29] + u[30];
COMPLEX subW18 = u[15]*u[16]*u[19]*u[28];
COMPLEX subW19 = u[16]*u[19]*u[28];
COMPLEX subW20 = u[16]*u[28];
COMPLEX subW29 = u[12]*u[26];
COMPLEX subW30 = -u[10]*u[31];
COMPLEX subW31 = u[12]*u[33];
COMPLEX subW32 = -u[10]*u[38];
COMPLEX subW33 = 2.*kTv*u[30];
COMPLEX subW37 = u[8]*u[26];
COMPLEX subW38 = u[35]*u[36];
COMPLEX subW40 = u[9]*u[10];
COMPLEX subW41 = u[11]*u[39];
COMPLEX subW45 = 2.*u[10]*u[38];
COMPLEX subW49 = 4.*u[10]*u[31];
COMPLEX subW54 = u[33]*u[39];
COMPLEX subW55 = -u[14]*u[19];
COMPLEX subW56 = -u[25] + u[41];
COMPLEX subW57 = u[11]*u[12];
COMPLEX subW58 = -2.*u[10]*u[37];
COMPLEX subW64 = u[28] -u[29];
COMPLEX subW66 = u[31]*u[45];
COMPLEX subW68 = u[17] -u[28] -u[29];
COMPLEX subW71 = u[20]*u[32];
COMPLEX subW72 = -2.*u[30]*u[45];
COMPLEX subW74 = u[28] + u[29];
COMPLEX subW77 = u[32]*u[39];
COMPLEX subW78 = u[21]*u[45];
COMPLEX subW82 = u[35]*u[37];
COMPLEX subW83 = -u[11]*u[52];
COMPLEX subW85 = pow2(u[9]);
COMPLEX subW86 = -u[12]*u[35];
COMPLEX subW87 = u[10]*u[52];
COMPLEX subW90 = pow3(kTv);
COMPLEX subW92 = u[33]*u[37];
COMPLEX subW93 = u[11]*u[38];
COMPLEX subW95 = u[11]*u[31];
COMPLEX subW96 = u[26]*u[37];
COMPLEX subW98 = -u[29]*u[39];
COMPLEX subW101 = u[25]*u[39];
COMPLEX subW105 = u[31]*u[33];
COMPLEX subW106 = u[26]*u[38];
COMPLEX subW108 = u[31]*u[32];
COMPLEX subW109 = u[21]*u[38];
COMPLEX subW111 = u[25]*u[47];
COMPLEX subW114 = u[10]*u[37];
COMPLEX subW117 = pow2(u[10]);
COMPLEX subW118 = -2.*u[10]*u[31];
COMPLEX subW121 = u[15]*u[16]*u[19];
COMPLEX subW122 = u[16] -u[19];
COMPLEX subW123 = u[16]*u[19];
COMPLEX subW131 = u[16] + u[19];
COMPLEX subW135 = -u[16] + u[19];
COMPLEX subW139 = -2.*u[12]*u[30];
COMPLEX subW140 = u[38]*u[39];
COMPLEX subW142 = 3.*u[16] + u[19];
COMPLEX subW147 = 2.*u[12]*u[30];
COMPLEX subW149 = u[25] + u[41];
COMPLEX subW152 = u[26]*u[45];
COMPLEX subW153 = u[9]*u[33];
COMPLEX subW155 = u[28] + u[30];
COMPLEX subW165 = -2.*u[12]*u[29];
COMPLEX subW168 = u[13] -u[15];
COMPLEX subW169 = -u[12]*u[34];
COMPLEX subW171 = 2.*kTv*u[29];
COMPLEX subW176 = u[8]*u[10];
COMPLEX subW177 = u[11]*u[45];
COMPLEX subW181 = u[12]*u[34];
COMPLEX subW184 = 4.*u[10]*u[34]*u[38];
COMPLEX subW187 = 2.*u[7]*u[33];
COMPLEX subW188 = u[26]*u[34];
COMPLEX subW193 = -u[15]*u[61];
COMPLEX subW194 = u[5] -u[25];
COMPLEX subW199 = u[28] -u[30];
COMPLEX subW203 = 2.*u[29]*u[39];
COMPLEX subW210 = u[30]*u[45];
COMPLEX subW212 = u[9]*u[38];
COMPLEX subW214 = u[25]*u[45];
COMPLEX subW221 = -2.*u[10]*u[38];
COMPLEX subW240 = -4.*u[17] + u[28];
COMPLEX subW242 = u[39]*u[76];
COMPLEX subW244 = u[39]*u[41];
COMPLEX subW251 = u[28]*u[30];
COMPLEX subW252 = u[46] + u[79];
COMPLEX subW253 = u[12]*u[35];
COMPLEX subW256 = u[41]*u[76];
COMPLEX subW261 = -u[6]*u[16];
COMPLEX subW263 = u[17] -u[29];
COMPLEX subW265 = u[10]*u[53];
COMPLEX subW266 = u[7]*u[37];
COMPLEX subW267 = u[61] + u[76];
COMPLEX subW270 = u[17] + u[29];
COMPLEX subW274 = u[8]*u[31];
COMPLEX subW281 = u[17] + u[30];
COMPLEX subW282 = 2.*kTv*u[28];
COMPLEX subW287 = 2.*u[11]*u[28];
COMPLEX subW289 = u[36]*u[52];
COMPLEX subW290 = -4.*u[17] + u[30];
COMPLEX subW291 = u[37]*u[76];
COMPLEX subW292 = 2.*u[28]*u[45];
COMPLEX subW295 = 2.*u[28]*u[39];
COMPLEX subW297 = u[15] + u[16];
COMPLEX subW299 = u[10]*u[31];
COMPLEX subW303 = u[28]*u[45];
COMPLEX subW305 = u[45]*u[95];
COMPLEX subW306 = u[5]*u[95];
COMPLEX subW309 = u[5]*u[45];
COMPLEX subW315 = u[46] + u[75];
COMPLEX subW322 = u[17] -u[30];
COMPLEX subW324 = u[10]*u[51];
COMPLEX subW326 = u[16]*u[18];
COMPLEX subW327 = -u[13] + u[19];
COMPLEX subW328 = u[13]*u[16];
COMPLEX subW329 = -2.*u[13] + u[16];
COMPLEX subW332 = u[19]*u[95];
COMPLEX subW338 = u[29] + 4.*u[30];
COMPLEX subW342 = subW10 + subW11;
COMPLEX subW343 = subW3 + subW4;
COMPLEX subW346 = subW13 + subW14;
COMPLEX subW347 = subW17 + u[28];
COMPLEX subW348 = 4.*subW17 + 5.*u[28];
COMPLEX subW355 = subW3 + subW33;
COMPLEX subW358 = subW40 + subW41;
COMPLEX subW359 = subW37 + subW38;
COMPLEX subW360 = -2.*subW29*u[34];
COMPLEX subW362 = -subW31 + subW45;
COMPLEX subW364 = -3.*subW29 + subW49;
COMPLEX subW365 = subW57 + subW58;
COMPLEX subW366 = -subW11*u[12];
COMPLEX subW369 = subW66 + subW64*u[12];
COMPLEX subW370 = subW71 + subW72;
COMPLEX subW371 = 2.*subW29*u[34];
COMPLEX subW372 = subW17 + u[17] -u[28];
COMPLEX subW375 = subW77 + subW78;
COMPLEX subW376 = subW82 + subW83;
COMPLEX subW377 = subW86 + subW87;
COMPLEX subW378 = subW11 + subW98;
COMPLEX subW379 = subW95 + subW96;
COMPLEX subW380 = subW92 + subW93;
COMPLEX subW381 = 2.*subW11*u[30];
COMPLEX subW385 = subW108 + subW109;
COMPLEX subW386 = 1. + subW111;
COMPLEX subW387 = subW105 + subW106;
COMPLEX subW388 = subW114 -subW57;
COMPLEX subW389 = subW118 + subW29;
COMPLEX subW390 = -subW38*u[12]*u[39];
COMPLEX subW391 = -subW123 + subW122*u[15];
COMPLEX subW393 = subW123 + subW122*u[15];
COMPLEX subW394 = subW49*u[13]*u[15]*u[19];
COMPLEX subW395 = -subW123 + subW142*u[15];
COMPLEX subW398 = subW147 + subW66;
COMPLEX subW399 = -subW123 + subW131*u[15];
COMPLEX subW401 = subW123 + subW135*u[15];
COMPLEX subW403 = subW139 + subW140;
COMPLEX subW404 = subW11*subW92;
COMPLEX subW410 = subW153 + subW38;
COMPLEX subW411 = subW38*subW66;
COMPLEX subW412 = subW165 + subW66;
COMPLEX subW414 = -2.*subW38*u[29];
COMPLEX subW417 = subW169 + subW71;
COMPLEX subW418 = subW171 + subW3;
COMPLEX subW421 = subW176 + subW177;
COMPLEX subW423 = subW181 - 3.*subW71;
COMPLEX subW424 = subW184 + subW71*u[33];
COMPLEX subW425 = subW187 + subW188;
COMPLEX subW428 = 1. + subW194*u[61];
COMPLEX subW429 = subW181 + subW71;
COMPLEX subW431 = subW140 + subW199*u[12];
COMPLEX subW432 = subW155 -u[17];
COMPLEX subW433 = subW11 + subW203;
COMPLEX subW434 = subW181 -subW71;
COMPLEX subW436 = subW1*subW299*u[39];
COMPLEX subW437 = subW210 + subW71;
COMPLEX subW439 = -2.*subW71*u[29];
COMPLEX subW443 = subW221 + subW31;
COMPLEX subW444 = -subW38*u[12];
COMPLEX subW446 = -3.*subW181 + subW71;
COMPLEX subW448 = 2.*subW2*u[30]*u[34];
COMPLEX subW450 = subW140*u[34] + subW194*u[45];
COMPLEX subW451 = -subW11*u[38]*u[61];
COMPLEX subW454 = subW32*u[12] + subW2*u[33];
COMPLEX subW456 = subW2*u[11]*u[34];
COMPLEX subW457 = subW38*u[12]*u[45];
COMPLEX subW458 = subW253 -subW87;
COMPLEX subW459 = 1. + subW256;
COMPLEX subW460 = 2.*subW10*u[30];
COMPLEX subW466 = 4.*subW252 -u[41];
COMPLEX subW469 = subW38*subW71;
COMPLEX subW470 = subW117*u[38]*u[53];
COMPLEX subW471 = 2. + subW261;
COMPLEX subW472 = 2.*subW263*u[9]*u[12];
COMPLEX subW473 = -subW152 + subW270*u[10];
COMPLEX subW475 = -subW114 + subW57;
COMPLEX subW476 = subW17 -u[17] - 3.*u[28];
COMPLEX subW477 = subW281 + subW64;
COMPLEX subW480 = subW74 -u[17] - 3.*u[30];
COMPLEX subW481 = subW282 + subW3;
COMPLEX subW485 = subW181 + subW292;
COMPLEX subW486 = subW10 + subW295;
COMPLEX subW487 = subW287 -subW38;
COMPLEX subW488 = subW11*subW299;
COMPLEX subW489 = -subW29 + subW299;
COMPLEX subW492 = subW169 + subW303;
COMPLEX subW493 = 1. + subW306;
COMPLEX subW494 = 2.*subW181*u[29];
COMPLEX subW500 = 4.*subW315 -u[5];
COMPLEX subW503 = subW181 -subW303;
COMPLEX subW504 = 2.*subW322*u[8]*u[12];
COMPLEX subW505 = subW324 + subW71;
COMPLEX subW506 = subW328 + subW329*u[19];
COMPLEX subW507 = -subW54 + subW281*u[10];
COMPLEX subW508 = subW212 + subW289;
COMPLEX subW509 = subW56 -u[46] + u[75];
COMPLEX subW510 = -subW332*subW71*u[31];
COMPLEX subW511 = 4.*subW149 + u[5];
COMPLEX subW514 = -2. + subW343*u[16];
COMPLEX subW515 = -subW348*u[19];
COMPLEX subW521 = 2. + subW355*u[15];
COMPLEX subW522 = subW360 + subW11*u[33];
COMPLEX subW523 = subW366 + subW2*u[7];
COMPLEX subW525 = subW289*subW372*u[47];
COMPLEX subW527 = subW101 + subW381;
COMPLEX subW530 = -subW121 + subW395*u[13];
COMPLEX subW531 = -2.*subW347*u[10];
COMPLEX subW536 = subW153*subW412;
COMPLEX subW537 = subW414 + subW96*u[34];
COMPLEX subW539 = 2. + subW418*u[19];
COMPLEX subW540 = -subW410*u[45];
COMPLEX subW541 = subW425*u[12] + subW71*u[26];
COMPLEX subW542 = subW429*subW57;
COMPLEX subW543 = subW38*subW433*u[12];
COMPLEX subW544 = subW214 + subW439;
COMPLEX subW547 = subW121*subW423;
COMPLEX subW548 = subW123*subW446;
COMPLEX subW549 = subW375*u[20]*u[38];
COMPLEX subW550 = subW451 + subW428*u[12];
COMPLEX subW551 = subW244 + subW460;
COMPLEX subW556 = 3. + subW466*u[76];
COMPLEX subW557 = 2.*subW473*u[9]*u[12];
COMPLEX subW558 = subW347 + 3.*u[17];
COMPLEX subW559 = subW432 - 3.*u[29];
COMPLEX subW560 = 2. + subW481*u[13];
COMPLEX subW561 = subW10*subW489;
COMPLEX subW563 = subW309 + subW494;
COMPLEX subW568 = 3. + subW500*u[95];
COMPLEX subW569 = -3. + subW511*u[95];
COMPLEX subW570 = subW20 + subW515;
COMPLEX subW575 = subW525 -u[37];
COMPLEX subW576 = u[39] + subW527*u[47];
COMPLEX subW577 = subW152 + subW531;
COMPLEX subW581 = u[45] + subW544*u[47];
COMPLEX subW582 = u[39] + subW551*u[76];
COMPLEX subW585 = subW488 + subW561;
COMPLEX subW586 = u[45] + subW563*u[95];
COMPLEX subW589 = subW19 + subW570*u[15];
COMPLEX subW592 = 2.*subW155*subW29 + subW577*u[31];
COMPLEX subW594 = subW242 + subW582*u[13];
COMPLEX subW595 = subW305 + subW586*u[13];
COMPLEX subW596 = subW18 + subW589*u[13];
COMPLEX subW597 = subW1*subW592;
COMPLEX subWW1 = u[13] + 2.*u[16];
COMPLEX subWW2 = u[13] -u[19];
COMPLEX subWW3 = -3.*subW122*u[15];
COMPLEX subWW7 = u[16] + 3.*u[19];
COMPLEX subWW9 = -2.*u[10]*u[29];
COMPLEX subWW11 = u[15]*u[16];
COMPLEX subWW12 = -2.*u[11]*u[28];
COMPLEX subWW14 = -u[13] + u[16];
COMPLEX subWW15 = subW123 + subWW3;
COMPLEX subWW18 = subW152 + subWW9;
COMPLEX subWW19 = subW38 + subWW12;
COMPLEX subWW20 = subW121 + subWW15*u[13];
u[24] = -subW1*subW2*subW40*subW514*subW8*(subW40*subW9 -subW342*u[11])*u[14]*u[15];
u[42] = -subW346*subW40*u[8]*u[12]*u[20]*u[27]*(subW57*(subW121*(-4. + kTv*subW20) + u[13]*(kTv*subW16*u[19]*u[28] + u[15]*(-(-2. + u[16]*(3.*subW3 + kTv*(subW348 - 2.*u[17])))*u[19] + kTv*subW16*u[28]))) -u[16]*((subW347*subW394 + subW29*subW596)*u[8] - 2.*kTv*((subW29 + subW30)*u[8] + (subW31 + subW32)*u[9])*u[13]*u[15]*u[19] + u[9]*(subW31*subW596 + 4.*subW347*u[10]*u[13]*u[15]*u[19]*u[38])));
u[44] = subW1*subW2*subW40*subW521*subW8*u[14]*u[16]*(-2.*kTv*subW358 + u[9]*(2.*subW54 - 4.*u[10]*u[30]) + subW359*u[39]);
u[48] = subW40*u[8]*u[12]*u[15]*(2.*(u[8]*(subW38*u[12]*u[13]*u[14]*(u[19]*(subW10*u[16]*u[30] + u[39]) + u[16]*(3.*subW11*u[19]*u[30] + 2.*u[39])) + u[9]*u[16]*(4.*u[10]*u[30]*(u[12]*(subW55 + u[13]*(u[19] + u[14]*(1. + subW56*u[19]))) + subW71*u[13]*u[14]*u[19]*u[31]) + u[12]*u[14]*(-u[13]*(subW54 + subW522*u[19]*u[30]) + u[19]*u[33]*(subW10*u[13]*u[30] + u[39])))) + u[14]*(subW123*subW147*u[9]*(subW362*u[9] + subW38*u[12])*u[13]*u[34] + subW1*(2.*subW299*(subW381*u[13]*u[16]*u[19] + (subW123 + u[13]*(u[16] + u[19]))*u[39]) + u[12]*u[19]*(subW328*subW364*u[7]*u[30] -u[26]*(subW11*u[13]*u[16]*u[30] + subWW1*u[39]))))) + u[16]*(subW3*subW55*u[13]*(-2.*subW181*subW365*u[9] -subW1*(subW29 - 2.*subW299)*u[39] + u[8]*(4.*subW369*subW40 + subW523*u[11] + subW38*u[12]*u[39])) + kTv*(u[8]*(u[9]*(4.*u[10]*(u[12]*(subW55 + u[13]*(u[19] + u[14]*(1. + u[19]*(subW56 + 2.*(-u[28] + u[29])*u[30])))) + subW370*u[13]*u[14]*u[19]*u[31]) + u[12]*u[13]*u[14]*u[19]*(subW371 + (subW10 -subW11)*u[33])) + u[12]*u[14]*(2.*u[11]*(subW11*u[13]*u[19]*u[30] + subWW2*u[39]) + u[13]*u[19]*(-2.*subW10*u[11]*u[30] + subW38*(subW10 + 3.*subW11 + 2.*subW68*u[39])))) + u[13]*u[14]*u[19]*(2.*subW181*u[9]*(subW362*u[9] - 4.*subW114*u[30] + u[12]*(subW38 + 2.*u[11]*u[30])) + subW1*(subW49*(subW11 + subW68*u[39]) + u[12]*(subW364*u[7] -u[26]*(subW11 + 2.*(-subW74 + u[17])*u[39])))))));
u[49] = subW1*subW2*subW40*subW8*subWW11*(2.*subW40*subW74 + subW342*u[11])*u[14];
u[50] = -subW1*subW2*subW40*subW8*subWW11*u[14]*(2.*subW40*subW74 -subW359*u[39]);
u[54] = subW121*subW40*u[8]*u[12]*u[13]*(u[8]*(subW11*subW57*u[27] + u[10]*(subW11*subW575*u[27] + subW289*u[39]*u[47]) -u[36]*u[47]*(subW253*(subW11*subW372*u[27] + u[39]) + subW375*u[20]*u[27]*(-u[31]*u[35] + u[26]*u[52]))) + u[9]*(subW57*subW71*u[27] + u[10]*(subW575*subW71*u[27] -subW289*u[45]*u[47]) -u[36]*u[47]*(subW253*(subW372*subW71*u[27] -u[45]) + subW375*u[20]*u[27]*(-u[35]*u[38] + u[33]*u[52]))) + subW376*u[20]*u[27]*u[36]*u[47]*(u[12]*(u[7]*u[32] + u[21]*u[34]) -u[10]*(u[21]*u[51] + u[32]*u[53])));
u[55] = subW121*subW176*subW377*subW85*u[12]*u[13]*u[36]*u[45]*u[47];
u[56] = subW328*subW40*u[8]*u[12]*u[15]*(u[19]*(subW14*u[20]*(subW139*subW38 + u[38]*(u[9]*(subW54 - 2.*u[10]*u[30]) + subW38*u[39])) -subW358*subW90*u[37]*u[45] + subW3*(subW85*u[10]*u[38]*u[45] + u[37]*u[39]*(subW71*u[11] + subW38*u[45]) + u[8]*(u[10]*(subW66*u[9] + subW378*u[37]) + subW379*u[39]*u[45]) + u[9]*(subW114*subW370 + (subW38*u[12] + subW380*u[39])*u[45])))*u[47] + subW1*(subW29*u[19]*u[39] -u[31]*(subW576*u[10]*u[19] + (u[10] -subW71*u[19]*u[26])*u[39]*u[47])) + u[8]*(-subW38*(subW527*u[12]*u[19] + (u[12] -subW71*u[19]*u[31])*u[39])*u[47] + u[9]*(u[19]*u[39]*(subW31 + subW387*subW71*u[47]) -u[10]*(subW576*u[19]*u[38] + (subW140 + 2.*subW71*u[19]*u[30]*u[31])*u[47]))) + kTv*(-u[19]*(subW469*u[37]*u[39] + subW1*u[31]*(subW378*u[10] + subW152*u[39]) + subW85*u[38]*(subW370*u[10] + subW54*u[45]) + u[9]*(subW370*subW38*u[12] + subW58*subW71*u[30] + u[39]*(subW380*subW71 + subW38*u[38]*u[45])))*u[47] -u[8]*(u[19]*(subW378*subW38*u[12] + u[39]*(subW71*subW96 + (subW105*u[9] + subW106*u[9] + subW38*u[31])*u[45]))*u[47] + subW41*u[19]*(u[12] + subW71*u[31]*u[47]) -u[10]*(u[37]*u[39]*u[47] + u[19]*(u[9]*(-subW385*u[20] + subW140*u[29] + 2.*subW66*u[30])*u[47] + u[37]*(subW386*u[39] + subW381*u[47]))))));
u[57] = subW121*subW40*u[8]*(2.*(subW369*subW40*u[8] + subW181*subW388*u[9]) + subW523*u[8]*u[11])*u[12]*u[13]*u[14];
u[58] = subW117*subW121*subW346*u[8]*u[9]*u[12]*u[13]*u[20]*u[27]*u[37];
u[59] = subW121*subW40*u[8]*u[12]*u[13]*u[14]*((subW390 + 2.*subW369*subW40)*u[8] + 2.*subW181*subW40*u[37] + subW1*subW389*u[39]);
u[60] = -subW40*u[8]*u[12]*u[16]*(subW3*subW57*(2.*subW181*u[9]*(subW121 + subW391*u[13]) + u[8]*(subW10*subWW20 + subW11*(3.*subW121 -subW393*u[13])))*u[14] + kTv*(subW1*(subW10*(subW394 -subW29*subWW20) + subW11*(subW394 + subW29*(-3.*subW121 + subW393*u[13])))*u[14] + u[8]*(u[14]*(subW38*(subW530*u[7]*pow2(u[12]) + subW11*u[12]*(-3.*subW121 + u[13]*(subW123 + subWW7*u[15]))) + 4.*u[13]*u[15]*u[19]*((subW41*subW56 + subW398*u[7]*u[11])*u[12] + subW375*subW95*u[20])) + u[9]*(4.*u[10]*u[13]*u[15]*u[19]*(u[12]*(1. + subW56*u[14]) + subW71*u[14]*u[31]) + u[12]*u[14]*(subW10*subW530*u[33] -subW121*(subW371 + 3.*subW11*u[33]) + u[13]*(subW122*subW522*u[15] + subW123*(subW371 + subW11*u[33]))))) + 2.*u[12]*(u[14]*u[34]*(-subW121*subW31*subW85 -u[13]*(subW31*subW399*subW85 + u[15]*u[19]*(subW221*subW85 - 2.*subW342*u[11]*u[37]))) + u[9]*(subW181*subW38*(-subW121 + subW401*u[13])*u[14] + 2.*u[11]*u[13]*u[15]*u[19]*(subW403*u[14]*u[34] + u[45])))) - 2.*u[13]*u[19]*(2.*(subW1*u[14]*u[15]*(u[20]*(subW531*u[21] + subW375*u[26])*u[31] + subW29*(2.*subW11*u[28] + subW56*u[39])) + u[12]*(u[9]*(-subW57*(u[15] + u[14]*(-2. + subW149*u[15]))*u[34] + u[15]*((subW38*subW403 + subW404)*u[14]*u[34] + subW38*u[45])) + u[15]*(subW11*subW38*u[14]*u[34]*u[37] + subW85*((subW221*subW347 + 2.*subW31*subW74)*u[14]*u[34] + u[33]*(subW140*u[14]*u[34] + u[45]))))) + u[8]*u[15]*(2.*(u[14]*(subW375*subW38*u[20]*u[31] + u[12]*(subW11*(-2.*subW17*subW38 + subW96*u[34]) + subW38*subW56*u[39])) + u[9]*(u[14]*(subW105*subW375*u[20] - 2.*subW188*subW2*u[30]) + u[12]*(subW152 + u[14]*(2.*subW11*u[28]*u[33] + (subW56*u[33] + subW106*u[34])*u[39])) + 2.*subW347*u[10]*(-subW71*u[14]*u[31] + u[12]*(-1. + u[14]*(u[25] -u[41]))))) + subW11*subW57*(-3. + u[14]*(u[25] - 3.*u[41] + 4.*u[46]))) + subW10*(2.*u[14]*u[15]*(subW597 + u[8]*(subW411 + subW536 + subW537*u[12]) + subW181*subW410*u[37]) + subW57*u[8]*(-u[15] + u[14]*(-4. + u[15]*(3.*u[25] -u[41] + 4.*u[46]))))));
u[63] = -subW168*subW176*subW2*subW514*subW85*(subW176*subW9 + subW417*u[11])*u[19]*u[61];
u[66] = -subW168*subW176*subW2*subW539*subW85*(2.*kTv*subW421 + subW540 - 2.*subWW18*u[8])*u[16]*u[61];
u[67] = subW40*u[8]*u[12]*u[19]*(2.*((-2.*subW1*subW10*subW328*subW389*u[15]*u[29] + u[9]*(subW38*u[12]*u[13]*(subW423*subWW11*u[29] + (u[15] + 2.*u[16])*u[45]) + u[9]*(subW45*(subW439*subWW11*u[13] + (subWW11 + u[13]*(u[15] + u[16]))*u[45]) + u[15]*(subW424*u[12]*u[13]*u[16]*u[29] -u[33]*(3.*subW2*subW328*u[29]*u[34] + subWW1*u[12]*u[45])))))*u[61] + u[8]*u[16]*(2.*subW2*subW38*u[7]*u[13]*u[15]*u[29]*u[61] + u[9]*(u[12]*(subW152*u[15] + u[13]*(-subW152 + subW541*u[15]*u[29]))*u[61] + 4.*u[10]*u[29]*(subW11*subW193*u[13]*u[38] + u[12]*(subW193 + u[13]*(subW428*u[15] + u[61])))))) + u[16]*(subW3*u[13]*u[15]*(2.*subW10*subW365*u[8] -u[9]*(4.*subW176*subW431 + subW542 + ((-subW153 + subW38)*u[12] + 2.*subW40*u[38])*u[45]))*u[61] + kTv*((-2.*subW1*subW10*subW389*u[13]*u[15] + u[9]*(-2.*subW57*(subW429*u[13]*u[15]*u[29] + (-u[13] + u[15])*u[45]) + u[13]*u[15]*(subW38*u[12]*(subW423 + 2.*(subW322 -u[28])*u[45]) + u[9]*(-3.*subW2*u[33]*u[34] - 4.*u[10]*u[38]*(subW71 + subW432*u[45]) + u[12]*(2.*subW45*u[34] + u[33]*(subW71 + 2.*subW432*u[45]))))))*u[61] + u[8]*(2.*subW10*u[13]*u[15]*(-4.*subW114*u[29] + u[12]*(subW38 + 2.*u[11]*u[29]))*u[61] + u[9]*(subW541*u[12]*u[13]*u[15]*u[61] + 4.*u[10]*(subW193*subW433*u[13]*u[38] + u[12]*(subW193 + u[13]*(u[61] + u[15]*(1. + (subW194 + 2.*u[29]*(-u[28] + u[30]))*u[61])))))))));
u[68] = subW123*subW168*subW176*subW2*subW85*(2.*subW155*subW176 + subW434*u[11])*u[61];
u[69] = -subW123*subW40*u[8]*u[12]*u[13]*(u[15]*(-subW1*subW11*subWW18*u[31] -subW421*subW90*u[37]*u[39] + subW3*(subW436 + u[37]*(-subW11*u[11] + subW38*u[39])*u[45] + u[9]*(-subW114*subW437 + subW380*u[39]*u[45]) + u[8]*(-subW11*u[10]*u[37] + u[39]*(subW212*u[10] + subW38*u[12] + subWW9*u[37] + subW379*u[45]))))*u[47] + u[8]*(-subW11*subW38*u[15]*(subW66 - 2.*u[12]*u[29])*u[47] + u[9]*(u[15]*u[45]*(subW29 -subW11*subW387*u[47]) -u[10]*(subW581*u[15]*u[31] + (subW66 - 2.*subW11*u[15]*u[29]*u[38])*u[47]))) + u[9]*(-subW38*(subW544*u[12]*u[15] + (u[12] + subW11*u[15]*u[38])*u[45])*u[47] + u[9]*(subW31*u[15]*u[45] -u[38]*(subW581*u[10]*u[15] + (u[10] + subW11*u[15]*u[33])*u[45]*u[47]))) + kTv*(u[15]*(subW1*u[31]*(subW433*u[10] -subW152*u[39]) + subW11*subW38*u[37]*u[45] + subW85*u[38]*(subW437*u[10] -subW54*u[45]) + u[8]*(subW543 + subW11*subW58*u[29] + (subW11*subW379 -subW38*u[31]*u[39])*u[45]))*u[47] + u[9]*(u[15]*((subW38*subW437*u[12] + (subW404 -(subW387*u[8] + subW38*u[38])*u[39])*u[45])*u[47] + subW177*(-u[12] + subW11*u[38]*u[47])) + u[10]*(u[37]*u[45]*u[47] + u[15]*(u[8]*(subW385*u[20] + 2.*subW140*u[29] + subW66*u[30])*u[47] + u[37]*(subW386*u[45] + subW439*u[47]))))));
u[70] = -subW123*subW168*subW176*subW2*(2.*subW155*subW176 + subW540)*subW85*u[61];
u[71] = subW1*subW121*subW377*subW40*u[12]*u[13]*u[36]*u[39]*u[47];
u[72] = subW121*subW40*u[8]*(2.*subW10*subW388*u[8] + (2.*subW176*subW431 + subW542)*u[9])*u[12]*u[13]*u[61];
u[73] = subW121*subW40*u[8]*u[12]*u[13]*(2.*subW176*(subW431*u[9] + subW10*u[37]) + u[9]*(subW444 + subW443*u[9])*u[45])*u[61];
u[74] = subW40*u[8]*u[12]*u[16]*(subW3*subW57*(-2.*subW10*u[8]*(subW121 -subW391*u[13]) -u[9]*(subW547 + u[13]*(subW548 + subW122*subW429*u[15])))*u[61] + kTv*((u[9]*(4.*u[11]*(subW448 + subW549 -subW450*u[12])*u[13]*u[15]*u[19] + subW38*u[12]*(subW547 + u[13]*(subW548 + u[15]*(subW429*u[16] + (subW169 + 3.*subW71)*u[19])))) + 2.*subW10*(subW1*(subW121*subW29 + u[13]*(subW29*subW401 + subW118*u[15]*u[19])) + 2.*subW417*u[11]*u[13]*u[15]*u[19]*u[37]) + subW85*(u[12]*(-subW424*u[13]*u[15]*u[19] + subW71*(-3.*subW121 + (subW123 + subWW11)*u[13])*u[33]) + subW2*(subW121 + u[13]*(-3.*subW123 + subWW7*u[15]))*u[33]*u[34] + 4.*subW71*u[10]*u[13]*u[15]*u[19]*u[38]))*u[61] + u[8]*(u[9]*(-4.*subW550*u[10]*u[13]*u[15]*u[19] + u[12]*(subW121*(subW425*u[12] - 3.*subW71*u[26]) + u[13]*(subW123*((subW187 - 3.*subW188)*u[12] + subW71*u[26]) + u[15]*(-subW541*u[19] + u[16]*(subW71*u[26] + u[12]*(subW188 - 2.*u[7]*u[33])))))*u[61]) - 2.*u[12]*(subW10*subW38*(-subW121 + subW399*u[13])*u[61] + 2.*u[11]*u[13]*u[15]*u[19]*(u[39] + subW398*u[7]*u[61])))) - 2.*u[13]*u[19]*(u[15]*(-2.*subW1*subW29*u[39] + 2.*u[8]*(subW390 + u[9]*(2.*subW347*subW550*u[10] -subW54*u[12] + u[26]*(subW448 + subW549 -u[12]*(subW450 - 2.*subW71*u[28]))*u[61]))) - 2.*subW10*(u[15]*(subW597 -subW410*subW417*u[37])*u[61] + u[8]*((subW411 + subW536 -subW71*subW96 + subW537*u[12])*u[15]*u[61] -subW57*(2.*u[61] + u[15]*(1. + (subW194 - 2.*u[46])*u[61])))) + u[9]*(-2.*u[15]*(subW38*(-subW549 + (subW450 + 2.*subW17*subW71)*u[12] - 2.*subW2*u[30]*u[34]) + u[9]*(2.*subW2*subW74*u[33]*u[34] + u[20]*(2.*subW347*u[10]*u[32] -subW375*u[33])*u[38] + u[12]*(subW450*u[33] - 2.*(subW71*u[28]*u[33] + subW347*u[10]*u[34]*u[38]))))*u[61] + subW57*(-4.*subW181*u[61] + u[15]*(subW181*(1. + (u[5] + u[25])*u[61]) + subW71*(-3. + (-3.*u[5] + u[25] + 4.*u[46])*u[61]))))));
u[78] = -subW1*subW117*subW131*subW521*u[9]*u[12]*u[13]*(u[9]*(-subW140 + 2.*u[12]*(kTv + 2.*u[30])) + kTv*u[37]*u[39])*u[76];
u[80] = subW121*subW40*u[8]*u[12]*(u[13]*(u[9]*(4.*u[30]*(subW469*u[12] + u[9]*(subW454*u[34] + subW71*u[10]*u[38])) + 2.*subW114*subW90*u[45]) + subW3*(u[8]*(2.*u[11]*(subW2*u[7] -u[12]*u[28]*u[39]) -u[10]*(2.*u[9]*u[12]*u[28] + u[37]*(2.*subW265 + subW240*u[39]))) - 2.*u[9]*(subW456 + subW457 + u[10]*(subW417*u[37] + (subW212 - 2.*u[30]*u[37])*u[45]))))*u[76] + u[8]*(-2.*subW458*u[36]*(subW242 + u[13]*(subW459*u[39] + subW460*u[76])) + u[9]*(-2.*subW31*subW594 + 4.*subW470*u[13]*u[30]*u[76] + u[10]*(subW140*(subW556*u[13] + u[76]) + 4.*u[12]*u[30]*(-u[76] + u[13]*(1. + (u[41] - 2.*u[46])*u[76]))))) + kTv*(2.*u[9]*u[13]*(-2.*(subW456 + subW457 + subW114*subW71)*u[30] + u[12]*(subW469 + 2.*subW114*u[30]*u[34]) + u[9]*(subW454*u[34] + subW370*u[10]*u[38]))*u[76] + u[8]*(2.*subW57*subW594 + (u[39]*(2.*(subW253 -subW87)*u[13]*u[28]*u[36] + subW114*(-1. + u[13]*(-4.*subW252 + u[41]))) + 2.*u[13]*(subW10*subW87*u[36] - 2.*subW117*u[30]*u[37]*u[53]))*u[76] -u[13]*(3.*subW114*u[39] + 2.*subW2*subW38*u[7]*u[76]) + u[9]*(2.*u[13]*(subW470 + subW31*(-subW10 + u[28]*u[39]))*u[76] + u[10]*(subW140*subW240*u[13]*u[76] - 2.*u[12]*(u[76] + u[13]*(-1. + (-u[41] + 2.*(subW251 + u[46]))*u[76])))))));
u[81] = kTv*subW1*subW117*subW2*subW85*(subW471*u[15] + u[13]*(-2. + u[4]*u[16]))*u[19]*(-2.*u[76] + u[61]*(-2. + (2.*kTv*subW155 + subW3)*u[76]));
u[82] = subW1*subW117*subW131*u[9]*u[12]*u[13]*u[15]*(subW472 + (-subW11 + subW265)*u[37])*u[76];
u[83] = subW168*subW176*subW2*subW85*u[16]*(2.*kTv*subW176*(2.*u[61]*u[76] + u[19]*(-u[61] + u[76])) + u[19]*u[61]*(3.*subW176*subW90*u[76] + 2.*(subW434*u[11] + subW410*u[45] + subW176*(4.*u[17] - 2.*(u[28] + u[30]) + subW3*(subW155 - 2.*u[17] + 2.*u[29])*u[76]))));
u[84] = subW1*subW117*u[9]*u[12]*u[19]*((subWW11 + u[13]*(-2.*u[15] + u[16]))*(2.*subW140*u[9] + u[12]*(2.*subW266 + u[9]*(4.*subW199 + (2.*subW155*subW3 + subW90)*u[61])))*u[76] + 2.*kTv*u[9]*u[12]*(-u[16]*(subW267*u[15] - 2.*u[61]*u[76]) + u[13]*(2.*subW267*u[15] - 4.*u[61]*u[76] + u[16]*(-u[76] + u[61]*(-1. + 2.*u[4]*u[76])))));
u[85] = -subW121*subW40*u[8]*u[12]*u[13]*((subW114*(subW11 + subW265) + subW557)*u[8] + 2.*subW40*subW475*u[51])*u[76];
u[86] = subW121*subW40*u[8]*u[12]*u[13]*(u[8]*(-2.*subW29*u[8]*u[39] + u[10]*(subW11*u[37] + (subW274 -subW289)*u[39]) + subW117*u[37]*u[53])*u[76] + u[61]*(subW85*(subW31*(u[45] + subW324*subW476*u[76]) -subW45*(u[45] + (subW54 -subW477*u[10])*u[51]*u[76])) + subW10*((subW1*(-2.*subW29*subW477 + (-2.*subW152 + subW558*u[10])*u[31]) - 2.*subW324*(subW92*u[9] + subW376*u[36]))*u[76] + u[8]*(-(u[10]*(subW289*subW559 + 2.*(subW252 + u[25])*u[37]) + 2.*(subW114*u[5] + u[26]*(subW434*u[37] + subW289*u[45])))*u[76] + 2.*u[11]*(u[12] + subW299*u[51]*u[76])))) -u[9]*((u[38]*(-2.*subW37*subW375*u[20] + u[10]*(2.*subW38*u[39]*u[51] + u[8]*(subW11*subW558 + 2.*((subW252 + u[5] + u[25])*u[39] + subW152*u[53]))))*u[61] + subW117*(2.*u[37]*u[51] + subW559*u[8]*u[38]*u[53]*u[61]))*u[76] + u[61]*(subW2*subW37*subW480*u[34]*u[76] + u[11]*(subW2*u[34] + (subW11 -subW265)*subW45*u[51]*u[76] + u[12]*(subW71 + 2.*subW324*u[76]*(-u[5] + u[25] + u[46] -u[79]))) + u[12]*(subW38*(u[45] + subW324*subW480*u[76]) + u[8]*u[76]*(u[5]*(2.*subW152 + u[10]*(-3.*subW281 + u[28] -u[29])) + u[26]*(subW476*subW71 + 2.*(subW140*u[34] -u[45]*(u[25] + u[46] -u[79]))) + u[10]*(u[25]*(3.*u[28] + u[29] -u[30]) + (u[28] + 3.*u[29] - 3.*u[30])*u[46] + u[17]*(3.*u[25] + u[46] -u[79]) + (3.*u[28] - 3.*u[29] -u[30])*u[79]))))));
u[89] = subW1*subW117*subW131*subW560*u[9]*u[12]*u[15]*(u[12]*(subW266 + 4.*u[9]*u[28]) + kTv*(2.*u[9]*u[12] + u[37]*u[39]))*u[76];
u[90] = -subW346*subW40*u[8]*u[12]*u[15]*u[19]*u[20]*u[27]*(2.*((2.*subW114 + subW20*(subW444 + subW389*u[8]))*u[13] + u[16]*(-subW114 + subW443*u[9]*u[13]*u[28])) + subW328*(subW3*(-3.*subW114 + subW57) + kTv*(subW389*u[8] + (subW153 + subW487)*u[12] - 2.*u[10]*(subW212 + (2.*subW17 - 2.*u[17] + u[28])*u[37]))));
u[91] = subW1*subW117*subW131*u[9]*u[12]*u[13]*u[15]*(subW472 + (subW274 + subW289)*u[39])*u[76];
u[92] = subW123*subW40*u[8]*u[12]*u[13]*(u[15]*(2.*subW41*subW90*u[8]*u[12] + subW3*(u[8]*(2.*(subW2*u[7]*u[11] + u[9]*u[12]*(-subW54 + u[10]*u[30])) + (-2.*subWW19*u[12] + u[10]*(2.*subW289 + subW290*u[37]))*u[39]) - 2.*u[9]*(subW57*subW71 + (subW114*u[30] + u[9]*(-subW31 + u[10]*u[38]))*u[45])))*u[76] + 2.*u[9]*(2.*u[12]*u[15]*u[28]*(subW469 + subW31*u[9]*u[34])*u[76] -subW417*u[10]*(subW291 + u[15]*(subW459*u[37] - 2.*subW212*u[28]*u[76]))) + u[8]*(-2.*subW117*u[37]*u[53]*(subW459*u[15] + u[76]) + subW10*(subW291*u[10] + u[15]*(subW556*u[10]*u[37] + 4.*(subW289*u[10] -subW38*u[12])*u[28]*u[76])) + 4.*u[9]*u[28]*(u[15]*(subW470 -subW2*u[7]*u[33])*u[76] + u[10]*u[12]*(u[76] + u[15]*(1. -u[76]*(u[41] - 2.*u[79]))))) + kTv*(2.*u[9]*((subW153*subW485 + subW71*subWW19)*u[12]*u[15]*u[76] + u[10]*(subW291*u[45] + u[15]*(subW459*u[37]*u[45] + (subW212*(-2.*subW303 + subW417) + subW417*u[30]*u[37])*u[76]))) + u[8]*(u[10]*(subW242*u[37] + u[15]*(subW556*u[37]*u[39] + (2.*subW289*subW486 + subW10*subW290*u[37])*u[76])) + 2.*(u[15]*(u[12]*(subW10*subW487 - 2.*subW38*u[28]*u[39]) + subW117*u[30]*u[37]*u[53])*u[76] + u[9]*((subW470 -subW31*subW486)*u[15]*u[76] + u[10]*u[12]*(u[76] + u[15]*(1. + u[76]*(-u[41] + 2.*(subW251 + u[79])))))))));
u[93] = subW121*subW40*u[8]*u[12]*u[13]*(subW1*(2.*subW29 + subW30)*u[39] + u[8]*(subW557 + subW87*u[36]*u[39]) + 2.*subW40*subW57*u[51])*u[76];
u[94] = subW121*subW2*subW346*subW40*u[8]*u[11]*u[13]*u[20]*u[27];
u[96] = -subW117*subW297*subW539*subW85*u[8]*u[12]*u[13]*(u[8]*(-subW66 + 2.*u[12]*(kTv + 2.*u[29])) + kTv*u[37]*u[45])*u[95];
u[97] = -subW121*subW40*u[8]*u[12]*(u[13]*(4.*subW1*subW585*u[29] + subW58*subW90*u[8]*u[39] + subW3*(2.*(subW436 + u[8]*(-subW114*subW433 + u[12]*(subW475*u[7] + subW40*u[28] + subW38*u[39]))) + u[9]*(2.*(subW114*subW324 + subW492*subW57) + subW114*subW240*u[45])))*u[95] + 2.*subW458*u[9]*u[36]*(subW305 + u[13]*(subW493*u[45] + subW494*u[95])) + u[8]*(4.*subW11*subW38*u[12]*u[13]*u[29]*u[95] + u[9]*(2.*subW29*subW595 - 4.*subW117*u[13]*u[29]*u[31]*u[51]*u[95] -u[10]*(subW66*(subW568*u[13] + u[95]) + 4.*u[12]*u[29]*(-u[95] + u[13]*(1. + (u[5] - 2.*u[46])*u[95]))))) + kTv*(2.*subW1*(subW299*subW433 + subW561)*u[13]*u[95] + u[9]*(-2.*subW57*subW595 + subW305*u[10]*u[37] + u[13]*(subW568*u[10]*u[37]*u[45] + 2.*(subW289*subW492*u[10] + subW38*subW503*u[12] + 2.*subW117*u[29]*u[37]*u[51])*u[95])) + u[8]*(2.*u[13]*(subW543 + (2.*subW10*subW475 + subW11*subW58)*u[29])*u[95] + u[9]*(2.*u[13]*(subW29*subW503 -subW117*u[31]*u[51])*u[95] + u[10]*(subW66*u[13]*(4.*u[17] -u[28])*u[95] - 2.*u[12]*(-u[95] + u[13]*(1. + (u[5] - 2.*(u[28]*u[29] + u[46]))*u[95])))))));
u[98] = subW117*subW297*subW332*subW85*u[8]*u[12]*u[13]*(subW504 + subW505*u[37]);
u[99] = kTv*subW1*subW117*subW2*subW85*u[15]*((-2. + subW326)*u[13] + subW471*u[19])*(-2.*u[95] + u[14]*(-2. + (subW3 + 2.*kTv*subW74)*u[95]));
u[100] = subW40*u[8]*u[12]*u[15]*(u[14]*(subW332*subW40*subW90*subWW14*u[8]*u[12] + u[16]*(u[8]*(u[11]*(subW2*subW327*u[7] + subW366*u[13]) + u[12]*(2.*subW40*subWW2*(subW74 - 2.*u[17]) + subW11*u[11]*u[19])) + subW327*u[12]*(subW38*u[8] + subW1*u[26])*u[39])) + subW40*((subW506*subW66*u[8] + u[12]*(u[8]*(-2.*subW328*u[29] + 2.*((subW123 + u[13]*(u[16] - 2.*u[19]))*u[28] + u[19]*(subW3*subW74*subWW14*u[14] + (2.*u[13] -u[16])*u[29]))) + subW506*u[34]*u[37]))*u[95] + 2.*kTv*u[8]*u[12]*(-subW123*u[95] + u[14]*(subW332 + u[16]*(-2.*u[19] + u[95])) + u[13]*(subW332 + u[14]*(subW131 + (-3. + subW326)*u[95])))));
u[101] = subW121*subW40*u[8]*u[12]*u[13]*(2.*u[8]*(subW265*subW475 + subW507*u[9]*u[12]) + subW40*(subW324 -subW71)*u[37])*u[95];
u[102] = subW121*subW40*u[8]*u[12]*u[13]*((u[14]*u[34]*(2.*(subW265*subW508*u[11]*u[12] + subW2*subW85*(-subW74 + u[30])*u[33]) -u[12]*(subW85*(2.*subW54 -subW347*u[10])*u[38] + 2.*u[9]*u[37]*(subW11*u[33] + u[10]*(u[25] + u[46])))) + u[9]*(-subW289*(subW181*u[14]*(2.*subW54 + u[10]*(u[28] + u[29] - 3.*u[30])) + u[10]*u[45]) + subW117*u[37]*u[51]) + u[10]*(subW85*u[38]*(3.*subW181*u[14]*u[17] + u[45]) -u[37]*(subW71*u[9] + 2.*subW181*u[14]*(u[9]*u[41] + subW38*u[53]))) + u[12]*(subW289*subW40*u[14]*u[17]*u[34] - 2.*(subW85*u[33]*u[45] + subW40*u[14]*u[34]*u[37]*u[75])))*u[95] + u[14]*(2.*subW2*u[34]*(u[9]*u[11] -subW85*u[17]*u[33]*u[95]) -subW10*(subW57*u[8] + (subW153*u[8]*(2.*subW66 + subW559*u[12]) + 2.*subW31*u[9]*u[34]*u[37])*u[95]) + subW1*(subW29*(u[39] + subW265*subW476*u[95]) - 2.*subW299*(u[39] + (subW152 -(subW322 + subW74)*u[10])*u[53]*u[95]))) + u[8]*((-2.*subW265*(subW114 + subW411*u[14]) + u[9]*u[14]*u[31]*(-2.*subW375*u[20]*u[33] + subW117*(subW68 + 3.*u[30])*u[51] + u[10]*(subW558*subW71 - 2.*((subW149 + subW315)*u[45] + subW54*u[51]))))*u[95] + u[14]*(u[11]*(subW11*u[12] + 2.*subW265*(subW509*u[12] + subW505*u[31])*u[95]) -u[12]*((2.*subW265*subW96*u[34] + u[9]*(u[33]*(subW11*(subW263 + 3.*u[28] -u[30]) + 2.*subW509*u[39]) + u[10]*(u[25]*(3.*u[28] -u[29] + u[30]) + (subW199 - 3.*u[29])*u[41] + (u[28] - 3.*u[29] + 3.*u[30])*u[46] + u[17]*(3.*u[25] - 3.*u[41] + u[46] -u[75]) + (3.*u[28] -u[29] - 3.*u[30])*u[75])))*u[95] + subW38*(u[39] + subW265*subW559*u[95])))));
u[103] = subW117*subW297*subW332*subW560*subW85*u[8]*u[12]*(u[12]*(4.*u[8]*u[28] + u[34]*u[37]) + kTv*(2.*u[8]*u[12] + u[37]*u[45]));
u[104] = subW40*subWW11*u[8]*u[12]*(-2.*u[8]*(subW11*(subW114*(2.*u[13] + u[19]) - 2.*subW38*u[12]*u[13]*u[19]*u[28])*u[95] + u[13]*(subW10*subW114*(subW493*u[19] + u[95]) + 2.*u[9]*u[28]*(-subW188*subW2*subW332 + u[10]*(subW510 + u[12]*(-u[95] + u[19]*(1. + (u[5] + 2.*u[25])*u[95])))))) + u[13]*(subW332*(4.*subW1*subW585*u[28] - 2.*subW57*subW90*u[9]*u[45] + subW3*(u[8]*(subW114*subW203 -subW11*(subW114 + 2.*u[11]*u[12]) + 2.*u[9]*u[12]*(subW152 + u[10]*u[29])) + 2.*subW1*subW489*u[39] + u[9]*(-2.*subW485*subW57 + (2.*subW38*u[12] + u[10]*(2.*subW212 + subW338*u[37]))*u[45]))) + u[9]*(4.*subW2*subW332*subW38*u[28]*u[34] -u[10]*((subW169 + 2.*subW71)*u[37]*u[95] + u[19]*((subW181*subW569 + 2.*subW493*subW71)*u[37] - 4.*subW181*subW212*u[28]*u[95]))) + kTv*(2.*subW1*subW332*((subW11 + subW295)*subW299 + u[12]*(subW489*u[7] - 2.*u[26]*u[28]*u[39])) + u[9]*(2.*subW332*u[12]*(subW38*subW485 - 2.*subW57*u[28]*u[34]) + u[10]*(subW305*u[37] + u[19]*(-subW569*u[37]*u[45] + (2.*subW212*subW485 + (subW181*subW338 + 2.*subW71*u[29])*u[37])*u[95]))) - 2.*u[8]*(subW11*subW332*subW487*u[12] + subW114*(subW493*u[19]*u[39] + (u[19]*(subW11*u[28] -subW10*u[29]) + u[39])*u[95]) + u[9]*(-subW29*subW332*subW485 + u[10]*(subW510 + u[12]*(-u[95] + u[19]*(1. + (u[5] + 2.*u[25] - 2.*u[28]*u[29])*u[95]))))))));
u[105] = subW117*subW297*subW332*subW85*u[8]*u[12]*u[13]*(subW504 + subW508*u[45]);
u[106] = subW121*subW40*u[8]*u[12]*u[13]*(2.*u[8]*(subW507*u[9] + subW265*u[11])*u[12] + u[9]*((2.*subW31 + subW32)*u[9] + subW87*u[36])*u[45])*u[95];
COMPLEX subA1 = u[23]*u[24];
COMPLEX subA2 = u[43]*u[44];
COMPLEX subA4 = u[48] + 4.*u[56];
COMPLEX subA6 = u[62]*u[63];
COMPLEX subA8 = -u[77]*u[78];
COMPLEX subA11 = u[77]*u[82];
COMPLEX subA14 = u[55] + u[71];
COMPLEX subA15 = u[77]*u[81];
COMPLEX subA16 = u[88]*u[92];
COMPLEX subA17 = -2.*u[88]*u[89];
COMPLEX subA20 = u[77]*u[91];
COMPLEX subA21 = pow2(u[22]);
COMPLEX subA23 = u[98] + u[105];
COMPLEX subA24 = subA1 + subA2 + u[49] -u[50];
COMPLEX subA25 = subA6 + 2.*u[42] + u[74];
COMPLEX subA26 = subA8 + u[48] + 2.*u[80];
COMPLEX subA28 = subA6 + u[60] + u[74];
COMPLEX subA30 = subA17 + u[84];
COMPLEX subA32 = -subA21*u[99];


COMPLEX amp12345 = 0.03125*(-subA24*u[22] + subA4*u[43] + 2.*u[54] - 2.*u[55] -u[57] - 2.*u[58] -u[59] + u[23]*(2.*u[42] -u[60]));

COMPLEX amp12435 = 0.015625*(u[62]*(-subA15 + u[83]) -u[77]*u[84] - 2.*(subA11 + subA26*u[43] + u[62]*u[70] + u[85]) + 2.*(subA24*u[22] + subA28*u[23] + u[57] + u[59] + u[73] + u[86]));

COMPLEX amp12534 = 0.015625*(subA32 + 2.*(subA28*u[23] + u[59] + u[62]*(u[68] -u[70]) + u[72] + u[73] + u[65]*(u[62]*u[66] -u[67] - 2.*u[97]) + u[22]*(subA1 -u[50] + u[65]*u[96] -u[98] -u[100]) + u[101] + u[102]));

COMPLEX amp13245 = 0.03125*(u[43]*(subA8 - 4.*u[56]) + u[85] + 2.*(u[55] + u[43]*u[80] + u[88]*u[90]) + u[77]*(u[82] + u[88]*u[89] + u[91]) -u[93] - 2.*(subA16 + u[54] + u[94]));

COMPLEX amp13425 = 0.015625*(subA21*u[99] + 2.*u[22]*(subA2 + u[49] + u[100] -u[88]*u[103] -u[105]) - 2.*(subA11 - 2.*subA16 + subA20 + subA26*u[43] -u[57] + u[85] + u[77]*u[88]*u[89] -u[93] + u[102] + 2.*u[88]*u[104] -u[106]));

COMPLEX amp13524 = 0.015625*(subA30*u[77] + u[62]*(subA15 + 2.*(u[65]*u[66] + u[68]) -u[83]) - 2.*(subA20 + subA23*u[22] + u[86] + u[65]*(u[67] -u[22]*u[96] + 2.*u[97])) + u[88]*(4.*u[92] - 2.*u[22]*u[103] - 4.*u[104]) + 2.*(u[72] + u[93] + u[101] + u[106]));

COMPLEX amp14235 = 0.015625*(4.*subA14 + u[65]*(2.*u[62]*u[66] - 2.*u[67] + 8.*u[69]) + u[62]*(subA15 -u[83]) + u[77]*u[84] + 2.*(subA11 + u[62]*u[68] + u[72] + u[85]) - 2.*(u[43]*(4.*u[56] + u[77]*u[78] - 2.*u[80]) + u[86]));

COMPLEX amp14325 = 0.015625*(subA32 - 2.*u[22]*(subA2 + u[49] -u[65]*u[96] + u[98] + u[100]) + 2.*(-2.*subA14 + subA4*u[43] -u[57] + u[65]*(-4.*u[69] - 2.*u[97]) + u[101] + u[102]));

COMPLEX amp14523 = 0.03125*(-subA23*u[22] + u[65]*(-4.*u[69] + u[22]*u[96] - 2.*u[97]) + u[101] + u[88]*(2.*u[90] -u[22]*u[103]) - 2.*(u[54] + u[71] + u[94] + u[88]*u[104]) + u[106]);

COMPLEX amp12354 = 0.03125*(-subA25*u[23] + 2.*u[58] + u[65]*(-u[62]*u[66] + u[67] - 4.*u[69]) + u[62]*(-u[68] + u[70]) - 2.*(u[54] + u[71]) -u[72] -u[73]);

COMPLEX amp12453 = 0.015625*(subA30*u[77] + u[62]*(subA15 + 2.*u[70] -u[83]) - 2.*(subA20 + subA25*u[23] + u[73] + u[86]) - 4.*u[88]*u[90] + 2.*u[93] + 4.*(subA16 + u[58] + u[94]));

COMPLEX amp12543 = 0.015625*(subA21*u[99] - 2.*(u[59] + u[23]*(-2.*u[42] + u[60]) + 2.*(u[58] + u[94]) + u[102] + u[88]*(-2.*u[90] + 2.*u[104]) + u[22]*(subA1 -u[50] -u[100] + u[88]*u[103] + u[105]) -u[106]));

delete [] u;

// color factors are included below, without averaging

return 2.*27.*8./32.*(norm(amp12345) +norm(amp12435) +norm(amp12534) +norm(amp13245) +norm(amp13425) +norm(amp13524)
+norm(amp14235) +norm(amp14325) +norm(amp14523) +norm(amp12354) +norm(amp12453) +norm(amp12543) );


}
