//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->ggg for helicities RLLR *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGGGG_RLLR() {
int Nsymb =98;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k1,k1);
u[2] = Dot(k1,k2);
u[3] = Dot(k2,n);
u[4] = Dot(k3,n);
u[5] = Dot(k4,k5);
u[6] = Dot(k4,n);
u[7] = S(L,k2,n);
u[8] = S(L,k3,k4);
u[9] = S(L,k3,n);
u[10] = S(L,k4,n);
u[11] = S(R,k4,n);
u[12] = S(R,k5,n);
u[13] = S(R,n,k2,e1);
u[14] = Den(u[6]);
u[15] = Den(u[5]);
u[16] = Den(u[4]);
u[17] = Den(u[3]);
u[18] = Dot(e1,k2);
u[19] = Dot(k5,n);
u[20] = Den(u[19]);
u[21] = S(L,k3,k5);
u[22] = Den(u[3] -u[4]);
u[23] = Den(u[1] + 2.*u[2]);
u[25] = Dot(k3,k4);
u[26] = S(L,k2,k3);
u[27] = S(R,k3,n);
u[28] = S(R,k5,n,e1);
u[29] = Den(u[25]);
u[30] = S(R,k3,k5);
u[31] = S(R,n,k3,e1);
u[32] = S(R,n,k4,e1);
u[33] = Dot(e1,k5);
u[34] = S(L,k4,k5);
u[35] = S(R,k4,k5);
u[36] = S(L,k2,k4);
u[37] = Dot(k1,k5);
u[38] = Dot(k2,k3);
u[39] = S(L,k2,k5);
u[40] = S(R,k2,n);
u[41] = Den(u[38]);
u[42] = S(R,k2,k5);
u[43] = Dot(e1,k3);
u[44] = Dot(e1,k4);
u[45] = Dot(k2,k4);
u[46] = Dot(k2,k5);
u[48] = Den(u[1] -2.*u[37]);
u[57] = Dot(k3,k5);
u[60] = Den(u[57]);
u[61] = Den(u[4] + u[19]);
u[63] = Dot(k1,k4);
u[64] = Den(u[1] -2.*u[63]);
u[74] = Den(u[45]);
u[79] = Dot(k1,k3);
u[80] = Den(u[1] -2.*u[79]);
u[87] = Den(u[46]);
u[88] = Den(u[3] -u[19]);
COMPLEX subW1 = pow2(u[10]);
COMPLEX subW2 = pow2(u[12]);
COMPLEX subW3 = pow2(kTv);
COMPLEX subW4 = -2.*kTv*u[18];
COMPLEX subW8 = u[14] -u[20];
COMPLEX subW9 = u[8]*u[11];
COMPLEX subW10 = u[12]*u[21];
COMPLEX subW12 = kTv - 2.*u[18];
COMPLEX subW13 = u[33] + u[44];
COMPLEX subW17 = u[11]*u[36];
COMPLEX subW18 = u[12]*u[39];
COMPLEX subW20 = u[8]*u[27];
COMPLEX subW21 = u[21]*u[27];
COMPLEX subW22 = u[11]*u[34];
COMPLEX subW24 = -u[28]*u[39];
COMPLEX subW25 = -u[27]*u[31];
COMPLEX subW26 = -u[11]*u[32];
COMPLEX subW27 = u[13]*u[40];
COMPLEX subW28 = u[27]*u[31];
COMPLEX subW29 = u[11]*u[32];
COMPLEX subW32 = -u[18] -u[33] + u[43] + u[44];
COMPLEX subW34 = u[32]*u[35];
COMPLEX subW35 = u[8]*u[13];
COMPLEX subW36 = u[13]*u[21];
COMPLEX subW37 = -u[31]*u[39];
COMPLEX subW38 = kTv + 2.*u[33];
COMPLEX subW39 = u[10]*u[11];
COMPLEX subW40 = u[9]*u[27];
COMPLEX subW43 = u[26]*u[27];
COMPLEX subW45 = u[7]*u[40];
COMPLEX subW46 = pow2(u[7]);
COMPLEX subW47 = -kTv*u[13];
COMPLEX subW48 = u[7]*u[12];
COMPLEX subW49 = u[13]*u[28];
COMPLEX subW60 = -u[16]*u[17]*u[20];
COMPLEX subW61 = u[17] -u[20];
COMPLEX subW63 = -u[17]*u[20];
COMPLEX subW68 = u[16]*u[17]*u[20];
COMPLEX subW69 = u[17] - 5.*u[20];
COMPLEX subW71 = u[17]*u[20];
COMPLEX subW75 = u[43] + u[44];
COMPLEX subW77 = -u[16]*u[17];
COMPLEX subW78 = pow2(u[27]);
COMPLEX subW81 = -2.*u[27]*u[33]*u[36];
COMPLEX subW82 = u[30]*u[32]*u[39];
COMPLEX subW86 = pow2(u[17]);
COMPLEX subW90 = 2.*kTv*u[18];
COMPLEX subW102 = pow2(u[11]);
COMPLEX subW103 = u[16]*u[17];
COMPLEX subW104 = -u[16] + u[17];
COMPLEX subW108 = u[26]*u[32];
COMPLEX subW109 = u[31]*u[36];
COMPLEX subW112 = -u[39]*u[40];
COMPLEX subW117 = pow2(u[9]);
COMPLEX subW118 = u[16] -u[20];
COMPLEX subW119 = -u[12]*u[34];
COMPLEX subW121 = -2.*kTv*u[13];
COMPLEX subW122 = 2.*kTv*u[44];
COMPLEX subW127 = kTv + 2.*u[44];
COMPLEX subW128 = u[38] + u[46];
COMPLEX subW135 = u[5] + u[25];
COMPLEX subW143 = -kTv*u[31];
COMPLEX subW144 = pow3(kTv);
COMPLEX subW146 = u[31]*u[39];
COMPLEX subW149 = pow3(u[12]);
COMPLEX subW150 = u[12]*u[34];
COMPLEX subW156 = u[32]*u[39];
COMPLEX subW158 = 2.*u[7]*u[21];
COMPLEX subW159 = -u[9]*u[39];
COMPLEX subW162 = 2.*kTv*u[43];
COMPLEX subW166 = -u[10]*u[21];
COMPLEX subW167 = 2.*u[9]*u[34];
COMPLEX subW169 = -2.*u[9]*u[34];
COMPLEX subW170 = u[45] + u[46];
COMPLEX subW171 = u[31]*u[33];
COMPLEX subW173 = u[57]*u[74];
COMPLEX subW176 = u[17] + u[20];
COMPLEX subW178 = u[25]*u[87];
COMPLEX subW180 = u[38] + u[45];
COMPLEX subW183 = -2.*u[13]*u[43];
COMPLEX subW185 = -4.*u[18] + u[44];
COMPLEX subW186 = u[31]*u[87];
COMPLEX subW187 = u[25]*u[31];
COMPLEX subW197 = subW10 + subW9;
COMPLEX subW198 = subW3 + subW4;
COMPLEX subW201 = kTv*subW13;
COMPLEX subW204 = subW17 + subW18;
COMPLEX subW205 = -subW27 + subW28 + subW29;
COMPLEX subW206 = -subW27 + subW28;
COMPLEX subW207 = subW21 + subW22;
COMPLEX subW208 = subW39 + subW40;
COMPLEX subW209 = subW28 + subW29;
COMPLEX subW210 = subW48 + subW49;
COMPLEX subW212 = subW17 + subW43;
COMPLEX subW214 = subW13 + u[43];
COMPLEX subW220 = subW63 + subW61*u[16];
COMPLEX subW224 = subW71 + subW69*u[16];
COMPLEX subW229 = subW81 + subW82;
COMPLEX subW231 = -2.*subW78*u[26]*u[33];
COMPLEX subW232 = subW28*u[30]*u[39];
COMPLEX subW234 = -subW3 + u[46];
COMPLEX subW237 = subW3 + subW90 - 6.*u[46];
COMPLEX subW241 = u[20] + subW86*u[46];
COMPLEX subW248 = subW18 + subW43 + subW47;
COMPLEX subW249 = subW103 + subW104*u[14];
COMPLEX subW250 = subW108 + subW109;
COMPLEX subW251 = subW112 + subW21;
COMPLEX subW252 = subW13 + u[18] -u[43];
COMPLEX subW253 = subW75 -u[18] - 3.*u[33];
COMPLEX subW254 = subW25 + subW27;
COMPLEX subW255 = subW119 + subW20;
COMPLEX subW256 = subW122 + subW3;
COMPLEX subW259 = -1. + subW128*u[60];
COMPLEX subW261 = -subW17*u[34];
COMPLEX subW262 = 2.*subW20*u[39];
COMPLEX subW263 = subW3*subW63*u[60];
COMPLEX subW264 = 1. + subW135*u[60];
COMPLEX subW265 = -subW17 -subW43 + kTv*u[13];
COMPLEX subW266 = 8. + subW3*u[17];
COMPLEX subW267 = subW34*u[21]*u[60];
COMPLEX subW269 = subW146 + subW36;
COMPLEX subW272 = -subW27 + subW29;
COMPLEX subW274 = subW40*u[12]*u[26];
COMPLEX subW275 = subW158 + subW159;
COMPLEX subW278 = subW162 + subW3;
COMPLEX subW281 = subW166 + subW167;
COMPLEX subW282 = subW10 + subW171;
COMPLEX subW283 = 1. + subW173;
COMPLEX subW284 = subW143 + subW9;
COMPLEX subW285 = 1. + subW178;
COMPLEX subW286 = subW20 + kTv*u[32];
COMPLEX subW287 = kTv + 2.*subW75;
COMPLEX subW289 = -2.*subW9*u[43];
COMPLEX subW295 = 4.*subW180 -u[25];
COMPLEX subW298 = -2. + subW198*u[17];
COMPLEX subW299 = subW170 + subW201;
COMPLEX subW301 = kTv*subW210;
COMPLEX subW302 = 2.*subW214*u[7];
COMPLEX subW305 = -subW212*u[28];
COMPLEX subW307 = subW231 + subW232 + subW229*u[11];
COMPLEX subW308 = 2.*subW234*subW86*u[16]*u[20]*u[29];
COMPLEX subW309 = 2.*subW234*subW86*u[20]*u[29];
COMPLEX subW310 = 2.*subW241*u[29];
COMPLEX subW311 = -4. + subW237*u[29];
COMPLEX subW318 = subW212 + subW47;
COMPLEX subW319 = subW60 + subW220*u[14];
COMPLEX subW321 = subW68 + subW224*u[14];
COMPLEX subW324 = 2. + subW256*u[14];
COMPLEX subW325 = subW267 + u[31];
COMPLEX subW326 = subW204 + subW43;
COMPLEX subW327 = subW2*subW275;
COMPLEX subW329 = 2. + subW278*u[16];
COMPLEX subW330 = subW183 + subW212;
COMPLEX subW331 = subW187 + subW289;
COMPLEX subW336 = 3. + subW295*u[87];
COMPLEX subW337 = subW24 + subW302;
COMPLEX subW340 = subW311*subW71;
COMPLEX subW346 = kTv*subW319;
COMPLEX subW347 = subW321*subW75;
COMPLEX subW349 = subW274 + subW327;
COMPLEX subW350 = u[31] + subW331*u[87];
COMPLEX subW353 = subW301 + subW305 + subW337*u[12];
COMPLEX subW354 = subW310 + subW340;
COMPLEX subW359 = subW346 + subW347;
COMPLEX subW360 = subW186 + subW350*u[14];
COMPLEX subW361 = subW309 + subW354*u[16];
COMPLEX subW364 = subW308 + subW361*u[14];
COMPLEX subWW1 = u[15]*u[20];
COMPLEX subWW2 = 3.*u[17] + u[20];
COMPLEX subWW3 = u[30]*u[31]*u[34];
COMPLEX subWW4 = -subW39 + subW45;
COMPLEX subWW7 = u[32]*u[87];
COMPLEX subWW8 = subW272*u[9] + subWW4*u[31];
u[24] = subW1*subW197*subW2*subW298*subW8*u[7]*u[9]*u[13]*u[15]*u[16];
u[47] = subW103*subW2*u[7]*u[9]*u[10]*(subW9*(-u[10]*(2.*subW12*subW18*subWW1*u[14] + u[13]*(subWW1 + u[14]*(-u[20] + u[15]*(-3. + subW299*u[20])))) + 2.*subW12*subW48*subWW1*u[14]*u[34]) + u[12]*(u[10]*(2.*subW12*subW17*subWW1*u[14] + u[13]*(-3.*subWW1 + u[14]*(u[15] + (-1. + subW299*u[15])*u[20])))*u[21] + 2.*(subW10*subW12*subWW1*u[7]*u[14] + u[9]*(-subW12*subW204*subWW1*u[14] + u[13]*(subWW1 + u[14]*(-subW299*subWW1 + u[15] + u[20]))))*u[34]));
u[49] = subW48*subW68*u[9]*u[10]*u[14]*u[26]*(subW20 -u[36]*u[40])*u[41]*(u[9]*(subW32*u[12]*u[27] + subW205*u[30]) + u[10]*(u[11]*(subW34 + subW32*u[12]) + subW206*u[35]) + u[12]*(subW207*u[28] + u[40]*(subW24 + u[7]*(u[18] + u[33] -u[43]))) + u[7]*((subW254 + subW26)*u[42] -u[12]*u[40]*u[44]));
u[50] = subW1*subW103*subW2*subW204*subW8*u[7]*u[9]*u[15]*u[31];
u[51] = subW1*subW2*subW77*subW8*u[7]*u[9]*((-subW109 + subW35)*u[11] + (subW36 + subW37)*u[12])*u[15];
u[52] = subW2*subW38*subW68*u[7]*u[8]*u[9]*u[10]*(2.*subW207*subW48 - 2.*kTv*subW209*u[7] + subW208*(-subW18 + subW212 + kTv*u[13]))*u[14]*u[29];
u[53] = subW2*subW68*u[7]*u[9]*u[10]*u[14]*u[26]*(subW206*u[10] + (-subW40 + subW45)*u[32])*u[41];
u[54] = subW2*subW68*u[7]*u[9]*u[10]*u[14]*u[15]*u[31]*((subW17 -subW18)*u[10] + 2.*subW48*u[34]);
u[55] = subW2*subW209*subW46*subW68*u[8]*u[9]*u[10]*u[14]*u[29];
u[56] = subW2*subW68*u[7]*u[8]*u[9]*u[10]*(subW209*u[7] -subW208*u[13])*u[14]*u[29];
u[58] = -subW48*u[9]*u[10]*(2.*(subW326 + subW47)*subW68*u[12]*u[14]*(u[10]*u[31] -u[9]*u[32]) + u[8]*(2.*subW207*subW353*subW68*u[12]*u[14]*u[29] + u[9]*(-u[12]*(subW364*u[13]*u[27] + 2.*subW71*(subW307*u[14]*u[16] -kTv*subW212*(subW77 + u[14]*(u[16] -u[17]))*u[27])*u[29]) + u[17]*u[29]*(-2.*subW209*subW318*u[14]*u[16]*u[20]*u[30] + subW2*subW359*u[27]*u[39])) + u[10]*(-2.*subW71*u[29]*(subW248*subW28*u[14]*u[16]*u[35] + subW102*(kTv*subW249*u[12] + u[14]*u[16]*(subW34 - 2.*u[12]*u[33]))*u[36]) + u[11]*(u[17]*u[29]*(2.*u[14]*u[16]*u[20]*(-subW250*u[27] + kTv*u[13]*u[32])*u[35] + subW2*subW359*u[39]) -u[12]*(subW364*u[13] + 2.*subW71*u[29]*(kTv*subW249*subW43 + u[14]*u[16]*(-2.*subW43*u[33] + subW34*u[39])))))));
u[59] = subW48*subW68*u[9]*u[10]*u[14]*(-2.*u[12]*(subW150*u[15]*(u[9]*(u[13] -subW252*subW43*u[41]) + u[7]*(-u[31] + subW252*u[26]*u[40]*u[41])) + u[26]*u[41]*(u[9]*(u[27]*(subWW3*u[15] + u[32]) -subW27*u[15]*u[30]*u[34]) + u[15]*u[28]*u[34]*(subW251*u[12] -subW17*u[40]) -u[7]*(u[32]*u[40] + subW206*u[15]*u[34]*u[42]))) + u[15]*(-u[8]*(2.*subW22*subW43*u[12]*u[28]*u[41] + u[10]*(2.*subW206*subW43*u[35]*u[41] + u[11]*(2.*subW34*subW43*u[41] + u[12]*(u[13] + subW253*subW43*u[41])))) + u[10]*(2.*subW205*u[26]*u[35]*u[36]*u[40]*u[41] + subW2*(subW36 + subW37 + subW251*u[26]*u[41]*(-u[18] + u[33] + u[43] - 3.*u[44])) + u[12]*(subW17*(u[31] + subW253*u[26]*u[40]*u[41]) + 2.*u[26]*u[41]*(subW34*(-subW21 + u[39]*u[40]) + subW206*(u[25] + u[46]) + subW254*(u[45] + u[57]))))));
u[62] = subW117*subW118*subW2*subW255*subW298*u[7]*u[10]*u[13]*u[14]*u[60];
u[65] = subW117*subW118*subW2*subW324*(subW121 + 2.*subW17 + subW18 + subW43)*u[7]*u[10]*u[17]*u[32]*u[60];
u[66] = subW2*u[7]*u[9]*u[10]*u[14]*u[17]*(2.*subW10*(u[10]*u[16]*u[20]*((-subW17 + subW18 + subW43)*u[44] + kTv*(subW18 + subW43 + u[13]*u[44]))*u[60] + u[7]*(subW259*u[16]*u[20]*u[32] + (subW127*subW255*u[16]*u[20] + 2.*(u[16] + u[20])*u[32])*u[60])) + u[9]*(-4.*subW18*u[20]*u[32]*u[60] + u[16]*(4.*subW43*u[32]*u[60] + u[20]*(subW259*(-subW156*u[12] + subW43*u[32]) + ((subW20*(subW17 + subW43 + subW47) -subW261*u[12] + subW2*u[34]*u[39] - 3.*(subW150*subW43 + subW20*u[12]*u[39]))*u[44] -kTv*(2.*subW150*subW43 + u[12]*(subW262 + u[13]*u[34]*u[44])))*u[60]))));
u[67] = subW117*subW118*subW2*(subW18 + subW43)*u[7]*u[10]*u[14]*u[17]*u[32]*u[60];
u[68] = subW48*u[9]*u[10]*u[17]*(u[8]*(-4.*subW10*subW353*u[14]*u[16]*u[20]*u[27]*u[60] + u[9]*((4.*subW209*subW318*u[14]*u[16]*u[20]*u[30] + subW2*(kTv*(subW68 + u[14]*(subW71 - 3.*subW61*u[16])) + 8.*subW75*u[14]*u[16]*u[20])*u[27]*u[39])*u[60] + u[12]*((4.*subW307*u[14]*u[16]*u[20] -kTv*subW212*(subW60 + u[14]*(subW63 + subWW2*u[16]))*u[27])*u[60] + u[13]*u[27]*(subW3*subW60*u[60] + u[14]*(subW263 + u[16]*(-2.*subW264*u[20] + (8. + subW3*subWW2 + 8.*kTv*u[20]*u[33])*u[60])))))) + u[12]*(4.*subW10*subW353*u[14]*u[16]*u[20]*u[34]*u[60] + u[9]*((4.*subW265*u[14]*u[16]*u[20]*(subWW3 + (u[5] -u[25])*u[32]) + subW2*u[34]*u[39]*(kTv*(subW68 + u[14]*(-3.*subW71 + subW61*u[16])) - 8.*u[14]*u[16]*u[20]*u[43]))*u[60] + u[12]*((kTv*(subW212*subW68 + u[14]*(-3.*subW212*subW71 + u[16]*(subW212*u[17] -(subW17 - 3.*subW43)*u[20])))*u[34] + 4.*u[14]*u[16]*u[20]*((-subWW3 + (-u[5] + u[25])*u[32])*u[39] + 2.*u[34]*(subW13*subW43 -subW17*u[43])))*u[60] -u[13]*u[34]*(subW266*u[16]*u[20]*u[60] + u[14]*(-3.*subW3*subW71*u[60] + u[16]*(-6.*subW264*u[20] + (subW266 + (8.*subW201 + 3.*subW3)*u[20])*u[60]))))) - 2.*u[10]*(-2.*subW265*subW325*u[14]*u[16]*u[20] + subW2*u[21]*u[39]*(kTv*(subW68 -u[14]*(subW71 + subW61*u[16])) + 4.*u[14]*u[16]*u[20]*u[44])*u[60] -u[12]*(u[14]*(kTv*subW212*subW71*u[21]*u[60] + u[16]*(kTv*subW212*u[17]*u[21]*u[60] + u[20]*(-2.*subW146 + u[21]*(kTv*(subW17 -subW43) + 4.*subW17*(u[33] + u[43]) - 2.*(subW34*u[39] + 2.*subW43*u[44]))*u[60]))) + u[21]*(kTv*subW212*subW60*u[60] + u[13]*(u[16]*(4. + subW3*u[17])*u[20]*u[60] + u[14]*(subW263 + u[16]*(-subW3*u[17]*u[60] + u[20]*(-2.*subW264 + (subW3 + 4.*kTv*u[44])*u[60])))))))));
u[69] = subW117*subW118*subW2*subW255*u[7]*u[10]*u[13]*u[14]*u[17]*u[60];
u[70] = subW2*subW68*u[7]*u[9]*(2.*subW10*u[7] + (-subW18 + subW43)*u[9])*u[10]*u[14]*u[32]*u[60];
u[71] = subW1*subW2*subW254*subW68*u[7]*u[9]*u[14]*u[26]*u[41];
u[72] = subW103*subW48*u[9]*u[10]*u[14]*(-(subW143 + subW197)*subW48*(-u[32]*u[41] + u[20]*(subW127*subW150*u[41] + u[32]*(-1. + (-u[5] + kTv*u[33])*u[41]))) + u[9]*(u[32]*(-u[20]*(subW17*u[12] + subW2*u[39]) + subW43*u[12]*u[41]) - 2.*subW2*subW43*u[20]*u[34]*u[41]*u[44]) + u[20]*(u[41]*(-subW3*(subW146*subW2*u[10] + u[32]*((subW269*u[12] + subW9*u[13])*u[28] + u[31]*(subW212*u[28] -u[10]*u[13]*u[35]))) + u[32]*(subW144*subW49*u[31] + subW43*(u[5]*u[9]*u[12] + u[10]*(subW9 + u[12]*u[21])*u[35]) + u[10]*u[35]*((subW102*u[8] + subW10*u[11])*u[36] + (subW9*u[12] + subW2*u[21])*u[39])) + 2.*u[10]*(subW2*subW21*u[26] + (subW2*subW9 + subW149*u[21])*u[39])*u[44]) + kTv*(-u[9]*u[12]*(-u[13]*u[32] + subW43*(subW150 + u[32]*u[33])*u[41]) + u[41]*(subW197*subW326*u[28]*u[32] + u[10]*(-subW34*(subW269*u[12] + subW9*u[13] + subW212*u[31]) + subW149*u[21]*u[39] + subW2*(subW21*u[26] + u[39]*(subW9 - 2.*u[31]*u[44])))))));
u[73] = subW2*subW68*u[7]*u[9]*u[10]*((subW150 + subW20)*u[9] - 2.*subW10*u[10])*u[13]*u[14]*u[60];
u[75] = subW2*subW38*subW60*u[7]*u[9]*u[10]*u[14]*(-subW10*subW39 -kTv*subWW8 + u[12]*(subW112*u[9] + subW22*u[9] + subW45*u[21]))*u[36]*u[74];
u[76] = subW117*subW118*subW2*u[7]*u[10]*u[14]*u[17]*((subW108 + subW35)*u[27] + u[12]*(subW156 -u[13]*u[34]))*u[60];
u[77] = subW48*subW68*u[9]*u[10]*u[14]*(u[36]*((u[11]*(u[12]*(-2.*u[9]*(subWW3 + u[32]*u[38]) + subW158*u[32]*u[42]) + subW2*u[34]*(-2.*u[21]*u[28] + u[9]*(-u[18] + u[33] + u[44]))) + u[9]*(-2.*u[13]*u[26]*u[30]*pow2(u[40]) + u[11]*(-3.*subW2*u[34]*u[43] + 2.*u[12]*u[32]*u[46])) + u[40]*((2.*(subW2*u[21]*u[28] + u[9]*u[12]*u[30]*u[31]) -subW2*u[9]*u[33])*u[39] + u[9]*(2.*(subW209*u[26]*u[30] + u[12]*u[13]*u[38]) + subW2*u[18]*u[39]) - 2.*(subW2*u[7]*u[21]*(u[18] + u[33]) + u[12]*u[13]*(u[9]*u[25] + u[7]*u[21]*u[42])) + (subW274 + subW2*(-2.*u[7]*u[21] + 3.*u[9]*u[39]))*u[43] + subW349*u[44] + u[12]*(2.*subW21*u[26]*u[28] -u[9]*(subW43*(u[18] + 3.*u[33]) + u[13]*(-2.*u[5] + 2.*u[46])))))*u[60] + 2.*u[12]*(subW45*u[31] + subW29*u[9]*u[25]*u[60]))*u[74] - 2.*u[10]*u[12]*(u[36]*(subW325*u[11] -subW27*u[21]*u[35]*u[60])*u[74] + subW10*u[60]*(u[13] -subW17*(u[18] + u[33] + u[43] -u[44])*u[74])) + u[60]*(subW349*u[32] + u[9]*(subW2*u[13]*u[34] - 2.*subW17*u[5]*u[12]*u[32]*u[74]) + u[8]*(2.*subW10*subW17*u[27]*u[28]*u[74] + u[9]*(2.*subW17*subW205*u[30]*u[74] + u[12]*u[27]*(u[13] + subW17*subW253*u[74])))));
u[78] = subW2*subW68*subWW8*u[7]*u[9]*u[10]*u[14]*u[36]*u[74];
u[81] = subW1*subW2*subW329*(subW121 + subW204 + 2.*subW43)*subW8*u[7]*u[9]*u[15]*u[17]*u[31];
u[82] = subW103*subW2*u[7]*u[9]*u[10]*(2.*subW48*u[34]*(-2.*subWW1*u[31] + u[14]*(u[20]*u[31] -u[15]*((2. + subW170*u[20])*u[31] - 2.*subW197*u[20]*u[43]))) + subWW1*u[14]*(subW170*subW18*u[10]*u[31] + (u[12]*(subW281*subW43 + subW17*(subW169 + 3.*u[10]*u[21])) + u[8]*u[10]*(-3.*subW18*u[11] + subW102*u[36]) + (subW166 + subW169)*subW2*u[39])*u[43] + kTv*(u[10]*(subW10*u[13]*u[43] + u[11]*(2.*u[12]*(u[21]*u[36] -u[8]*u[39]) -subW35*u[43])) + 2.*subW150*(subW197*u[7] -u[9]*(subW204 + u[13]*u[43])))) + u[10]*(subW17*u[14]*u[31]*(u[20] -u[15]*(4. + u[20]*u[45])) + u[20]*(-subW18*(u[14] - 4.*u[15])*u[31] + u[11]*u[14]*u[15]*(subW20*u[26]*u[43] -subW109*u[46]))));
u[83] = subW103*subW48*u[9]*u[10]*u[14]*((u[20]*(subW3*(u[31]*(u[28]*((subW108 -subW35)*u[27] + subW18*u[32]) + u[13]*(subW150*u[28] -u[9]*u[30]*u[32])) + u[32]*(-subW282*subW48 + subW17*u[28]*u[31] + subW2*u[9]*u[39])) + (2.*subW17*subW2*u[10]*u[21] + u[9]*(subW2*(subW262 - 2.*subW17*u[34]) - 2.*subW149*u[34]*u[39]))*u[43]) + u[31]*(u[20]*(-subW144*subW49*u[32] + u[30]*(subW18*subW20*u[9] -subW150*subW40*u[26] + subW159*subW2*u[34])) -subW17*(-subW255*u[9]*u[20]*u[30] + u[10]*u[12]*(1. + u[20]*u[57]))))*u[74] + u[20]*u[31]*(u[10]*(subW43*u[12] + subW2*u[39]) + subW78*u[8]*u[9]*u[26]*u[30]*u[74]) + subW255*subW48*(subW283*u[20]*u[31] + (u[31] - 2.*subW10*u[20]*u[43])*u[74]) + kTv*(subW48*(subW283*u[20]*u[31]*u[32] + (u[31]*(u[32] + (subW150 -subW20)*u[20]*u[33]) + subW10*u[20]*(subW150 -subW20 - 2.*u[32]*u[43]))*u[74]) + u[20]*((subW119*subW326*u[28]*u[31] + subW20*(subW326*u[28]*u[31] + u[9]*(-u[13]*u[30]*u[31] + subW2*u[39])) + u[9]*(u[30]*u[31]*(subW212*u[32] + u[12]*(subW156 + u[13]*u[34])) -subW149*u[34]*u[39] + subW2*(subW261 + 2.*subW156*u[43])))*u[74] + u[10]*u[12]*(-u[13]*u[31] + subW17*subW282*u[74]))));
u[84] = subW1*subW103*subW197*subW2*subW8*u[7]*u[9]*u[13]*u[15];
u[85] = subW117*subW2*(subW26 + subW27)*subW68*u[7]*u[10]*u[14]*u[36]*u[74];
u[86] = subW2*subW68*u[7]*u[9]*u[10]*(subW9*u[10] + subW281*u[12])*u[13]*u[14]*u[15];
u[89] = subW176*subW2*subW284*subW324*subW46*subWW7*u[9]*u[10]*u[16];
u[90] = subW2*subW71*u[7]*u[9]*u[10]*u[14]*(-2.*subW265*(subW127*u[10]*u[16]*(-subW9 + kTv*u[31])*u[87] -u[9]*(subWW7 + u[16]*(subW127*subW20*u[87] + u[32]*(1. + (u[25] -kTv*u[43])*u[87])))) + u[7]*(subW186*subW3*u[16]*(-2.*u[36]*u[40] + u[32]*(4.*u[18] -u[43])) + 2.*subW108*u[40]*(subW285*u[16] + u[87]) + kTv*(-subW186*u[32] + u[16]*(-2.*subW108*u[40]*u[43]*u[87] + u[31]*(-4.*u[36]*u[40]*u[44]*u[87] + u[32]*(-3. + (-4.*subW180 + u[25])*u[87])))) + u[8]*(2.*subW127*subW43*u[16]*u[40]*u[87] + u[11]*(subWW7 + u[16]*(2.*subW127*u[36]*u[40]*u[87] + u[32]*(3. + (subW295 + kTv*(-4.*u[18] + u[43]))*u[87]))))));
u[91] = subW176*subW186*subW2*subW286*subW46*u[9]*u[10]*u[14]*u[16];
u[92] = -subW2*subW209*subW46*u[8]*u[9]*u[10]*(subW77 + u[14]*(2.*u[16] -u[17]))*u[20]*u[87];
u[93] = subW186*subW2*subW68*u[7]*u[9]*u[10]*u[14]*(2.*subW18*u[10] + u[7]*(subW119 + u[36]*u[40]));
u[94] = subW48*u[9]*u[10]*u[14]*u[16]*(2.*subW2*subW71*(u[7]*(-u[21]*u[32] + u[31]*u[34]) + (-u[10]*u[31] + u[9]*u[32])*u[39])*u[87] + u[8]*(-(subW48*(2.*kTv*subW207*subW71*u[12]*u[29] + u[17]*u[20]*(4.*subW75*(subW150*u[11] + subW10*u[27])*u[29] + u[27]*u[31] + u[11]*u[32])) + subW209*u[29]*(subW3*(subW48 + 2.*subW49)*subW71 - 2.*(kTv*subW326*subW71*u[28] + subW48*(u[17] + u[20] + kTv*subW71*(u[18] -u[33])))))*u[87] + 2.*subW71*u[29]*(u[9]*((subW209*subW318*u[30] + subW2*subW287*u[27]*u[39])*u[87] + u[12]*(-u[13]*u[27] + subW209*u[30]*u[39]*u[87])) + u[10]*(u[35]*(subW248*subW28 + subW102*u[32]*u[36])*u[87] + u[11]*(((subW250*u[27] + subW47*u[32])*u[35] + subW2*subW287*u[39])*u[87] + u[12]*(-u[13] + subW34*u[39]*u[87]))))));
u[95] = subW176*subW186*subW2*subW286*subW329*subW46*u[9]*u[10]*u[14];
u[96] = subW176*subW2*subW284*subW46*subWW7*u[9]*u[10]*u[14]*u[16];
u[97] = subW2*subW68*subWW7*u[7]*u[9]*u[10]*u[14]*(2.*subW18*u[9] + u[7]*(-subW10 + u[26]*u[40]));
u[98] = subW2*subW68*u[7]*u[9]*u[10]*(u[14]*(2.*subW144*u[9]*u[13]*u[32] + subW3*((-2.*subW330*u[9] + subW185*u[7]*u[31])*u[32] + 2.*(subW108*subW45 + u[13]*(subW208*u[8] + u[10]*u[31]*u[44]))))*u[87] + 2.*subW212*(subW360*u[10] - 2.*subW20*u[9]*u[14]*u[43]*u[87]) + u[7]*(-2.*subW109*u[40]*(subW285*u[14] + u[87]) + u[8]*(subW336*u[14]*u[27]*u[31] + (subW28 + 4.*u[14]*(subW17 + u[26]*u[27])*u[40]*u[43])*u[87])) + kTv*(-2.*(subW360*u[10]*u[13] + u[14]*(subW20*subW330*u[9] + subW212*(2.*u[9]*u[32]*u[43] + u[10]*(subW9 + u[31]*u[44])))*u[87]) + u[7]*(subW186*u[32] + u[14]*(subW336*u[31]*u[32] + (subW185*subW20*u[31] + 2.*u[40]*(subW212*u[8] + 2.*subW108*u[43] + u[31]*u[36]*u[44]))*u[87]))));
COMPLEX subA1 = u[23]*u[24];
COMPLEX subA3 = u[47] + u[58];
COMPLEX subA5 = -u[61]*u[67];
COMPLEX subA6 = u[61]*u[62];
COMPLEX subA9 = 4.*u[64]*u[72];
COMPLEX subA10 = -u[61]*u[65];
COMPLEX subA11 = u[49] -u[75];
COMPLEX subA12 = u[61]*u[76];
COMPLEX subA13 = u[52] + 2.*u[75];
COMPLEX subA16 = -4.*u[80]*u[83];
COMPLEX subA17 = -u[80]*u[81];
COMPLEX subA21 = -u[88]*u[89];
COMPLEX subA22 = 2.*u[64]*u[90];
COMPLEX subA23 = u[88]*u[91];
COMPLEX subA24 = u[80]*u[88]*u[95];
COMPLEX subA25 = -u[88]*u[96];
COMPLEX subA26 = -2.*u[80]*u[98];
COMPLEX subA27 = -u[88]*u[92];
COMPLEX subA28 = u[88]*u[95];
COMPLEX subA29 = subA1 + u[50] -u[51];
COMPLEX subA30 = subA6 - 2.*u[47] + u[68];
COMPLEX subA32 = subA13*u[48] + u[78];
COMPLEX subA33 = subA1 + subA17 + u[50] + u[84];
COMPLEX subA34 = subA17 + u[51] + u[84];


COMPLEX amp12345 = 0.03125*(subA29*u[22] + u[48]*(-4.*u[49] - 2.*u[52]) + u[54] + 2.*(subA3*u[23] + u[53] + u[55] + u[56]) + u[59]);

COMPLEX amp12435 = 0.03125*(2.*subA32 - 2.*(u[55] + u[56] + u[23]*u[58]) -u[23]*u[68] + u[70] + u[61]*(-u[23]*u[62] + u[67] -u[76]) + u[77]);

COMPLEX amp12534 = 0.03125*(subA22 + subA23 - 2.*u[55] + u[64]*(subA10 + subA21 + 2.*u[66]) -u[23]*(subA6 + 2.*u[58] + u[68]) + u[61]*(u[67] -u[69]) + u[70] -u[73] + u[88]*u[92] -u[93] + u[94]);

COMPLEX amp13245 = 0.03125*(subA34*u[22] -u[59] - 2.*(u[53] + u[78] + u[80]*u[82]) + 4.*(subA11*u[48] + u[80]*u[83]) + 2.*u[85] + u[86]);

COMPLEX amp13425 = 0.03125*(subA25 + subA27 + 2.*subA32 + u[80]*(subA28 - 4.*u[83]) -u[94] -u[97] - 2.*(u[56] + u[85] + u[80]*u[98]));

COMPLEX amp13524 = 0.03125*(subA16 + subA23 + subA24 + subA25 + subA26 -u[73] -u[61]*(u[64]*u[65] + u[69] -u[76]) -u[77] - 2.*u[85] + u[64]*(subA21 + 2.*u[66] + 2.*u[90]) -u[93] -u[97]);

COMPLEX amp14235 = 0.03125*(subA12 + 4.*subA11*u[48] -u[61]*u[69] + 2.*u[71] + u[64]*(subA10 + 2.*u[66] - 4.*u[72]) -u[73] -u[77] - 2.*(u[53] + u[78]));

COMPLEX amp14325 = 0.03125*(-2.*(u[48]*(2.*u[49] + u[52]) + u[71]) + u[64]*(subA21 + 4.*u[72]) + 2.*(u[53] + u[56] + u[64]*u[90]) + u[88]*(u[91] + u[92]) -u[93] + u[94]);

COMPLEX amp14523 = 0.03125*(subA22 + subA23 + subA24 + subA25 + subA26 + subA9 + subA34*u[22] -u[59] + subA21*u[64] - 2.*u[71] - 2.*u[80]*u[82] + u[86] -u[93] -u[97]);

COMPLEX amp12354 = 0.03125*(subA5 + subA9 -subA29*u[22] + subA30*u[23] -u[54] -u[59] + u[61]*u[64]*u[65] - 2.*u[64]*u[66] + u[61]*u[69] -u[70] - 2.*u[71] + u[73]);

COMPLEX amp12453 = 0.03125*(subA12 + subA16 + subA5 -subA33*u[22] + subA30*u[23] -u[54] -u[70] -u[77] + 2.*u[80]*u[82] - 2.*u[85] -u[86]);

COMPLEX amp12543 = 0.03125*(subA25 + subA26 + subA27 + subA33*u[22] + u[54] + 2.*(subA3*u[23] + u[55]) + u[80]*(subA28 - 2.*u[82]) + u[86] -u[94] -u[97]);

delete [] u;

// color factors are included below, without averaging

return 2.*27.*8./32.*(norm(amp12345) +norm(amp12435) +norm(amp12534) +norm(amp13245) +norm(amp13425) +norm(amp13524)
+norm(amp14235) +norm(amp14325) +norm(amp14523) +norm(amp12354) +norm(amp12453) +norm(amp12543) );


}
