//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->ggg for helicities RLRL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGGGG_RLRL() {
int Nsymb =98;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k1,k1);
u[2] = Dot(k1,k2);
u[3] = Dot(k2,n);
u[4] = Dot(k3,n);
u[5] = Dot(k4,k5);
u[6] = Dot(k4,n);
u[7] = S(L,k2,n);
u[8] = S(L,k3,k4);
u[9] = S(L,k3,n);
u[10] = S(L,k5,n);
u[11] = S(R,k4,n);
u[12] = S(R,n,k2,e1);
u[13] = Den(u[6]);
u[14] = Den(u[5]);
u[15] = Den(u[4]);
u[16] = Den(u[3]);
u[17] = Dot(k5,n);
u[18] = Dot(e1,k2);
u[19] = Dot(k3,k4);
u[20] = S(L,k3,k5);
u[21] = S(R,k3,n);
u[22] = Den(u[19]);
u[23] = Den(u[17]);
u[24] = S(R,k5,n);
u[25] = S(L,k4,k5);
u[26] = Den(u[3] -u[4]);
u[27] = Den(u[1] + 2.*u[2]);
u[29] = Den(u[3] -u[17]);
u[31] = S(L,k2,k3);
u[32] = S(L,k2,k4);
u[33] = S(R,k4,n,e1);
u[34] = Dot(k1,k5);
u[35] = S(R,k4,k5);
u[36] = S(R,n,k5,e1);
u[37] = S(L,k2,k5);
u[38] = Dot(e1,k5);
u[39] = S(R,k3,k4);
u[40] = S(R,n,k3,e1);
u[41] = Dot(e1,k4);
u[42] = Dot(k2,k4);
u[43] = Dot(k2,k5);
u[44] = Den(u[1] -2.*u[34]);
u[46] = Dot(k3,k5);
u[48] = Dot(k2,k3);
u[49] = Den(u[48]);
u[50] = Dot(e1,k3);
u[56] = S(R,k2,n);
u[58] = S(R,k2,k4);
u[65] = Den(u[46]);
u[66] = Dot(k1,k4);
u[67] = Den(u[1] -2.*u[66]);
u[74] = Den(u[42]);
u[75] = Den(u[3] -u[6]);
u[82] = Dot(k1,k3);
u[83] = Den(u[1] -2.*u[82]);
u[92] = Den(u[43]);
COMPLEX subW1 = pow2(u[10]);
COMPLEX subW2 = pow2(u[11]);
COMPLEX subW3 = pow2(kTv);
COMPLEX subW4 = -2.*kTv*u[18];
COMPLEX subW8 = u[13] -u[23];
COMPLEX subW9 = u[8]*u[11];
COMPLEX subW10 = u[20]*u[24];
COMPLEX subW12 = pow2(u[9]);
COMPLEX subW13 = u[13] -u[15];
COMPLEX subW14 = u[20]*u[21];
COMPLEX subW15 = u[11]*u[25];
COMPLEX subW17 = -2.*kTv*u[12];
COMPLEX subW18 = u[21]*u[31];
COMPLEX subW19 = u[11]*u[32];
COMPLEX subW20 = 2.*u[24]*u[37];
COMPLEX subW21 = 2.*kTv*u[38];
COMPLEX subW25 = kTv - 2.*u[18];
COMPLEX subW26 = u[38] + u[41];
COMPLEX subW30 = u[24]*u[37];
COMPLEX subW32 = u[25]*u[31];
COMPLEX subW33 = -u[20]*u[32];
COMPLEX subW35 = u[42] + u[48];
COMPLEX subW36 = pow2(u[21]);
COMPLEX subW40 = -kTv*u[40];
COMPLEX subW41 = pow3(u[11]);
COMPLEX subW42 = pow2(u[24]);
COMPLEX subW43 = pow3(kTv);
COMPLEX subW47 = -2.*u[38]*u[40];
COMPLEX subW50 = -u[21]*u[40];
COMPLEX subW51 = u[12]*u[56];
COMPLEX subW54 = -kTv*u[12];
COMPLEX subW55 = u[7]*u[11];
COMPLEX subW56 = u[12]*u[33];
COMPLEX subW65 = -u[15]*u[16]*u[23];
COMPLEX subW66 = u[16] + u[23];
COMPLEX subW67 = u[5] + u[46];
COMPLEX subW69 = u[24]*u[36];
COMPLEX subW70 = u[21]*u[40];
COMPLEX subW72 = u[25]*u[39]*u[40];
COMPLEX subW73 = -u[5] + u[46];
COMPLEX subW76 = u[38] + u[50];
COMPLEX subW77 = u[16] -u[23];
COMPLEX subW80 = u[20]*u[32];
COMPLEX subW81 = u[16]*u[23];
COMPLEX subW82 = u[32]*u[39]*u[40];
COMPLEX subW83 = -u[18] - 3.*u[38] + u[41] + u[50];
COMPLEX subW86 = -u[37]*u[56];
COMPLEX subW90 = u[9]*u[21];
COMPLEX subW91 = u[10]*u[24];
COMPLEX subW93 = u[8]*u[21];
COMPLEX subW94 = -u[24]*u[25];
COMPLEX subW96 = kTv + 2.*u[41];
COMPLEX subW97 = u[24]*u[25];
COMPLEX subW98 = u[18] -u[38] + u[41] -u[50];
COMPLEX subW99 = u[7]*u[56];
COMPLEX subW100 = pow2(u[7]);
COMPLEX subW102 = kTv -u[38] -u[50];
COMPLEX subW104 = pow2(u[16]);
COMPLEX subW106 = 2.*kTv*u[18];
COMPLEX subW114 = u[13] + u[16];
COMPLEX subW116 = -u[36]*u[50];
COMPLEX subW118 = u[36]*u[74];
COMPLEX subW120 = u[36]*u[46];
COMPLEX subW126 = 2.*u[31]*u[56];
COMPLEX subW127 = u[46]*u[74];
COMPLEX subW129 = u[43] + u[48];
COMPLEX subW141 = -u[18] + u[41];
COMPLEX subW145 = 2.*kTv*u[50];
COMPLEX subW149 = u[42] + u[43];
COMPLEX subW151 = u[12]*u[50];
COMPLEX subW152 = u[31]*u[56];
COMPLEX subW153 = u[38]*u[40];
COMPLEX subW155 = 2.*u[36]*u[50];
COMPLEX subW157 = u[40]*u[74];
COMPLEX subW158 = u[40]*u[46];
COMPLEX subW174 = u[18] -u[38] + u[41] + u[50];
COMPLEX subW175 = u[40]*u[41];
COMPLEX subW177 = subW10 + subW9;
COMPLEX subW178 = subW3 + subW4;
COMPLEX subW181 = subW14 + subW15;
COMPLEX subW182 = subW21 + subW3;
COMPLEX subW185 = kTv*subW26;
COMPLEX subW188 = subW19 + subW30;
COMPLEX subW189 = subW32 + subW33;
COMPLEX subW190 = subW18 + subW19;
COMPLEX subW191 = subW30*u[11] + subW2*u[32];
COMPLEX subW194 = subW10 + subW47;
COMPLEX subW195 = subW50 + subW51;
COMPLEX subW196 = subW72 + subW73*u[36];
COMPLEX subW197 = subW18 + subW30;
COMPLEX subW198 = subW69 + subW70;
COMPLEX subW199 = -subW18 -subW30 + kTv*u[12];
COMPLEX subW200 = subW55 + subW56;
COMPLEX subW203 = subW26 + u[50];
COMPLEX subW206 = subW14 + subW86;
COMPLEX subW207 = subW76 -u[18] - 3.*u[41];
COMPLEX subW208 = subW26 + u[18] -u[50];
COMPLEX subW209 = subW93 + subW94;
COMPLEX subW210 = subW90 + subW91;
COMPLEX subW211 = kTv + subW76;
COMPLEX subW212 = -kTv + subW76;
COMPLEX subW213 = kTv + 5.*subW76;
COMPLEX subW214 = subW10*subW96*u[65];
COMPLEX subW216 = subW3 -u[42];
COMPLEX subW217 = subW106 + subW3 - 6.*u[42];
COMPLEX subW220 = -subW3 + u[42];
COMPLEX subW221 = subW10 + subW40;
COMPLEX subW222 = subW116 + subW14;
COMPLEX subW223 = 2.*subW14*u[38];
COMPLEX subW229 = 1. + subW127;
COMPLEX subW230 = 4.*subW129 -u[46];
COMPLEX subW234 = subW14 + kTv*u[36];
COMPLEX subW236 = kTv + 2.*subW76;
COMPLEX subW239 = 2.*kTv*subW141 + subW3;
COMPLEX subW242 = subW145 + subW3;
COMPLEX subW245 = 2.*subW15*u[9];
COMPLEX subW246 = subW10 + subW153;
COMPLEX subW247 = subW14 + subW155;
COMPLEX subW248 = -2.*subW10*u[50];
COMPLEX subW254 = 4.*subW152*u[50]*u[74];
COMPLEX subW256 = -subW91 + subW99;
COMPLEX subW258 = subW10 + subW152;
COMPLEX subW259 = subW51 -subW69;
COMPLEX subW260 = subW26 -u[18] - 3.*u[50];
COMPLEX subW261 = subW175 + subW9;
COMPLEX subW262 = -2. + subW178*u[16];
COMPLEX subW263 = 2. + subW182*u[23];
COMPLEX subW264 = subW149 + subW185;
COMPLEX subW266 = subW18 + subW188;
COMPLEX subW268 = kTv*subW200;
COMPLEX subW271 = subW198 -subW51;
COMPLEX subW272 = subW214 + u[40];
COMPLEX subW273 = -4. + subW217*u[65];
COMPLEX subW274 = subW120 + subW223;
COMPLEX subW279 = 3. + subW230*u[74];
COMPLEX subW281 = -2.*subW198*u[20]*u[65];
COMPLEX subW282 = subW14*subW236*u[65];
COMPLEX subW284 = 1. + subW239*u[65];
COMPLEX subW285 = 2. + subW242*u[15];
COMPLEX subW286 = subW158 + subW248;
COMPLEX subW292 = subW266*u[33]*u[36];
COMPLEX subW293 = -subW266*u[33];
COMPLEX subW295 = u[36] + subW274*u[74];
COMPLEX subW298 = subW282 + u[36];
COMPLEX subW299 = subW254 + subW279*u[40];
COMPLEX subW300 = u[40] + subW286*u[74];
COMPLEX subW303 = subW268 + subW293 + 2.*subW203*subW55;
COMPLEX subW304 = subW118 + subW295*u[15];
COMPLEX subW305 = subW157 + subW300*u[23];
COMPLEX subWW1 = u[14]*u[23];
COMPLEX subWW2 = u[12]*u[35]*u[36];
COMPLEX subWW3 = u[16] + 3.*u[23];
COMPLEX subWW4 = u[21]*u[31];
COMPLEX subWW5 = u[24]*u[37];
COMPLEX subWW7 = subW273*subW81;
COMPLEX subWW8 = subWW4 + subWW5;
u[28] = subW1*subW177*subW2*subW262*subW8*u[7]*u[9]*u[12]*u[14]*u[15];
u[30] = -subW12*subW13*subW181*subW2*subW262*u[7]*u[10]*u[12]*u[22]*u[23];
u[45] = -subW12*subW13*subW2*(subW17 + subW190 + subW20)*subW263*u[7]*u[10]*u[16]*u[22]*u[36];
u[47] = subW2*u[7]*u[9]*u[10]*u[15]*u[16]*(subW10*u[10]*(2.*subW19*subW25*subWW1*u[13] + u[12]*(-3.*subWW1 + u[13]*(u[14] + (-1. + subW264*u[14])*u[23]))) + u[11]*(-u[8]*(-2.*subW15*subW25*subWW1*u[7]*u[13] + u[10]*(subW20*subW25*subWW1*u[13] + u[12]*(subWW1 + u[13]*(-u[23] + u[14]*(-3. + subW264*u[23]))))) + 2.*(subW10*subW25*subWW1*u[7]*u[13] + u[9]*(-subW188*subW25*subWW1*u[13] + u[12]*(subWW1 + u[13]*(-subW264*subWW1 + u[14] + u[23]))))*u[25]));
u[51] = subW2*subW81*u[7]*u[9]*u[10]*(2.*subW9*u[7]*(2.*u[15]*u[22]*u[36] + u[13]*(2.*u[22]*u[36] + u[15]*((-1. + subW35*u[22])*u[36] + 2.*subW181*u[22]*u[38]))) + u[13]*u[15]*u[22]*(-subW19*subW35*u[9]*u[36] + ((subW14 -subW15)*subW30*u[9] + u[11]*((2.*subW18 - 2.*subW30)*u[8]*u[10] + 3.*subW18*u[9]*u[25]) + (-3.*subW14*u[9]*u[11] + subW2*(2.*u[8]*u[10] -u[9]*u[25]))*u[32])*u[38] + kTv*(u[9]*(2.*subW189*u[11]*u[21] + u[12]*(-subW14 + u[11]*u[25])*u[38]) + 2.*subW9*(subW181*u[7] + u[10]*(subW190 + u[12]*u[38])))) + u[9]*(subW18*u[15]*u[36]*(4.*u[22] + u[13]*(-1. + u[22]*u[42])) + u[13]*(subW19*(u[15] - 4.*u[22])*u[36] + u[15]*u[22]*u[31]*(subW36*u[20]*u[38] + u[21]*u[36]*u[48]))));
u[52] = subW1*subW188*subW2*subW8*u[7]*u[9]*u[14]*u[15]*u[16]*u[40];
u[53] = -subW1*subW2*subW8*u[7]*u[9]*u[14]*u[15]*u[16]*(subW177*u[12] -subW188*u[40]);
u[54] = -subW12*subW13*subW190*subW2*subW81*u[7]*u[10]*u[22]*u[36];
u[55] = -subW12*subW13*subW181*subW2*subW81*u[7]*u[10]*u[12]*u[22];
u[57] = subW55*subW65*u[9]*u[10]*(u[9]*u[36]*(-subW191*u[13] + subW18*u[11]*u[49]) + (subW177 + subW40)*subW55*(u[36]*u[49] + u[13]*(subW15*(kTv + 2.*u[38])*u[49] + u[36]*(1. + (u[5] -kTv*u[41])*u[49]))) + u[13]*((2.*(subW18*subW2*(u[8]*u[10] + u[9]*u[25]) + (subW10*subW2 + subW41*u[8])*u[10]*u[32])*u[38] + u[36]*(subW18*u[11]*(u[5]*u[9] -u[8]*u[10]*u[35]) -u[10]*u[35]*(subW191*u[8] + u[20]*(subW190*u[24] + subW42*u[37])) + subW43*subW56*u[40]) -subW3*(subW177*u[12]*u[33]*u[36] + (subW292 + u[10]*(subWW2 + subW2*u[32]))*u[40]))*u[49] + kTv*((subW10*subW292 + subW9*(subW292 + u[10]*(subWW2 + subW18*u[11] + subW2*u[32])) + u[10]*(subW194*subW2*u[32] + u[35]*u[36]*(subW10*u[12] + subW266*u[40])))*u[49] + u[9]*u[11]*(u[12]*u[36] + subW18*(subW15 -u[36]*u[41])*u[49]))));
u[59] = subW2*subW81*u[7]*u[9]*(2.*subW9*u[7] + (subW18 -subW19)*u[9])*u[10]*u[13]*u[15]*u[22]*u[36];
u[60] = subW1*subW195*subW2*subW81*u[7]*u[9]*u[13]*u[15]*u[31]*u[49];
u[61] = subW2*subW81*u[7]*u[9]*u[10]*(2.*subW15*u[7] + (subW19 -subW30)*u[10])*u[13]*u[14]*u[15]*u[40];
u[62] = subW2*subW81*u[7]*u[9]*u[10]*((-subW14 + subW15)*u[9] + 2.*subW9*u[10])*u[12]*u[13]*u[15]*u[22];
u[63] = subW55*u[9]*u[10]*u[16]*(u[9]*(-u[11]*(u[12]*(-3.*subW14*subW3*subW81*u[15]*u[22] + u[13]*(subW14*(8. + subW3*u[16])*u[22]*u[23] + u[15]*(4.*kTv*subW196*u[22]*u[23] + subW14*(-6.*u[23] + u[22]*(8. + subW3*subWW3 + (-6.*subW67 + 8.*kTv*subW76)*u[23]))))) -u[22]*(kTv*subW14*subW197*(-3.*subW81*u[15] + u[13]*(subW81 + subW77*u[15])) + 4.*u[13]*u[15]*u[23]*(subW196*subW197 + u[20]*(u[21]*(subW82 - 2.*subW18*u[41]) + u[24]*(u[32]*u[36]*u[39] - 2.*u[21]*u[37]*u[41]))))) + u[22]*(kTv*subW41*(subW65 + u[13]*(3.*subW81 + u[15]*(-u[16] + u[23])))*u[25]*u[32] - 4.*u[13]*u[15]*u[23]*(subW198*subW199*u[20]*u[39] - 2.*subW41*u[25]*u[32]*u[50])) + subW2*(u[22]*(subW3*u[12]*(subW81*u[15] + u[13]*(-3.*subW81 + subW77*u[15]))*u[25] -kTv*(subW81*u[15]*((subW32 + 3.*subW80)*u[21] + subW30*u[25]) + u[13]*(-subW81*((3.*subW32 + subW80)*u[21] + 3.*subW30*u[25]) + u[15]*(subW189*subWW3*u[21] + (subW30*(u[16] -u[23]) + 8.*subW151*u[23])*u[25])))) + 2.*u[13]*u[23]*(u[12]*(-4.*u[22] + u[15]*(1. + subW67*u[22]))*u[25] + 2.*u[15]*u[22]*(-2.*(subW26*subW32 + subW33*subW76)*u[21] + subW196*u[32] + subW20*u[25]*u[50])))) + u[11]*(-4.*(subW266 + subW54)*u[10]*u[13]*u[15]*u[23]*u[40] - 2.*u[8]*(2.*subW181*subW303*u[13]*u[15]*u[22]*u[23] + u[10]*(u[22]*(kTv*subW2*(subW65 + u[13]*(-subW81 + subW66*u[15]))*u[32] + 2.*u[13]*u[15]*u[23]*(subW199*u[35]*u[36] + 2.*subW2*u[32]*u[38])) -u[11]*(u[12]*(subW3*subW65*u[22] + u[13]*(-subW3*subW81*u[22] + u[15]*(-2.*u[23] + u[22]*(4. + subW3*subW66 + u[23]*(-2.*subW67 + 4.*kTv*u[38]))))) + u[22]*(kTv*(subW197*subW81*u[15] + u[13]*(subW197*subW81 -u[15]*(subW197*u[16] + (subW18 -subW30)*u[23]))) + 2.*u[13]*u[15]*u[23]*(u[32]*u[35]*u[36] - 2.*subW18*u[38] + subW20*(u[41] + u[50]))))))));
u[64] = subW55*subW81*u[9]*u[10]*u[13]*u[15]*(u[14]*(-subW9*(2.*subW15*subW18*u[33]*u[49] + u[10]*(2.*subW18*u[35]*u[36]*u[49] + u[11]*(u[12] + subW18*subW83*u[49]))) + u[10]*(-2.*subW206*subW271*u[31]*u[35]*u[49] + subW2*u[32]*(u[40] + subW152*subW83*u[49]) + u[11]*(u[12]*(subW10 + subW126*(-u[19] + u[42] -u[43] + u[46])*u[49]) -u[24]*(u[37]*(u[40] + subW152*subW207*u[49]) + subW14*u[31]*u[49]*(u[18] -u[38] + 3.*u[41] -u[50])) + 2.*u[31]*u[49]*(subW70*(u[19] -u[42] + u[43] -u[46]) + u[32]*u[35]*u[36]*u[56])))) - 2.*u[11]*(u[9]*(-u[31]*(u[21]*(-subW72*u[14] + u[36]) + subW51*u[14]*u[25]*u[39])*u[49] + subW15*u[14]*(u[12] -subW18*subW208*u[49])) + subW32*u[14]*u[33]*u[49]*(subW10*u[21] -subW188*u[56]) + u[7]*(subW15*u[14]*(-u[40] + subW152*subW208*u[49]) + u[31]*u[49]*(u[36]*u[56] + subW195*u[14]*u[25]*u[58]))));
u[68] = subW2*subW81*subW96*u[7]*u[9]*u[10]*(2.*u[7]*(-kTv*subW198 + subW209*u[11]) + subW210*(-subW19 + subW197 + kTv*u[12]))*u[13]*u[15]*u[20]*u[65];
u[69] = subW206*subW55*subW65*u[9]*u[10]*u[13]*u[31]*u[49]*(u[10]*(subW98*u[11]*u[24] + subW271*u[35]) + u[9]*(subW98*u[11]*u[21] -subW271*u[39]) + u[11]*((-subW93 + subW97)*u[33] + (u[32]*u[33] + u[7]*(subW76 -u[18] -u[41]))*u[56]) + subW271*u[7]*u[58]);
u[70] = subW2*subW81*u[7]*u[9]*u[10]*u[13]*u[15]*u[31]*((-subW51 + subW70)*u[10] + (-subW90 + subW99)*u[36])*u[49];
u[71] = subW100*subW198*subW2*subW81*u[9]*u[10]*u[13]*u[15]*u[20]*u[65];
u[72] = subW2*subW81*u[7]*u[9]*u[10]*(subW198*u[7] -subW210*u[12])*u[13]*u[15]*u[20]*u[65];
u[73] = -subW55*u[9]*u[10]*(2.*subW209*subW303*subW81*u[11]*u[13]*u[15]*u[20]*u[65] + u[10]*(u[16]*(subW199*subW281*u[13]*u[15]*u[23]*u[35] + subW2*u[32]*(subW10*subW211*subW81*u[15]*u[65] + u[13]*(subW10*subW212*subW81*u[65] + u[15]*(subW10*subW212*u[16]*u[65] + u[23]*(2.*u[40] -subW10*subW213*u[65]))))) + u[11]*(2.*u[13]*u[16]*(-kTv*subW10*subW197*subW81*u[65] + u[15]*(subW272*subWW8*u[23] + (-kTv*subW10*subWW8*u[16] + subW80*u[23]*u[35]*(u[24]*u[36] + u[21]*u[40]))*u[65])) + u[12]*(-2.*subW10*subW104*u[15]*u[23]*u[42]*u[65] + u[13]*(2.*subW10*subW104*subW216*u[23]*u[65] + u[15]*(-2.*kTv*subW81*u[40] -subW10*(subWW7 + 2.*(-subW104*subW216 + u[23])*u[65])))))) -u[9]*(u[16]*(subW199*subW281*u[13]*u[15]*u[23]*u[39] + subW2*u[32]*(subW14*subW211*subW65*u[65] + u[13]*(subW102*subW14*subW81*u[65] + u[15]*(subW102*subW14*u[16]*u[65] + u[23]*(2.*u[36] + subW14*subW213*u[65]))))) + u[11]*(u[12]*(2.*subW104*subW14*u[15]*u[23]*u[42]*u[65] + u[13]*(2.*subW104*subW14*subW220*u[23]*u[65] + u[15]*(-2.*kTv*subW81*u[36] + subW14*(subWW7 + 2.*(subW104*subW220 + u[23])*u[65])))) + 2.*u[13]*u[16]*(kTv*subW14*subW197*subW81*u[65] + u[15]*(subW36*u[20]*u[31]*(kTv*subW77 - 2.*u[23]*u[41])*u[65] + subW69*u[23]*(u[37] + subW80*u[39]*u[65]) + u[21]*(kTv*subW10*u[16]*u[37]*u[65] + u[23]*(u[31]*u[36] + u[20]*(subW82 + subW30*(-kTv - 2.*u[41]))*u[65])))))));
u[76] = subW100*subW114*subW118*subW2*subW221*subW263*u[9]*u[10]*u[15];
u[77] = subW2*subW81*u[7]*u[9]*u[10]*u[13]*(u[15]*(-2.*subW43*u[10]*u[12]*u[40] + subW3*(2.*(subW222*u[9]*u[12] + u[10]*(subW194*u[12] + subW197*u[40])) + u[7]*u[40]*(u[36]*(4.*u[18] -u[50]) - 2.*u[37]*u[56])))*u[74] - 2.*subW197*(subW304*u[9] + 2.*subW10*u[10]*u[15]*u[38]*u[74]) + u[7]*(subW118*(subW10 + subW126) + u[15]*(subW126*subW229*u[36] + u[20]*(subW279*u[24]*u[36] + 4.*(subW18 + subWW5)*u[38]*u[56]*u[74]))) + kTv*(-2.*u[10]*u[15]*(subW197*subW47 + subW10*(subW197 - 2.*u[12]*u[38]))*u[74] + 2.*u[9]*(subW304*u[12] -subW197*subW222*u[15]*u[74]) -u[7]*(subW118*u[40] + u[15]*(-2.*(subW197*u[20] + subW47*u[37])*u[56]*u[74] + u[36]*(subW279*u[40] + (4.*subW10*u[18] + (-subW10 + subW126)*u[50])*u[74])))));
u[78] = subW100*subW198*subW2*u[9]*u[10]*u[13]*u[20]*(subW81 + u[15]*(u[16] - 2.*u[23]))*u[74];
u[79] = subW100*subW114*subW157*subW2*subW234*u[9]*u[10]*u[15]*u[23];
u[80] = subW157*subW2*subW81*u[7]*u[9]*u[10]*u[13]*u[15]*(2.*subW19*u[10] + u[7]*(subW15 + u[37]*u[56]));
u[81] = subW55*u[9]*u[10]*u[15]*u[23]*(-(2.*kTv*subW198*(-subW19 + subW199)*u[13]*u[16]*u[20]*u[33]*u[65] + subW55*((subW281 + 2.*subW298*subW9*u[13])*u[16] + u[13]*(subW281 + u[16]*(2.*subW15*u[40] + u[20]*(subW284*subW70 + u[24]*(subW284*u[36] - 2.*subW15*subW236*u[65]))))))*u[74] + 2.*u[13]*u[16]*(u[10]*((subW198*subW199*u[20]*u[35]*u[65] + subW2*u[32]*(-u[40] + subW10*subW236*u[65]))*u[74] -u[11]*u[20]*u[65]*(u[12]*u[24] + subW198*u[32]*u[35]*u[74])) + u[9]*((subW2*subW298*u[32] -subW198*subW199*u[20]*u[39]*u[65])*u[74] + u[11]*u[20]*u[65]*(-u[12]*u[21] + subW198*u[32]*u[39]*u[74]))));
u[84] = subW1*(subW17 + 2.*subW18 + subW188)*subW2*subW285*subW8*u[7]*u[9]*u[14]*u[16]*u[40];
u[85] = subW100*subW114*subW157*subW2*subW234*subW285*u[9]*u[10]*u[23];
u[86] = subW2*u[7]*u[9]*u[10]*u[15]*u[16]*(subWW1*u[13]*(kTv*(subW15*(2.*subW177*u[7] - 2.*(subW151 + subW188)*u[9]) + u[10]*(subW10*subW151 + u[11]*(-(subW151 + subW20)*u[8] + 2.*subW10*u[32]))) + (subW18*(subW245 -subW10*u[10]) + (u[10]*(subW2*u[8] + 3.*subW10*u[11]) - 2.*subW2*u[9]*u[25])*u[32] -(subW42*u[10]*u[20] + (2.*subW15*u[9] + 3.*subW9*u[10])*u[24])*u[37])*u[50]) + u[10]*(subW19*u[13]*(u[23] -u[14]*(4. + subW149*u[23]))*u[40] + u[23]*(subW30*(4.*u[14] + u[13]*(-1. + subW149*u[14]))*u[40] + subW18*subW9*u[13]*u[14]*u[50])) + 2.*subW15*u[7]*(-2.*subWW1*u[40] + u[13]*(u[23]*u[40] -u[14]*((2. + subW149*u[23])*u[40] - 2.*subW177*u[23]*u[50]))));
u[87] = subW1*subW177*subW2*subW8*u[7]*u[9]*u[12]*u[14]*u[15]*u[16];
u[88] = subW100*subW114*subW118*subW2*subW221*u[9]*u[10]*u[15]*u[23];
u[89] = subW118*subW2*subW81*u[7]*u[9]*((subW152 -subW9)*u[7] + 2.*subW19*u[9])*u[10]*u[13]*u[15];
u[90] = subW2*u[7]*u[9]*u[10]*u[13]*u[15]*u[16]*(u[23]*(2.*subW43*u[9]*u[12]*u[36] + subW3*(2.*((subW247*u[9] + subW246*u[10])*u[12] -subW197*u[9]*u[36]) + u[7]*u[36]*(subW126 + (-4.*u[18] + u[38])*u[40])))*u[74] + 2.*subW197*(subW305*u[10] - 2.*subW14*u[9]*u[23]*u[50]*u[74]) + u[7]*(-2.*u[37]*u[40]*u[56]*(subW229*u[23] + u[74]) + u[20]*(u[21]*(subW157 + subW299*u[23]) + 4.*subW30*u[23]*u[50]*u[56]*u[74])) + kTv*(-2.*(subW305*u[10]*u[12] + (subW14*(-2.*subW151 + subW197)*u[9] + subW197*(subW155*u[9] + subW246*u[10]))*u[23]*u[74]) + u[7]*(subW118*u[40] + u[23]*(subW299*u[36] + (u[20]*((subW126 + subW153)*u[21] + subW20*u[56]) + u[40]*(-4.*subW14*u[18] + 2.*u[37]*u[38]*u[56]))*u[74]))));
u[91] = subW2*subW81*u[7]*u[9]*u[10]*(subW245 + (-subW10 + subW9)*u[10])*u[12]*u[13]*u[14]*u[15];
u[93] = subW2*subW65*subW96*u[7]*u[9]*u[10]*u[13]*u[37]*(subW256*subW9 + kTv*(subW91 -subW99)*u[40] -u[9]*(u[24]*(subW15 + kTv*u[36]) + (subW19 + subW54)*u[56]))*u[92];
u[94] = -subW12*subW13*subW2*subW81*u[7]*u[10]*u[22]*(subW181*u[12] + subW190*u[36]);
u[95] = subW55*subW81*u[9]*u[10]*u[13]*u[15]*(u[11]*(2.*subW256*u[37]*u[40]*u[92] - 2.*u[8]*u[22]*(-u[33]*u[37]*(subW258*u[21] + u[11]*(subW97 + u[32]*u[56]))*u[92] + u[10]*(subW259*u[35]*u[37]*u[92] + u[11]*(u[12] -subW174*subW30*u[92])) + u[7]*(subW259*u[37]*u[58]*u[92] + u[11]*(-u[36] + subW174*u[37]*u[56]*u[92])))) + u[9]*u[22]*(2.*subW258*subW271*u[37]*u[39]*u[92] -subW2*(u[25]*(u[12] + subW260*subW30*u[92]) + u[32]*(u[36] + subW260*u[37]*u[56]*u[92])) + u[11]*(2.*u[37]*(u[24]*(subW72 + u[36]*(subW73 + u[42] -u[48])) + subW82*u[56])*u[92] + u[12]*(subW14 + 2.*u[37]*(u[5] -u[42] -u[46] + u[48])*u[56]*u[92]) + u[21]*(subW10*subW207*u[37]*u[92] + u[31]*(u[36] + subW207*u[37]*u[56]*u[92])))));
u[96] = subW2*subW81*u[7]*u[9]*u[10]*u[13]*u[15]*u[37]*((-subW51 + subW69)*u[9] + subW256*u[40])*u[92];
u[97] = subW55*subW81*u[9]*u[10]*u[15]*(((-subW30*u[10]*u[11]*(1. + u[13]*u[19]) + u[9]*u[13]*((subW32 + subW80)*u[11]*u[21] + subW191*u[25] + u[20]*(subW30*u[21] + subW36*u[31]))*u[39])*u[40] + u[13]*(-subW3*(u[33]*(subW181*u[12] -subW266*u[36])*u[40] + u[36]*(subW261*subW55 + u[9]*(-subW2*u[32] + u[12]*u[39]*u[40]))) + 2.*(subW2*subW30*u[8]*u[10] + u[9]*(subW2*subW30*u[25] + (subW14*subW2 + subW41*u[25])*u[32]))*u[50]))*u[92] + u[13]*u[40]*(u[10]*(subW18*u[11] + subW2*u[32]) -subW43*subW56*u[36]*u[92]) + subW181*subW55*(u[40]*u[92] + u[13]*(-2.*subW9*u[50]*u[92] + u[40]*(1. + u[19]*u[92]))) + kTv*(u[13]*((subW181*subW266*u[33]*u[40] + u[9]*(subW41*u[25]*u[32] + subW2*(subW30*u[25] + subW247*u[32]) + (-subW14*u[12] + subW197*u[36] + u[11]*(-u[12]*u[25] + u[32]*u[36]))*u[39]*u[40]))*u[92] + u[10]*u[11]*(-u[12]*u[40] + subW261*subW30*u[92])) -subW55*(-u[36]*u[40]*u[92] + u[13]*(subW181*subW261*u[92] -u[36]*(u[40] + (u[19]*u[40] - 2.*subW9*u[50])*u[92])))));
u[98] = subW12*subW2*subW259*subW81*u[7]*u[10]*u[13]*u[15]*u[37]*u[92];
COMPLEX subA1 = u[27]*u[28];
COMPLEX subA3 = u[29]*u[30];
COMPLEX subA6 = u[47] -u[73];
COMPLEX subA8 = u[75]*u[76];
COMPLEX subA11 = u[44]*u[45];
COMPLEX subA15 = -u[75]*u[78];
COMPLEX subA16 = u[75]*u[83]*u[85];
COMPLEX subA17 = -u[83]*u[84];
COMPLEX subA19 = -u[75]*u[88];
COMPLEX subA20 = -2.*u[83]*u[90];
COMPLEX subA21 = -2.*u[83]*u[86];
COMPLEX subA24 = u[83]*u[90];
COMPLEX subA25 = -4.*u[69] + 4.*u[93];
COMPLEX subA28 = u[70] + u[96];
COMPLEX subA29 = -4.*u[83]*u[97];
COMPLEX subA30 = subA1 + u[52] -u[53];
COMPLEX subA31 = subA3 + 2.*u[47] + u[63];
COMPLEX subA33 = -2.*subA6*u[27];
COMPLEX subA34 = subA8 + 4.*u[57] - 2.*u[77];
COMPLEX subA36 = subA3 + u[63] + 2.*u[73];
COMPLEX subA38 = subA1 + subA17 + u[52] + u[87];
COMPLEX subA39 = subA17 + u[53] + u[87];
COMPLEX subA41 = subA11 + u[55] -u[94];
COMPLEX subA42 = -subA36*u[27];


COMPLEX amp12345 = 0.03125*(subA30*u[26] + subA31*u[27] + u[29]*(-u[54] + u[55]) + u[44]*(u[29]*u[45] - 2.*u[51] - 4.*u[57]) -u[59] - 2.*u[60] + u[61] -u[62] + u[64]);

COMPLEX amp12435 = 0.03125*(subA42 + u[44]*(-subA8 + 2.*u[51]) -u[29]*(subA11 -u[54] + u[55]) + u[59] + u[62] - 2.*u[71] + 2.*u[44]*u[77] + u[75]*u[78] + u[75]*u[79] -u[80] + u[81]);

COMPLEX amp12534 = 0.03125*(subA42 + u[59] - 2.*(u[71] + u[72]) + u[67]*(2.*u[68] + 4.*u[93]) + u[29]*(u[54] -u[94]) + u[95] + 2.*u[96]);

COMPLEX amp13245 = 0.03125*(-subA16 + subA21 + subA39*u[26] + subA34*u[44] + 2.*(subA24 + u[60]) -u[64] -u[75]*u[79] + u[80] + u[75]*u[88] + u[89] + u[91]);

COMPLEX amp13425 = 0.03125*(subA19 + subA20 + subA29 -subA41*u[29] + u[62] + u[44]*(-subA8 + 2.*u[51] + 2.*u[77]) -u[80] + u[75]*(u[79] + u[83]*u[85]) -u[89] -u[95] - 2.*u[98]);

COMPLEX amp13524 = 0.03125*(subA15 + subA16 + subA19 + subA29 - 2.*(subA24 + u[72]) -u[81] -u[89] + 2.*u[67]*(u[68] + 2.*u[93]) + 2.*u[96] - 2.*u[98]);

COMPLEX amp14235 = 0.03125*(subA34*u[44] + 2.*(u[60] + u[67]*u[68]) + 4.*u[67]*u[69] - 2.*(u[70] + u[72]) -u[75]*(u[78] + u[79]) + u[80] -u[81]);

COMPLEX amp14325 = 0.03125*(2.*subA28 + subA41*u[29] - 2.*(u[44]*(u[51] + 2.*u[57]) + u[60]) -u[62] + subA25*u[67] + u[95]);

COMPLEX amp14523 = 0.03125*(2.*subA28 + subA39*u[26] -u[64] + subA25*u[67] + u[91] + u[83]*(-2.*u[86] - 4.*u[97]) - 2.*u[98]);

COMPLEX amp12354 = 0.03125*(subA33 -subA30*u[26] -u[61] -u[64] - 2.*u[67]*u[68] - 4.*u[67]*u[69] + 2.*u[70] + 2.*u[71] + 2.*u[72]);

COMPLEX amp12453 = 0.03125*(subA15 + subA16 + subA19 + subA20 + subA33 -subA38*u[26] -u[61] + 2.*u[71] -u[81] + 2.*u[83]*u[86] -u[89] -u[91]);

COMPLEX amp12543 = 0.03125*(subA21 + subA29 + subA38*u[26] + subA31*u[27] -u[29]*u[54] -u[59] + u[61] + u[91] + u[29]*u[94] -u[95] - 2.*u[98]);

delete [] u;

// color factors are included below, without averaging

return 2.*27.*8./32.*(norm(amp12345) +norm(amp12435) +norm(amp12534) +norm(amp13245) +norm(amp13425) +norm(amp13524)
+norm(amp14235) +norm(amp14325) +norm(amp14523) +norm(amp12354) +norm(amp12453) +norm(amp12543) );


}
