//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->ggg for helicities RRLL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGGGG_RRLL() {
int Nsymb =98;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k1,k1);
u[2] = Dot(k1,k2);
u[3] = Dot(k2,n);
u[4] = Dot(k5,n);
u[5] = Dot(k3,k4);
u[6] = Dot(k3,n);
u[7] = S(L,k2,n);
u[8] = S(L,k3,k5);
u[9] = S(L,k4,n);
u[10] = S(L,k5,n);
u[11] = S(R,k3,n);
u[12] = S(R,n,k2,e1);
u[13] = Den(u[6]);
u[14] = Den(u[5]);
u[15] = Den(u[4]);
u[16] = Den(u[3]);
u[17] = Dot(e1,k2);
u[18] = Dot(k4,n);
u[19] = Den(u[18]);
u[20] = S(L,k4,k5);
u[21] = S(R,k4,n);
u[22] = Den(u[3] -u[4]);
u[23] = Den(u[1] + 2.*u[2]);
u[25] = S(L,k2,k3);
u[26] = S(L,k3,k4);
u[27] = S(R,k3,n,e1);
u[28] = S(R,k3,k5);
u[29] = S(R,n,k5,e1);
u[30] = Dot(k1,k5);
u[31] = Dot(k2,k3);
u[32] = Dot(k4,k5);
u[33] = S(R,k5,n);
u[34] = Den(u[31]);
u[35] = Den(u[32]);
u[36] = Dot(e1,k5);
u[37] = S(R,k3,k4);
u[38] = S(R,n,k4,e1);
u[39] = Dot(e1,k4);
u[40] = Den(u[3] -u[6]);
u[41] = Den(u[1] -2.*u[30]);
u[43] = Dot(k3,k5);
u[44] = S(L,k2,k4);
u[45] = S(L,k2,k5);
u[46] = Dot(e1,k3);
u[48] = Dot(k2,k4);
u[50] = S(R,k2,n);
u[56] = Dot(k2,k5);
u[64] = Den(u[43]);
u[65] = Den(u[4] + u[6]);
u[67] = Dot(k1,k4);
u[68] = Den(u[1] -2.*u[67]);
u[80] = Den(u[48]);
u[84] = S(R,k2,k3);
u[86] = Dot(k1,k3);
u[87] = Den(u[1] -2.*u[86]);
u[92] = Den(u[56]);
COMPLEX subW1 = pow2(u[9]);
COMPLEX subW2 = pow2(u[11]);
COMPLEX subW3 = pow2(kTv);
COMPLEX subW4 = -2.*kTv*u[17];
COMPLEX subW8 = u[13] -u[19];
COMPLEX subW9 = u[8]*u[11];
COMPLEX subW10 = u[20]*u[21];
COMPLEX subW12 = pow2(u[7]);
COMPLEX subW13 = u[13] + u[16];
COMPLEX subW14 = 2.*kTv*u[36];
COMPLEX subW18 = u[20]*u[33];
COMPLEX subW19 = -kTv*u[38];
COMPLEX subW21 = -2.*kTv*u[12];
COMPLEX subW22 = u[11]*u[25];
COMPLEX subW23 = u[21]*u[44];
COMPLEX subW24 = 2.*u[33]*u[45];
COMPLEX subW25 = u[12]*u[36];
COMPLEX subW27 = -u[33]*u[45];
COMPLEX subW28 = u[31] + u[48];
COMPLEX subW30 = u[33]*u[45];
COMPLEX subW34 = -u[15]*u[16]*u[19];
COMPLEX subW35 = u[16] -u[19];
COMPLEX subW36 = -u[16]*u[19];
COMPLEX subW37 = -3.*u[15]*u[16]*u[19];
COMPLEX subW39 = u[16]*u[19];
COMPLEX subW43 = u[29]*u[33];
COMPLEX subW44 = u[21]*u[38];
COMPLEX subW46 = u[7]*u[11];
COMPLEX subW47 = u[12]*u[27];
COMPLEX subW49 = u[14]*u[26]*u[28]*u[29];
COMPLEX subW55 = u[36] + u[46];
COMPLEX subW56 = u[36] + u[39];
COMPLEX subW57 = u[32] -u[43];
COMPLEX subW58 = u[32] + u[43];
COMPLEX subW61 = u[25]*u[27];
COMPLEX subW67 = u[25]*u[38];
COMPLEX subW68 = u[39] + u[46];
COMPLEX subW71 = u[21]*u[26];
COMPLEX subW72 = u[8]*u[33];
COMPLEX subW81 = -kTv*u[12];
COMPLEX subW84 = kTv + 2.*u[46];
COMPLEX subW85 = u[16]*u[31];
COMPLEX subW91 = u[16] + u[19];
COMPLEX subW94 = u[45]*u[50];
COMPLEX subW95 = pow3(kTv);
COMPLEX subW96 = u[29]*u[34];
COMPLEX subW97 = u[29]*u[32];
COMPLEX subW104 = -u[29]*u[39];
COMPLEX subW106 = -2.*u[36]*u[38];
COMPLEX subW109 = 2.*u[44]*u[50];
COMPLEX subW110 = u[32]*u[34];
COMPLEX subW112 = u[5] + u[56];
COMPLEX subW122 = pow2(u[10]);
COMPLEX subW123 = u[13] -u[15];
COMPLEX subW124 = u[11]*u[26];
COMPLEX subW127 = 2.*kTv*u[39];
COMPLEX subW131 = u[12]*u[39];
COMPLEX subW132 = kTv + 2.*u[39];
COMPLEX subW133 = u[31] + u[56];
COMPLEX subW139 = pow3(u[11]);
COMPLEX subW142 = u[26]*u[28]*u[29];
COMPLEX subW144 = u[5] + u[32];
COMPLEX subW147 = u[5] -u[32];
COMPLEX subW151 = u[44]*u[50];
COMPLEX subW152 = u[34]*u[38];
COMPLEX subW153 = u[32]*u[38];
COMPLEX subW160 = u[36]*u[38];
COMPLEX subW162 = 2.*u[29]*u[39];
COMPLEX subW165 = u[48] + u[56];
COMPLEX subW171 = u[7]*u[8];
COMPLEX subW172 = u[10]*u[25];
COMPLEX subW174 = pow2(u[33]);
COMPLEX subW177 = u[12]*u[26];
COMPLEX subW178 = u[38]*u[45];
COMPLEX subW180 = u[12]*u[50];
COMPLEX subW187 = u[17] -u[36] -u[39] + 3.*u[46];
COMPLEX subW188 = u[9]*u[21];
COMPLEX subW189 = -u[7]*u[50];
COMPLEX subW191 = u[25]*u[50];
COMPLEX subW193 = u[10]*u[33];
COMPLEX subW195 = u[7]*u[50];
COMPLEX subW196 = u[12]*u[37]*u[38];
COMPLEX subW201 = -u[31] -u[32] + u[43] + u[48];
COMPLEX subW204 = u[17] -u[36] -u[39] + u[46];
COMPLEX subW205 = subW10 + subW9;
COMPLEX subW206 = subW3 + subW4;
COMPLEX subW209 = subW18 + subW19;
COMPLEX subW210 = subW14 + subW3;
COMPLEX subW213 = -3.*subW23 + subW30;
COMPLEX subW214 = subW23 + subW30;
COMPLEX subW215 = subW39 + subW35*u[15];
COMPLEX subW218 = subW46 + subW47;
COMPLEX subW221 = subW49 + u[38];
COMPLEX subW222 = subW43 + subW44;
COMPLEX subW224 = subW55 + u[39];
COMPLEX subW230 = subW10 + kTv*u[29];
COMPLEX subW231 = subW22 + subW23;
COMPLEX subW232 = subW71 + subW72;
COMPLEX subW241 = 1. + subW85;
COMPLEX subW242 = -subW3 + u[31];
COMPLEX subW243 = subW3 - 2.*u[31] + kTv*u[46];
COMPLEX subW247 = 2.*subW10*u[36];
COMPLEX subW253 = subW10 + subW104;
COMPLEX subW254 = subW106 + subW18;
COMPLEX subW255 = 1. + subW110;
COMPLEX subW256 = 4.*subW112 + 3.*u[32];
COMPLEX subW260 = kTv + 2.*subW56;
COMPLEX subW265 = subW124 -subW18;
COMPLEX subW266 = subW127 + subW3;
COMPLEX subW269 = -1. + subW133*u[64];
COMPLEX subW271 = -subW23 + 3.*subW30;
COMPLEX subW273 = subW3*subW34*u[64];
COMPLEX subW274 = 1. + subW144*u[64];
COMPLEX subW275 = subW142 + subW147*u[38];
COMPLEX subW276 = 8. + subW3*u[16];
COMPLEX subW277 = subW160 + subW18;
COMPLEX subW278 = subW10 + subW162;
COMPLEX subW279 = -2.*subW18*u[39];
COMPLEX subW285 = 4.*subW165 -u[32];
COMPLEX subW289 = 4.*subW151*u[34]*u[39];
COMPLEX subW291 = subW171 + subW172;
COMPLEX subW293 = subW180 -subW44;
COMPLEX subW295 = subW10 -subW94;
COMPLEX subW296 = subW68 -u[17] - 3.*u[36];
COMPLEX subW297 = subW188 + subW189;
COMPLEX subW298 = subW55 + u[17] -u[39];
COMPLEX subW299 = subW188 + subW193;
COMPLEX subW300 = subW180 -subW43;
COMPLEX subW301 = subW151 + subW18;
COMPLEX subW302 = subW55 -u[17] - 3.*u[39];
COMPLEX subW303 = -subW180 + subW43;
COMPLEX subW304 = subW68 + u[17] -u[36];
COMPLEX subW305 = -2. + subW206*u[16];
COMPLEX subW306 = 2. + subW210*u[15];
COMPLEX subW307 = subW37 + subW215*u[13];
COMPLEX subW308 = subW214*subW36;
COMPLEX subW309 = -2.*subW224*u[7];
COMPLEX subW313 = subW222*u[25]*u[37];
COMPLEX subW314 = kTv*subW218;
COMPLEX subW315 = 2.*subW224*u[7];
COMPLEX subW318 = -subW214*u[27];
COMPLEX subW320 = subW214 + subW81;
COMPLEX subW321 = -1. + subW243*u[35];
COMPLEX subW322 = -subW214*u[29];
COMPLEX subW323 = subW247 + subW97;
COMPLEX subW328 = 3. + subW256*u[34];
COMPLEX subW330 = subW10*subW260*u[35];
COMPLEX subW332 = subW18*subW260*u[35];
COMPLEX subW334 = 2. + subW266*u[19];
COMPLEX subW335 = subW153 + subW279;
COMPLEX subW340 = 3. + subW285*u[34];
COMPLEX subW343 = subW214 + subW22;
COMPLEX subW344 = -subW180 + subW222;
COMPLEX subW345 = subW309 + subW61;
COMPLEX subW348 = subW315 -subW61;
COMPLEX subW351 = u[29] + subW323*u[34];
COMPLEX subW354 = subW22 + subW320;
COMPLEX subW355 = subW330 + u[29];
COMPLEX subW356 = subW332 -u[38];
COMPLEX subW357 = subW335*u[34] + u[38];
COMPLEX subW360 = subW289 + subW340*u[38];
COMPLEX subW361 = subW345*u[11] + subW214*u[27];
COMPLEX subW362 = subW314 + subW318 + subW348*u[11];
COMPLEX subW363 = subW96 + subW351*u[19];
COMPLEX subW364 = subW152 + subW357*u[15];
u[24] = subW1*subW2*subW205*subW305*subW8*u[7]*u[10]*u[12]*u[14]*u[15];
u[42] = subW12*subW13*subW2*subW209*subW306*subW96*u[9]*u[10]*u[19];
u[47] = subW1*subW2*(subW21 + subW231 + subW24)*subW306*subW8*u[7]*u[10]*u[14]*u[16]*u[29];
u[49] = subW2*u[7]*u[9]*u[10]*u[15]*u[16]*(kTv*u[13]*u[14]*u[19]*(2.*subW124*(subW205*u[7] + (subW231 + subW25)*u[10]) + u[9]*(subW10*subW25 + u[11]*(-(2.*subW23 + subW25)*u[8] + 2.*subW10*u[25]))) + 2.*subW124*((subW231 + subW27)*u[10]*u[13]*u[14]*u[19]*u[36] + u[7]*(2.*u[14]*u[19]*u[29] + u[13]*(-u[19]*u[29] + u[14]*((2. + subW28*u[19])*u[29] + 2.*subW205*u[19]*u[36])))) + u[9]*(u[11]*u[13]*(-u[19]*u[25]*u[29] + u[14]*(subW213*u[8]*u[19]*u[36] + u[25]*((4. + subW28*u[19])*u[29] + 3.*subW10*u[19]*u[36]))) + u[19]*(subW2*u[8]*u[13]*u[14]*u[25]*u[36] -u[21]*(subW214*u[13]*u[14]*u[20]*u[36] + (4.*u[14] + u[13]*(-1. + subW28*u[14]))*u[29]*u[44]))));
u[51] = subW46*u[9]*u[10]*u[16]*(subW3*u[11]*u[12]*u[14]*(u[9]*(subW10*subW307 + subW9*(subW34 + u[13]*(subW36 + 3.*subW35*u[15]))) + 2.*subW124*u[10]*(subW34 + u[13]*(subW39 + u[15]*(-u[16] + u[19])))) -kTv*(u[11]*(u[8]*u[14]*(4.*subW124*subW218*u[13]*u[15]*u[19] + u[9]*(4.*subW196*u[13]*u[15]*u[19] + u[11]*(subW308*u[13] + u[15]*(subW214*u[16]*(3.*u[13] -u[19]) + (subW213 + 8.*subW55*u[12])*u[13]*u[19])) + subW2*(subW34 + u[13]*(subW36 + u[15]*(3.*u[16] + u[19])))*u[25])) + 2.*(2.*subW10*subW218*u[13]*u[14]*u[15]*u[19]*u[26] -u[10]*(-2.*subW221*u[12]*u[13]*u[15]*u[19] + u[14]*(u[11]*(subW308*u[13] + u[15]*((-subW23 + 4.*subW25 + subW30)*u[13]*u[19] + subW214*u[16]*(u[13] + u[19]))) + subW2*(subW36*u[13] + (subW39 + subW35*u[13])*u[15])*u[25])*u[26]))) + u[9]*u[14]*(u[20]*(subW2*(subW37 + u[13]*(subW39 + u[15]*(u[16] + 3.*u[19])))*u[21]*u[25] + 4.*subW222*u[12]*u[13]*u[15]*u[19]*u[37]) + u[11]*(subW10*subW214*subW307 + 4.*u[12]*u[13]*u[15]*u[19]*(u[29]*(-u[32] + u[43]) + 2.*subW10*u[46])))) + 2.*u[19]*(u[11]*(2.*u[13]*(subW10*subW361*u[14]*u[15]*u[26] + u[10]*(u[15]*(subW214*subW221 - 2.*subW2*u[14]*u[25]*u[26]*u[36]) + u[11]*(-subW177*(u[15] + u[14]*(-2. + subW58*u[15])) + u[15]*(subW67 + u[14]*u[26]*(subW24*subW68 + u[25]*u[28]*u[29] - 2.*subW23*u[36]))))) + u[8]*(2.*subW124*subW361*u[13]*u[14]*u[15] + u[9]*(2.*u[13]*u[14]*u[15]*(subW214*u[37]*u[38] - 2.*subW2*u[25]*u[39]) + u[11]*(u[12]*(-4.*u[14]*u[15] + u[13]*(3.*u[15] + u[14]*(-4. + 3.*subW58*u[15]))) + 2.*u[13]*u[14]*u[15]*(subW67*u[37] + 2.*(subW23*subW55 + subW27*u[39])))))) + u[9]*u[15]*(u[13]*u[14]*(-2.*subW2*u[25]*(2.*subW10*subW56 + subW57*u[29]) + 2.*subW214*subW222*u[20]*u[37]) + u[11]*(subW10*u[12]*(-4.*u[14] + u[13]*(1. + subW58*u[14])) + 2.*u[13]*u[14]*(subW322*subW57 + u[20]*(subW313 + 2.*subW214*u[21]*u[46]))))));
u[52] = subW12*subW2*subW222*u[9]*u[10]*u[13]*(subW39 + u[15]*(u[16] - 2.*u[19]))*u[20]*u[34];
u[53] = subW12*subW13*subW152*subW2*subW230*u[9]*u[10]*u[15]*u[19];
u[54] = subW1*subW2*subW231*subW8*u[7]*u[10]*u[14]*u[15]*u[16]*u[29];
u[55] = subW1*subW2*subW205*subW8*u[7]*u[10]*u[12]*u[14]*u[15]*u[16];
u[57] = subW46*u[9]*u[10]*u[16]*(-2.*subW232*subW362*u[11]*u[13]*u[15]*u[19]*u[20]*u[35] + u[10]*(2.*subW222*subW320*u[13]*u[15]*u[19]*u[20]*u[28]*u[35] + subW2*u[25]*(subW18*(subW39*subW56*u[15] -kTv*(subW34 + u[13]*(subW39 + subW91*u[15])))*u[35] + u[13]*(subW18*subW56*(subW39 + u[15]*(u[16] - 5.*u[19]))*u[35] + 2.*u[15]*u[19]*u[38])) - 2.*u[11]*(-u[13]*(kTv*subW18*subW308*u[35] + u[15]*(-kTv*subW18*subW214*u[16]*u[35] + u[19]*(u[20]*(subW222*u[25]*u[28] + subW214*subW84*u[33])*u[35] + subW214*u[38]))) + u[12]*(subW18*subW241*u[15]*u[19]*u[35] + u[13]*(subW18*subW242*subW39*u[35] + u[15]*(subW18*subW242*u[16]*u[35] + u[19]*(subW18*subW321 + kTv*u[38])))))) + u[9]*(-2.*u[11]*(u[13]*(-subW322*u[15]*u[19] + (kTv*subW10*subW214*(subW39 + u[15]*u[16]) -u[15]*u[19]*u[20]*(subW313 + subW214*subW84*u[21]))*u[35]) + u[12]*(subW10*subW241*u[15]*u[19]*u[35] + u[13]*(subW10*subW242*subW39*u[35] + u[15]*(u[19]*(subW10*subW321 -kTv*u[29]) + subW10*subW242*u[16]*u[35])))) + 2.*subW222*subW320*u[13]*u[15]*u[19]*u[20]*u[35]*u[37] + subW2*u[25]*(subW10*subW39*(kTv + subW56)*u[15]*u[35] -u[13]*(subW10*subW39*(kTv -subW56)*u[35] + u[15]*(u[19]*(2.*u[29] + subW10*(kTv + 5.*subW56)*u[35]) + subW10*u[16]*u[35]*(kTv -u[36] -u[39]))))));
u[58] = subW2*subW39*u[7]*u[9]*u[10]*u[13]*u[14]*u[15]*((subW22 -subW23)*u[9] + 2.*subW46*u[26])*u[29];
u[59] = subW152*subW2*subW39*u[7]*u[9]*u[10]*((subW9 + subW94)*u[7] + 2.*subW22*u[10])*u[13]*u[15];
u[60] = subW12*subW2*subW222*subW39*u[9]*u[10]*u[13]*u[15]*u[20]*u[35];
u[61] = subW2*subW39*u[7]*u[9]*u[10]*((subW10 -subW9)*u[9] + 2.*subW124*u[10])*u[12]*u[13]*u[14]*u[15];
u[62] = subW2*u[7]*u[9]*u[10]*u[13]*u[15]*u[16]*(-2.*(subW152*subW95*u[10]*u[12]*u[19] + subW214*(subW363*u[9] + 2.*subW18*u[10]*u[19]*u[34]*u[36])) + subW3*u[19]*u[34]*(2.*(subW253*u[9]*u[12] + u[10]*(subW254*u[12] + subW214*u[38])) + u[7]*u[38]*(-2.*subW94 + u[29]*(4.*u[17] + 3.*u[39]))) + u[7]*((subW109 - 3.*subW18)*subW96 + u[19]*(subW109*subW255*u[29] + u[20]*(subW328*subW43 + 4.*subW214*u[34]*u[36]*u[50]))) + kTv*(2.*(subW363*u[9]*u[12] -(-2.*subW18*subW25*u[10] + subW214*(subW253*u[9] + subW254*u[10]))*u[19]*u[34]) -u[7]*(subW96*(4.*subW18*u[17]*u[19] - 3.*u[38]) + u[19]*(u[29]*(subW328*u[38] + (subW109 + 3.*subW18)*u[34]*u[39]) - 2.*u[34]*(subW214*u[20] + subW106*u[45])*u[50]))));
u[63] = -subW46*u[9]*u[10]*u[15]*u[19]*(2.*u[13]*u[16]*(subW2*(subW355*u[9] + subW356*u[10])*u[25]*u[34] -u[20]*u[35]*(-kTv*subW222*subW354*u[27]*u[34] + u[10]*(subW222*subW320*u[28]*u[34] + u[11]*(u[12]*u[33] + subW222*u[25]*u[28]*u[34])) + u[9]*(u[11]*(u[12]*u[21] + subW313*u[34]) + subW222*subW320*u[34]*u[37]))) + subW46*u[34]*(2.*u[11]*u[13]*u[16]*(subW356*u[8] + subW355*u[26]) -subW222*u[20]*(-2.*u[16]*u[35] + u[13]*(-2.*u[35] + u[16]*(1. + u[35]*(subW3 + 2.*kTv*(-u[17] + u[46])))))));
u[66] = subW122*subW123*subW2*subW265*subW305*u[7]*u[9]*u[12]*u[19]*u[64];
u[69] = subW12*subW13*subW152*subW2*subW230*subW334*u[9]*u[10]*u[15];
u[70] = subW122*subW123*subW2*(subW21 + subW22 + 2.*subW23 + subW30)*subW334*u[7]*u[9]*u[16]*u[38]*u[64];
u[71] = subW2*subW39*u[7]*u[9]*u[10]*(2.*subW9*(u[9]*u[13]*u[15]*(kTv*(subW131 + subW22 + subW30) + (subW22 -subW23 + subW30)*u[39])*u[64] + u[7]*(subW269*u[13]*u[15]*u[38] + (subW132*subW265*u[13]*u[15] + 2.*(u[13] + u[15])*u[38])*u[64])) + u[10]*(u[15]*(u[13]*(subW2*u[25]*u[26] + subW320*u[20]*u[33])*u[39]*u[64] -subW178*u[33]*(subW269*u[13] + 4.*u[64])) + u[11]*u[13]*(4.*subW67*u[64] + u[15]*(-u[26]*(kTv*(subW131 + subW24) + subW271*u[39])*u[64] + u[25]*(subW269*u[38] -subW18*(2.*kTv + 3.*u[39])*u[64])))));
u[72] = subW46*u[9]*u[10]*u[16]*(u[10]*((kTv*subW139*(subW35*u[13]*u[15] + subW39*(-3.*u[13] + u[15]))*u[25]*u[26] - 4.*u[13]*u[15]*u[19]*(subW222*subW320*u[20]*u[28] + 2.*subW139*u[25]*u[26]*u[36]))*u[64] + subW2*((kTv*subW39*u[15]*(-3.*subW18*u[25] + subW214*u[26]) + u[13]*(kTv*subW39*(subW18*u[25] - 3.*subW214*u[26]) + u[15]*(kTv*u[16]*(subW18*u[25] + subW214*u[26]) + u[19]*(u[26]*(kTv*subW271 + 8.*subW30*subW68 - 8.*subW23*u[36]) + u[25]*(-4.*subW153 + subW18*(3.*kTv + 8.*subW56) + 4.*(subW142 + u[5]*u[38]))))))*u[64] + subW177*(subW273 + u[13]*((8. + 3.*subW3*u[16])*u[19]*u[64] + u[15]*(-subW3*u[16]*u[64] + u[19]*(-2.*subW274 + (subW3 + 8.*kTv*u[36])*u[64]))))) -u[11]*((3.*kTv*subW18*subW214*subW39*u[15] + u[13]*(kTv*subW18*subW308 + u[15]*(-kTv*subW18*subW214*u[16] + u[19]*(-4.*subW214*subW275 + u[20]*(4.*subW222*u[25]*u[28] + subW214*u[33]*(kTv + 8.*u[46]))))))*u[64] + u[12]*(subW18*subW3*subW37*u[64] + u[13]*(subW18*subW276*u[19]*u[64] + u[15]*(subW18*subW276*u[64] + u[19]*(4.*kTv*subW275*u[64] + subW18*(-6.*subW274 + (3.*subW3 + 8.*kTv*subW56)*u[64]))))))) + u[11]*(4.*subW354*u[9]*u[13]*u[15]*u[19]*u[29] - 2.*u[8]*(2.*subW265*subW362*u[13]*u[15]*u[19]*u[64] + u[9]*((2.*(-subW23 + subW27 + kTv*u[12])*u[13]*u[15]*u[19]*u[37]*u[38] + subW2*u[25]*(kTv*(subW34 + u[13]*(subW36 + subW91*u[15])) + 4.*u[13]*u[15]*u[19]*u[39]))*u[64] -u[11]*((kTv*subW214*subW39*u[15] + u[13]*(kTv*subW214*subW39 + u[15]*(-kTv*subW214*u[16] + u[19]*(kTv*(subW23 -subW30) + 4.*subW23*subW55 + 2.*subW67*u[37] - 4.*subW30*u[39]))))*u[64] + u[12]*(subW273 + u[13]*(subW3*subW36*u[64] + u[15]*(-2.*subW274*u[19] + (4. + subW3*(u[16] + u[19]) + 4.*kTv*u[19]*u[39])*u[64]))))))));
u[73] = subW12*subW13*subW2*subW209*subW96*u[9]*u[10]*u[15]*u[19];
u[74] = subW122*subW123*subW2*(subW22 + subW30)*subW39*u[7]*u[9]*u[38]*u[64];
u[75] = subW122*subW123*subW2*subW265*subW39*u[7]*u[9]*u[12]*u[64];
u[76] = subW2*subW39*subW96*u[7]*u[9]*((subW124 + subW151)*u[7] + 2.*subW22*u[9])*u[10]*u[13]*u[15];
u[77] = subW2*subW39*u[7]*u[9]*u[10]*(2.*subW9*u[7] + (subW22 + subW27)*u[10])*u[13]*u[15]*u[38]*u[64];
u[78] = subW2*subW39*u[7]*u[9]*u[10]*u[13]*(subW3*u[15]*u[34]*(2.*(subW322*u[9] + (subW278*u[9] + subW277*u[10])*u[12]) + u[7]*u[29]*(subW109 + (-4.*u[17] + u[36])*u[38])) + 2.*(subW95*subW96*u[9]*u[12]*u[15] + subW214*(subW364*u[10] - 2.*subW10*u[9]*u[15]*u[34]*u[39])) + u[7]*(subW152*(subW10 - 2.*subW94) + u[15]*(-2.*subW255*subW94*u[38] + u[20]*(subW360*u[21] + 4.*subW30*u[34]*u[39]*u[50]))) + kTv*(2.*(2.*subW10*subW131 -subW214*subW278)*u[9]*u[15]*u[34] - 2.*u[10]*(subW364*u[12] + subW214*subW277*u[15]*u[34]) + u[7]*(subW96*u[38] + u[15]*(subW360*u[29] + u[34]*((-4.*subW10*u[17] + 2.*subW94*u[36])*u[38] + u[20]*((subW109 + subW160)*u[21] + subW24*u[50]))))));
u[79] = subW2*subW39*u[7]*u[9]*u[10]*(-2.*subW9*u[9] + (subW124 + subW18)*u[10])*u[12]*u[13]*u[15]*u[64];
u[81] = subW34*subW46*u[9]*u[10]*((-u[29]*(u[13]*((-subW124*subW27*u[10] + subW172*subW2*u[26])*u[28] + subW47*subW95*u[38]) + subW18*(subW46 + u[13]*(-subW22*u[10]*u[28] + subW46*u[43]))) + u[13]*(subW291*(-2.*subW18*subW2 + 2.*subW139*u[26])*u[36] + u[26]*u[29]*(-subW23*u[10]*u[11]*u[28] + subW2*u[7]*u[43]) + u[10]*(subW23*(subW18*u[28]*u[29] + 2.*subW2*u[26]*u[36]) + subW174*u[20]*u[28]*u[29]*u[45]) + subW3*(subW2*subW291*u[38] + u[29]*(-subW47*u[11]*u[26] + subW18*u[12]*u[27] + u[38]*(subW214*u[27] + u[10]*u[12]*u[28] + u[11]*(subW61 -u[7]*u[46]))))))*u[80] + u[7]*u[29]*(-subW18*u[11]*u[13] + subW2*u[26]*(u[13] + u[80])) + u[9]*u[11]*(u[11]*u[13]*(u[25]*u[29] - 2.*subW23*u[8]*u[36]*u[80]) + u[29]*(subW30*u[13] -subW23*(1. + u[13]*u[43])*u[80])) + kTv*(u[13]*((subW265*subW343*u[27]*u[29] + u[10]*(subW139*u[25]*u[26] + subW2*((2.*subW160 -subW18)*u[25] + subW23*u[26]) + u[28]*u[29]*((subW177 -subW67)*u[11] -subW18*u[12] -subW214*u[38])))*u[80] -u[9]*u[11]*(u[12]*u[29] + subW23*(subW9 -u[29]*u[46])*u[80])) + subW46*(u[29]*u[38]*u[80] + u[13]*((2.*subW160 + subW265)*subW9*u[80] + u[29]*((-subW124 + subW18)*u[46]*u[80] + u[38]*(1. + u[43]*u[80]))))));
u[82] = subW122*subW123*subW2*subW39*u[7]*u[9]*((subW177 + subW67)*u[11] + (subW178 -u[12]*u[20])*u[33])*u[64];
u[83] = subW122*subW2*subW293*subW39*u[7]*u[9]*u[13]*u[15]*u[44]*u[80];
u[85] = subW39*subW46*u[9]*u[10]*u[13]*u[15]*(u[10]*u[64]*(-2.*subW295*subW344*u[28]*u[44]*u[80] + subW2*(u[25]*(u[38] + subW151*subW296*u[80]) + u[26]*(u[12] + subW23*subW296*u[80])) + u[11]*(2.*(subW191*u[28]*u[29] + u[21]*(subW142 + (subW112 -u[31] -u[32])*u[38]))*u[44]*u[80] -u[33]*(subW178 + subW187*subW295*u[44]*u[80]) + u[12]*(subW18 + subW109*(-u[5] + u[31] + u[32] -u[56])*u[80]))) + u[11]*(2.*subW297*u[29]*u[44]*u[80] - 2.*u[8]*u[64]*(-u[27]*((subW191 + subW71)*u[11] + (-subW10 + subW94)*u[33])*u[44]*u[80] + u[9]*(subW293*u[37]*u[44]*u[80] + u[11]*(u[12] -subW23*subW298*u[80])) + u[7]*(u[11]*(-u[38] + subW151*subW298*u[80]) + subW293*u[44]*u[80]*u[84]))));
u[88] = subW2*subW34*subW84*u[7]*u[9]*u[10]*u[13]*u[44]*(subW297*(subW9 + kTv*u[29]) -u[10]*(u[21]*(subW124 + kTv*u[38]) + (subW22 + subW81)*u[50]))*u[80];
u[89] = subW2*subW34*subW84*u[7]*u[9]*u[10]*u[13]*u[20]*u[35]*(subW188*(subW214 -subW22) + kTv*(-2.*subW222*u[7] + subW299*u[12]) -u[11]*(2.*subW232*u[7] + subW172*u[33]) + u[10]*(subW23*u[33] + subW174*u[45]));
u[90] = subW2*subW39*u[7]*u[9]*u[10]*u[13]*u[15]*((-subW180 + subW44)*u[10] + (-subW188 + subW195)*u[29])*u[44]*u[80];
u[91] = subW2*subW39*u[7]*u[9]*u[10]*(subW222*u[7] -subW299*u[12])*u[13]*u[15]*u[20]*u[35];
u[93] = subW1*subW2*subW8*u[7]*u[10]*u[14]*u[15]*u[16]*(subW205*u[12] + subW231*u[29]);
u[94] = subW34*subW46*u[9]*u[10]*((subW27*u[10]*u[11]*u[38] + u[13]*(subW3*(u[9]*(subW196 + subW2*u[25])*u[29] + u[27]*(-subW205*u[12] + subW343*u[29])*u[38]) + subW30*(-(u[5]*u[10]*u[11] + u[9]*(subW10 + u[8]*u[11])*u[37])*u[38] + 2.*subW2*(u[8]*u[9] -u[10]*u[26])*u[39]) + u[9]*(u[25]*(-(subW2*u[8] + subW10*u[11])*u[37]*u[38] + 2.*(subW10*subW2 + subW139*u[8])*u[39]) -u[21]*(subW9 + u[20]*u[21])*u[37]*u[38]*u[44])))*u[92] + subW46*(subW205 + kTv*u[29])*(u[38]*u[92] + u[13]*(subW124*subW132*u[92] + u[38]*(1. + (u[5] -kTv*u[46])*u[92]))) + u[13]*(u[38]*(u[10]*(subW23*u[11] + subW2*u[25]) -subW47*subW95*u[29]*u[92]) + kTv*((subW10*subW343*u[27]*u[38] + subW9*(u[9]*(subW196 + subW30*u[11] + subW2*u[25]) + subW343*u[27]*u[38]) + u[9]*(subW2*subW278*u[25] + (subW322 + subW10*u[12] -u[11]*u[25]*u[29])*u[37]*u[38]))*u[92] -u[10]*u[11]*(u[12]*u[38] + subW30*(subW124 -u[38]*u[46])*u[92]))));
u[95] = subW1*subW2*subW300*subW39*u[7]*u[10]*u[13]*u[15]*u[45]*u[92];
u[96] = subW39*subW46*u[9]*u[10]*u[13]*u[15]*(u[9]*u[14]*(2.*subW301*subW344*u[37]*u[45]*u[92] + subW2*u[25]*(u[29] + subW302*subW94*u[92]) -u[11]*(-2.*u[45]*(subW201*subW43 + subW67*u[37]*u[50])*u[92] + u[12]*(subW10 + 2.*subW201*subW94*u[92]) + u[21]*(u[29]*u[44] -subW187*subW301*u[45]*u[92]))) + u[11]*(2.*u[45]*(u[38]*(u[10]*u[33] -u[7]*u[50]) + u[14]*u[26]*(subW303*u[10]*u[28] + u[27]*(subW10*u[33] + subW231*u[50]) -subW300*u[7]*u[84]))*u[92] + u[14]*(u[8]*u[9]*(subW24*u[37]*u[38]*u[92] + u[11]*(u[12] + subW30*subW302*u[92])) + subW124*(subW24*u[8]*u[27]*u[92] - 2.*u[10]*(u[12] + subW27*subW304*u[92]) + 2.*u[7]*(u[29] -subW304*subW94*u[92])))));
u[97] = subW301*subW39*subW46*u[9]*u[10]*u[13]*u[15]*u[45]*(u[9]*(subW204*u[11]*u[21] + subW344*u[37]) + u[11]*(subW193*subW204 + (subW191 + subW232)*u[27] + subW195*(subW56 -u[17] -u[46])) + subW344*(u[10]*u[28] + u[7]*u[84]))*u[92];
u[98] = subW2*subW39*u[7]*u[9]*u[10]*u[13]*u[15]*(subW303*u[9] + (-subW193 + subW195)*u[38])*u[45]*u[92];
COMPLEX subA1 = -u[41]*u[42];
COMPLEX subA2 = u[23]*u[24];
COMPLEX subA3 = u[41]*u[47];
COMPLEX subA5 = u[51] + 2.*u[57];
COMPLEX subA7 = u[65]*u[66];
COMPLEX subA10 = -u[68]*u[69];
COMPLEX subA13 = -u[65]*u[74];
COMPLEX subA14 = u[41]*u[42];
COMPLEX subA15 = -u[65]*u[75];
COMPLEX subA16 = -u[65]*u[70];
COMPLEX subA17 = -2.*u[62] - 4.*u[81];
COMPLEX subA19 = u[65]*u[82];
COMPLEX subA20 = u[65]*u[74];
COMPLEX subA21 = u[49] + 2.*u[81];
COMPLEX subA22 = 4.*u[87]*u[88];
COMPLEX subA23 = -2.*u[68]*u[78];
COMPLEX subA25 = 4.*u[68]*u[94];
COMPLEX subA27 = -2.*u[87]*u[89];
COMPLEX subA28 = -4.*u[87]*u[97];
COMPLEX subA29 = subA2 + subA3 -u[54] + u[55];
COMPLEX subA30 = subA7 - 2.*u[57] + u[72];
COMPLEX subA32 = subA10 + u[52] + u[73];
COMPLEX subA34 = subA3 + u[55] -u[93];
COMPLEX subA35 = subA2 -u[54] + u[93];
COMPLEX subA36 = -subA32*u[40];


COMPLEX amp12345 = 0.03125*(subA29*u[22] + subA5*u[23] + u[40]*(subA1 + u[52] + u[53]) -u[58] -u[59] - 2.*(u[41]*u[49] + u[60]) -u[61] + 2.*u[41]*u[62] -u[63]);

COMPLEX amp12435 = 0.03125*(-subA19 + subA20 -subA29*u[22] -subA7*u[23] + 2.*subA21*u[41] -u[23]*u[51] + u[58] + u[61] -u[23]*u[72] + u[77] - 2.*u[83] + u[85]);

COMPLEX amp12534 = 0.03125*(subA15 + subA20 -subA35*u[22] + u[58] -u[23]*(subA7 + u[51] + u[72]) + u[77] -u[79] + u[68]*(subA16 + 2.*u[71] + 4.*u[94]) - 2.*u[95] + u[96]);

COMPLEX amp13245 = 0.03125*(subA17*u[41] + u[40]*(subA14 -u[52] -u[53]) + u[59] + u[63] + 2.*u[83] + u[87]*(-4.*u[88] - 2.*u[89]) - 2.*(u[90] + u[91]));

COMPLEX amp13425 = 0.03125*(-subA34*u[22] + u[61] - 2.*u[83] -u[96] + u[87]*(4.*u[88] - 4.*u[97]) + 2.*(subA21*u[41] + u[90] + u[98]));

COMPLEX amp13524 = 0.03125*(subA22 + subA28 -u[79] -u[65]*(u[68]*u[70] + u[75] -u[82]) -u[85] + 2.*u[90] + 2.*u[68]*(u[71] + 2.*u[94]) - 2.*u[95] + 2.*u[98]);

COMPLEX amp14235 = 0.03125*(subA15 + subA19 + subA17*u[41] + u[59] + u[40]*(subA10 + subA14 -u[53] + u[73]) + u[76] + u[68]*(subA16 + 2.*u[71] + 2.*u[78]) -u[79] + 2.*u[83] -u[85]);

COMPLEX amp14325 = 0.03125*(subA23 + subA25 + subA34*u[22] -u[59] -u[61] + u[41]*(-2.*u[49] + 2.*u[62]) + u[40]*(subA1 + u[53] + u[68]*u[69] -u[73]) -u[76] - 2.*u[95] + u[96]);

COMPLEX amp14523 = 0.03125*(subA23 + subA25 + subA27 + subA28 + subA36 + u[63] -u[76] - 2.*u[91] - 2.*u[95] + 2.*u[98]);

COMPLEX amp12354 = 0.03125*(subA13 + subA36 + subA30*u[23] + 2.*u[60] + u[63] + u[65]*u[75] -u[76] -u[77] + u[68]*(u[65]*u[70] - 2.*u[71] - 2.*u[78]) + u[79]);

COMPLEX amp12453 = 0.03125*(subA13 + subA19 + subA22 + subA30*u[23] -u[77] -u[85] + 2.*(u[60] + u[87]*u[89]) + 2.*u[90] + 2.*u[91]);

COMPLEX amp12543 = 0.03125*(subA27 + subA28 + subA35*u[22] + subA5*u[23] -u[58] - 2.*u[60] - 2.*u[91] -u[96] + 2.*u[98]);

delete [] u;

// color factors are included below, without averaging

return 2.*27.*8./32.*(norm(amp12345) +norm(amp12435) +norm(amp12534) +norm(amp13245) +norm(amp13425) +norm(amp13524)
+norm(amp14235) +norm(amp14325) +norm(amp14523) +norm(amp12354) +norm(amp12453) +norm(amp12543) );


}
