//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->QQ for helicities LRL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_2.h"

double ME_2::me2_RgGQQb_LRL() {
int Nsymb =24;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,n);
u[2] = Dot(k3,k4);
u[4] = S(L,k2,k3);
u[5] = S(R,k2,k4);
u[6] = S(R,k2,n);
u[7] = S(R,k2,n,e1);
u[8] = Den(u[2]);
u[9] = Den(u[1]);
u[10] = S(L,k3,n);
u[11] = Dot(e1,k2);
u[12] = S(R,k4,n);
u[13] = S(R,k4,k3,e1);
u[15] = Dot(k2,k4);
u[16] = S(L,k2,n);
u[17] = S(R,k2,k3,e1);
u[18] = Den(u[15]);
u[19] = S(L,k4,n);
u[21] = Dot(k2,k3);
u[22] = S(R,k2,k3);
u[23] = Den(u[21]);
u[3] = 1.4142135623730951;
u[14] = 0.25*Ii*u[3]*u[6]*u[8]*u[9]*(u[10]*(2.*u[5]*(kTv - 2.*u[11]) + u[7]*u[12]) + u[7]*(-u[4]*u[5] + kTv*u[13]));
u[20] = 0.5*u[3]*u[5]*u[6]*u[9]*u[18]*(u[16]*u[17] -u[13]*u[19]);
u[24] = -0.5*u[3]*u[6]*u[9]*u[10]*u[13]*u[22]*u[23];


COMPLEX amp12D3D4 = 0.5*(Ii*u[14] -u[20]);

COMPLEX amp21D3D4 = 0.5*(-Ii*u[14] + u[24]);

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = -2./3.*conj(amp12D3D4)*amp21D3D4+16./3.*norm(amp12D3D4)+16./3.*norm(amp21D3D4)-2./3.*conj(amp21D3D4)*amp12D3D4;

return real(tmp);
}
