//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->QQbg for helicities LLRL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGQQbG_LLRL() {
int Nsymb =80;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k4);
u[2] = Dot(k2,k5);
u[3] = Dot(k4,k5);
u[4] = Dot(k2,n);
u[5] = Dot(k5,n);
u[6] = S(L,k4,k5);
u[7] = S(L,k4,n);
u[8] = S(L,k5,n);
u[9] = S(L,k2,k4);
u[10] = S(R,k2,k3);
u[11] = S(R,k2,n);
u[12] = S(R,k4,n);
u[13] = Den(u[5]);
u[14] = Den(u[4]);
u[15] = Den(u[3]);
u[16] = Den(u[2]);
u[17] = Dot(e1,k3);
u[18] = S(R,k3,n,e1);
u[19] = S(R,k5,n);
u[20] = S(L,k2,k5);
u[21] = Den(u[1] + u[2] -u[3]);
u[23] = S(R,k2,k5);
u[24] = S(R,k3,n);
u[25] = Dot(k3,n);
u[26] = Dot(k4,n);
u[27] = S(R,k3,k5);
u[28] = Dot(k3,k4);
u[29] = Den(u[28]);
u[31] = Den(u[4] -u[5]);
u[33] = Den(u[25] + u[26]);
u[35] = Dot(e1,k4);
u[36] = Dot(k3,k5);
u[37] = S(R,k2,n,e1);
u[38] = S(R,k3,k4);
u[39] = S(L,k3,k5);
u[40] = S(L,k3,n);
u[41] = Dot(e1,k5);
u[42] = Dot(e1,k2);
u[43] = S(R,k2,k4);
u[44] = S(R,k3,k4,e1);
u[45] = S(R,k3,k5,e1);
u[46] = Den(u[3] + u[28] + u[36]);
u[49] = S(R,n,k5,e1);
u[56] = Dot(k2,k3);
u[57] = Den(u[1]);
u[58] = Den(u[1] -u[28] + u[56]);
u[65] = Den(u[56]);
u[66] = S(L,k2,n);
u[67] = S(L,k3,k4);
u[68] = S(R,k2,k4,e1);
u[70] = S(R,k2,k5,e1);
u[72] = S(R,n,k4,e1);
u[73] = Den(u[2] -u[36] + u[56]);
u[77] = Den(u[36]);
COMPLEX subW1 = kTv + 2.*u[17];
COMPLEX subW2 = u[11]*u[18];
COMPLEX subW3 = u[7]*u[12];
COMPLEX subW4 = u[8]*u[19];
COMPLEX subW6 = -2.*u[7]*u[10]*u[11]*u[20];
COMPLEX subW7 = -2.*u[6]*u[23]*u[24];
COMPLEX subW8 = u[9]*u[10];
COMPLEX subW9 = u[6]*u[27];
COMPLEX subW15 = u[18]*u[19];
COMPLEX subW16 = pow2(u[8]);
COMPLEX subW17 = pow2(u[11]);
COMPLEX subW18 = u[13] + u[14];
COMPLEX subW19 = u[25] + u[26];
COMPLEX subW22 = u[7]*u[24];
COMPLEX subW24 = 2.*u[7]*u[10];
COMPLEX subW25 = u[37]*u[44];
COMPLEX subW28 = u[17] + u[35];
COMPLEX subW30 = pow3(kTv);
COMPLEX subW31 = pow2(kTv);
COMPLEX subW32 = u[6]*u[12];
COMPLEX subW33 = u[24]*u[39];
COMPLEX subW36 = u[10]*u[40];
COMPLEX subW37 = u[7]*u[43];
COMPLEX subW42 = -u[7]*u[11];
COMPLEX subW50 = pow2(u[7]);
COMPLEX subW51 = u[8]*u[14]*u[23]*u[41];
COMPLEX subW54 = u[14]*u[24]*u[40];
COMPLEX subW61 = u[14]*u[24]*u[37]*u[41];
COMPLEX subW63 = kTv + 2.*u[41];
COMPLEX subW64 = -u[8]*u[23];
COMPLEX subW66 = kTv + 2.*u[35];
COMPLEX subW67 = subW3 + subW4;
COMPLEX subW68 = subW8 + subW9;
COMPLEX subW73 = subW22 -subW8 + subW9;
COMPLEX subW74 = subW24 + subW25;
COMPLEX subW75 = subW32 + subW33;
COMPLEX subW77 = subW36 + subW37;
COMPLEX subW79 = subW28 + u[41];
COMPLEX subW80 = -1. + subW19*u[14];
COMPLEX subW81 = -5. + subW19*u[14];
COMPLEX subW84 = -3. + subW19*u[14];
COMPLEX subW88 = subW51 -u[37];
COMPLEX subW90 = 4. + subW54;
COMPLEX subW96 = subW61 - 2.*u[10];
COMPLEX subW97 = subW64 + kTv*u[37];
COMPLEX subW98 = subW7 + subW68*u[11];
COMPLEX subW101 = subW81*u[13] + u[14];
COMPLEX subW102 = subW84*u[13] -u[14];
COMPLEX subW104 = 4.*subW28 + subW90*u[41];
COMPLEX subW107 = subW84*u[13] + u[14];
COMPLEX subW108 = subW6 + subW98*u[8];
COMPLEX subW109 = subW104*u[10] + subW88*u[24];
COMPLEX subWW1 = -2.*u[10]*u[17];
COMPLEX subWW3 = subW2 + subWW1;
u[22] = 0.5*subW67*u[6]*u[8]*(subW2 -subW1*u[10])*u[11]*u[13]*u[14]*u[15];
u[30] = 0.25*Ii*u[8]*u[11]*u[13]*u[14]*u[16]*(kTv*subW108 + 2.*subWW3*u[7]*u[11]*u[20] + u[8]*(-subWW3*u[9]*u[11] + u[6]*(-4.*u[17]*u[23]*u[24] + u[11]*(subW15 + 2.*u[17]*u[27]))));
u[32] = 0.25*Ii*subW16*subW17*subW18*u[16]*(u[9]*(subW2 -u[10]*(kTv + 2.*u[17])) + u[6]*(subW15 + subW1*u[27]));
u[34] = -0.25*kTv*subW16*subW17*subW19*subW22*u[13]*(-2. + subW19*u[14])*u[16]*u[29];
u[47] = 0.25*Ii*u[6]*u[8]*u[11]*u[13]*u[14]*u[15]*(u[37]*(subW73*u[12] -u[19]*(u[10]*u[20] -u[8]*u[24] + u[6]*u[38])) - 4.*subW67*u[10]*u[42] + kTv*(subW74*u[12] + u[19]*(2.*u[8]*u[10] + u[37]*u[45])));
u[48] = 0.25*subW16*subW17*(2. + subW19*u[13])*u[14]*u[16]*(2.*u[44] + u[29]*(kTv*subW22 + subW28*(subW22 + subW8 -subW9 -kTv*u[44])));
u[50] = -0.25*subW22*u[8]*u[11]*u[14]*(2.*kTv*u[8]*u[11]*(u[13]*(u[16] -u[29]) + 2.*u[16]*u[29]) + u[13]*u[29]*(u[8]*u[11]*(2.*subW28*(-2. + subW31*u[16]) + u[16]*(3.*subW30 + subW31*(4.*u[41] - 4.*u[42])) + 8.*u[42]) + 2.*(subW75*u[37] + subW77*u[49])));
u[51] = 0.125*subW22*u[8]*u[11]*u[13]*u[14]*u[29]*(-2.*subW28*u[8]*u[11] + subW77*u[49]);
u[52] = -0.125*subW22*u[8]*u[11]*u[29]*(u[8]*u[11]*(8.*subW28*(u[14] + u[13]*(subW80 + 2.*subW31*u[14])) + 4.*kTv*(2.*u[14] + u[13]*(-1. + 2.*(subW19 + subW28*subW79)*u[14])) - 8.*(1. + (subW19 + subW31)*u[13])*u[14]*u[42]) + u[13]*(u[14]*(subW31*subW75*u[37] + 2.*u[8]*u[11]*(3.*subW30 + 4.*subW31*u[41])) - 2.*(subW75*u[37] + kTv*u[14]*(subW75*u[37] + 4.*u[8]*u[11]*(2.*subW28 + u[41]))*u[42])));
u[53] = 0.25*u[8]*u[11]*u[13]*u[14]*u[29]*(-u[8]*u[11]*u[44] + u[7]*u[10]*u[49]);
u[54] = 0.25*u[8]*u[11]*u[29]*(u[14]*(u[16]*(kTv*u[13]*(u[11]*(subW68*u[8] -subW74*u[20]) - 2.*u[6]*u[8]*u[23]*u[24]) -u[8]*u[11]*(2. + kTv*u[13]*(u[41] + u[42]))*u[44]) + u[13]*(u[7]*(-2.*u[10] + u[8]*u[16]*u[23]*u[24]) + u[8]*u[16]*u[23]*(subW9 + kTv*u[44]))*u[49]) + u[13]*(-2.*u[8]*u[11]*u[16]*u[44] + u[14]*((-2.*u[6]*u[24] + u[16]*u[20]*(-subW9*u[11] + subW42*u[24]))*u[37] + u[16]*((u[11]*(subW9*u[8] - 4.*u[7]*u[10]*u[20]) + u[8]*(subW42 - 4.*u[6]*u[23])*u[24])*u[41] + (u[11]*(-3.*subW9*u[8] + 4.*u[7]*u[10]*u[20]) + u[8]*(subW42 + 4.*u[6]*u[23])*u[24])*u[42] + subW8*(u[11]*(u[20]*u[37] + u[8]*(3.*u[41] -u[42])) + subW64*u[49])))));
u[55] = 0.25*u[8]*u[11]*u[14]*(-u[6]*(u[37]*(u[13]*(-2.*u[24] + subW8*u[12]*u[29]) + u[24]*u[29]*(2. + 2.*u[2]*(u[14] + u[13]*(-2. + u[14]*(u[25] + u[26]))) -u[13]*u[27]*u[39])) + u[29]*(u[8]*(-4.*subW79*u[11]*u[13]*u[27] + (u[13] + (-1. + subW19*u[13])*u[14])*u[23]*u[24]*u[41]) + u[24]*(u[10]*u[40]*(subW101*u[17] + (u[14] + u[13]*(-5. + subW19*u[14]))*u[35] + subW102*u[41]) + subW50*u[12]*u[13]*u[14]*u[41]*u[43]) + u[7]*(subW109*u[12]*u[13] + u[24]*(subW101*subW28 + subW102*u[41])*u[43]))) + u[29]*(u[6]*(subW107*subW31*u[24] + u[6]*u[12]*u[13]*u[27])*u[37] -subW33*u[13]*(subW109*u[7] + subW8*u[37] + subW50*u[14]*u[24]*u[41]*u[43]) + kTv*(subW33*(subW25 + subW96*u[7])*u[13] + u[6]*(u[13]*(subW25*u[12] + 2.*u[8]*u[11]*u[27]) + u[24]*(u[14]*(-subW36 + u[37]*(subW28 -u[41])) + u[13]*(-subW36*subW84 + u[37]*(subW28*subW81 + subW80*u[41]))) + u[7]*(subW96*u[12]*u[13] -subW107*u[24]*u[43])))));
u[59] = 0.25*Ii*subW37*u[8]*u[11]*u[13]*u[14]*(-2.*subW63*u[6]*u[24] + (subW73 + kTv*u[44])*u[49])*u[57];
u[60] = 0.5*subW1*subW22*u[6]*u[8]*u[11]*u[13]*u[14]*u[43]*u[57];
u[61] = 0.25*u[8]*u[11]*u[13]*(2.*subW63*u[14]*u[29]*(subW8*u[8]*u[11] + subW42*u[10]*u[20] + u[6]*u[24]*(-u[8]*u[23] + kTv*u[37])) + (-u[7]*(subW97*u[14]*u[24]*u[29] + 2.*u[10]*(u[29] + u[14]*(1. + u[29]*(u[2] -kTv*u[42])))) + u[14]*u[29]*(u[8]*u[23] -kTv*u[37])*(-subW8 + subW9 + kTv*u[44]))*u[49]);
u[62] = 0.125*subW22*u[8]*u[11]*(2. + kTv*subW63*u[13])*u[14]*u[29]*(2.*subW63*u[8]*u[11] + subW97*u[49]);
u[63] = -0.125*subW22*u[8]*u[11]*u[13]*u[14]*u[29]*(2.*subW28*u[8]*u[11] + subW75*u[37]);
u[64] = -0.25*u[8]*u[11]*u[13]*u[14]*u[29]*(u[6]*u[24]*u[37] + u[8]*u[11]*u[44]);
u[69] = 0.25*Ii*u[8]*u[10]*u[11]*u[13]*u[14]*u[65]*(u[6]*(u[40]*(-4.*u[24]*u[41] + u[27]*u[49]) + (4.*u[11]*u[41] -u[23]*u[49])*u[66]) + u[49]*((subW22 -subW8)*u[40] + u[66]*(subW42 + u[10]*u[67])) + kTv*(u[6]*(-2.*u[24]*u[40] + 2.*u[11]*u[66]) + u[49]*(u[40]*u[44] -u[66]*u[68])));
u[71] = 0.5*u[6]*u[8]*u[10]*u[11]*u[13]*u[14]*u[15]*u[65]*(u[12]*(-u[40]*u[44] + u[66]*u[68]) + u[19]*(-u[40]*u[45] + u[66]*u[70]));
u[74] = 0.25*Ii*u[8]*u[11]*u[13]*u[14]*u[16]*(subW108*subW66 + u[8]*(u[8]*(-2.*u[23]*u[24] + u[11]*u[27]) -u[10]*u[11]*u[66])*u[72]);
u[75] = 0.5*u[8]*u[10]*u[11]*u[13]*u[14]*u[65]*(u[24]*u[40] -u[11]*u[66])*(subW66*u[6] + u[8]*u[72]);
u[76] = 0.25*Ii*subW16*subW17*subW18*u[16]*(subW66*(-subW8 + subW9) + (u[8]*u[27] + u[10]*u[66])*u[72]);
u[78] = 0.25*Ii*subW33*u[8]*u[11]*u[13]*u[14]*(kTv*subW74 + subW73*u[37] - 4.*u[7]*u[10]*u[42])*u[77];
u[79] = -0.5*subW22*u[8]*u[11]*u[13]*u[14]*u[39]*u[43]*u[44]*u[57]*u[77];
u[80] = -0.5*subW22*subW66*u[8]*u[10]*u[11]*u[13]*u[14]*u[39]*u[77];
COMPLEX subA1 = u[31]*u[32];
COMPLEX subA3 = u[33]*u[34];
COMPLEX subA4 = 2.*u[58]*u[62];
COMPLEX subA7 = u[58]*u[61];
COMPLEX subA8 = u[46]*u[52];
COMPLEX subA9 = -u[58]*u[62];
COMPLEX subA10 = u[53] + u[64];
COMPLEX subA11 = Ii*u[73]*u[76];
COMPLEX subA13 = -u[55] + Ii*u[78];
COMPLEX subA15 = subA1 + u[30];
COMPLEX subA16 = subA4 + u[50] - 4.*u[63];
COMPLEX subA18 = subA11 + subA3 -u[48];


COMPLEX amp125D3D4 = 0.125*(-u[33]*(u[50] + 4.*u[51]) - 4.*u[53] + 2.*(u[31]*(-subA3 + u[48]) + u[54]) - 2.*(u[21]*(Ii*subA15 + u[22]) + u[46]*(Ii*u[47] + u[33]*u[52] -u[55])));

COMPLEX amp152D3D4 = 0.125*(subA16*u[33] + 2.*(u[31]*(subA3 -u[48]) + Ii*(subA15*u[21] + u[58]*u[59])) - 2.*(subA7 + u[54] + u[21]*u[60] + 2.*u[64]));

COMPLEX amp215D3D4 = 0.25*(2.*subA10 + subA7 -u[46]*u[55] + u[33]*(subA8 + subA9 + 2.*u[51] + 2.*u[63]) + Ii*(u[46]*u[47] -u[58]*u[69]) -u[71]);

COMPLEX amp251D3D4 = 0.125*(2.*subA18*u[31] + subA16*u[33] - 2.*(u[54] + 2.*u[64] + u[58]*(u[61] -Ii*u[69]) + u[73]*(-Ii*u[74] + u[75])));

COMPLEX amp512D3D4 = 0.25*(2.*subA10 + subA13*u[46] + u[58]*(-Ii*u[59] + u[61]) + u[33]*(subA8 + subA9 + 2.*(u[51] + u[63])) -u[79]);

COMPLEX amp521D3D4 = 0.125*(-u[33]*(2.*subA8 + u[50] + 4.*u[51]) - 2.*(subA18*u[31] + subA13*u[46] + 2.*u[53] -u[54] + u[73]*(Ii*u[74] + u[80])));

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = ((-8*amp152D3D4 - 8*amp215D3D4 + amp251D3D4 + amp512D3D4 + 10*amp521D3D4)*conj(amp125D3D4) + (-8*amp125D3D4 + amp215D3D4 + 10*amp251D3D4 - 8*amp512D3D4 + amp521D3D4)*conj(amp152D3D4) - 8*amp125D3D4*conj(amp215D3D4) + amp152D3D4*conj(amp215D3D4) - 8*amp251D3D4*conj(amp215D3D4) + 10*amp512D3D4*conj(amp215D3D4) + amp521D3D4*conj(amp215D3D4) + amp125D3D4*conj(amp251D3D4) + 10*amp152D3D4*conj(amp251D3D4) - 8*amp215D3D4*conj(amp251D3D4) + amp512D3D4*conj(amp251D3D4) - 8*amp521D3D4*conj(amp251D3D4) + amp125D3D4*conj(amp512D3D4) - 8*amp152D3D4*conj(amp512D3D4) + 10*amp215D3D4*conj(amp512D3D4) + amp251D3D4*conj(amp512D3D4) - 8*amp521D3D4*conj(amp512D3D4) + (10*amp125D3D4 + amp152D3D4 + amp215D3D4 - 8*(amp251D3D4 + amp512D3D4))*conj(amp521D3D4) + 64*(norm(amp125D3D4) + norm(amp152D3D4) + norm(amp215D3D4) + norm(amp251D3D4) + norm(amp512D3D4) + norm(amp521D3D4)))/9.;

return real(tmp);
}
