//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->QQbg for helicities LRLL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGQQbG_LRLL() {
int Nsymb =80;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k4);
u[2] = Dot(k2,k5);
u[3] = Dot(k4,k5);
u[4] = Dot(k2,n);
u[5] = Dot(k5,n);
u[6] = S(L,k2,k3);
u[7] = S(L,k5,n);
u[8] = S(R,k2,k4);
u[9] = S(R,k2,n);
u[10] = Den(u[5]);
u[11] = Den(u[4]);
u[12] = Den(u[2]);
u[13] = S(L,k3,n);
u[14] = S(L,k4,k5);
u[15] = S(R,k4,n);
u[16] = Den(u[3]);
u[17] = Dot(e1,k3);
u[18] = Den(u[1] + u[2] -u[3]);
u[20] = S(L,k2,k5);
u[21] = S(L,k2,n);
u[22] = S(R,n,k3,e1);
u[23] = S(L,k3,k5);
u[24] = S(R,k2,k5);
u[25] = S(R,k4,k5);
u[27] = Dot(k3,n);
u[28] = Dot(k4,n);
u[29] = Dot(k3,k4);
u[30] = Den(u[29]);
u[31] = Den(u[27] + u[28]);
u[32] = Den(u[4] -u[5]);
u[34] = Dot(k3,k5);
u[36] = S(R,k2,n,e1);
u[37] = S(R,k3,n);
u[38] = S(R,k2,k3);
u[39] = Dot(e1,k5);
u[40] = Dot(e1,k4);
u[41] = S(L,k4,n);
u[42] = Dot(e1,k2);
u[43] = S(R,k4,k3,e1);
u[44] = Den(u[3] + u[29] + u[34]);
u[47] = S(R,n,k5,e1);
u[54] = Dot(k2,k3);
u[55] = Den(u[1]);
u[56] = S(L,k3,k4);
u[57] = S(R,k2,k3,e1);
u[58] = Den(u[1] -u[29] + u[54]);
u[65] = Den(u[54]);
u[68] = S(R,k4,n,e1);
u[69] = S(R,k5,n);
u[70] = Den(u[2] -u[34] + u[54]);
u[74] = Den(u[34]);
u[75] = S(R,k3,k4);
u[76] = S(R,k4,k5,e1);
u[78] = S(R,k2,k5,e1);
COMPLEX subW1 = kTv + 2.*u[17];
COMPLEX subW2 = pow2(u[7]);
COMPLEX subW3 = u[7]*u[22];
COMPLEX subW6 = u[27] + u[28];
COMPLEX subW7 = pow2(u[9]);
COMPLEX subW9 = u[10] + u[11];
COMPLEX subW10 = -u[6]*u[8];
COMPLEX subW11 = u[13]*u[15];
COMPLEX subW12 = u[23]*u[25];
COMPLEX subW15 = -4.*u[8]*u[13]*u[42];
COMPLEX subW16 = 2.*u[8]*u[13];
COMPLEX subW18 = u[6]*u[8];
COMPLEX subW20 = u[17] + u[40];
COMPLEX subW21 = pow2(kTv);
COMPLEX subW25 = pow2(u[15]);
COMPLEX subW26 = u[13]*u[37];
COMPLEX subW27 = pow2(u[13]);
COMPLEX subW29 = u[14]*u[15];
COMPLEX subW30 = u[23]*u[37];
COMPLEX subW33 = pow3(kTv);
COMPLEX subW35 = u[13]*u[38];
COMPLEX subW36 = u[8]*u[41];
COMPLEX subW39 = u[8]*u[9]*u[13]*u[20];
COMPLEX subW40 = u[7]*u[15]*u[23]*u[24];
COMPLEX subW42 = u[6]*u[7];
COMPLEX subW43 = -u[7]*u[24];
COMPLEX subW45 = kTv + 2.*u[39];
COMPLEX subW46 = u[7]*u[24];
COMPLEX subW47 = -kTv*u[36];
COMPLEX subW49 = kTv + 2.*u[40];
COMPLEX subW50 = u[9]*u[68];
COMPLEX subW51 = u[7]*u[69];
COMPLEX subW53 = subW3 + subW1*u[23];
COMPLEX subW54 = subW10 + subW11 + subW12;
COMPLEX subW56 = -3. + subW6*u[11];
COMPLEX subW59 = -5. + subW6*u[11];
COMPLEX subW60 = subW29 + subW30;
COMPLEX subW61 = subW20 + u[39];
COMPLEX subW63 = subW35 + subW36;
COMPLEX subW65 = subW39 + subW40;
COMPLEX subW66 = subW43 + kTv*u[36];
COMPLEX subW67 = subW46 + subW47;
COMPLEX subW68 = subW26 + subW51;
COMPLEX subW69 = subW56*u[10] + u[11];
COMPLEX subWW1 = kTv + 2.*u[17];
COMPLEX subWW2 = u[36]*u[43];
COMPLEX subWW4 = u[27] + u[28];
COMPLEX subWW5 = -3. + subW6*u[11];
COMPLEX subWW6 = u[17] + u[40];
COMPLEX subWW7 = -5. + subW6*u[11];
COMPLEX subWW8 = 2.*u[15]*u[23];
COMPLEX subWW9 = -u[43]*u[47];
COMPLEX subWW11 = -2.*u[8]*u[40];
COMPLEX subWW13 = subW16 + subWW2;
COMPLEX subWW14 = subWW8 + subWW9;
COMPLEX subWW15 = subW50 + subWW11;
u[19] = -0.5*subW1*subW11*u[7]*u[8]*u[9]*u[10]*u[11]*u[14]*u[16];
u[26] = 0.25*Ii*u[7]*u[9]*u[10]*u[11]*u[12]*(-2.*u[15]*(subW2*u[22] + subWW1*u[7]*u[23])*u[24] + u[9]*(u[8]*(-2.*subWW1*u[13]*u[20] + u[7]*(subW1*u[6] -u[21]*u[22])) + subW53*u[7]*u[25]));
u[33] = -0.25*kTv*subW11*subW2*subW6*subW7*u[10]*(-2. + subW6*u[11])*u[12]*u[30];
u[35] = 0.25*Ii*subW2*subW7*subW9*u[12]*(u[8]*(-subW1*u[6] + u[21]*u[22]) + subW53*u[25]);
u[45] = 0.25*Ii*subW29*u[7]*u[9]*u[10]*u[11]*u[16]*(subW15 + kTv*subWW13 + subW54*u[36]);
u[46] = 0.25*subW2*subW7*(2. + subW6*u[10])*u[11]*u[12]*(2.*u[43] + u[30]*((subW11 -subW12 + subW18)*subW20 + kTv*(subW11 -subW20*u[43])));
u[48] = 0.25*u[7]*u[9]*u[11]*(u[10]*(u[23]*(2.*u[15]*u[36] + u[30]*(u[25]*(4.*u[7]*u[9]*u[17] + u[23]*u[36]*u[37]) -subW11*u[11]*u[17]*u[27]*u[38])) -subW40*u[30]*u[39]) + u[30]*((subW25*u[10]*u[13]*u[14] + u[15]*(subW12*u[10]*u[14] + (-2. + subW21*subW69 + subW26*u[10] - 2.*u[2]*(u[11] + u[10]*(-2. + subWW4*u[11])))*u[23]))*u[36] + (-subW25*subW27*u[10]*u[11]*u[14]*u[38] + u[23]*(u[7]*(-(-1. + (subW26 + subWW4)*u[10])*u[11]*u[15]*u[24] + 4.*u[9]*u[10]*u[25]) + u[15]*(u[11]*u[13] -u[10]*(subWW5*u[13] + subW27*u[11]*u[37]))*u[38]))*u[39] + u[13]*(-u[15]*u[17]*u[23]*(u[11] + u[10]*(-5. + u[11]*u[28]))*u[38] + subW25*subW43*u[10]*u[11]*u[14]*u[39]) + u[23]*(4.*u[7]*u[9]*u[10]*u[25] -subW11*(subW59*u[10] + u[11])*u[38])*u[40] + u[8]*(-subW60*u[10]*(4.*subW61*u[13] + u[6]*u[36]) -u[15]*(u[11]*u[23]*(subW20 -u[39]) + u[10]*(subW59*subWW6*u[23] + (subW60*u[11]*u[13] + subWW5*u[23])*u[39]))*u[41]) + kTv*(u[23]*(2.*u[7]*u[9]*u[10]*u[25] + u[15]*(-subW35*(subWW5*u[10] + u[11]) + u[36]*(subWW6*u[11] + u[10]*(subWW7*u[17] -u[39])))) -u[8]*(2.*subW60*u[10]*u[13] + subW69*u[15]*u[23]*u[41]) + u[36]*(u[15]*(u[11]*(subW30*u[10]*u[13] + (-1. + subWW4*u[10])*u[23])*u[39] + subWW7*u[10]*u[23]*u[40]) + u[10]*(subW25*u[11]*u[13]*u[14]*u[39] + subW60*u[43])))));
u[49] = 0.125*subW11*u[7]*u[9]*u[30]*(u[7]*u[9]*(4.*kTv*(u[10] - 2.*(1. + (subW6 + subW20*subW61)*u[10])*u[11]) - 8.*subW20*(u[11] + u[10]*(-1. + (2.*subW21 + subW6)*u[11])) + 8.*(1. + (subW21 + subW6)*u[10])*u[11]*u[42]) + u[10]*(-u[11]*(subW21*subW60*u[36] + 2.*u[7]*u[9]*(3.*subW33 + 4.*subW21*u[39])) + 2.*(subW60*u[36] + kTv*u[11]*(subW60*u[36] + 4.*u[7]*u[9]*(2.*subW20 + u[39]))*u[42])));
u[50] = 0.125*subW11*u[7]*u[9]*u[10]*u[11]*u[30]*(-2.*subW20*u[7]*u[9] + subW63*u[47]);
u[51] = -0.25*subW11*u[7]*u[9]*u[11]*(2.*kTv*u[7]*u[9]*(u[10]*(u[12] -u[30]) + 2.*u[12]*u[30]) + u[10]*u[30]*(u[7]*u[9]*(2.*subW20*(-2. + subW21*u[12]) + u[12]*(3.*subW33 + subW21*(4.*u[39] - 4.*u[42])) + 8.*u[42]) + 2.*(subW60*u[36] + subW63*u[47])));
u[52] = 0.25*u[7]*u[9]*u[10]*u[11]*u[30]*(-u[7]*u[9]*u[43] + u[8]*u[13]*u[47]);
u[53] = -0.25*u[7]*u[9]*u[30]*(u[11]*(u[12]*(2.*u[7]*u[9]*u[43] + kTv*u[10]*(u[7]*(subW10*u[9] + subWW14*u[24]) + u[9]*(subWW13*u[20] + u[7]*(-subW12 + (u[39] + u[42])*u[43])))) + u[10]*(subW16 + (subW11 + subW12)*subW43*u[12])*u[47]) + u[10]*(2.*u[7]*u[9]*u[12]*u[43] + u[11]*((subWW8 + u[9]*u[12]*(subW12 + u[13]*u[15])*u[20])*u[36] + u[12]*(4.*subW65*(u[39] -u[42]) + u[9]*(-subW18*(u[20]*u[36] + 3.*u[7]*u[39]) + u[7]*((subW11 -subW12)*u[39] + (subW11 + 3.*subW12 + subW18)*u[42])) + subW18*subW46*u[47]))));
u[59] = -0.25*Ii*u[7]*u[8]*u[9]*u[10]*u[11]*u[55]*(u[9]*u[21]*(-4.*u[23]*u[39] + u[13]*u[47]) + u[23]*(4.*u[15]*u[39]*u[41] + u[21]*u[24]*u[47]) + u[47]*(-(subW11 + subW12 -subW18)*u[41] + u[8]*u[21]*u[56]) + kTv*(subWW14*u[41] + u[21]*(-2.*u[9]*u[23] + u[47]*u[57])));
u[60] = 0.25*u[7]*u[9]*u[10]*(2.*subW45*u[11]*(u[8]*u[9]*(subW42 -u[13]*u[20]) + subW66*u[15]*u[23])*u[30] + (-u[8]*(2.*u[13]*u[30] + u[11]*(subW67*u[6]*u[30] + 2.*u[13]*(1. + u[30]*(u[2] -kTv*u[42])))) + subW67*u[11]*u[30]*(subW11 + subW12 + kTv*u[43]))*u[47]);
u[61] = 0.5*subW53*u[7]*u[8]*u[9]*u[10]*u[11]*(-u[9]*u[21] + u[15]*u[41])*u[55];
u[62] = 0.125*subW11*u[7]*u[9]*(2. + kTv*subW45*u[10])*u[11]*u[30]*(2.*subW45*u[7]*u[9] + subW66*u[47]);
u[63] = -0.125*subW11*u[7]*u[9]*u[10]*u[11]*u[30]*(2.*subW20*u[7]*u[9] + subW60*u[36]);
u[64] = -0.25*u[7]*u[9]*u[10]*u[11]*u[30]*(u[15]*u[23]*u[36] + u[7]*u[9]*u[43]);
u[66] = 0.25*Ii*subW35*u[7]*u[9]*u[10]*u[11]*(-2.*subW45*u[15]*u[23] + (subW54 + kTv*u[43])*u[47])*u[65];
u[67] = -0.5*subW11*u[7]*u[9]*u[10]*u[11]*u[14]*u[16]*u[38]*u[43]*u[65];
u[71] = 0.5*subW11*subW49*u[7]*u[9]*u[10]*u[11]*u[23]*u[38]*u[65];
u[72] = 0.25*Ii*u[7]*u[9]*u[10]*u[11]*u[12]*(-subW42*subWW15*u[9] + kTv*(u[8]*u[9]*(subW42 - 2.*u[13]*u[20]) + u[7]*u[23]*(-2.*u[15]*u[24] + u[9]*u[25])) + (-4.*subW65 + 2.*subW12*u[7]*u[9])*u[40] + (2.*subW7*u[13]*u[20] + subW51*u[9]*u[23])*u[68]);
u[73] = 0.25*Ii*subW2*subW7*subW9*u[12]*(kTv*(subW10 + subW12) + subWW15*u[6] + u[23]*(2.*u[25]*u[40] + u[68]*u[69]));
u[77] = 0.25*Ii*u[7]*u[9]*u[10]*u[11]*u[23]*u[74]*((subW15 + subW54*u[36])*u[37] + u[69]*(-4.*u[7]*u[8]*u[42] + u[36]*(u[7]*u[15] -u[8]*u[20] + u[23]*u[75])) + kTv*(2.*subW68*u[8] + u[36]*(u[37]*u[43] + u[69]*u[76])));
u[79] = 0.5*u[7]*u[8]*u[9]*u[10]*u[11]*u[23]*u[55]*u[74]*(u[37]*(-u[41]*u[43] + u[21]*u[57]) + u[69]*(-u[41]*u[76] + u[21]*u[78]));
u[80] = 0.5*subW68*u[7]*(subW50 -subW49*u[8])*u[9]*u[10]*u[11]*u[23]*u[74];
COMPLEX subA1 = u[32]*u[35];
COMPLEX subA3 = u[32]*u[33];
COMPLEX subA4 = u[44]*u[49];
COMPLEX subA8 = u[32]*u[46];
COMPLEX subA9 = u[58]*u[62];
COMPLEX subA13 = u[58]*u[60];
COMPLEX subA14 = u[31]*u[49];
COMPLEX subA16 = u[50] + u[63];
COMPLEX subA19 = u[52] + u[64];
COMPLEX subA20 = subA1 + u[26];
COMPLEX subA21 = subA3 + subA4;
COMPLEX subA24 = subA3 + subA9;
COMPLEX subA27 = 2.*subA16 -subA9;
COMPLEX subA29 = 2.*subA21 + 4.*u[50] + u[51];
COMPLEX subA31 = 2.*subA24 + u[51] - 4.*u[63];
COMPLEX subA33 = -subA29*u[31];


COMPLEX amp125D3D4 = 0.125*(subA33 - 2.*u[18]*(Ii*subA20 + u[19]) + 2.*(subA8 + u[44]*(-Ii*u[45] + u[48]) - 2.*u[52] + u[53]));

COMPLEX amp152D3D4 = 0.125*(subA31*u[31] + 2.*Ii*(subA20*u[18] + u[58]*u[59]) - 2.*(subA13 + subA8 + u[53] + u[18]*u[61] + 2.*u[64]));

COMPLEX amp215D3D4 = 0.25*(subA13 + 2.*subA19 + subA27*u[31] + u[44]*(subA14 -u[48]) + Ii*(u[44]*u[45] -u[58]*u[66]) -u[67]);

COMPLEX amp251D3D4 = 0.125*(subA31*u[31] - 2.*(u[53] + 2.*u[64] + u[58]*(u[60] -Ii*u[66]) + u[70]*(u[71] -Ii*u[72]) + u[32]*(u[46] -Ii*u[70]*u[73])));

COMPLEX amp512D3D4 = 0.25*(2.*subA19 + subA27*u[31] + u[58]*(-Ii*u[59] + u[60]) + u[44]*(subA14 -u[48] + Ii*u[77]) -u[79]);

COMPLEX amp521D3D4 = 0.125*(subA33 - 2.*(2.*u[52] -u[53] + u[32]*(-u[46] + Ii*u[70]*u[73]) + u[44]*(-u[48] + Ii*u[77]) + u[70]*(Ii*u[72] + u[80])));

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = ((-8*amp152D3D4 - 8*amp215D3D4 + amp251D3D4 + amp512D3D4 + 10*amp521D3D4)*conj(amp125D3D4) + (-8*amp125D3D4 + amp215D3D4 + 10*amp251D3D4 - 8*amp512D3D4 + amp521D3D4)*conj(amp152D3D4) - 8*amp125D3D4*conj(amp215D3D4) + amp152D3D4*conj(amp215D3D4) - 8*amp251D3D4*conj(amp215D3D4) + 10*amp512D3D4*conj(amp215D3D4) + amp521D3D4*conj(amp215D3D4) + amp125D3D4*conj(amp251D3D4) + 10*amp152D3D4*conj(amp251D3D4) - 8*amp215D3D4*conj(amp251D3D4) + amp512D3D4*conj(amp251D3D4) - 8*amp521D3D4*conj(amp251D3D4) + amp125D3D4*conj(amp512D3D4) - 8*amp152D3D4*conj(amp512D3D4) + 10*amp215D3D4*conj(amp512D3D4) + amp251D3D4*conj(amp512D3D4) - 8*amp521D3D4*conj(amp512D3D4) + (10*amp125D3D4 + amp152D3D4 + amp215D3D4 - 8*(amp251D3D4 + amp512D3D4))*conj(amp521D3D4) + 64*(norm(amp125D3D4) + norm(amp152D3D4) + norm(amp215D3D4) + norm(amp251D3D4) + norm(amp512D3D4) + norm(amp521D3D4)))/9.;

return real(tmp);
}
