//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->QQbg for helicities RLRL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGQQbG_RLRL() {
int Nsymb =70;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k4);
u[2] = Dot(k2,k5);
u[3] = Dot(k4,k5);
u[4] = Dot(k2,n);
u[5] = Dot(k5,n);
u[6] = S(L,k2,k4);
u[7] = S(L,k2,n);
u[8] = S(L,k4,k5);
u[9] = S(L,k5,n);
u[10] = S(L,k2,k5);
u[11] = S(R,k3,n);
u[12] = S(R,k4,n);
u[13] = Den(u[5]);
u[14] = Den(u[4]);
u[15] = S(R,k2,n);
u[16] = Den(u[2]);
u[17] = Den(u[3]);
u[18] = Dot(e1,k3);
u[19] = S(R,k5,n);
u[20] = Den(u[1] + u[2] -u[3]);
u[22] = Dot(k3,k4);
u[23] = Dot(k3,k5);
u[24] = S(R,k2,k3);
u[25] = S(R,n,k2,e1);
u[26] = Dot(e1,k2);
u[27] = S(L,k2,k3);
u[28] = S(L,k3,k5);
u[29] = S(L,k4,n);
u[30] = Den(u[22]);
u[31] = Dot(e1,k5);
u[33] = S(R,k3,k4);
u[34] = Dot(k3,n);
u[35] = S(R,k3,k5);
u[36] = Dot(k4,n);
u[37] = S(R,k3,k4,e1);
u[38] = Dot(e1,k4);
u[39] = S(R,k3,k5,e1);
u[40] = Den(u[3] + u[22] + u[23]);
u[42] = Den(u[34] + u[36]);
u[44] = S(R,n,k5,e1);
u[50] = Dot(k2,k3);
u[51] = Den(u[1]);
u[53] = S(R,k3,k2,e1);
u[54] = Den(u[1] -u[22] + u[50]);
u[60] = Den(u[50]);
u[63] = S(R,n,k4,e1);
u[64] = Den(u[2] -u[23] + u[50]);
u[67] = Den(u[23]);
COMPLEX subW1 = kTv + 2.*u[18];
COMPLEX subW2 = u[6]*u[15];
COMPLEX subW3 = u[8]*u[19];
COMPLEX subW5 = u[6]*u[12];
COMPLEX subW6 = u[10]*u[19];
COMPLEX subW8 = -u[6]*u[24];
COMPLEX subW9 = u[11]*u[29];
COMPLEX subW10 = u[8]*u[35];
COMPLEX subW11 = 2.*u[6]*u[11];
COMPLEX subW12 = u[25]*u[37];
COMPLEX subW14 = u[34] + u[36];
COMPLEX subW15 = u[8]*u[12];
COMPLEX subW16 = u[11]*u[28];
COMPLEX subW18 = u[11]*u[27];
COMPLEX subW20 = u[24]*u[25];
COMPLEX subW21 = u[12]*u[14]*u[29];
COMPLEX subW22 = u[6]*u[24];
COMPLEX subW23 = pow2(u[11]);
COMPLEX subW26 = u[18] -u[31] + u[38];
COMPLEX subW28 = u[31] + u[38];
COMPLEX subW29 = pow2(kTv);
COMPLEX subW30 = u[12]*u[29];
COMPLEX subW35 = -u[10]*u[15];
COMPLEX subW37 = kTv + 2.*u[31];
COMPLEX subW38 = -kTv*u[25];
COMPLEX subW40 = u[12]*u[37];
COMPLEX subW41 = kTv + 2.*u[38];
COMPLEX subW42 = subW2 + subW3;
COMPLEX subW43 = subW5 + subW6;
COMPLEX subW44 = subW11 + subW12;
COMPLEX subW45 = subW15 + subW16;
COMPLEX subW46 = subW18 + subW5;
COMPLEX subW47 = -3. + subW14*u[14];
COMPLEX subW48 = -5. + subW14*u[14];
COMPLEX subW49 = subW14 + subW30;
COMPLEX subW52 = subW15 + subW35;
COMPLEX subW53 = subW38 + subW6;
COMPLEX subW54 = 1. + subW49*u[14];
COMPLEX subWW1 = subW14*subW28*u[14];
u[21] = 0.5*Ii*subW1*subW42*u[7]*u[9]*u[10]*u[11]*u[13]*u[14]*u[16];
u[32] = 0.5*subW1*subW43*u[7]*u[8]*u[9]*u[11]*u[13]*u[14]*u[17];
u[41] = -0.25*Ii*u[7]*u[8]*u[9]*u[13]*u[14]*u[17]*(-4.*subW43*u[11]*u[26] + u[25]*((subW10 + subW8 + subW9)*u[12] + u[19]*(u[9]*u[11] -u[10]*u[24] -u[8]*u[33])) + kTv*(subW44*u[12] + u[19]*(2.*u[10]*u[11] + u[25]*u[39])));
u[43] = 0.125*subW45*subW9*u[7]*u[9]*u[13]*u[25]*(-2. + kTv*u[14]*(kTv - 2.*u[26]))*u[30];
u[45] = -0.125*subW46*subW9*u[7]*u[9]*u[13]*u[14]*u[30]*u[44];
u[46] = 0.5*subW9*u[7]*u[9]*u[13]*u[14]*u[30]*(subW45*u[25] + subW46*u[44]);
u[47] = -0.25*u[6]*u[7]*u[9]*u[11]*u[13]*u[14]*u[30]*u[44];
u[48] = 0.25*u[7]*u[9]*u[13]*u[14]*u[30]*((-subW6*subW9*u[16] + u[6]*(2.*u[11] + subW6*u[16]*u[24]))*u[44] + u[8]*(2.*u[11]*(u[25] + 2.*subW6*u[16]*(-u[26] + u[31])) + u[10]*u[16]*u[35]*(u[15]*u[25] -u[19]*u[44])) + u[10]*u[16]*(u[15]*(subW9*u[25] -u[6]*(subW20 + 4.*u[11]*(u[26] -u[31]))) + kTv*(subW44*u[15] + u[19]*(2.*u[8]*u[11] -u[37]*u[44]))));
u[49] = 0.25*u[7]*u[9]*u[14]*(u[13]*u[30]*(-pow2(u[8])*u[12]*u[25]*u[35] + subW16*(subW9*(-u[25] + (subW18 + subW6)*u[14]*u[31]) + kTv*(subW11 -u[25]*(subW9*u[14]*u[31] + u[37])) + u[6]*(subW20 + u[11]*((4. + subW21)*u[31] + 4.*(u[18] + u[38]))))) + u[8]*(u[30]*(u[12]*u[13]*u[25]*(subW22 -kTv*u[37]) + subW23*u[27]*(subW26*u[14] + kTv*(subW47*u[13] + u[14]) + u[13]*(subWW1 + subW48*u[18] + (-3. + subW21)*u[31] - 5.*u[38]))) + u[11]*(u[30]*(2.*u[25] + u[14]*((kTv + subW26)*subW5 -(kTv*subW26 + subW29 - 2.*u[2])*u[25] -subW6*u[31])) + u[13]*(-u[25]*(2. + u[30]*(subW30 + subW29*subW47 + u[2]*(4. - 2.*subW14*u[14]) + u[28]*u[35] + kTv*(subWW1 + subW48*u[18] + (-1. + subW21)*u[31] - 5.*u[38]))) + u[30]*(subW54*(subW5 + subW6)*u[31] + subW5*(-1. + subW14*u[14])*(kTv + u[18] + u[38]))))));
u[52] = -0.5*subW1*subW52*u[6]*u[7]*u[9]*u[11]*u[13]*u[14]*u[51];
u[55] = 0.25*Ii*u[6]*u[7]*u[9]*u[13]*u[14]*u[51]*(4.*subW52*u[11]*u[31] + (-subW30*u[11] + (-subW10 + subW22)*u[12] + u[15]*(u[7]*u[11] + u[6]*u[33] + u[10]*u[35]))*u[44] + kTv*(2.*u[11]*(subW15 -u[10]*u[15]) + u[44]*(-subW40 + u[15]*u[53])));
u[56] = 0.25*u[7]*u[9]*u[13]*(2.*subW37*(subW38*u[8] + subW42*u[10])*u[11]*u[14]*u[30] + (u[6]*(subW53*u[14]*u[24]*u[30] + 2.*u[11]*(u[14] + (1. + u[14]*(u[2] -kTv*u[26]))*u[30])) -subW53*u[14]*u[30]*(subW10 + subW9 + kTv*u[37]))*u[44]);
u[57] = 0.125*subW53*subW9*u[7]*u[9]*(2. + kTv*subW37*u[13])*u[14]*u[30]*u[44];
u[58] = 0.25*u[7]*u[8]*u[9]*u[11]*u[13]*u[14]*u[25]*u[30];
u[59] = 0.125*subW45*subW9*u[7]*u[9]*u[13]*u[14]*u[25]*u[30];
u[61] = -0.25*Ii*subW18*u[7]*u[9]*u[13]*u[14]*(-2.*subW37*u[8]*u[11] + (subW10 + subW8 + subW9 + kTv*u[37])*u[44])*u[60];
u[62] = 0.5*subW18*u[7]*u[8]*u[9]*u[13]*u[14]*u[17]*(subW40 + u[19]*u[39])*u[60];
u[65] = -0.5*subW23*u[7]*u[9]*u[13]*u[14]*u[27]*u[60]*(subW41*u[8] + u[9]*u[63]);
u[66] = 0.5*Ii*u[7]*u[9]*u[10]*u[11]*u[13]*u[14]*u[16]*(subW41*subW42 + (-u[7]*u[15] + u[9]*u[19])*u[63]);
u[68] = -0.25*Ii*subW16*u[7]*u[9]*u[13]*u[14]*(kTv*subW44 + (subW10 + subW9)*u[25] -u[6]*(subW20 + 4.*u[11]*u[26]))*u[67];
u[69] = 0.5*subW16*u[6]*u[7]*u[9]*u[13]*u[14]*u[51]*(subW40 -u[15]*u[53])*u[67];
u[70] = 0.5*subW23*u[7]*u[9]*u[13]*u[14]*u[28]*(subW41*u[6] -u[7]*u[63])*u[67];
COMPLEX subA1 = u[20]*u[21];
COMPLEX subA2 = u[40]*u[41];
COMPLEX subA3 = u[54]*u[56];
COMPLEX subA4 = 2.*u[54]*u[57];
COMPLEX subA7 = u[42]*u[43];
COMPLEX subA8 = u[47] + u[58];
COMPLEX subA9 = -u[54]*u[57];
COMPLEX subA10 = u[45] + u[59];
COMPLEX subA15 = subA4 + u[46] - 4.*u[59];
COMPLEX subA17 = 2.*subA10 + subA9;
COMPLEX subA19 = subA7 -u[49] + Ii*u[68];


COMPLEX amp125D3D4 = 0.125*(-2.*(Ii*(subA1 + subA2) + u[20]*u[32]) -u[42]*(2.*u[40]*u[43] + 4.*u[45] + u[46]) - 4.*u[47] + 2.*(u[48] + u[40]*u[49]));

COMPLEX amp152D3D4 = 0.125*(subA15*u[42] + 2.*Ii*(subA1 + u[54]*u[55]) - 2.*(subA3 + u[48] + u[20]*u[52] + 2.*u[58]));

COMPLEX amp215D3D4 = 0.25*(subA3 + 2.*subA8 + subA17*u[42] + u[40]*(subA7 -u[49]) + Ii*(subA2 -u[54]*u[61]) -u[62]);

COMPLEX amp251D3D4 = 0.125*(subA15*u[42] - 2.*(u[48] + 2.*u[58] + u[54]*(u[56] -Ii*u[61]) + u[64]*(u[65] -Ii*u[66])));

COMPLEX amp512D3D4 = 0.25*(2.*subA8 + subA19*u[40] + subA17*u[42] + u[54]*(-Ii*u[55] + u[56]) -u[69]);

COMPLEX amp521D3D4 = 0.125*(-u[42]*(4.*u[45] + u[46]) - 2.*(subA19*u[40] + 2.*u[47] -u[48] + u[64]*(Ii*u[66] + u[70])));

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = ((-8*amp152D3D4 - 8*amp215D3D4 + amp251D3D4 + amp512D3D4 + 10*amp521D3D4)*conj(amp125D3D4) + (-8*amp125D3D4 + amp215D3D4 + 10*amp251D3D4 - 8*amp512D3D4 + amp521D3D4)*conj(amp152D3D4) - 8*amp125D3D4*conj(amp215D3D4) + amp152D3D4*conj(amp215D3D4) - 8*amp251D3D4*conj(amp215D3D4) + 10*amp512D3D4*conj(amp215D3D4) + amp521D3D4*conj(amp215D3D4) + amp125D3D4*conj(amp251D3D4) + 10*amp152D3D4*conj(amp251D3D4) - 8*amp215D3D4*conj(amp251D3D4) + amp512D3D4*conj(amp251D3D4) - 8*amp521D3D4*conj(amp251D3D4) + amp125D3D4*conj(amp512D3D4) - 8*amp152D3D4*conj(amp512D3D4) + 10*amp215D3D4*conj(amp512D3D4) + amp251D3D4*conj(amp512D3D4) - 8*amp521D3D4*conj(amp512D3D4) + (10*amp125D3D4 + amp152D3D4 + amp215D3D4 - 8*(amp251D3D4 + amp512D3D4))*conj(amp521D3D4) + 64*(norm(amp125D3D4) + norm(amp152D3D4) + norm(amp215D3D4) + norm(amp251D3D4) + norm(amp512D3D4) + norm(amp521D3D4)))/9.;

return real(tmp);
}
