//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)g->QQbg for helicities RRLL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgGQQbG_RRLL() {
int Nsymb =70;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k4);
u[2] = Dot(k2,k5);
u[3] = Dot(k4,k5);
u[4] = Dot(k2,n);
u[5] = Dot(k5,n);
u[6] = S(L,k2,k3);
u[7] = S(L,k2,k5);
u[8] = S(L,k2,n);
u[9] = S(L,k5,n);
u[10] = S(R,k2,n);
u[11] = S(R,k4,n);
u[12] = Den(u[5]);
u[13] = Den(u[4]);
u[14] = Den(u[2]);
u[15] = Dot(e1,k3);
u[16] = S(L,k4,k5);
u[17] = Den(u[3]);
u[18] = S(R,n,k3,e1);
u[19] = S(L,k3,k5);
u[20] = S(R,k5,n);
u[21] = Den(u[1] + u[2] -u[3]);
u[24] = Dot(k3,k4);
u[25] = Dot(k3,k5);
u[26] = Dot(k3,n);
u[27] = Dot(k4,n);
u[28] = S(R,k2,k4);
u[29] = S(R,n,k2,e1);
u[30] = S(L,k3,n);
u[31] = S(R,k3,n);
u[32] = Den(u[24]);
u[33] = Dot(e1,k2);
u[34] = S(R,k4,k5);
u[35] = Dot(e1,k5);
u[36] = Den(u[26] + u[27]);
u[37] = Den(u[3] + u[24] + u[25]);
u[39] = S(R,k4,k3,e1);
u[41] = S(R,n,k5,e1);
u[42] = S(L,k2,k4);
u[47] = Dot(e1,k4);
u[49] = Dot(k2,k3);
u[50] = Den(u[1]);
u[51] = Den(u[1] -u[24] + u[49]);
u[58] = Den(u[49]);
u[59] = S(R,k3,k4);
u[60] = S(R,k4,k2,e1);
u[63] = Den(u[2] -u[25] + u[49]);
u[66] = Den(u[25]);
u[67] = S(R,k4,k5,e1);
COMPLEX subW1 = pow2(u[11]);
COMPLEX subW2 = kTv + 2.*u[15];
COMPLEX subW4 = -u[8]*u[18];
COMPLEX subW6 = u[9]*u[18];
COMPLEX subW9 = u[26] + u[27];
COMPLEX subW10 = u[11]*u[16];
COMPLEX subW11 = u[19]*u[31];
COMPLEX subW13 = u[11]*u[30];
COMPLEX subW14 = u[19]*u[34];
COMPLEX subW15 = 2.*u[6]*u[11];
COMPLEX subW16 = u[29]*u[39];
COMPLEX subW18 = u[6]*u[31];
COMPLEX subW19 = u[6]*u[41];
COMPLEX subW20 = -u[33] + u[35];
COMPLEX subW21 = u[6]*u[28];
COMPLEX subW23 = u[6]*u[10];
COMPLEX subW24 = u[19]*u[20];
COMPLEX subW29 = u[30]*u[31];
COMPLEX subW32 = u[15] + u[47];
COMPLEX subW34 = -kTv*u[39];
COMPLEX subW37 = kTv + 2.*u[35];
COMPLEX subW39 = u[7]*u[20];
COMPLEX subW40 = -kTv*u[29];
COMPLEX subW42 = u[31]*u[39];
COMPLEX subW43 = kTv + 2.*u[47];
COMPLEX subW45 = subW4 + subW2*u[6];
COMPLEX subW46 = subW6 + subW2*u[19];
COMPLEX subW47 = subW10 + subW11;
COMPLEX subW48 = subW15 + subW16;
COMPLEX subW49 = subW23 + subW24;
COMPLEX subW50 = kTv + subW32 -u[35];
COMPLEX subW51 = subW29 + subW9;
COMPLEX subW54 = -3. + subW9*u[13];
COMPLEX subW55 = -5. + subW9*u[13];
COMPLEX subW56 = subW39 + subW40;
COMPLEX subW57 = subW18 + subW39;
COMPLEX subW58 = 1. + subW51*u[13];
COMPLEX subWW1 = u[10]*u[29];
COMPLEX subWW2 = -u[20]*u[41];
COMPLEX subWW4 = subW13 + subW14 -subW21;
COMPLEX subWW5 = subWW1 + subWW2;
u[22] = 0.5*subW1*subW45*u[8]*u[9]*u[12]*u[13]*u[16]*u[17];
u[23] = 0.5*Ii*u[7]*u[8]*u[9]*u[11]*u[12]*u[13]*u[14]*(subW45*u[10] + subW46*u[20]);
u[38] = 0.125*subW13*subW47*u[8]*u[9]*u[12]*u[29]*u[32]*(-2. + kTv*u[13]*(kTv - 2.*u[33]));
u[40] = -0.25*Ii*subW10*u[8]*u[9]*u[12]*u[13]*u[17]*(kTv*subW48 + (subW13 + subW14 -u[6]*u[28])*u[29] - 4.*u[6]*u[11]*u[33]);
u[43] = -0.125*subW13*u[8]*u[9]*u[12]*u[13]*u[32]*u[41]*(subW18 + u[11]*u[42]);
u[44] = 0.5*subW13*u[8]*u[9]*u[12]*u[13]*u[32]*((subW19 + u[19]*u[29])*u[31] + u[11]*(u[16]*u[29] + u[41]*u[42]));
u[45] = 0.25*u[8]*u[9]*u[12]*u[13]*u[32]*(u[11]*(2.*(subW19 + u[19]*(2.*subW20*subW39*u[14] + u[29])) + u[7]*u[14]*(4.*subW20*u[6]*u[10] + subWW5*u[30])) + u[7]*u[14]*((subW14 -subW21)*subWW5 + kTv*(2.*subW49*u[11] + subWW5*u[39])));
u[46] = -0.25*subW19*u[8]*u[9]*u[11]*u[12]*u[13]*u[32];
u[48] = 0.25*u[8]*u[9]*u[13]*(u[11]*(u[19]*u[32]*(2.*u[29] + u[13]*(subW18*subW50 + (-kTv*subW50 + 2.*u[2])*u[29] -subW39*u[35])) + u[12]*((subW21 + subW34)*u[16]*u[29]*u[32] + u[19]*(u[32]*(subW18*(kTv + subW32)*(-1. + subW9*u[13]) + (subW18 + subW39)*subW58*u[35]) -u[29]*(2. + u[32]*(subW29 + u[2]*(4. - 2.*subW9*u[13]) + u[16]*u[34] + kTv*(kTv*subW54 + subW32*subW55 + (-1. + subW51*u[13])*u[35])))))) + u[32]*(u[12]*(-subW11*u[29]*(subW14 -subW21 + kTv*u[39]) + pow3(u[11])*u[13]*u[16]*u[30]*u[35]*u[42]) + subW1*(u[12]*(u[16]*(2.*(kTv + 2.*subW32)*u[6] -u[29]*u[30] + (u[6]*(4. + subW29*u[13]) + u[13]*(subW39 -kTv*u[29])*u[30])*u[35]) - 5.*u[15]*u[19]*u[42]) + u[19]*u[42]*(kTv*(subW54*u[12] + u[13]) + u[13]*((1. + subW9*u[12])*u[15] + (-1. + subW51*u[12])*u[35] + u[47]) + u[12]*(-3.*u[35] + subW55*u[47])))));
u[52] = 0.25*Ii*u[8]*u[9]*u[11]*u[12]*u[13]*(2.*subW37*u[11]*u[19] + (-subW13 -subW14 + subW21 + subW34)*u[41])*u[42]*u[50];
u[53] = -0.5*subW1*subW46*u[8]*u[9]*u[12]*u[13]*u[42]*u[50];
u[54] = 0.125*subW13*subW56*u[8]*u[9]*(2. + kTv*subW37*u[12])*u[13]*u[32]*u[41];
u[55] = 0.125*subW13*subW47*u[8]*u[9]*u[12]*u[13]*u[29]*u[32];
u[56] = 0.25*u[8]*u[9]*u[11]*u[12]*u[13]*u[19]*u[29]*u[32];
u[57] = 0.25*u[8]*u[9]*u[12]*(2.*subW37*u[11]*u[13]*(subW23*u[7] + subW56*u[19])*u[32] + (u[6]*(subW56*u[13]*u[28]*u[32] + 2.*u[11]*(u[32] + u[13]*(1. + u[32]*(u[2] -kTv*u[33])))) -subW56*u[13]*u[32]*(subW13 + subW14 + kTv*u[39]))*u[41]);
u[61] = 0.25*Ii*u[6]*u[8]*u[9]*u[12]*u[13]*u[58]*(u[11]*(4.*subW11*u[35] + u[8]*u[10]*u[41]) + u[7]*u[10]*(-4.*u[11]*u[35] + u[34]*u[41]) + u[41]*(-subWW4*u[31] -subW23*u[59]) + kTv*(u[31]*(2.*u[11]*u[19] -u[39]*u[41]) + u[10]*(-2.*u[7]*u[11] + u[41]*u[60])));
u[62] = 0.5*subW10*u[6]*u[8]*u[9]*u[12]*u[13]*u[17]*u[58]*(subW42 -u[10]*u[60]);
u[64] = -0.5*subW43*u[6]*u[8]*u[9]*(subW11 -u[7]*u[10])*u[11]*u[12]*u[13]*u[58];
u[65] = 0.5*Ii*subW43*subW49*u[7]*u[8]*u[9]*u[11]*u[12]*u[13]*u[14];
u[68] = -0.25*Ii*u[8]*u[9]*u[12]*u[13]*u[19]*u[66]*(-4.*subW57*u[11]*u[33] + u[29]*(subWW4*u[31] + u[20]*(u[9]*u[11] -u[7]*u[28] + u[19]*u[59])) + kTv*(subW48*u[31] + u[20]*(2.*u[7]*u[11] + u[29]*u[67])));
u[69] = 0.5*u[8]*u[9]*u[11]*u[12]*u[13]*u[19]*u[42]*u[50]*u[66]*(subW42 + u[20]*u[67]);
u[70] = 0.5*subW43*subW57*u[8]*u[9]*u[11]*u[12]*u[13]*u[19]*u[66];
COMPLEX subA1 = 2.*u[37]*u[38];
COMPLEX subA4 = 2.*u[51]*u[54];
COMPLEX subA7 = u[37]*u[38];
COMPLEX subA8 = -u[51]*u[54];
COMPLEX subA9 = u[43] + u[55];
COMPLEX subA12 = u[46] + u[56];
COMPLEX subA13 = -Ii*u[61];
COMPLEX subA16 = -u[48] + Ii*u[68];
COMPLEX subA18 = subA1 + 4.*u[43] + u[44];
COMPLEX subA20 = subA4 + u[44] - 4.*u[55];
COMPLEX subA22 = subA7 + subA8 + 2.*subA9;
COMPLEX subA24 = subA13 + u[57];
COMPLEX subA26 = -subA18*u[36];


COMPLEX amp125D3D4 = 0.125*(subA26 - 2.*u[21]*(u[22] + Ii*u[23]) + 2.*(u[45] - 2.*u[46] + u[37]*(-Ii*u[40] + u[48])));

COMPLEX amp152D3D4 = 0.125*(subA20*u[36] + 2.*Ii*(u[21]*u[23] + u[51]*u[52]) - 2.*(u[45] + u[21]*u[53] + 2.*u[56] + u[51]*u[57]));

COMPLEX amp215D3D4 = 0.25*(2.*subA12 + subA22*u[36] + u[37]*(Ii*u[40] -u[48]) + subA24*u[51] -u[62]);

COMPLEX amp251D3D4 = 0.125*(subA20*u[36] - 2.*(u[45] + subA24*u[51] + 2.*u[56] + u[63]*(u[64] -Ii*u[65])));

COMPLEX amp512D3D4 = 0.25*(2.*subA12 + subA22*u[36] + subA16*u[37] + u[51]*(-Ii*u[52] + u[57]) -u[69]);

COMPLEX amp521D3D4 = 0.125*(subA26 - 2.*(subA16*u[37] -u[45] + 2.*u[46] + u[63]*(Ii*u[65] + u[70])));

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = ((-8*amp152D3D4 - 8*amp215D3D4 + amp251D3D4 + amp512D3D4 + 10*amp521D3D4)*conj(amp125D3D4) + (-8*amp125D3D4 + amp215D3D4 + 10*amp251D3D4 - 8*amp512D3D4 + amp521D3D4)*conj(amp152D3D4) - 8*amp125D3D4*conj(amp215D3D4) + amp152D3D4*conj(amp215D3D4) - 8*amp251D3D4*conj(amp215D3D4) + 10*amp512D3D4*conj(amp215D3D4) + amp521D3D4*conj(amp215D3D4) + amp125D3D4*conj(amp251D3D4) + 10*amp152D3D4*conj(amp251D3D4) - 8*amp215D3D4*conj(amp251D3D4) + amp512D3D4*conj(amp251D3D4) - 8*amp521D3D4*conj(amp251D3D4) + amp125D3D4*conj(amp512D3D4) - 8*amp152D3D4*conj(amp512D3D4) + 10*amp215D3D4*conj(amp512D3D4) + amp251D3D4*conj(amp512D3D4) - 8*amp521D3D4*conj(amp512D3D4) + (10*amp125D3D4 + amp152D3D4 + amp215D3D4 - 8*(amp251D3D4 + amp512D3D4))*conj(amp521D3D4) + 64*(norm(amp125D3D4) + norm(amp152D3D4) + norm(amp215D3D4) + norm(amp251D3D4) + norm(amp512D3D4) + norm(amp521D3D4)))/9.;

return real(tmp);
}
