//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)Q->Qqqb for helicities LLRL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgQQqqb_LLRL() {
int Nsymb =54;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k4);
u[2] = Dot(k2,k5);
u[3] = Dot(k4,k5);
u[4] = S(L,k3,k5);
u[5] = S(R,k2,k4);
u[6] = Den(u[3]);
u[7] = Dot(k3,k4);
u[8] = Dot(k3,k5);
u[9] = Dot(e1,k3);
u[10] = S(L,k5,n);
u[11] = S(R,n,k3,e1);
u[12] = Den(u[1] + u[2] -u[3]);
u[14] = Dot(k4,n);
u[15] = Dot(k5,n);
u[16] = Dot(e1,k2);
u[17] = S(R,k2,n,e1);
u[18] = S(R,k4,n);
u[19] = S(L,k3,k4);
u[20] = Den(u[3] + u[7] + u[8]);
u[22] = S(R,k2,k5);
u[23] = S(L,k4,n);
u[24] = Den(u[14] + u[15]);
u[26] = S(R,k5,n);
u[28] = Dot(k2,k3);
u[29] = Den(u[28]);
u[30] = Dot(e1,k4);
u[31] = S(R,k2,n);
u[32] = S(R,k4,n,e1);
u[33] = Den(u[2] -u[8] + u[28]);
u[35] = Dot(k2,n);
u[36] = Dot(k3,n);
u[37] = S(L,k3,n);
u[38] = S(L,k2,k5);
u[39] = Den(u[35] -u[36]);
u[41] = S(R,k3,k4);
u[42] = Dot(e1,k5);
u[43] = S(R,k3,n);
u[45] = S(R,k4,k5,e1);
u[46] = S(R,k2,k3,e1);
u[50] = S(R,n,k5,e1);
u[51] = Den(u[1] -u[7] + u[28]);
u[53] = S(L,k2,n);
COMPLEX subW1 = u[10]*u[11];
COMPLEX subW2 = kTv - 2.*u[16];
COMPLEX subW3 = u[14] + u[15];
COMPLEX subW4 = u[5]*u[19];
COMPLEX subW5 = u[4]*u[22];
COMPLEX subW7 = -u[5]*u[38];
COMPLEX subW8 = u[4]*u[41];
COMPLEX subW11 = u[10]*u[18];
COMPLEX subW12 = u[30] + u[42];
COMPLEX subW13 = -u[37]*u[50];
COMPLEX subW14 = subW4 + subW5;
COMPLEX subW15 = subW7 + subW8;
COMPLEX subW17 = kTv*subW15;
COMPLEX subWW1 = -u[5]*u[38];
u[13] = 2.*u[5]*u[6]*(subW1 + u[4]*(kTv + 2.*u[9]));
u[21] = 2.*u[4]*u[6]*(subW2*u[5] + u[17]*u[18]);
u[25] = -subW11*u[6]*(kTv*subW14 + (subW1 + 2.*u[4]*u[9])*u[22] + u[5]*(2.*u[9]*u[19] + u[11]*u[23]));
u[27] = -subW11*u[6]*(subW14*subW2 + u[17]*(u[18]*u[19] + u[4]*u[26]));
u[34] = 2.*u[4]*u[29]*(u[5]*(kTv + 2.*u[30]) -u[31]*u[32]);
u[40] = -Ii*kTv*subW11*subW3*u[6]*u[29]*u[31]*u[37];
u[44] = u[29]*u[31]*u[37]*(subW17 + 2.*(subW8 + subWW1)*u[30] + u[32]*(u[31]*u[38] -u[4]*u[43]));
u[47] = -Ii*u[29]*u[31]*u[37]*(2.*u[45] + u[6]*(subW12*(subW11 -subW8 + u[5]*u[38]) + kTv*(subW11 -subW12*u[45])));
u[48] = Ii*u[6]*u[29]*((-2.*kTv - 4.*subW12)*u[4]*u[5] + (subW4 + u[4]*u[22] + u[31]*u[37])*u[45] -(subW11 + subWW1 + u[4]*u[41])*u[46]);
u[49] = Ii*subW11*u[6]*(2.*u[46] + u[29]*(-kTv*u[31]*u[37] + (u[9] -u[16])*(subW14 -u[31]*u[37] + kTv*u[46])));
u[52] = 2.*u[5]*u[29]*(subW13 + u[4]*(kTv + 2.*u[42]));
u[54] = u[29]*u[31]*u[37]*(subW17 + u[41]*(subW13 + 2.*u[4]*u[42]) + u[5]*(-2.*u[38]*u[42] + u[50]*u[53]));
COMPLEX subA1 = u[39]*u[47];
COMPLEX subA2 = -u[39]*u[40];
COMPLEX subA6 = subA2 + u[49];
COMPLEX subA9 = subA1 + subA6*u[24] + u[48];


COMPLEX amp1D3D2 = 0.041666666666666664*(u[12]*(-u[13] + u[24]*u[25]) + u[20]*(-u[21] + u[24]*u[27]));

COMPLEX amp1D3D4 = 0.125*(-Ii*subA9 + u[12]*(u[13] -u[24]*u[25]) + u[33]*(u[34] -u[39]*u[44]));

COMPLEX amp1D5D2 = 0.125*(Ii*subA9 + u[20]*(u[21] -u[24]*u[27]) + u[51]*(-u[52] + u[39]*u[54]));

COMPLEX amp1D5D4 = 0.041666666666666664*(u[33]*(-u[34] + u[39]*u[44]) + u[51]*(u[52] -u[39]*u[54]));

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = 12*norm(amp1D3D2) + 12*norm(amp1D3D4) + 12*norm(amp1D5D2) + 12
      *norm(amp1D5D4) + 4*conj(amp1D3D2)*amp1D5D2 + 4*conj(amp1D3D2)*
      amp1D3D4 + 4*conj(amp1D3D4)*amp1D5D4 + 4*conj(amp1D3D4)*amp1D3D2
       + 4*conj(amp1D5D2)*amp1D5D4 + 4*conj(amp1D5D2)*amp1D3D2 + 4*
      conj(amp1D5D4)*amp1D5D2 + 4*conj(amp1D5D4)*amp1D3D4;

return real(tmp);
}
