//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)Q->QQQb for helicities LLLR *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgQQQQb_LLLR() {
int Nsymb =54;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k4);
u[2] = Dot(k2,k5);
u[3] = Dot(k4,k5);
u[4] = Dot(k4,n);
u[5] = S(L,k3,k4);
u[6] = S(R,k2,k5);
u[7] = Den(u[3]);
u[8] = Dot(k5,n);
u[9] = Dot(e1,k3);
u[10] = S(L,k4,n);
u[11] = S(R,n,k3,e1);
u[12] = S(R,k2,k4);
u[13] = S(R,k5,n);
u[14] = Den(u[1] + u[2] -u[3]);
u[16] = S(L,k3,k5);
u[17] = Dot(k3,k4);
u[18] = Dot(k3,k5);
u[19] = S(L,k5,n);
u[20] = Den(u[4] + u[8]);
u[22] = Dot(e1,k2);
u[23] = S(R,k2,n,e1);
u[24] = Den(u[3] + u[17] + u[18]);
u[26] = S(R,k4,n);
u[28] = Dot(k2,k3);
u[29] = Den(u[28]);
u[30] = Dot(e1,k4);
u[31] = S(L,k3,n);
u[32] = S(R,n,k4,e1);
u[33] = Den(u[2] -u[18] + u[28]);
u[35] = Dot(k2,n);
u[36] = Dot(k3,n);
u[37] = S(L,k2,k4);
u[38] = S(R,k2,n);
u[39] = S(L,k2,n);
u[40] = S(R,k3,k5);
u[41] = Den(u[35] -u[36]);
u[43] = Dot(e1,k5);
u[45] = S(R,k5,k4,e1);
u[47] = S(R,k2,k3,e1);
u[50] = S(R,k5,n,e1);
u[51] = Den(u[1] -u[17] + u[28]);
u[53] = S(R,k3,n);
COMPLEX subW1 = kTv + 2.*u[9];
COMPLEX subW2 = u[4] + u[8];
COMPLEX subW3 = u[5]*u[12];
COMPLEX subW4 = u[6]*u[16];
COMPLEX subW6 = u[13]*u[23];
COMPLEX subW7 = kTv + 2.*u[30];
COMPLEX subW9 = -u[31]*u[32];
COMPLEX subW11 = u[10]*u[13];
COMPLEX subW12 = u[30] + u[43];
COMPLEX subW13 = subW3 + subW4;
COMPLEX subW14 = subW9 + subW7*u[5];
COMPLEX subWW1 = u[5]*u[12];
COMPLEX subWW2 = -u[6]*u[37];
COMPLEX subWW3 = u[5]*u[40];
u[15] = 2.*u[6]*u[7]*(subW1*u[5] + u[10]*u[11]);
u[21] = -subW11*u[7]*(subW1*subW13 + u[11]*(u[10]*u[12] + u[6]*u[19]));
u[25] = 2.*u[5]*u[7]*(subW6 + u[6]*(kTv - 2.*u[22]));
u[27] = -subW11*u[7]*(kTv*subW13 + subW6*u[16] - 2.*(subWW1 + u[6]*u[16])*u[22] + u[5]*u[23]*u[26]);
u[34] = 2.*subW14*u[6]*u[29];
u[42] = u[29]*u[31]*u[38]*(u[6]*(-subW7*u[37] + u[32]*u[39]) + subW14*u[40]);
u[44] = -Ii*kTv*subW11*subW2*u[7]*u[29]*u[31]*u[38];
u[46] = -Ii*u[29]*u[31]*u[38]*(2.*u[45] + u[7]*(subW12*(subW11 -subWW3 + u[6]*u[37]) + kTv*(subW11 -subW12*u[45])));
u[48] = Ii*subW11*u[7]*(2.*u[47] + u[29]*(-kTv*u[31]*u[38] + (u[9] -u[22])*(subW13 -u[31]*u[38] + kTv*u[47])));
u[49] = Ii*u[7]*u[29]*((-2.*kTv - 4.*subW12)*u[5]*u[6] + (subW4 + subWW1 + u[31]*u[38])*u[45] -(subW11 + subWW2 + subWW3)*u[47]);
u[52] = 2.*u[5]*u[29]*(u[6]*(kTv + 2.*u[43]) -u[38]*u[50]);
u[54] = u[29]*u[31]*u[38]*(kTv*(subWW2 + subWW3) + (2.*subWW3 - 2.*u[6]*u[37])*u[43] + u[50]*(u[37]*u[38] -u[5]*u[53]));
COMPLEX subA1 = u[41]*u[46];
COMPLEX subA2 = -u[41]*u[44];
COMPLEX subA6 = subA2 + u[48];
COMPLEX subA9 = subA1 + subA6*u[20] + u[49];


COMPLEX amp1D3D2 = 0.041666666666666664*(u[14]*(-u[15] + u[20]*u[21]) + u[24]*(-u[25] + u[20]*u[27]));

COMPLEX amp1D3D4 = 0.125*(-Ii*subA9 + u[14]*(u[15] -u[20]*u[21]) + u[33]*(u[34] -u[41]*u[42]));

COMPLEX amp1D5D2 = 0.125*(Ii*subA9 + u[24]*(u[25] -u[20]*u[27]) + u[51]*(-u[52] + u[41]*u[54]));

COMPLEX amp1D5D4 = 0.041666666666666664*(u[33]*(-u[34] + u[41]*u[42]) + u[51]*(u[52] -u[41]*u[54]));

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = 12*norm(amp1D3D2) + 12*norm(amp1D3D4) + 12*norm(amp1D5D2) + 12
      *norm(amp1D5D4) + 4*conj(amp1D3D2)*amp1D5D2 + 4*conj(amp1D3D2)*
      amp1D3D4 + 4*conj(amp1D3D4)*amp1D5D4 + 4*conj(amp1D3D4)*amp1D3D2
       + 4*conj(amp1D5D2)*amp1D5D4 + 4*conj(amp1D5D2)*amp1D3D2 + 4*
      conj(amp1D5D4)*amp1D5D2 + 4*conj(amp1D5D4)*amp1D3D4;
return real(tmp);
}
