//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)Q->QQQb for helicities LLRL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgQQQQb_LLRL() {
int Nsymb =76;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k4);
u[2] = Dot(k2,k5);
u[3] = Dot(k4,k5);
u[4] = S(L,k3,k5);
u[5] = S(R,k2,k4);
u[6] = Den(u[3]);
u[7] = Dot(e1,k3);
u[8] = Dot(k2,n);
u[9] = Dot(k5,n);
u[10] = S(L,k5,n);
u[11] = S(R,n,k3,e1);
u[12] = Den(u[1] + u[2] -u[3]);
u[14] = S(L,k2,k3);
u[15] = S(R,k2,n);
u[16] = Den(u[2]);
u[17] = S(L,k2,n);
u[18] = S(R,k4,k5);
u[19] = Dot(k3,n);
u[20] = Dot(k4,n);
u[21] = Dot(k3,k4);
u[22] = S(L,k3,n);
u[23] = S(R,k4,n);
u[24] = Den(u[21]);
u[26] = Den(u[19] + u[20]);
u[27] = Den(u[8] -u[9]);
u[30] = Dot(k3,k5);
u[31] = Dot(e1,k2);
u[32] = S(R,k2,n,e1);
u[33] = Den(u[3] + u[21] + u[30]);
u[36] = S(R,k2,k3);
u[37] = S(R,k3,n);
u[38] = Dot(e1,k4);
u[39] = S(L,k4,k5);
u[41] = Dot(e1,k5);
u[42] = S(R,k4,k3,e1);
u[43] = S(L,k3,k4);
u[44] = S(R,k2,k5,e1);
u[46] = S(R,k2,k5);
u[48] = S(L,k4,n);
u[49] = Den(u[9] + u[20]);
u[51] = S(R,k5,n);
u[54] = Dot(k2,k3);
u[55] = Den(u[54]);
u[56] = S(R,k4,n,e1);
u[57] = Den(u[2] -u[30] + u[54]);
u[60] = S(L,k2,k5);
u[61] = Den(u[8] -u[19]);
u[63] = S(R,k3,k4);
u[66] = S(R,k4,k5,e1);
u[68] = S(R,k2,k3,e1);
u[71] = S(R,n,k5,e1);
u[72] = Den(u[1] -u[21] + u[54]);
COMPLEX subW1 = kTv + 2.*u[7];
COMPLEX subW3 = u[10]*u[11];
COMPLEX subW5 = u[19] + u[20];
COMPLEX subW6 = kTv - 2.*u[31];
COMPLEX subW8 = u[23]*u[32];
COMPLEX subW10 = u[7] + u[38];
COMPLEX subW11 = u[5]*u[14];
COMPLEX subW12 = -u[4]*u[18];
COMPLEX subW13 = u[10]*u[15];
COMPLEX subW14 = u[4]*u[36];
COMPLEX subW15 = u[5]*u[39];
COMPLEX subW16 = u[31] -u[41];
COMPLEX subW17 = u[9] + u[20];
COMPLEX subW18 = u[5]*u[43];
COMPLEX subW19 = u[4]*u[46];
COMPLEX subW21 = u[4]*u[51];
COMPLEX subW22 = -2.*kTv*u[4];
COMPLEX subW23 = kTv + 2.*u[38];
COMPLEX subW25 = -u[15]*u[56];
COMPLEX subW27 = u[38] + u[41];
COMPLEX subW28 = u[10]*u[23];
COMPLEX subW29 = u[5]*u[60];
COMPLEX subW30 = -u[4]*u[63];
COMPLEX subW31 = u[7] -u[31];
COMPLEX subW32 = u[15]*u[22];
COMPLEX subW33 = kTv + 2.*u[41];
COMPLEX subW35 = -u[22]*u[71];
COMPLEX subW37 = subW3 + subW1*u[4];
COMPLEX subW38 = subW8 + subW6*u[5];
COMPLEX subW39 = subW18 + subW19;
COMPLEX subW40 = subW25 + subW23*u[5];
COMPLEX subW41 = subW35 + subW33*u[4];
COMPLEX subWW1 = u[22]*u[23];
u[13] = 2.*subW37*u[5]*u[6];
u[25] = -2.*subW37*u[5]*u[16];
u[28] = Ii*kTv*subW13*subW5*subWW1*u[16]*u[24];
u[29] = subW13*u[16]*(u[5]*(-subW1*u[14] + u[11]*u[17]) + subW37*u[18]);
u[34] = -2.*subW38*u[4]*u[24];
u[35] = 2.*subW38*u[4]*u[6];
u[40] = subWW1*u[24]*(u[4]*(subW6*u[36] + u[32]*u[37]) + subW38*u[39]);
u[45] = -Ii*subW13*u[16]*(2.*u[42] + u[24]*(kTv*subWW1 + subW10*(subW11 + subW12 + subWW1 -kTv*u[42])));
u[47] = Ii*subWW1*u[24]*(2.*u[44] + u[16]*((subW13 + subW14 + subW15)*subW16 -kTv*(subW13 + subW16*u[44])));
u[50] = -subW28*u[6]*(kTv*subW39 + (subW3 + 2.*u[4]*u[7])*u[46] + u[5]*(2.*u[7]*u[43] + u[11]*u[48]));
u[52] = -subW28*u[6]*(subW39*subW6 + u[32]*(subW21 + u[23]*u[43]));
u[53] = Ii*u[16]*u[24]*((subW22 - 4.*subW10*u[4])*u[5] + (-subW13 + u[4]*u[36] + u[5]*u[39])*u[42] + (-subW11 + subWW1 + u[4]*u[18])*u[44]);
u[58] = -2.*subW40*u[4]*u[16];
u[59] = 2.*subW40*u[4]*u[55];
u[62] = -Ii*kTv*subW13*subW17*subWW1*u[6]*u[55];
u[64] = subW32*u[55]*((-subW23*u[5] + u[15]*u[56])*u[60] + u[4]*(-u[37]*u[56] + subW23*u[63]));
u[65] = subW13*u[16]*(-(subW11 + subW12)*subW23 + (subW21 + u[14]*u[15])*u[56]);
u[67] = -Ii*subW32*u[55]*(2.*u[66] + u[6]*(subW27*(subW28 + subW29 + subW30) + kTv*(subW28 -subW27*u[66])));
u[69] = Ii*subW28*u[6]*(((subW18 + subW19)*subW31 -(kTv + subW31)*subW32)*u[55] + (2. + kTv*subW31*u[55])*u[68]);
u[70] = Ii*u[6]*u[55]*((subW22 - 4.*subW27*u[4])*u[5] + (subW18 + subW32 + u[4]*u[46])*u[66] -(subW28 -u[5]*u[60] + u[4]*u[63])*u[68]);
u[73] = 2.*subW41*u[5]*u[55];
u[74] = -2.*subW41*u[5]*u[24];
u[75] = subW32*u[55]*(-(subW29 + subW30)*subW33 + (u[5]*u[17] -u[22]*u[63])*u[71]);
u[76] = subWW1*u[24]*((subW14 + subW15)*subW33 -(u[22]*u[36] + u[5]*u[48])*u[71]);
COMPLEX subA1 = u[61]*u[67];
COMPLEX subA2 = -u[61]*u[62];
COMPLEX subA6 = subA2 + u[69];
COMPLEX subA9 = subA1 + subA6*u[49] + u[70];


COMPLEX amp1D3D2 = 0.041666666666666664*(u[12]*(-u[13] + 3.*u[25] - 3.*u[27]*u[29] + u[49]*u[50]) + u[33]*(-3.*u[34] -u[35] + 3.*u[26]*u[40] + u[49]*u[52]) - 3.*Ii*(u[27]*(u[26]*u[28] + u[45]) + u[26]*u[47] -u[53]));

COMPLEX amp1D3D4 = 0.041666666666666664*(-3.*Ii*subA9 + u[12]*(3.*u[13] -u[25] + u[27]*u[29] - 3.*u[49]*u[50]) + u[57]*(u[58] + 3.*u[59] - 3.*u[61]*u[64] -u[27]*u[65]));

COMPLEX amp1D5D2 = 0.041666666666666664*(3.*Ii*subA9 + u[33]*(u[34] + 3.*u[35] -u[26]*u[40] - 3.*u[49]*u[52]) + u[72]*(-3.*u[73] + u[74] + 3.*u[61]*u[75] -u[26]*u[76]));

COMPLEX amp1D5D4 = 0.041666666666666664*(3.*Ii*(u[27]*u[45] + u[26]*(u[27]*u[28] + u[47]) -u[53]) + u[57]*(-3.*u[58] -u[59] + u[61]*u[64] + 3.*u[27]*u[65]) + u[72]*(u[73] - 3.*u[74] -u[61]*u[75] + 3.*u[26]*u[76]));

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = 12*norm(amp1D3D2) + 12*norm(amp1D3D4) + 12*norm(amp1D5D2) + 12
      *norm(amp1D5D4) + 4*conj(amp1D3D2)*amp1D5D2 + 4*conj(amp1D3D2)*
      amp1D3D4 + 4*conj(amp1D3D4)*amp1D5D4 + 4*conj(amp1D3D4)*amp1D3D2
       + 4*conj(amp1D5D2)*amp1D5D4 + 4*conj(amp1D5D2)*amp1D3D2 + 4*
      conj(amp1D5D4)*amp1D5D2 + 4*conj(amp1D5D4)*amp1D3D4;
return real(tmp);
}
