//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.



//********************* ME squared (g*)Q->QQQb for helicities LRLL *****************************
// calculated using the method of A. van Hameren, P. Kotko, K. Kutak JHEP 1212 (2012) 029

#include"complex.h"
#include "me_3.h"

double ME_3::me2_RgQQQQb_LRLL() {
int Nsymb =54;

COMPLEX *u = new COMPLEX[Nsymb+1];
u[1] = Dot(k2,k4);
u[2] = Dot(k2,k5);
u[3] = Dot(k4,k5);
u[4] = S(L,k4,k5);
u[5] = S(R,k2,k3);
u[6] = Den(u[2]);
u[7] = Dot(e1,k3);
u[8] = Dot(k2,n);
u[9] = Dot(k5,n);
u[10] = S(R,k2,n);
u[11] = S(R,k3,n,e1);
u[12] = Dot(k3,n);
u[13] = Dot(k4,n);
u[14] = Den(u[1] + u[2] -u[3]);
u[16] = Dot(k3,k4);
u[17] = S(L,k2,k4);
u[18] = S(L,k5,n);
u[19] = S(L,k4,n);
u[20] = S(R,k3,n);
u[21] = Den(u[16]);
u[22] = Den(u[12] + u[13]);
u[23] = Den(u[8] -u[9]);
u[25] = Dot(e1,k4);
u[26] = S(R,k3,k5);
u[27] = S(R,k5,n);
u[29] = S(R,k3,k4,e1);
u[31] = S(L,k3,k5);
u[32] = Dot(k3,k5);
u[33] = Dot(e1,k2);
u[34] = Dot(e1,k5);
u[35] = S(R,k2,k4);
u[36] = S(R,k2,n,e1);
u[37] = Den(u[3] + u[16] + u[32]);
u[39] = S(R,k4,n);
u[40] = S(R,k2,k5,e1);
u[44] = Dot(k2,k3);
u[45] = S(R,n,k4,e1);
u[46] = Den(u[2] -u[32] + u[44]);
u[48] = S(L,k2,n);
u[50] = S(R,n,k5,e1);
u[51] = Den(u[1] -u[16] + u[44]);
u[53] = S(L,k3,n);
COMPLEX subW1 = u[12] + u[13];
COMPLEX subW2 = -u[5]*u[17];
COMPLEX subW3 = u[4]*u[26];
COMPLEX subW6 = u[7] + u[25];
COMPLEX subW7 = kTv - 2.*u[33];
COMPLEX subW9 = u[20]*u[36];
COMPLEX subW11 = u[33] -u[34];
COMPLEX subW12 = u[10]*u[18];
COMPLEX subW13 = u[5]*u[31];
COMPLEX subW14 = u[4]*u[35];
COMPLEX subW15 = u[18]*u[45];
COMPLEX subW16 = -u[19]*u[50];
COMPLEX subW17 = subW2 + subW3;
COMPLEX subW19 = subW9 + subW7*u[5];
COMPLEX subW20 = kTv*subW17;
u[15] = -2.*u[4]*u[6]*(u[5]*(kTv + 2.*u[7]) -u[10]*u[11]);
u[24] = Ii*kTv*subW1*subW12*u[6]*u[19]*u[20]*u[21];
u[28] = subW12*u[6]*(subW20 + 2.*u[7]*(subW3 -u[5]*u[17]) + u[11]*(u[10]*u[17] + u[4]*u[27]));
u[30] = -Ii*subW12*u[6]*((subW6*(-subW3 + u[5]*u[17]) + (kTv + subW6)*u[19]*u[20])*u[21] + (2. -kTv*subW6*u[21])*u[29]);
u[38] = -2.*subW19*u[4]*u[21];
u[41] = u[19]*u[20]*u[21]*(subW19*u[31] + u[4]*(subW7*u[35] + u[36]*u[39]));
u[42] = Ii*u[19]*u[20]*u[21]*(2.*u[40] + u[6]*(subW11*(subW12 + subW13 + subW14) -kTv*(subW12 + subW11*u[40])));
u[43] = Ii*u[6]*u[21]*((-2.*kTv - 4.*subW6)*u[4]*u[5] + u[29]*(-subW12 + u[5]*u[31] + u[4]*u[35]) + (subW2 + u[19]*u[20] + u[4]*u[26])*u[40]);
u[47] = -2.*u[5]*u[6]*(subW15 + u[4]*(kTv + 2.*u[25]));
u[49] = subW12*u[6]*(subW20 + (subW15 + 2.*u[4]*u[25])*u[26] + u[5]*(-2.*u[17]*u[25] + u[45]*u[48]));
u[52] = -2.*u[5]*u[21]*(subW16 + u[4]*(kTv + 2.*u[34]));
u[54] = u[19]*u[20]*u[21]*(kTv*(subW13 + subW14) + (subW16 + 2.*u[4]*u[34])*u[35] + u[5]*(2.*u[31]*u[34] -u[50]*u[53]));


COMPLEX amp1D3D2 = 0.125*(u[14]*(u[15] -u[23]*u[28]) + u[37]*(-u[38] + u[22]*u[41]) -Ii*(u[23]*(u[22]*u[24] + u[30]) + u[22]*u[42] -u[43]));

COMPLEX amp1D3D4 = 0.041666666666666664*(u[14]*(-u[15] + u[23]*u[28]) + u[46]*(u[47] -u[23]*u[49]));

COMPLEX amp1D5D2 = 0.041666666666666664*(u[37]*(u[38] -u[22]*u[41]) + u[51]*(u[52] -u[22]*u[54]));

COMPLEX amp1D5D4 = 0.125*(Ii*(u[23]*u[30] + u[22]*(u[23]*u[24] + u[42]) -u[43]) + u[46]*(-u[47] + u[23]*u[49]) + u[51]*(-u[52] + u[22]*u[54]));

delete [] u;

// color factors are included below, without averaging

COMPLEX tmp = 12*norm(amp1D3D2) + 12*norm(amp1D3D4) + 12*norm(amp1D5D2) + 12
      *norm(amp1D5D4) + 4*conj(amp1D3D2)*amp1D5D2 + 4*conj(amp1D3D2)*
      amp1D3D4 + 4*conj(amp1D3D4)*amp1D5D4 + 4*conj(amp1D3D4)*amp1D3D2
       + 4*conj(amp1D5D2)*amp1D5D4 + 4*conj(amp1D5D2)*amp1D3D2 + 4*
      conj(amp1D5D4)*amp1D5D2 + 4*conj(amp1D5D4)*amp1D3D4;
return real(tmp);
}
