//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


#include "procspace.h"



//--------------------------------------------------------------------------------------------------
//---------------------------------------- PROCSPACE -----------------------------------------------
//--------------------------------------------------------------------------------------------------


PROCSPACE::PROCSPACE(int Njet_ ) { 
    
   switch(Njet_) {
      
    case 2:  {
    
      int sizex = (int) sizeof(state_space_HHto2j)/sizeof(*state_space_HHto2j);
      int sizey = (int) sizeof(state_space_HHto2j[0])/sizeof(*state_space_HHto2j[0]);	
      state_space.clear();
      for (int i=0; i<sizex; i++) state_space.push_back(vector_from_array(state_space_HHto2j[i],sizey));
      break; }
      
    case 3:  {
    
      int sizex = (int) sizeof(state_space_HHto3j)/sizeof(*state_space_HHto3j);
      int sizey = (int) sizeof(state_space_HHto3j[0])/sizeof(*state_space_HHto3j[0]);	
      state_space.clear();
      for (int i=0; i<sizex; i++) state_space.push_back(vector_from_array(state_space_HHto3j[i],sizey)); 
      break; }
    
    default:
      print_error(*LxJet::out_stream,"in PROCSPACE:PROCSPACE(int Njet): not implemented table of subprocesses."); }
     
  }
  
