//    Copyright (C) 2013 Piotr Kotko
//
//    This file is part of LxJet
//
//    LxJet is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


#include "spinor.h"



//--------------------------------------------------------------------------------------------------
//------------------------------ SPINOR and MSPINOR friends ----------------------------------------
//--------------------------------------------------------------------------------------------------

void dirac_prod(CVEC & cvout, const MSPINOR & Sq, const MSPINOR & Sk, SPINOR & S) {
  // note the roles of z and y are reversed according to the definition of
  // the "plus" component in the MSPINOR class
  S.X = Sk.Y; S.Y = Sk.X;
  COMPLEX x = Sq*S;
  S.X = -(S.X);
  COMPLEX z = S.Ii*(Sq*S);
  S.X = Sk.X; S.Y = -(Sk.Y);
  COMPLEX y = Sq*S;
  COMPLEX t = Sq*Sk;
  cvout.set(Sq.hel*x,Sq.hel*y,Sq.hel*z,t); }
  


// __________________________________________________________________________________________________



ostream & operator<<(ostream & os, const SPINOR & e_) {
  os << "[ " << e_.get_X() << " , " << e_.get_Y() << " ]" << endl; }